<%--
Licensed Materials - Property of IBM
(c) Copyright IBM Corporation 2011, 2013. All Rights Reserved.
Note to U.S. Government Users Restricted Rights:  Use,
duplication or disclosure restricted by GSA ADP Schedule 
Contract with IBM Corp.
--%>
<%@ tag language="java" pageEncoding="UTF-8"%>
<%@ attribute name="title" required="true"%>
<%@ attribute name="bannerTitle" required="true"%>
<%@ attribute name="bannerIcon" required="true"%>
<%@ attribute name="bannerRight" %>
<%@ attribute name="homeLink" %>
<%@ attribute name="navbar" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>

<div class="jazz-ui-PageTemplate"
		data-jazz-type="jazz.ui.PageTemplate"
		data-dojo-props="dojoAttachPoint:'ui'">
	<div class="jazz-ui-PageTemplate-skip"><a href="#" dojoattachevent="onclick:_skipToContent"></a></div>
	<div dojoAttachPoint="_aboveBannerNode"></div>
	<div class="banner" dojoattachpoint="_banner">
		<div class="above-banner">
			<div class="title" dojoattachpoint="_title">${title}</div>
			<div class="info" dojoattachpoint="_info"></div>
		</div>
		<div dojoattachpoint="_homeMenu">
			<a title="Home" class="home-button" href="${homeLink}" dojoAttachPoint="_homeMenuButton">
				<a title="Home Menu" href="#" class="home-menu jazz-ui-MenuPopup" dojoAttachPoint="_homeMenuAnchor"></a>
			</a>
		</div>
		<div class="banner-area">
			<div class="left">
				<div class="right">
					<div class="middle">
						<div class="content">
							<div class="header-right">
								<div class="header-inner">
									${bannerRight}
								</div>
							</div>
							<div class="header-left" dojoattachpoint="_headerLeft">
								<div class="banner-icon" dojoattachpoint="_bannerIcon">
									<img src="${bannerIcon}"/>
								</div>
								<div class="banner-title" dojoattachpoint="_bannerTitle">${bannerTitle}</div>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="navbar-wrapper" dojoattachpoint="_navbarWrapper">
		<div class="navbar" dojoattachpoint="_navbar">
			<div class="search-area" dojoattachpoint="_searchArea"></div>
			<div class="links" dojoattachpoint="_links" role="navigation">
				${navbar}
			</div>
			<div class="clearLeft"></div>
		</div>
	</div>
	<table class="content-table" dojoattachpoint="_table">
		<!-- Use a table to achieve expand to fit (horizontal scrolling, when needed) across browsers  -->
		<tbody>
			<tr class="middle-row">
				<td class="minibar-cell"><div data-dojo-attach-point="_leftAnchor" data-jazz-type="jazz.ui.internal.DrawerAnchorLeft"></div></td>
				<td id="content-cell" dojoattachpoint="_content" role="main">
					<div class="status-message" dojoAttachPoint="_statusMessage" role="status"></div>
					<div class="containerNode" dojoAttachPoint="containerNode">
						<div data-jazz-type="net.jazz.ajax.ui.PageContainer">
							<jsp:doBody/>
							<div style="clear:both, height: 0"></div>
						</div>
					</div>
				</td>
				<td class="minibar-cell"><div data-dojo-attach-point="_rightAnchor" data-jazz-type="jazz.ui.internal.DrawerAnchorRight"></div></td>
			</tr>
			<tr>
				<td></td>
				<td>
					<div class="jazz-ui-PageTemplate-footer" dojoattachpoint="_footerWrapper">
						<div class="footer" dojoattachpoint="_footer"></div>
					</div>
				</td>
				<td></td>
			</tr>
		</tbody>
	</table>
</div>