/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2014. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.authoring.web.common.common.internal.UIHelper");//$NON-NLS-1$
	
	dojo.require("net.jazz.ajax.contextRoot");//$NON-NLS-1$
	dojo.require("net.jazz.ajax.oauthDomains");//$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants"); //$NON-NLS-1$ 
	dojo.require("dojox.xml.parser"); //$NON-NLS-1$
	dojo.require("dojox.xmpp.util"); //$NON-NLS-1$
	dojo.require("net.jazz.ajax.BootstrapProperties"); //$NON-NLS-1$
	var ProcessAuthoringConstants = com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants;
	var UIHelper = com.ibm.team.process.authoring.web.common.common.internal.UIHelper;
	var ns = [];
	ns[ProcessAuthoringConstants.NAMESPACE_RDF] = "rdf:"; //$NON-NLS-1$
	ns[ProcessAuthoringConstants.NAMESPACE_DC] = "dc:"; //$NON-NLS-1$
	ns[ProcessAuthoringConstants.NAMESPACE_JTP] = "jtp:"; //$NON-NLS-1$
	
	function isNode(o) {
		return o && o.nodeType && o.cloneNode;
	}

    var getRegForTag = function(tag, type) {
    	tag = tag || ''; //$NON-NLS-1$
		var regstr = [  "<" + tag + "[^>]*>([\\s\\S]*?)<\/" + tag + ">", //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
						"<\/?" + tag + "([^>]+)?>", //$NON-NLS-1$ //$NON-NLS-2$
						"<" + tag + "[^>]*>|<\/"+tag+">" //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
					];
    	return new RegExp(regstr[type], "gi"); //$NON-NLS-1$
    };
    
    var stripContentTagArray = []; //$NON-NLS-1$
    var singleTagArray = ['br', 'hr']; //$NON-NLS-1$ //$NON-NLS-2$
	var stripTagArray = ['table', 'span', 'tr', 'td', 'tbody', 'th', 'img', 'p', 'b', 'a', 'i','ol','li','ul', 'blockquote','div','sup','sub','u','strike']; //$NON-NLS-10$ //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$ //$NON-NLS-7$ //$NON-NLS-8$ //$NON-NLS-9$ //$NON-NLS-11$ //$NON-NLS-12$ //$NON-NLS-13$ //$NON-NLS-14$ //$NON-NLS-15$ //$NON-NLS-16$ //$NON-NLS-17$ //$NON-NLS-18$ //$NON-NLS-19$ //$NON-NLS-20$
	
	com.ibm.team.process.authoring.web.common.common.internal.UIHelper = {
		
		/*
		 * Retrieves the width of the longest string in the array of
		 * strings passed to it. Can be used to determine the correct size for buttons.
		 * Returns the width in EM.
		 */
		getMaxStringDisplayWidthInEms: function(stringArray, testNode, pxMinWidth){
			if (!isNode(testNode)) {
				return -1;
			}
			var tester = document.createElement("div"); //$NON-NLS-1$
			dojo.style(tester, "position", "absolute"); //$NON-NLS-1$ //$NON-NLS-2$
			dojo.style(tester, "left", "-10000px"); //$NON-NLS-1$ //$NON-NLS-2$
			dojo.style(tester, "pad", "0"); //$NON-NLS-1$ //$NON-NLS-2$
			dojo.style(tester, "border", "0"); //$NON-NLS-1$ //$NON-NLS-2$
			testNode.appendChild(tester);
			var width = pxMinWidth || -1;
			
			// Find the longest string
			dojo.forEach(stringArray, function(sample){
				var sampleDiv = document.createElement("div"); //$NON-NLS-1$
				dojo.style(sampleDiv, "float", "right"); //$NON-NLS-1$ //$NON-NLS-2$
				sampleDiv.innerHTML = sample;
				tester.appendChild(sampleDiv);
				width = sampleDiv.clientWidth > width ? sampleDiv.clientWidth : width;
				tester.removeChild(sampleDiv);
				sampleDiv = null;
			});
			
			// Compute pixels per EM
			tester.style.height = '100em'; //$NON-NLS-1$
			var emSize = tester.offsetHeight / 100;
			
			testNode.removeChild(tester);
			
			return width / emSize;
		},
		
		/*
		 *  Helper to style the button for I18N support.  Adds the desired pad
		 *  to the width and sets the button width in em.  Removes any left
		 *  or right pad on the button to ensure that it doesn't eat into the
		 *  content space
		 */
		styleI18NButton: function(button, emWidth, emPad){
			if (emPad === undefined) {
				emPad = 1; //  Set a default pad
			}
			var width = emWidth + emPad + "em"; //$NON-NLS-1$
			dojo.style(button, "width", width); //$NON-NLS-1$
			dojo.style(button, "paddingLeft", 0); //$NON-NLS-1$
			dojo.style(button, "paddingRight", 0); //$NON-NLS-1$
		},
		
		/*
		 * Resize the buttons in the array to accomodate the width of their labels.
		 *
		 * testNode - The node that can be used to calculate the required button width
		 * buttons - The array of buttons with their labels set
		 * pxMinWidth - The optional min width of the buttons in pixels
		 * emPad - The option left and right pad to give the button on each side of label
		 */
		resizeI18NButtons: function(testNode, buttons, pxMinWidth, emPad){
			var labels = [];
			for (var i = 0; i < buttons.length; i++) {
				labels[i] = buttons[i].innerHTML;
			}
			var newWidth = this.getMaxStringDisplayWidthInEms(labels, testNode, pxMinWidth);
			dojo.forEach(buttons, function(button){
				this.styleI18NButton(button, newWidth, emPad);
			}, this);
			return newWidth;
		},
		
		
		isSpecifiedNode: function(node, baseName, namespaceURI) {
			if ((node.baseName == baseName || node.localName == baseName) && (node.namespaceURI == namespaceURI || (node.namespaceURI === "" && namespaceURI === null))) { //$NON-NLS-1$
				return true;
			}
			return false;
		},
		
		getNode: function(collection, baseName, namespaceURI) {
			var matchingNode;
			dojo.some(collection, function(node) {
				if (this.isSpecifiedNode(node, baseName, namespaceURI)) {
					matchingNode = node;
					return true;
				}
				return false;
			}, this);
			return matchingNode;
		},
		
		getNodes: function(collection, baseName, namespaceURI) {
			var matchingNodes = [];
			dojo.forEach(collection, function(node) {
				if (this.isSpecifiedNode(node, baseName, namespaceURI)) {
					matchingNodes.push(node);
				}
			}, this);
			return matchingNodes;
		},
		
		getAttributeNode: function(node, name, namespace) {
			var attribute;
            // After dojo 1.8.3, the returned object from dojo xhr request doesn't have getQualifiedItem method in IE 9.
			if (dojo.isIE && (typeof node.attributes.getQualifiedItem  !== "undefined")) { //$NON-NLS-1$
				attribute = node.attributes.getQualifiedItem(name, namespace);
			} else {
				attribute = node.attributes.getNamedItemNS(namespace, name);
			}
			
			//for bug 117488, can't set attribute for a node which namespace is different from the attribute
			if ( !attribute && ns[namespace] ) {
				attribute = node.getAttributeNode(ns[namespace]+name);
			}
			return attribute;
		},
		
		getPracticeElementPresentation: function(xml) {
			var presentation = this.getNode(xml.documentElement.childNodes, ProcessAuthoringConstants.XMLELEMENT_PRESENTATION, ProcessAuthoringConstants.NAMESPACE_JTP);
			return presentation;
		},
		
		getSections: function(practiceElement) {
			var presentation = this.getNode(practiceElement.childNodes, ProcessAuthoringConstants.XMLELEMENT_PRESENTATION, ProcessAuthoringConstants.NAMESPACE_JTP);
			if (presentation) {
				return this.getNodes(presentation.childNodes, ProcessAuthoringConstants.XMLELEMENT_SECTION, ProcessAuthoringConstants.NAMESPACE_JTP);
			}
			return null;
		},
		
		getSectionLabel: function(section) {
			var labelNode = this.getAttributeNode(section, ProcessAuthoringConstants.XMLATTRIBUTE_LABEL, ""); //$NON-NLS-1$
			if (labelNode) {
				return this.unescapeXML(labelNode.value);
			}
			return ""; //$NON-NLS-1$
		},
		
		isNewCreated: function(node) {
			var newCreatedNode = this.getAttributeNode(node, ProcessAuthoringConstants.XMLATTRIBUTE_NEW_CREATED, ""); //$NON-NLS-1$
			if (newCreatedNode) {
				return newCreatedNode.value === ProcessAuthoringConstants.VALUE_TRUE;
			}
			return false; //$NON-NLS-1$
		},
		
		getFieldType: function(field) {
			var typeNode = this.getAttributeNode(field, ProcessAuthoringConstants.XMLATTRIBUTE_TYPE, ""); //$NON-NLS-1$
			if (typeNode) {
				return typeNode.value;
			}
			return ""; //$NON-NLS-1$
		},
		
		getFieldLabel: function(field) {
			var labelNode = this.getAttributeNode(field, ProcessAuthoringConstants.XMLATTRIBUTE_LABEL, ""); //$NON-NLS-1$
			if (labelNode) {
				return this.unescapeXML(labelNode.value);
			}
			return ""; //$NON-NLS-1$
		},
		
		getFieldName: function(field) {
			var nameNode = this.getAttributeNode(field, ProcessAuthoringConstants.XMLATTRIBUTE_NAME, ""); //$NON-NLS-1$
			if (nameNode) {
				return nameNode.value;
			}
			return ""; //$NON-NLS-1$
		},
		
		getFieldText: function(field) {
			if (field.textContent) {
				return field.textContent;
			} else if (field.firstChild) {
				return this.unescapeXML(field.firstChild.data);
			} else {
				return ''; //$NON-NLS-1$
			}
		},
		
		setNodeText: function(node, value) {
			if (typeof node.textContent !== "undefined") { //$NON-NLS-1$
				node.textContent = value;
			} else if (node.firstChild) {
				node.firstChild.data = value;
			} else {
				node.text = value;
			}
		},
		
		getPracticeElementTitle: function(practiceElement) {
			var title = this.getNode(practiceElement.childNodes, ProcessAuthoringConstants.XMLELEMENT_TITLE, ProcessAuthoringConstants.NAMESPACE_DC);
			if (title.firstChild) {
				return this.unescapeXML(title.firstChild.data);
			}
			return "&lt;No Title&gt;"; //$NON-NLS-1$
		},
		
		getLanguages: function(element) {
			var languages = this.getNode(element.childNodes, ProcessAuthoringConstants.XMLELEMENT_LANGUAGES, ProcessAuthoringConstants.NAMESPACE_JTP);
			if (languages && languages.firstChild) {
				return languages.firstChild.data;
			}
			return null; //$NON-NLS-1$
		},
		
		getAttachmentsUrl: function(element) {
			var attachmentsUrlNode = this.getNode(element.childNodes, ProcessAuthoringConstants.XMLELEMENT_ATTACHMENTS, ProcessAuthoringConstants.NAMESPACE_JTP);
			if (attachmentsUrlNode) {
				var attachmentsUrl = this.getAttributeNode(attachmentsUrlNode, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, ProcessAuthoringConstants.NAMESPACE_RDF).value;
				return attachmentsUrl ? attachmentsUrl : ProcessAuthoringConstants.EMPTY;
			}
			return null; //$NON-NLS-1$
		},
		
		getPracticeElementDescription: function(practiceElement) {
			var description = this.getNode(practiceElement.childNodes, ProcessAuthoringConstants.XMLELEMENT_DESCRIPTION, ProcessAuthoringConstants.NAMESPACE_DC);
			if (description && description.firstChild) {
				return this.unescapeXML(description.firstChild.data);
			}
			return ProcessAuthoringConstants.EMPTY; //$NON-NLS-1$
		},
		
		getFields: function(section) {
			return this.getNodes(section.childNodes, ProcessAuthoringConstants.XMLELEMENT_FIELD, ProcessAuthoringConstants.NAMESPACE_JTP);
		},
		
		getProcessDescriptionValues: function(processDescriptionNode) {
			var aboutAttribute = this.getAttributeNode(processDescriptionNode, ProcessAuthoringConstants.XMLATTRIBUTE_ABOUT, ProcessAuthoringConstants.NAMESPACE_RDF);
			var nameNode = this.getNode(processDescriptionNode.childNodes, ProcessAuthoringConstants.XMLELEMENT_TITLE, ProcessAuthoringConstants.NAMESPACE_DC);
			var descriptionNode = this.getNode(processDescriptionNode.childNodes, ProcessAuthoringConstants.XMLELEMENT_DESCRIPTION, ProcessAuthoringConstants.NAMESPACE_DC); //$NON-NLS-1$			
			return {
				name: nameNode && nameNode.firstChild ? this.unescapeXML(nameNode.firstChild.data) : ProcessAuthoringConstants.EMPTY,
				url: aboutAttribute ? aboutAttribute.value : ProcessAuthoringConstants.EMPTY,
				description: descriptionNode && descriptionNode.firstChild ? this.unescapeXML(descriptionNode.firstChild.data) : ProcessAuthoringConstants.EMPTY
			};
		},
		
		getProcessDescriptionTitle: function(xml) {
			var data = xml.documentElement ? xml.documentElement : xml; 
			var processDescription = this.getNode([data], "ProcessDescription", ProcessAuthoringConstants.NAMESPACE_JTP); //$NON-NLS-1$
			var nameNode = this.getNode(processDescription.childNodes, "title", ProcessAuthoringConstants.NAMESPACE_DC); //$NON-NLS-1$ 
			if (nameNode) {
				var name = this.unescapeXML(nameNode.firstChild.data);
				return name;
			} else {
				return ""; //$NON-NLS-1$
			}
			
		},
		
		getProcessDescriptionDescription: function(xml) {
			var processDescription = this.getNode([xml.documentElement], "ProcessDescription", ProcessAuthoringConstants.NAMESPACE_JTP); //$NON-NLS-1$
			var descriptionNode = this.getNode(processDescription.childNodes, "description", ProcessAuthoringConstants.NAMESPACE_DC); //$NON-NLS-1$
			var description = ""; //$NON-NLS-1$
			if (descriptionNode && descriptionNode.firstChild) {
				description = descriptionNode.firstChild.data;
			}
			return this.unescapeXML(description);
		},
		
		getProcessDescriptionOwnerURL: function(xml) {
			var processDescription = this.getNode([xml.documentElement], "ProcessDescription", ProcessAuthoringConstants.NAMESPACE_JTP); //$NON-NLS-1$
			var xmlOwnerNode = this.getNode(processDescription.childNodes, "owner", ProcessAuthoringConstants.NAMESPACE_JTP); //$NON-NLS-1$
			if (xmlOwnerNode) {
				var ownerAttribute = this.getAttributeNode(xmlOwnerNode, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, ProcessAuthoringConstants.NAMESPACE_RDF);
				var ownerURI = ownerAttribute.value;
			}
			return ownerURI;
		},
		
		getProcessDescriptionOwnerName: function(xml) {
			var processDescription = this.getNode([xml.documentElement], "ProcessDescription", ProcessAuthoringConstants.NAMESPACE_JTP); //$NON-NLS-1$
			var xmlOwnerNode = this.getNode(processDescription.childNodes, "owner", ProcessAuthoringConstants.NAMESPACE_JTP); //$NON-NLS-1$
			if (xmlOwnerNode) {
				var attribute = this.getAttributeNode(xmlOwnerNode, ProcessAuthoringConstants.XMLATTRIBUTE_LABEL, ""); //$NON-NLS-1$
				var ownerName = attribute.value;
			}
			return ownerName;
		},
		
		/**
		 * Parse the association presentation xml and get process description url from it.
		 * 
		 * @param {Object} data the association presentation xml
		 */
		getProcessDescriptionUrlFromAssociation: function(data) {
			var descriptionURL = null;
			dojo.some(data.documentElement.childNodes, function(node) {
				if (node.nodeType == ProcessAuthoringConstants.NodeType.ELEMENT) {
					if (this.isSpecifiedNode(node, "source", ProcessAuthoringConstants.NAMESPACE_JTP)) { //$NON-NLS-1$
						var sourceUrl = this.getAttributeNode(node, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, ProcessAuthoringConstants.NAMESPACE_RDF).value;
						if (sourceUrl) {
							descriptionURL = sourceUrl;
							return true;
						} else {
							return false;
						}
					}
				}
			}, this);
			return descriptionURL;
		},
		
		getLanguage: function(xml) {
			var xmlData = xml.documentElement ? xml.documentElement : xml;
			var languageNode = this.getAttributeNode(xmlData, ProcessAuthoringConstants.XMLATTRIBUTE_LANGUAGE, ProcessAuthoringConstants.NAMESPACE_XML); //$NON-NLS-1$
			if (languageNode) {
				return languageNode.value;
			}
			return ""; //$NON-NLS-1$
		},
		
		isSharedElement: function(xml) {
			var root = xml.documentElement;
			var sharedNode = this.getNode(root.childNodes, ProcessAuthoringConstants.XMLELEMENT_SHARED, ProcessAuthoringConstants.NAMESPACE_JTP); //$NON-NLS-1$
			if (sharedNode && sharedNode.firstChild) {
				var value = sharedNode.firstChild.data;
				if (value == "true") { //$NON-NLS-1$
					return true;
				}
			}
			return false;
		},
		
		isArchivedXmlElement: function(xml) {
			var root = xml.documentElement ? xml.documentElement : xml;
			var archivedNode = this.getNode(root.childNodes, ProcessAuthoringConstants.XMLELEMENT_ARCHIVED, ProcessAuthoringConstants.NAMESPACE_JTP);
			if (archivedNode && archivedNode.firstChild) {
				var value = archivedNode.firstChild.data;
				if (value == "true") { //$NON-NLS-1$
					return true;
				}
			}
			return false;
		},
		
		getPracticeElement: function(xml) {
			return this.getNode([xml.documentElement], ProcessAuthoringConstants.XMLELEMENT_PRACTICEELEMENT_ROOT, ProcessAuthoringConstants.NAMESPACE_JTP);
		},
		
		getPracticeElementOwner: function(xml) {
			var rdf = this.getNode([xml.documentElement], ProcessAuthoringConstants.XMLELEMENT_RDF, ProcessAuthoringConstants.NAMESPACE_RDF);
			var xmlOwnerNode = this.getNode(rdf.childNodes, "owner", null); //$NON-NLS-1$
			if (xmlOwnerNode) {
				var ownerAttribute = this.getAttributeNode(xmlOwnerNode, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, ProcessAuthoringConstants.NAMESPACE_RDF);
				var ownerURI = ownerAttribute.value;
			}
			return ownerURI;
		},
		
		getPresentation: function(xml) {
			var presentation = this.getNode(xml.documentElement.childNodes, ProcessAuthoringConstants.XMLELEMENT_PRESENTATION, ProcessAuthoringConstants.NAMESPACE_JTP);
			if (!presentation) {
				presentation = this.getEmptyPresentation();
			}
			return presentation;
		},
		
		getEmptyPresentation: function() {
			var xml = "<Practice xmlns=\"http://jazz.net/xmlns/prod/jazz/jtp/0.6/\" xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" xmlns:dc=\"http://purl.org/dc/terms/\"><presentation rdf:parseType=\"Literal\"></presentation></Practice>"; //$NON-NLS-1$
			var doc = this.parseXmlTextToDOMDocument(xml);
			return this.getNode(doc.documentElement.childNodes, ProcessAuthoringConstants.XMLELEMENT_PRESENTATION, ProcessAuthoringConstants.NAMESPACE_JTP);
		},
		
		getPracticePresentation: function(xml) {
			var practice = this.getNode([xml.documentElement], ProcessAuthoringConstants.XMLELEMENT_PRACTICE_ROOT, ProcessAuthoringConstants.NAMESPACE_JTP);
			if (practice) {
				return this.getNode(practice.childNodes, ProcessAuthoringConstants.XMLELEMENT_PRESENTATION, ProcessAuthoringConstants.NAMESPACE_JTP);
			}
			return null;
		},
		
		getTitle: function(xml) {
			return this.unescapeXML(this.getNode(xml.documentElement.childNodes, ProcessAuthoringConstants.XMLELEMENT_TITLE, ProcessAuthoringConstants.NAMESPACE_DC).firstChild.data);			
		},
		
		getPracticeTitle: function(xml) {
			var practice = this.getNode([xml.documentElement], ProcessAuthoringConstants.XMLELEMENT_PRACTICE_ROOT, ProcessAuthoringConstants.NAMESPACE_JTP);
			if (practice) {
				return this.unescapeXML(this.getNode(practice.childNodes, ProcessAuthoringConstants.XMLELEMENT_TITLE, ProcessAuthoringConstants.NAMESPACE_DC).firstChild.data);
			}
			return ""; //$NON-NLS-1$
		},
		
		getDescription: function(xml) {
			var description = this.getNode(xml.documentElement.childNodes, ProcessAuthoringConstants.XMLELEMENT_DESCRIPTION, ProcessAuthoringConstants.NAMESPACE_DC);
			return (description && description.firstChild) ? this.unescapeXML(description.firstChild.data) : ""; //$NON-NLS-1$
		},
		
		getPracticeDescription: function(xml) {
			var practice = this.getNode([xml.documentElement], ProcessAuthoringConstants.XMLELEMENT_PRACTICE_ROOT, ProcessAuthoringConstants.NAMESPACE_JTP);
			if (practice) {
				var description = this.getNode(practice.childNodes, ProcessAuthoringConstants.XMLELEMENT_DESCRIPTION, ProcessAuthoringConstants.NAMESPACE_DC);
				return (description && description.firstChild) ? this.unescapeXML(description.firstChild.data) : ""; //$NON-NLS-1$
			}
			return ""; //$NON-NLS-1$
		},
		
		getResourceUrl: function(node) {
			var aboutNode = this.getAttributeNode(node, ProcessAuthoringConstants.XMLATTRIBUTE_ABOUT, ProcessAuthoringConstants.NAMESPACE_RDF); //$NON-NLS-1$
			if (aboutNode) {
				return aboutNode.value;
			}
			return ""; //$NON-NLS-1$
		},
		
		getPracticeUrl: function(xml) {
			var practice = this.getNode([xml.documentElement], ProcessAuthoringConstants.XMLELEMENT_PRACTICE_ROOT, ProcessAuthoringConstants.NAMESPACE_JTP);
			if (practice) {
				return this.getAttributeNode(practice, ProcessAuthoringConstants.XMLATTRIBUTE_ABOUT, ProcessAuthoringConstants.NAMESPACE_RDF).value;
			}
			return ""; //$NON-NLS-1$
		},
		
		addPracticeElement: function(practiceNode, practiceElement, language, parentId) {
			var presentation = practiceNode.model.structure;
			var parent = null;
			if (parentId) {
				parent = this.getGroupingNode(presentation, parentId)
			} else {
				parent = presentation;
			}
			var element = this.createElementNS(ProcessAuthoringConstants.NAMESPACE_JTP, ProcessAuthoringConstants.XMLELEMENT_ELEMENT);
			this.createAttributeNS(element, "", ProcessAuthoringConstants.XMLATTRIBUTE_LABEL, practiceElement.label); //$NON-NLS-1$
			this.createAttributeNS(element, ProcessAuthoringConstants.NAMESPACE_RDF, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, practiceElement.id);
			parent.appendChild(element);
			
			practiceNode.languages[language].textContent[practiceElement.id] = {label: practiceElement.label};
		},
		
		updatePracticeElement: function(practiceNode, language, id, label) {
			practiceNode.languages[language].textContent[id] = {label: label};
		},
		
		deletePracticeElement: function(practiceNode, id) {
			var presentation = practiceNode.model.structure;
			var elementNode = this.getPracticeElementNode(presentation, id);
			elementNode.parentNode.removeChild(elementNode);
		},
		
		updatePracticeElementResource: function(practiceNode, oldResource, newResource) {
			var presentation = practiceNode.model.structure;
			var elementNode = this.getPracticeElementNode(presentation, oldResource);
			var resourceAttr = this.getAttributeNode(elementNode, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, ProcessAuthoringConstants.NAMESPACE_RDF);
			resourceAttr.value = newResource;
		},
		
		addCategory: function(practiceNode, categoryNode, language, parentId) {
			var presentation = practiceNode.model.structure;
			var parent = null;
			if (parentId) {
				parent = this.getGroupingNode(presentation, parentId)
			} else {
				parent = presentation;
			}
			var grouping = this.createElementNS(ProcessAuthoringConstants.NAMESPACE_JTP, ProcessAuthoringConstants.XMLELEMENT_GROUPING);
			this.createAttributeNS(grouping, "", ProcessAuthoringConstants.XMLATTRIBUTE_LABEL, categoryNode.label); //$NON-NLS-1$
			this.createAttributeNS(grouping, ProcessAuthoringConstants.NAMESPACE_RDF, ProcessAuthoringConstants.XMLATTRIBUTE_ID, categoryNode.id);
			this.createAttributeNS(grouping, "", ProcessAuthoringConstants.XMLATTRIBUTE_NEW_CREATED, "true"); //$NON-NLS-1$ //$NON-NLS-2$
			parent.appendChild(grouping);
			
			practiceNode.languages[language].textContent[categoryNode.id] = {label: categoryNode.label};
		},
		
		updateCategory: function(practiceNode, language, id, label) {
			practiceNode.languages[language].textContent[id] = {label: label};
		},
		
		archiveOrRestoreCategory: function(practiceNode, id, targetArchiveStatus) {
			var presentation = practiceNode.model.structure;
			var group = this.getGroupingNode(presentation, id);
			var archivedAttr = this.getAttributeNode(group, ProcessAuthoringConstants.XMLATTRIBUTE_ARCHIVED, ""); //$NON-NLS-1$ //$NON-NLS-2$
			if (!archivedAttr) {
				this.createAttributeNS(group, "", ProcessAuthoringConstants.XMLATTRIBUTE_ARCHIVED, targetArchiveStatus + ""); //$NON-NLS-1$ //$NON-NLS-2$
			} else {
				archivedAttr.value = targetArchiveStatus + ""; //$NON-NLS-1$
			}
		},
		
		deleteCategory: function(practiceNode, id) {
			var presentation = practiceNode.model.structure;
			var categoryNode = this.getGroupingNode(presentation, id);
			categoryNode.parentNode.removeChild(categoryNode);
		},
		
		/**
		 * Move a node to a specified place in practice presentation.
		 * 
		 * @param {XMLDomNode} presentation - The presentation element in practice 
		 * @param {XMLDomNode} target - The node to be moved
		 * @param {XMLDomNode} targetParent - The parent node of the moved node with the new position
		 * @param {Integer} position - Target position in targetParent's children, start from 0
		 * 
		 */
		moveNode: function(structure, node, targetParent, position) {
			if (node.type === ProcessAuthoringConstants.NAVIGATORTYPE_CATEGORY) {
				node = this.getGroupingNode(structure, node.id);
			} else {
				if (node.status === ProcessAuthoringConstants.STATUS_NEW) {
					node = this.getPracticeElementNode(structure, node.id);
				} else {
					node = this.getPracticeElementNode(structure, node.resource);
				}
			}
			if (targetParent.type === ProcessAuthoringConstants.NAVIGATORTYPE_CATEGORY) {
				targetParent = this.getGroupingNode(structure, targetParent.id);
			} else {
				targetParent = structure;
			}
			
			node.parentNode.removeChild(node);
			var childNodes = targetParent.childNodes;
			var indexNumber = -1;
			var insertPosition = 0;
			
			// if position is 0 or a negative value, insert the node to the first place in targetParent's children list directly.
			// otherwise, find the insert position in the original children list.
			if (position > 0) {
				// initialize insertPosition for the case that append a node to the last place.
				insertPosition = childNodes.length;
				// filter empty Text nodes and try to find the target position in the original children list if it exists.
				// if no insert position found, use insertPosition's default value to append the node to the last place.
				for (var i = 0; i < childNodes.length; i++) {
					if (childNodes[i].nodeType === ProcessAuthoringConstants.NODETYPE_ELEMENT) {
						indexNumber++;	
					}
				
					if (indexNumber == position) {
						insertPosition = i;
						break;
					}
				}
			}
			
			dojo.place(node, targetParent, insertPosition);
		},
		
		isPractice: function(node) {
			return this.isSpecifiedNode(node, ProcessAuthoringConstants.XMLELEMENT_PRACTICE, ProcessAuthoringConstants.NAMESPACE_JTP);
		},
		
		isPracticeElement: function(node) {
			return this.isSpecifiedNode(node, ProcessAuthoringConstants.XMLELEMENT_ELEMENT, ProcessAuthoringConstants.NAMESPACE_JTP);
		},
		
		isCategoryNode: function(node) {
			return this.isSpecifiedNode(node, ProcessAuthoringConstants.XMLELEMENT_GROUPING, ProcessAuthoringConstants.NAMESPACE_JTP);
		},
		
		getNodeLabel: function(node) {
			var labelNode = this.getAttributeNode(node, ProcessAuthoringConstants.XMLATTRIBUTE_LABEL, ""); //$NON-NLS-1$
			if (labelNode) {
				return this.unescapeXML(labelNode.value);
			}
			return ""; //$NON-NLS-1$
		},
		
		getNodeTitle: function(node) {
			return this.unescapeXML(this.getNode(node.childNodes, ProcessAuthoringConstants.XMLATTRIBUTE_TITLE, ProcessAuthoringConstants.NAMESPACE_DC).firstChild.data);
		},
		
		getNodeId: function(node) {
			var idNode = this.getAttributeNode(node, ProcessAuthoringConstants.XMLATTRIBUTE_ID, ProcessAuthoringConstants.NAMESPACE_RDF);
			if (idNode) {
				return idNode.value;
			}
			return ""; //$NON-NLS-1$
		},
		
		isArchivedXmlAttribute: function(node) {
			var archivedAttr = this.getAttributeNode(node, ProcessAuthoringConstants.XMLATTRIBUTE_ARCHIVED, ""); //$NON-NLS-1$ //$NON-NLS-2$
			if (archivedAttr && archivedAttr.value === "true") { //$NON-NLS-1$
				return true;
			}
			return false; //$NON-NLS-1$
		},
		
		
		getNodeDcTitle: function(node) {
			var labelNode = this.getAttributeNode(node, ProcessAuthoringConstants.XMLATTRIBUTE_TITLE, ProcessAuthoringConstants.NAMESPACE_DC); //$NON-NLS-1$
			if (labelNode) {
				return this.unescapeXML(labelNode.value);
			}
			return ""; //$NON-NLS-1$
		},
		
		getNodeShareAttr: function(node) {
			var SharedNode = this.getAttributeNode(node, ProcessAuthoringConstants.XMLATTRIBUTE_SHARED, ProcessAuthoringConstants.NAMESPACE_DC); 
			if (SharedNode) {
				return this.unescapeXML(SharedNode.value).toLowerCase() === "true" ? true:false; //$NON-NLS-1$
			}
			return false; 
		},

		getNodeResource: function(node) {
			var resourceNode = this.getAttributeNode(node, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, ProcessAuthoringConstants.NAMESPACE_RDF);
			if (resourceNode) {
				return resourceNode.value;
			}
			return ""; //$NON-NLS-1$
		},
		
		getNodeIcon: function(node) {
			var iconNode = this.getAttributeNode(node, ProcessAuthoringConstants.XMLATTRIBUTE_ICON, ""); //$NON-NLS-1$
			if (iconNode) {
				return iconNode.value;
			}
			return ""; //$NON-NLS-1$
		},
		
		/**
		 * Get all practice references from process description xml
		 * 
		 * @param {Object} xml process description xml
		 * @param {Object} includeArchived indicates whether to include archived practices
		 */
		getAllPracticesFromProcessDescription: function(xml, includeArchived) {
			var practiceInfo = [];
			var urlMap = {};
			var xmlData = xml.documentElement ? xml.documentElement : xml;
			var processDescription = this.getNode([xmlData], ProcessAuthoringConstants.XMLELEMENT_PROCESSDESCRIPTION_ROOT, ProcessAuthoringConstants.NAMESPACE_JTP);
			if (processDescription) {
				var practices = this.getNodes(processDescription.childNodes, ProcessAuthoringConstants.XMLELEMENT_PRACTICE, ProcessAuthoringConstants.NAMESPACE_JTP);
				for (var i = 0; i < practices.length; i++) {
					var node = practices[i];
					var attrResource = this.getAttributeNode(node, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, ProcessAuthoringConstants.NAMESPACE_RDF);
					var attrTitle = this.getAttributeNode(node, ProcessAuthoringConstants.XMLATTRIBUTE_TITLE, ProcessAuthoringConstants.NAMESPACE_DC);
					var attrShared = this.getAttributeNode(node, ProcessAuthoringConstants.XMLATTRIBUTE_SHARED, ""); //$NON-NLS-1$
					if (!includeArchived) {
						var attrArchived = this.isArchivedXmlAttribute(node);
						if (attrArchived) {
							continue;
						}
					}
					if (attrResource && attrTitle) { //resource and title are required attribute					
						if (!urlMap[attrResource.value]) {
							practiceInfo.push({
								url: attrResource.value,
								title: this.unescapeXML(attrTitle.value),
								shared: attrShared ? attrShared.value : "false", //$NON-NLS-1$
								isArchived: this.isArchivedXmlAttribute(node)
							});
							urlMap[attrResource.value] = true;
						}
					}
				}
			}
			return practiceInfo;
		},
		
		getLinkSource: function(linkNode) {
			if (linkNode) {
				var source = this.getNode(linkNode.childNodes, ProcessAuthoringConstants.XMLELEMENT_SOURCE, ProcessAuthoringConstants.NAMESPACE_JTP);
				if (source) {
					return this.getNodeResource(source);
				}
			}
			return ""; //$NON-NLS-1$
		},
		
		getLinkTarget: function(linkNode) {
			if (linkNode) {
				var source = this.getNode(linkNode.childNodes, ProcessAuthoringConstants.XMLELEMENT_TARGET, ProcessAuthoringConstants.NAMESPACE_JTP);
				if (source) {
					return this.getNodeResource(source);
				}
			}
			return ""; //$NON-NLS-1$
		},
		
		getLinks: function(xml) {
			var links = [];
			var rdfNode = this.getNode([xml.documentElement], ProcessAuthoringConstants.XMLELEMENT_RDF, ProcessAuthoringConstants.NAMESPACE_RDF);
			if (rdfNode) {
				var linkNodes = this.getNodes(rdfNode.childNodes, ProcessAuthoringConstants.XMLELEMENT_LINK, ProcessAuthoringConstants.NAMESPACE_JTP);
				dojo.forEach(linkNodes, function(linkNode) {
					var link = {};
					link.source = this.getLinkSource(linkNode);
					link.target = this.getLinkTarget(linkNode);
					link.name = this.getLinkName(linkNode);
					links.push(link);
				}, this);
			}
			return links;
		},
		
		getLinkName: function(linkNode) {
			var titleNode = this.getNode(linkNode.childNodes, "targetTitle", ProcessAuthoringConstants.NAMESPACE_JTP); //$NON-NLS-1$
			return titleNode.firstChild.data;
		},
		
		getGroupingNode: function(presentation, id) {
			var groupingNode = null;
			var groupings = this.getElementsByTagNameNS(presentation, ProcessAuthoringConstants.NAMESPACE_JTP, ProcessAuthoringConstants.XMLELEMENT_GROUPING);
			
			dojo.some(groupings, function(node) {
				var groupingId = this.getAttributeNode(node, ProcessAuthoringConstants.XMLATTRIBUTE_ID, ProcessAuthoringConstants.NAMESPACE_RDF);
				if ((groupingId) && (groupingId.value == id)) {
					groupingNode = node;
					return true;
				}
				return false;
			}, this);
			return groupingNode;
		},
		
		getPracticeElementNode: function(presentation, resource) {
			var elementNode = null;
			var elements = this.getElementsByTagNameNS(presentation, ProcessAuthoringConstants.NAMESPACE_JTP, ProcessAuthoringConstants.XMLELEMENT_ELEMENT);
			
			dojo.some(elements, function(node) {
				var elementResource = this.getAttributeNode(node, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, ProcessAuthoringConstants.NAMESPACE_RDF);
				if ((elementResource) && (elementResource.value == resource)) {
					elementNode = node;
					return true;
				}
				return false;
			}, this);
			return elementNode;
		},
		
		getElementsByTagNameNS: function(node, namespace, tagName) {
			if (node.getElementsByTagNameNS && !dojo.isChrome) {
				return node.getElementsByTagNameNS(namespace, tagName);
			} else {
				var nodes = node.getElementsByTagName(tagName);
				
				return this.getNodes(nodes, tagName, namespace);
			}
		},
		
		getAttachmentNodes: function(xml) {
			return this.getNodes(xml.documentElement.childNodes, ProcessAuthoringConstants.XMLELEMENT_ATTACHMENT, ProcessAuthoringConstants.NAMESPACE_JTP);
		},
		
		getAttachmentPath: function(attachment) {
			var node = this.getNode(attachment.childNodes, ProcessAuthoringConstants.XMLELEMENT_PATH, ProcessAuthoringConstants.NAMESPACE_JTP);
			if (node) {
				return node.firstChild.data;
			}
			return ""; //$NON-NLS-1$
		},
		
		getAttachmentSize: function(attachment) {
			var node = this.getNode(attachment.childNodes, ProcessAuthoringConstants.XMLELEMENT_SIZE, ProcessAuthoringConstants.NAMESPACE_JTP);
			if (node) {
				return node.firstChild.data;
			}
			return ""; //$NON-NLS-1$
		},
		
		getAttachmentService: function(attachment) {
			var node = this.getNode(attachment.childNodes, ProcessAuthoringConstants.XMLELEMENT_SERVICE, ProcessAuthoringConstants.NAMESPACE_JTP);
			if (node && node.firstChild) {
				return node.firstChild.data;
			}
			return ""; //$NON-NLS-1$
		},
		
		getAttachmentDate: function(attachment) {
			var node = this.getNode(attachment.childNodes, ProcessAuthoringConstants.XMLELEMENT_CREATED_DATE, ProcessAuthoringConstants.NAMESPACE_DC);
			if (node) {
				return node.firstChild.data;
			}
			return ""; //$NON-NLS-1$
		},
		
		getAttachmentCreator: function(attachment) {
			var node = this.getNode(attachment.childNodes, ProcessAuthoringConstants.XMLELEMENT_CREATOR, ProcessAuthoringConstants.NAMESPACE_DC);
			if (node) {
				var attribute = this.getAttributeNode(node, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, ProcessAuthoringConstants.NAMESPACE_RDF);
				return attribute.value;
			}
			return ""; //$NON-NLS-1$
		},
		
		getAttachmentContent: function(attachment) {
			var node = this.getNode(attachment.childNodes, ProcessAuthoringConstants.XMLELEMENT_CONTENT, ProcessAuthoringConstants.NAMESPACE_JTP);
			if (node) {
				var attribute = this.getAttributeNode(node, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, ProcessAuthoringConstants.NAMESPACE_RDF);
				return attribute.value;
			}
			return ""; //$NON-NLS-1$
		},
		
		
		getPracticeElementXML: function(practiceElement, language, isPractice) {
			var title = practiceElement.languages[language].basicInformation.label;
			var description = practiceElement.languages[language].basicInformation.description;
			var presentation = this.updatePracticeElementPresentation(practiceElement.model, practiceElement.languages[language].textContent);
			return this.parseXmlTextToDOMDocument(this.buildPracticeElementXML(title, description, presentation, language, isPractice));
		},
		
		buildPracticeElementXML: function(title, description, presentation, language, isArchived) {
			if (presentation) {
				presentation = dojox.xml.parser.innerXML(presentation);
			} else {
				presentation = "<presentation/>" //$NON-NLS-1$
			}
			
			var pdata = "<PracticeElement xmlns=\"http://jazz.net/xmlns/prod/jazz/jtp/0.6/\" xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" xmlns:dc=\"http://purl.org/dc/terms/\" xml:lang=\"" + language + "\"><presentation-type>description</presentation-type><dc:title>"; //$NON-NLS-1$ //$NON-NLS-2$
			pdata += this.escapeXML(title);
			pdata += "</dc:title><dc:description>"; //$NON-NLS-1$
			pdata += this.escapeXML(description);
			pdata += "</dc:description>"; //$NON-NLS-1$
			if (isArchived !== undefined) {
				pdata += "<archived>" + isArchived + "</archived>"; //$NON-NLS-1$ //$NON-NLS-2$
			}
			pdata += presentation; //$NON-NLS-1$
			pdata += "</PracticeElement>"; //$NON-NLS-1$
			return pdata;
		},

		buildPracticeXML: function(title, description, presentation, language, presentationType, isDefault, isArchived) {
			if ( presentation ) {
				presentation = dojox.xml.parser.innerXML(presentation);	
			} else {
				presentation = "<presentation/>" //$NON-NLS-1$
			}
			
			if ( !presentationType || typeof(presentationType) === "undefined" ) { //$NON-NLS-1$
				presentationType = "description"; //$NON-NLS-1$
			}
			
			var pdata = "<Practice xmlns=\"http://jazz.net/xmlns/prod/jazz/jtp/0.6/\" xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\" xmlns:dc=\"http://purl.org/dc/terms/\" xml:lang=\"" + language + "\"><presentation-type>${0}</presentation-type>"; //$NON-NLS-1$ //$NON-NLS-2$
			pdata += title !== null ? "<dc:title>" +  this.escapeXML(title) + "</dc:title>" : ""; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			pdata += description !== null ? "<dc:description>" + this.escapeXML(description) + "</dc:description>" : ""; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			if (isArchived !== undefined) {
				pdata += "<archived>" + isArchived + "</archived>"; //$NON-NLS-1$ //$NON-NLS-2$
			}
			if(typeof(isDefault) !== "undefined") { //$NON-NLS-1$
				pdata += "<default>" + isDefault + "</default>"; //$NON-NLS-1$ //$NON-NLS-2$
			}
			pdata += presentation; //$NON-NLS-1$
			pdata += "</Practice>"; //$NON-NLS-1$

			return dojo.string.substitute(pdata, [presentationType]);
		},

		/**
		 * Builds XML to update only title and description of a practice for a given language.
		 * 
		 * @param {String} title
		 * @param {String} description
		 * @param {String} language
		 * @param {Boolean} isDefault
		 * @return the practice XML for partial update
		 */
		buildBasicPracticeXML: function(title, description, language, isDefault, isArchived) {
			return "<Practice xmlns=\"" + ProcessAuthoringConstants.NAMESPACE_JTP + //$NON-NLS-1$
				"\" xmlns:rdf=\"" + ProcessAuthoringConstants.NAMESPACE_RDF + //$NON-NLS-1$
				"\" xmlns:dc=\"" + ProcessAuthoringConstants.NAMESPACE_DC + //$NON-NLS-1$
				"\" xml:lang=\"" + language + //$NON-NLS-1$
				"\"><presentation-type>description</presentation-type>" + //$NON-NLS-1$
				((title !== null) ? "<dc:title>" + this.escapeXML(title) + "</dc:title>" : "") + //$NON-NLS-1$ $NON-NLS-2$ $NON-NLS-3$
				((description !== null) ?"<dc:description>" +  this.escapeXML(description) + "</dc:description>" : "")+ //$NON-NLS-1$ $NON-NLS-2$ $NON-NLS-3$
				"<default>" + isDefault + "</default>" + "<archived>" + isArchived + "</archived>" + "</Practice>"; //$NON-NLS-1$  //$NON-NLS-2$ //$NON-NLS-3$ // $NON-NLS-4$ // $NON-NLS-5$
		},
		
		updateNewElements: function(practiceElement, newElements, newSections, newFields) {
			var updatedTextContent = {};
			var i;
			if (newElements.newSections && newSections.length === newElements.newSections.length ) {
				for (i = 0; i < newElements.newSections.length; i++) {
					this.createAttributeNS(newSections[i].node, ProcessAuthoringConstants.NAMESPACE_RDF, ProcessAuthoringConstants.XMLATTRIBUTE_ID, newElements.newSections[i]);
					updatedTextContent[newSections[i].id] = newElements.newSections[i];
				}
			}
			
			if (newElements.newFields && newFields.length === newElements.newFields.length ) {
				for (i = 0; i < newElements.newFields.length; i++) {
					this.createAttributeNS(newFields[i].node, ProcessAuthoringConstants.NAMESPACE_RDF, ProcessAuthoringConstants.XMLATTRIBUTE_ID, newElements.newFields[i]);
					updatedTextContent[newFields[i].id] = newElements.newFields[i];
				}
			}
			
			for (var language in practiceElement.languages) {
				if (practiceElement.languages[language].status === ProcessAuthoringConstants.STATUS_UPDATE) {
					for (var key in updatedTextContent) {
						var textContent = practiceElement.languages[language].textContent;
						if (textContent[key]) {
							textContent[updatedTextContent[key]] = textContent[key];
						}
					}
				}
			}
		},
		
		updateNewGroups: function(practice, newElements, newGroups, updateCurrentItem) {
			var updatedTextContent = {};
			var i;
			if (newElements.newGroupings && newGroups.length === newElements.newGroupings.length ) {
				for (i = 0; i < newElements.newGroupings.length; i++) {
					this.createAttributeNS(newGroups[i].node, ProcessAuthoringConstants.NAMESPACE_RDF, ProcessAuthoringConstants.XMLATTRIBUTE_ID, newElements.newGroupings[i]);
					updatedTextContent[newGroups[i].id] = newElements.newGroupings[i];
					updateCurrentItem(newGroups[i].id, newElements.newGroupings[i]);
				}
			}
			
			for (var language in practice.languages) {
				if (practice.languages[language].status === ProcessAuthoringConstants.STATUS_UPDATE) {
					for (var key in updatedTextContent) {
						var textContent = practice.languages[language].textContent;
						if (textContent[key]) {
							textContent[updatedTextContent[key]] = textContent[key];
						}
					}
				}
			}
		},
		
		updatePracticeElementModel: function(practiceElement, newSections, newFields) {
			var model = practiceElement.model.data;
			if ( !model || typeof model === "undefined") { //$NON-NLS-1$
				return;
			}
			var sections = this.getAllSections(model);
            dojo.forEach(sections, function(section) {
            	var newCreatedAttribute = this.getAttributeNode(section, ProcessAuthoringConstants.XMLATTRIBUTE_NEW_CREATED, ""); //$NON-NLS-1$
            	if (newCreatedAttribute && newCreatedAttribute.value == ProcessAuthoringConstants.VALUE_TRUE) {
            		var idAttribute = this.getAttributeNode(section, ProcessAuthoringConstants.XMLATTRIBUTE_ID, ProcessAuthoringConstants.NAMESPACE_RDF);
            		var id = idAttribute.value;
            		section.removeAttributeNode(newCreatedAttribute);
            		section.removeAttributeNode(idAttribute);
            		newSections.push({
            			'node': section, //$NON-NLS-1$
            			'id': id //$NON-NLS-1$
            		});
            	}
            }, this);
			
			var fields = this.getAllFields(model);
            dojo.forEach(fields, function(field) {
            	var newCreatedAttribute = this.getAttributeNode(field, ProcessAuthoringConstants.XMLATTRIBUTE_NEW_CREATED, ""); //$NON-NLS-1$
            	if (newCreatedAttribute && newCreatedAttribute.value == ProcessAuthoringConstants.VALUE_TRUE) {
            		var idAttribute = this.getAttributeNode(field, ProcessAuthoringConstants.XMLATTRIBUTE_ID, ProcessAuthoringConstants.NAMESPACE_RDF);
            		var id = idAttribute.value;
            		field.removeAttributeNode(newCreatedAttribute);
            		field.removeAttributeNode(idAttribute);
            		newFields.push({
            			'node': field, //$NON-NLS-1$
            			'id': id //$NON-NLS-1$
            		});
            	}
            }, this);
		},
		
		updatePracticeElementPresentation: function(model, textContent) {
			if ( !model.data || typeof model.data === "undefined") { //$NON-NLS-1$
				return null;
			}
			var sections = this.getAllSections(model.data);
            dojo.forEach(sections, function(section) {
            	var idAttr = this.getAttributeNode(section, ProcessAuthoringConstants.XMLATTRIBUTE_ID, ProcessAuthoringConstants.NAMESPACE_RDF);
            	if (idAttr) {
            		var key = idAttr.value;
            		if (textContent[key]) {
            			var label = this.getAttributeNode(section, ProcessAuthoringConstants.XMLATTRIBUTE_LABEL, ""); //$NON-NLS-1$
            			label.value = textContent[key].label;
            		}
            	}
            }, this);
			var fields = this.getAllFields(model.data);
			dojo.forEach(fields, function(field) {
            	var idAttr = this.getAttributeNode(field, ProcessAuthoringConstants.XMLATTRIBUTE_ID, ProcessAuthoringConstants.NAMESPACE_RDF);
            	if (idAttr) {
					var key = idAttr.value;
					if (textContent[key]) {
						var label = this.getAttributeNode(field, ProcessAuthoringConstants.XMLATTRIBUTE_LABEL, ""); //$NON-NLS-1$
						label.value = textContent[key].label;
						this.setNodeText(field, textContent[key].value);
					}
				}
			}, this);
			return model.data;
		},
		
		updatePracticeStructurePresentation: function(model, textContent, archivedStatusChangingCategories, archivedStatusChangingPracticeElements) {
			if ( !model.structure || typeof model.structure === "undefined") { //$NON-NLS-1$
				return null;
			}
			var groups = this.getAllGroupings(model.structure);
            dojo.forEach(groups, function(group) {
				var idAttr = this.getAttributeNode(group, ProcessAuthoringConstants.XMLATTRIBUTE_ID, ProcessAuthoringConstants.NAMESPACE_RDF);
				if (idAttr) {
					var key = idAttr.value;
					if (textContent[key]) {
						var label = this.getAttributeNode(group, ProcessAuthoringConstants.XMLATTRIBUTE_LABEL, ""); //$NON-NLS-1$
						label.value = textContent[key].label;
					}
				}
				
				// if the group (category) will change its archived status, then set the new status, otherwise, remove archived attribute.
				if (archivedStatusChangingCategories !== undefined) {
					var targetArchiveStatus;
					var isGroupArchivedStatusChanging = dojo.some(archivedStatusChangingCategories, function(category) {
						if (idAttr && category.id === idAttr.value) {
							targetArchiveStatus = category.targetArchiveStatus;
							return true;
						}
						return false;
					}, this);
					var archivedAttr = this.getAttributeNode(group, ProcessAuthoringConstants.XMLATTRIBUTE_ARCHIVED, ""); //$NON-NLS-1$ //$NON-NLS-2$
					if (isGroupArchivedStatusChanging) {
						if (!archivedAttr) {
							this.createAttributeNS(group, "", ProcessAuthoringConstants.XMLATTRIBUTE_ARCHIVED, targetArchiveStatus + ""); //$NON-NLS-1$ //$NON-NLS-2$
						} else {
							archivedAttr.value = targetArchiveStatus + ""; //$NON-NLS-1$
						}
					} else {
						if (archivedAttr) {
							group.removeAttributeNode(archivedAttr);
						}
					}
				}
				
				return false; //$NON-NLS-1$
			}, this);
			
			var elements = this.getAllElements(model.structure);
			dojo.forEach(elements, function(element) {
            	var idAttr = this.getAttributeNode(element, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, ProcessAuthoringConstants.NAMESPACE_RDF);
            	if (idAttr) {
            		var key = idAttr.value;
            		if (textContent[key]) {
            			var label = this.getAttributeNode(element, ProcessAuthoringConstants.XMLATTRIBUTE_LABEL, ""); //$NON-NLS-1$
            			label.value = textContent[key].label;
            		}
            	}
				
				// if the practice element reference will change its archived status, then set the new status, otherwise, remove archived attribute.
				if (archivedStatusChangingPracticeElements !== undefined) {
					var targetArchiveStatus;
					var isPracticeElementArchivedStatusChanging = dojo.some(archivedStatusChangingPracticeElements, function(practiceElement) {
						if (idAttr && practiceElement.resource === idAttr.value) {
							targetArchiveStatus = practiceElement.targetArchiveStatus;
							return true;
						}
						return false;
					}, this);
					var archivedAttr = this.getAttributeNode(element, ProcessAuthoringConstants.XMLATTRIBUTE_ARCHIVED, ""); //$NON-NLS-1$ //$NON-NLS-2$
					if (isPracticeElementArchivedStatusChanging) {
						if (!archivedAttr) {
							this.createAttributeNS(element, "", ProcessAuthoringConstants.XMLATTRIBUTE_ARCHIVED, targetArchiveStatus + ""); //$NON-NLS-1$ //$NON-NLS-2$
						} else {
							archivedAttr.value = targetArchiveStatus + ""; //$NON-NLS-1$
						}
					} else {
						if (archivedAttr) {
							element.removeAttributeNode(archivedAttr);
						}
					}
				}
				
            }, this);
			
			return model.structure;
		},
		
		updatePracticeStructureModel: function(practice, newGroups) {
			var structure = practice.model.structure;
			if ( !structure || typeof structure === "undefined") { //$NON-NLS-1$
				return;
			}
			var groups = this.getAllGroupings(structure);
            dojo.forEach(groups, function(group) {
            	var newCreatedAttribute = this.getAttributeNode(group, ProcessAuthoringConstants.XMLATTRIBUTE_NEW_CREATED, ""); //$NON-NLS-1$
            	if (newCreatedAttribute && newCreatedAttribute.value == ProcessAuthoringConstants.VALUE_TRUE) {
            		var idAttribute = this.getAttributeNode(group, ProcessAuthoringConstants.XMLATTRIBUTE_ID, ProcessAuthoringConstants.NAMESPACE_RDF);
            		var id = idAttribute.value;
            		group.removeAttributeNode(newCreatedAttribute);
            		group.removeAttributeNode(idAttribute);
            		newGroups.push({
            			'node': group, //$NON-NLS-1$
            			'id': id //$NON-NLS-1$
            		});
            	}
            }, this);
		},
		
		getPracticeElementTextContent: function(doc) {
			var textContent = {};
			var sections = this.getAllSections(doc);
			dojo.forEach(sections, function(section) {
            	var idAttr = this.getAttributeNode(section, ProcessAuthoringConstants.XMLATTRIBUTE_ID, ProcessAuthoringConstants.NAMESPACE_RDF);
            	if (idAttr) {
					var key = idAttr.value;
					var value = this.getAttributeNode(section, ProcessAuthoringConstants.XMLATTRIBUTE_LABEL, "").value; //$NON-NLS-1$
					textContent[key] = {};
					textContent[key].label = value;
				}
			}, this);
			var fields = this.getAllFields(doc);
			dojo.forEach(fields, function(field) {
            	var idAttr = this.getAttributeNode(field, ProcessAuthoringConstants.XMLATTRIBUTE_ID, ProcessAuthoringConstants.NAMESPACE_RDF);
            	if (idAttr) {
					var key = idAttr.value;
					var label = this.getAttributeNode(field, ProcessAuthoringConstants.XMLATTRIBUTE_LABEL, "").value; //$NON-NLS-1$
					var value = this.getFieldText(field);
					textContent[key] = {};
					textContent[key].label = label;
					textContent[key].value = value;
				}
			}, this);
			return textContent;
		},
		
		getAllSections: function(doc) {
			return this.getElementsByTagNameNS(doc, ProcessAuthoringConstants.NAMESPACE_JTP, ProcessAuthoringConstants.XMLELEMENT_SECTION);
		},
		
		getAllFields: function(doc) {
			return this.getElementsByTagNameNS(doc, ProcessAuthoringConstants.NAMESPACE_JTP, ProcessAuthoringConstants.XMLELEMENT_FIELD);
		},
		
		getAllGroupings: function(doc) {
			return this.getElementsByTagNameNS(doc, ProcessAuthoringConstants.NAMESPACE_JTP, ProcessAuthoringConstants.XMLELEMENT_GROUPING);
		},
		
		getAllElements: function(doc) {
			return this.getElementsByTagNameNS(doc, ProcessAuthoringConstants.NAMESPACE_JTP, ProcessAuthoringConstants.XMLELEMENT_ELEMENT);
		},
		
		getPracticeTextContent: function(doc) {
			var textContent = {};
			var groupings = this.getAllGroupings(doc);
			dojo.forEach(groupings, function(grouping) {
				var key = this.getAttributeNode(grouping, ProcessAuthoringConstants.XMLATTRIBUTE_ID, ProcessAuthoringConstants.NAMESPACE_RDF).value;
				var value = this.getAttributeNode(grouping, ProcessAuthoringConstants.XMLATTRIBUTE_LABEL, "").value; //$NON-NLS-1$
				textContent[key] = {};
				textContent[key].label = value;
			}, this);
			var elements = this.getAllElements(doc);
			dojo.forEach(elements, function(element) {
				var key = this.getResourceId(this.getAttributeNode(element, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, ProcessAuthoringConstants.NAMESPACE_RDF).value);
				var valueNode = this.getAttributeNode(element, ProcessAuthoringConstants.XMLATTRIBUTE_LABEL, ""); //$NON-NLS-1$
				var value = valueNode ? valueNode.value : ""; //$NON-NLS-1$
				textContent[key] = {};
				textContent[key].label = value;
			}, this);
			return textContent;
		},
		
		getAssociationTargets: function(doc) {
			var targetNodes = this.getElementsByTagNameNS(doc, ProcessAuthoringConstants.NAMESPACE_JTP, ProcessAuthoringConstants.XMLELEMENT_TARGET);
			var targets = [];
			dojo.forEach(targetNodes, function(target) {
				var targetName = this.getAttributeNode(target, ProcessAuthoringConstants.XMLELEMENT_TITLE, ProcessAuthoringConstants.NAMESPACE_DC).value;
				var targetUri = this.getAttributeNode(target, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, ProcessAuthoringConstants.NAMESPACE_RDF).value;
				targets.push({
					'name': targetName, //$NON-NLS-1$
					'target': targetUri //$NON-NLS-1$
				});
			}, this);
			return targets;
		},
		
		/**
		* Create a XML element
		*
		* @param namespace
		* the element namespace like 'http://purl.org/dc/terms/'
		* 
		* @param tagName
		* the element tag name like 'Owner'
		* 
		* @return the created XML element
		*/
		createElementNS: function(namespace, tagName) {
			// dojo 1.8.3 bug 267727: Can't add new practice element in practice in IE9
			if (dojo.isIE < 9) {
				var doc = this.getMsxmlDOMDocument();
				var node = doc.createNode(1/*NODE_ELEMENT (1)*/, tagName, namespace);
				return node;
			} else {
				return document.createElementNS(namespace, tagName);
			}
		},
		
		/**
		* Create a XML attribute for a XML element
		*
		* @param node
		* the target XML element
		* 
		* @param namespace
		* the attribute namespace like 'http://purl.org/dc/terms/'
		* 
		* @param name
		* the attribute name
		* 
		* @param value
		* the attribute value
		* 
		*/
		createAttributeNS: function(node, namespace, name, value) {
			if (node) {
				if (namespace) {
					// dojo 1.8.3 bug 267727: Can't add new practice element in practice in IE9
					if (dojo.isIE >= 9) {
						var attribute = document.createAttributeNS(namespace, ns[namespace] + name);
						attribute.nodeValue = value;
						node.attributes.setNamedItem(attribute);
					} else {
						dojo.attr(node, ns[namespace] + name, value);
					}
				} else {
					dojo.attr(node, name, value);
				}
			}
		},
		
		/**
		* Get a XML dom document in IE
		*/
		getMsxmlDOMDocument: function() {
			var doc = null;
			var ms = function(n) {
				return "MSXML" + n + ".DOMDocument"; //$NON-NLS-1$ //$NON-NLS-2$
			};
			var dp = ["Microsoft.XMLDOM", ms(6), ms(4), ms(3), ms(2)]; //$NON-NLS-1$
			dojo.some(dp, function(p) {
				try {
					doc = new ActiveXObject(p);
				} catch (e) {
					return false;
				}
				return true;
			});
			
			return doc; //DOMDocument
		},
		
		/**
		* Parse a XML text to DOM document. 
		* In dojo, the function dojox.xml.parser.parse() works for IE7,IE8 and FF, 
		* but it does not work for IE9. IE9 is treated as FF in that function.
		* So we write this function to handle this bug for IE9.
		* 
		* @param {String} xmlStr the xml text that to be parsed
		* 
		*/
		parseXmlTextToDOMDocument: function(/*String?*/xmlStr) {
			// dojo 1.8.3 bug 267727: Can't add new practice element in practice in IE9
			if (dojo.isIE < 9) {
				// Handle the dojo bug that mistakes IE9 for Mozilla based browsers
				// The code is copied from dojox.xml.parser.parse()
				var doc = this.getMsxmlDOMDocument();
				if (xmlStr && doc) {
					doc.async = false;
					doc.loadXML(xmlStr);
					var pe = doc.parseError;
					if (pe.errorCode !== 0) {
						throw new Error("Line: " + pe.line + "\n" + //$NON-NLS-1$ //$NON-NLS-2$
						"Col: " + pe.linepos + "\n" + //$NON-NLS-1$ //$NON-NLS-2$
						"Reason: " + pe.reason + "\n" + //$NON-NLS-1$ //$NON-NLS-2$
						"Error Code: " + pe.errorCode +	"\n" + //$NON-NLS-1$ //$NON-NLS-2$
						"Source: " + pe.srcText); //$NON-NLS-1$
					}
				}
                
                if (doc) {
                	return doc; //DOMDocument
                }
                return null;
			} else {
				return dojox.xml.parser.parse(xmlStr);
			}
		},
		
		/**
		 * This method is written for ContentEditor and GeneralInputFieldEditor,
		 * which should share a supertype.
		 */
		setReadOnlyWarning: function(editor) {
			var messageBoxArgs = {};
			
			editor.connect(editor.warningLink, "onclick", "onNavigateSharedPractice"); //$NON-NLS-1$ //$NON-NLS-2$
			dojo.style(editor.warningMessageSpan, "display", "inline"); //$NON-NLS-1$ //$NON-NLS-2$
			messageBoxArgs.summary = editor.warningMessageSpan;
			messageBoxArgs.closable = false;
			
			//show message
			messageBoxArgs.type = jazz.ui.MessageBox.STATUS_TYPES.WARNING;
			editor.messageBox.showMessage(messageBoxArgs);
		},

		getServerUrl: function() {
			var location = document.location.href;
			var separator = "/"; //$NON-NLS-1$
			var path = location.split(separator); //$NON-NLS-1$
			var serverAddress;
			if (path.length > 0) {
				serverAddress = path.shift() + separator + separator;
				path.shift(); //empty from the double //
				serverAddress = serverAddress + path.shift();
			}
			return serverAddress;
		},
		
		getContextRoot: function() {
			return net.jazz.ajax.contextRoot();
		},
		
		getURLPrefix: function() {
			return document.location.protocol + "//" + document.location.host + net.jazz.ajax.contextRoot(); //$NON-NLS-1$
		},
		
		getFullProcessAuthoringRoot: function() {
			return this.getURLPrefix() + ProcessAuthoringConstants.PROCESS_AUTHORING_URI_PART_WITHOUT_SLASH; 
		},
		
		isPracticeElementURL: function(url){
			if (url) {
				var urlPrefix = url.substring(0, url.lastIndexOf("/")); //$NON-NLS-1$
				if (urlPrefix.indexOf(ProcessAuthoringConstants.PROCESS_AUTHORING_URI_PART + ProcessAuthoringConstants.PRACTICE_ELEMENTS) != -1) { //$NON-NLS-1$
					return true;
				} else {
					return false;
				}
			} else {
				return false;
			}
		},

		isProcessAuthoringResourceURL: function(url) {
			if (url) {
				var urlObj = new dojo._Url(url);
				var domain = this.getMatchingAuthDomain(urlObj);
				if(domain) {
					if (domain.charAt(domain.length - 1) === '/') { //$NON-NLS-1$
						domain = domain.substring(0, domain.length - 1);
					}
					return url.indexOf(domain + ProcessAuthoringConstants.PROCESS_AUTHORING_URI_PART) != -1;
				}
			}
			return false;
		},
		
		isPracticeLibraryApp: function() {
			return net.jazz.ajax.BootstrapProperties.APP_ID == ProcessAuthoringConstants.PRACTICELIBRARY_APPID; 
		},
		
		extractETag: function(ETag) {
			if (ETag) {
				ETag = ETag.split(' '); //$NON-NLS-1$
				return {
					'modelETag': ETag[0], //$NON-NLS-1$
					'textContentETag': ETag[1] //$NON-NLS-1$
				};
			}
			
			return null;
		},
		
		getResourceId: function(resource) {
			return resource.substring(resource.lastIndexOf('/') + 1); //$NON-NLS-1$
		},
		
		//escape characters: < to &lt;
		//                   > to &gt;
		//				     " to &quot;  
		//                   ' to &#039;(Since IE doesn't support &apos; for now)
		//                   & to &amp; 
		escapeXML: function(value) {
			//don't use jazz.util.html.escape(value). This function doesn't encode character "
			if (!value) {
				return ProcessAuthoringConstants.EMPTY;
			}
			return value.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/\"/g, "&quot;").replace(/\'/g, "&#039;"); //$NON-NLS-1$ //$NON-NLS-2$  //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
		},
		
		unescapeXML: function(value) {
			if (!value) {
				return ProcessAuthoringConstants.EMPTY;
			}
			return value.replace(/&lt;/g, "<").replace(/&gt;/g, ">").replace(/&quot;/g, "\"").replace(/&#039;/g, "\'").replace(/&amp;/g, "&"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
		},
		
		escapeHTML: function(value) {
			if (!value) {
				return ProcessAuthoringConstants.EMPTY;
			}
			return value.replace(/&/g, "&amp;").replace(/\"/g, "&quot;").replace(/\'/g, "&#039;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/\ /g, "&nbsp;").replace(/\n/g, "<br>"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$ //$NON-NLS-7$
		},
		
		escapeHTMLWithoutSpace: function(value) {
			if (!value) {
				return ProcessAuthoringConstants.EMPTY;
			}
			return value.replace(/&/g, "&amp;").replace(/\"/g, "&quot;").replace(/\'/g, "&#039;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/\n/g, "<br>"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
		},
		
		getRichText: function(text) {
            if (!text) {
            	return ProcessAuthoringConstants.EMPTY;
            }
			return this.escapeHTML(text); //$NON-NLS-1$ //$NON-NLS-2$ 
		},
		
		getPlainText: function(richText) {
			if ( !richText ) {
				return ProcessAuthoringConstants.EMPTY;
			}
			
			//<p> and <li> will not be changed to RETURN in innerText, <li> and <br> will not be changed to RETURN in textContent
			//so we need to pre-process this
            if (dojo.isIE ) {
            	richText = richText.replace(/<p>|<\/p>|<\/li>/gi, '<br/>'); //$NON-NLS-1$
            } else {
				richText = richText.replace(/<br>|<br\/>|<\/li>/gi, '\n'); //$NON-NLS-1$
			}
			var div = document.createElement(ProcessAuthoringConstants.DIV);
			dojo.html.set(div, richText);
			if (div.innerText) {
				return div.innerText;
			} else if (div.textContent) {
				return div.textContent;
			} else {
				//most likely will not go here, just for safety   
				return this._getPlainText(richText);
			}
		},

		_getPlainText: function(richText) {
			if ( !richText ) {
				return ProcessAuthoringConstants.EMPTY;
			}
            dojo.forEach(stripContentTagArray, function(tag){
            	richText = richText.replace(getRegForTag(tag, 0), ProcessAuthoringConstants.EMPTY);
            });
            dojo.forEach(singleTagArray, function(tag){
                if (tag === 'br' ) { //$NON-NLS-1$ 
                	richText = richText.replace(getRegForTag(tag, 1), '\n'); //$NON-NLS-1$
                } else {
                	richText = richText.replace(getRegForTag(tag, 1), ProcessAuthoringConstants.EMPTY);
                }
			});
            dojo.forEach(stripTagArray, function(tag){
            	richText = richText.replace(getRegForTag(tag, 2), function(match){
					return (match.toLowerCase() === "</li>" || match.toLowerCase() === '</p>')? '\n' : ProcessAuthoringConstants.EMPTY; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				});
			});
			
	     	return this.unescapeXML(richText);			
		},
		
		
		/**
		 * NOTE: copied from /net.jazz.web.app/resources/internal/ProxyRequestInterceptor.js
		 * 
		 * Compare the two dojo._Url objects' scheme, host, and port. Returns 'true' if
		 * all parts are the same (disregarding case differences), otherwise false.
		 * 
		 * @param {Object} url1
		 * @param {Object} url2
		 */
		originsAreEquivalent: function(url1, url2) {
			var props = ["scheme", "host", "port"]; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			for(var i=0; i<props.length; i++) {
				var prop = props[i];
				var val1 = url1[prop];
				var val2 = url2[prop];
				if((!val1 && val2) || (val1 && !val2)) {
					return false;
				}
				if(val1.toLowerCase() !== val2.toLowerCase()) {
					return false;
				}
			}
			return true;
		},
		
		startWith: function(str, substr) {
			var reg = new RegExp("^" + substr);  //$NON-NLS-1$   
			return reg.test(str);    
		},
		
		endWith: function(str, substr) {
			var reg=new RegExp(substr+"$");  //$NON-NLS-1$
			return reg.test(str); 
		},
		
		/**
		 * Checks the URL object's port property and if the port property is not set,
		 * sets it to either "80" (HTTP) or "443" (HTTPS).
		 * 
		 * @param {Object} url the URL object to check and perhaps normalize
		 */
		normalizePort: function(url) {
			var scheme = url.scheme || "http"; //$NON-NLS-1$
			if(!url.port) {
				url.port = scheme === "http" ? "80" : "443"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			}
		},
		
		/**
		 * @param {Object} url
		 */
		matchesAuthDomain: function (url) {
			for (var i = 0; i < net.jazz.ajax.oauthDomains().length; i++) {
				var curDomain = new dojo._Url(net.jazz.ajax.oauthDomains()[i]);
				this.normalizePort(curDomain);
				var curDomainPath = curDomain.path;
				if (this.originsAreEquivalent(url, curDomain) && (url.path.indexOf(curDomainPath) === 0))
					return true;
			}
			return false;
		},
		
		/**
		 * @param {Object} url
		 */
		getMatchingAuthDomain: function (url) {
			for (var i = 0; i < net.jazz.ajax.oauthDomains().length; i++) {
				var curDomain = new dojo._Url(net.jazz.ajax.oauthDomains()[i]);
				this.normalizePort(curDomain);
				var curDomainPath = curDomain.path;
				if (this.originsAreEquivalent(url, curDomain) && (url.path.indexOf(curDomainPath) === 0))
					return net.jazz.ajax.oauthDomains()[i];
			}
			return null;			
		},
		
		getLicenseWarning: function (ioArgs) {
			var warning = ioArgs.xhr.getResponseHeader("Warning"); //$NON-NLS-1$
			var licenseWarning = null;
			if(warning) {
				var splits = warning.split(" "); //$NON-NLS-1$
				if(splits.length > 2 && splits[0] == 199 && splits[1] == ProcessAuthoringConstants.WARNING_SOURCE_PROCESS_AUTHORING_LICENSE) {
					var start = warning.indexOf(ProcessAuthoringConstants.WARNING_SOURCE_PROCESS_AUTHORING_LICENSE) + ProcessAuthoringConstants.WARNING_SOURCE_PROCESS_AUTHORING_LICENSE.length + 2;
					end = warning.length - 1;
					licenseWarning = warning.substring(start, end);
					licenseWarning = decodeURI(licenseWarning);
				}
			}
			return licenseWarning;
		},
		
		encodeProxiedUri: function(origUri) {
			return net.jazz.ajax.contextRoot() + "/proxy?uri=" + encodeURIComponent(origUri); //$NON-NLS-1$
		},
		
		/**
		 * Get the process description owner type ("PROJECT_AREA", "TEAM_AREA", "PROCESS_TEMPLATE"). 
		 * 
		 * @param {String} ownerUrl The url of project area, team area or process template.
		 * @return the type of the owner ("PROJECT_AREA", "TEAM_AREA", "PROCESS_TEMPLATE").
		 */
		getDescriptionOwnerType: function(ownerUrl){
			if (ownerUrl) {
				var contextRoot = net.jazz.ajax.BootstrapProperties.FRONTSIDE_URL;
				var urlPart = ownerUrl.substring(contextRoot.length + 1);
				if (urlPart) {
					var segments = urlPart.split("/"); //$NON-NLS-1$
					if (segments.length == 3 && urlPart.indexOf("process/project-areas/") == 0) { //$NON-NLS-1$
						return ProcessAuthoringConstants.PROJECT_AREA;
					} else if (segments.length == 3 && urlPart.indexOf("process/templates/") == 0) { //$NON-NLS-1$
						return ProcessAuthoringConstants.PROCESS_TEMPLATE;
					} else if (segments.length == 5 && segments[3] === "team-areas") { //$NON-NLS-1$
						return ProcessAuthoringConstants.TEAM_AREA;
					}
				}
			}
			return ""; //$NON-NLS-1$
		},
		
		/**
		 * Gets the URL of a process area in the local application given its project area ID and team area ID.
		 * 
		 * @param {Object} projectAreaId the ID of the project area
		 * @param {Object} teamAreaId the ID of the team area, can be null if the process area is a project area
		 * @return the URL of the process area
		 */
		getProcessAreaUrl: function(projectAreaId, teamAreaId) {
			var contextRoot = net.jazz.ajax.BootstrapProperties.FRONTSIDE_URL;
			if (projectAreaId) {
				if (teamAreaId) {
					return dojo.string.substitute(ProcessAuthoringConstants.PROCESSDESCRIPTION_TEAM_AREA_OWNER_TEMPLATE, [contextRoot, projectAreaId, teamAreaId]);
				} else {
					return dojo.string.substitute(ProcessAuthoringConstants.PROCESSDESCRIPTION_PROJECT_AREA_OWNER_TEMPLATE, [contextRoot, projectAreaId]);
				}
			}
			
			return null;
		},
		
		/**
		 * Gets the URL of the process template in the local application with the given ID.
		 * 
		 * @param {Object} processTemplateId the ID of the process template
		 * @return the URL of the process template
		 */
		getProcesTemplateUrl: function(processTemplateId) {
			return net.jazz.ajax.BootstrapProperties.FRONTSIDE_URL + ProcessAuthoringConstants.PROCESS_TEMPLATE_URI_PART + processTemplateId;
		},
		
		/**
		 * Append the lang param to the URL, if it has existed, replace it with the new value
		 * Example
		 *  -url: https://localhost:9443/jazz/admin#action=com.ibm.team.process.editProjectArea&itemId=_RCklAKfmEeKLGaHufpH8tA
		 *  -return: https://localhost:9443/jazz/admin?lang=en-us#action=com.ibm.team.process.editProjectArea&itemId=_RCklAKfmEeKLGaHufpH8tA
		 * @param {String} url
		 * @param {String} lang
		 */
		appendLangParamToURL: function(url, lang) {
			if (!url || !lang) {
				return url;
			}
			
			var hashIndex = url.indexOf("#");  //$NON-NLS-1$
			var hashString = "";  //$NON-NLS-1$
			if (hashIndex > 0) {
				//Split the URL into two parts based on the #, the first part is saved in url, and the second part is saved in hashString
				hashString = url.substring(hashIndex, url.length);
				url = url.substring(0, hashIndex);
			}
			
			var queryIndex = url.indexOf("?"); //$NON-NLS-1$
			if (queryIndex < 0) {
				//If the url doesn't contain any parameter, append the lang param and the hashstring
				return url + "?lang=" + lang + hashString; //$NON-NLS-1$
			}
			
			var obj = dojo.queryToObject(url.substring(queryIndex + 1));
			obj.lang = lang;		
			var queryString = dojo.objectToQuery(obj);
			return url.substring(0, queryIndex) + "?" + queryString + hashString;  //$NON-NLS-1$
			
		},
		
		/**
		 * remove the lang param from the url if the url has the lang param
		 * Example
		 *  url: https://localhost:9443/jazz/admin?lang=en-us#action=com.ibm.team.process.editProjectArea&itemId=_RCklAKfmEeKLGaHufpH8tA
		 *  return: https://localhost:9443/jazz/admin#action=com.ibm.team.process.editProjectArea&itemId=_RCklAKfmEeKLGaHufpH8tA
		 * @param {String} url the url that will remove the lang param from it
		 */
		removeLangParamFromURL: function(url) {
			if (!url) {
				return url;
			}
			var queryIndex = url.indexOf("?"); //$NON-NLS-1$
			//If the URL doesn't contain any query parameters, return the url
			if (queryIndex < 0) {
				return url;
			}
			
			var hashIndex = url.indexOf("#");  //$NON-NLS-1$
			var hashString = "";  //$NON-NLS-1$
			if (hashIndex > 0) {
				//Split the URL into two parts based on the #, the first part is saved in url, and the second part is saved in hashString
				hashString = url.substring(hashIndex, url.length); //starts with #
				url = url.substring(0, hashIndex);
			}
			
			//Render the query parameter string into object
			var obj = dojo.queryToObject(url.substring(queryIndex + 1));
			if (obj.lang) {//Delete the lang paramter if it has
				delete obj.lang;
			}
			
			var queryString = dojo.objectToQuery(obj);
			if (queryString) {
				return url.substring(0, queryIndex) + "?" + queryString + hashString;  //$NON-NLS-1$
			} else {
				return url.substring(0, queryIndex) + hashString;
			}
		}

	}
	
})();
