/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("jazz.ensemble.internal.util.bindings");

var NAMESPACES = {
	dc: "http://purl.org/dc/terms/",
	jw: "http://jazz.net/xmlns/prod/jazz/widget/1.0/",
	rdf: "http://www.w3.org/1999/02/22-rdf-syntax-ns#",
	xml: "http://www.w3.org/XML/1998/namespace"
};

var WidgetReference = {
	namespaces: NAMESPACES,
	getId: ["string", "@rdf:nodeID", "1"],
	setId: ["string", "@rdf:nodeID", "1"]
};
var Column = {
	namespaces: NAMESPACES,
	getWidth: ["number", "jw:width", "1"],
	getWidgetReferences: [WidgetReference, "jw:widgets/jw:Widget", "*"],
	setWidth: ["number", "jw:width", "1"],
	setWidgetReferences: [WidgetReference, "jw:widgets/jw:Widget", "*"],
	setWidgetReferencesParseType: ["string", "jw:widgets/@rdf:parseType", "1"]
};
var ColumnLayoutData = {
	namespaces: NAMESPACES,
	getColumns: [Column, "jw:columns/jw:Column", "*"],
	setColumns: [Column, "jw:columns/jw:Column", "*"],
	setColumnsParseType: ["string", "jw:columns/@rdf:parseType", "1"]
};
var LayoutData = {};
var Layout = {
	namespaces: NAMESPACES,
	getData: [LayoutData, "jw:data/jw:LayoutData", "1"],
	getType: ["string", "dc:type", "1"],
	setData: [LayoutData, "jw:data/jw:LayoutData", "1"],
	setType: ["string", "dc:type", "1"]
};
var ColumnLayout = {
	namespaces: NAMESPACES,
	getType: ["string", "dc:type", "1"],
	getData: [ColumnLayoutData, "jw:data/jw:LayoutData", "1"],
	setData: [ColumnLayoutData, "jw:data/jw:LayoutData", "1"]
};
var Preference = {
	namespaces: NAMESPACES,
	getName: ["string", "jw:name", "1"],
	getValue: ["string", "jw:value", "1"],
	setName: ["string", "jw:name", "1"],
	setValue: ["string", "jw:value", "1"]
};
var Widget = {
	namespaces: NAMESPACES,
	getId: ["string", "@rdf:nodeID", "1"],
	getTitle: ["string", "dc:title", "1"],
	getType: ["string", "dc:type", "1"],
	getDefinition: ["string", "jw:definition/@rdf:resource", "1"],
	getIcon: ["string", "jw:icon/@rdf:resource", "1"],
	getMemento: ["string", "jw:memento", "1"],
	getPreferences: [Preference, "jw:preferences/jw:Preference", "*"],
	getPreferencesParseType: ["string", "jw:preferences/@rdf:parseType", "1"],
	getShowBackground: ["boolean", "jw:showBackground", "1"],
	getTrim: ["string", "jw:trim", "1"],
	isCollapsed: ["boolean", "jw:collapsed", "1"],
	isCustomTitle: ["boolean", "jw:customTitle", "1"],
	setCollapsed: ["boolean", "jw:collapsed", "1"],
	setCustomTitle: ["boolean", "jw:customTitle", "1"],
	setId: ["string", "@rdf:nodeID", "1"],
	setTitle: ["string", "dc:title", "1"],
	setType: ["string", "dc:type", "1"],
	setDefinition: ["string", "jw:definition/@rdf:resource", "1"],
	setIcon: ["string", "jw:icon/@rdf:resource", "1"],
	setMemento: ["string", "jw:memento", "1"],
	setPreferences: [Preference, "jw:preferences/jw:Preference", "*"],
	setPreferencesParseType: ["string", "jw:preferences/@rdf:parseType", "1"],
	setShowBackground: ["boolean", "jw:showBackground", "1"],
	setTrim: ["string", "jw:trim", "1"]
};
var Page = {
	namespaces: NAMESPACES,
	getId: ["string", "@rdf:ID", "1"],
	getTitle: ["string", "dc:title", "1"],
	getWidgets: [Widget, "jw:widgets/jw:Widget", "*"],
	getLayout: [Layout, "jw:layout/jw:Layout", "1"],
	setId: ["string", "@rdf:ID", "1"],
	setTitle: ["string", "dc:title", "1"],
	setWidgets: [Widget, "jw:widgets/jw:Widget", "*"],
	setWidgetsParseType: ["string", "jw:widgets/@rdf:parseType", "1"],
	setLayout: [Layout, "jw:layout/jw:Layout", "1"]
};
var WidgetEnsemble = {
	namespaces: NAMESPACES,
	getPages: [Page, "jw:pages/jw:Page", "*"]
};

jazz.ensemble.internal.util.bindings = {
	NAMESPACES: NAMESPACES,
	Column: Column,
	ColumnLayout: ColumnLayout,
	ColumnLayoutData: ColumnLayoutData,
	Layout: Layout,
	Page: Page,
	Widget: Widget,
	WidgetEnsemble: WidgetEnsemble,
	WidgetReference: WidgetReference
};

})();