ALTER SESSION SET CURRENT_SCHEMA= &&CALM_SCHEMA;

GRANT REFERENCES ON &&NF_SCHEMA..TIMESHEET TO &&CALM_SCHEMA;
GRANT REFERENCES ON &&NF_SCHEMA..ACTIVITY TO &&CALM_SCHEMA;

CREATE TABLE TIMESHEET_ENTRY (
        TIMESHEET_ENTRY_ID INTEGER NOT NULL,
        TIMESHEET_ID INTEGER DEFAULT -1 NOT NULL,
		ACTIVITY_ID INTEGER DEFAULT -1 NOT NULL,
		TIMESHEET_REPORTING_WEEK DATE,
		REFERENCE_ID VARCHAR(50),
		WORK_DATE DATE,
	    DAY_NAME VARCHAR(60) NOT NULL,
		WORK_TIME INTEGER DEFAULT 0,
		EXTERNAL_ID VARCHAR(100),
		EXTERNAL_KEY1 INTEGER  DEFAULT -1 NOT NULL,
		EXTERNAL_KEY2 CHAR(40) DEFAULT '-1' NOT NULL,
		EXTERNAL_KEY3 CHAR(40) DEFAULT '-1' NOT NULL,
		SOURCE_ID VARCHAR (36) DEFAULT '-1' NOT NULL,
		URL VARCHAR(2048),
		REC_DATETIME TIMESTAMP DEFAULT CURRENT_TIMESTAMP NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL
) TABLESPACE VNF_32K ;

CREATE INDEX TMENTRY_IDX1 ON TIMESHEET_ENTRY (EXTERNAL_KEY2 ASC) REVERSE TABLESPACE VNF_IDX;

CREATE INDEX TMENTRY_IDX2 ON TIMESHEET_ENTRY (EXTERNAL_KEY3 ASC) REVERSE TABLESPACE VNF_IDX;

ALTER TABLE TIMESHEET_ENTRY ADD CONSTRAINT TMENTRY_PK PRIMARY KEY (TIMESHEET_ENTRY_ID) USING INDEX TABLESPACE  VNF_IDX;

ALTER TABLE TIMESHEET_ENTRY ADD CONSTRAINT TMENTRY_FK1 FOREIGN KEY (TIMESHEET_ID)
	REFERENCES &&NF_SCHEMA..TIMESHEET (TIMESHEET_ID);

ALTER TABLE TIMESHEET_ENTRY ADD CONSTRAINT TMENTRY_FK2 FOREIGN KEY (ACTIVITY_ID)
	REFERENCES &&NF_SCHEMA..ACTIVITY (ACTIVITY_ID);

UPDATE &&CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=6, CHAR_VALUE='4.0.3' WHERE INFO_ID=16;
UPDATE &&CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=25, CHAR_VALUE='4.0.3 M1' WHERE INFO_ID=17;
