SET CURRENT SCHEMA $CALM_SCHEMA;

ALTER TABLE REQUEST_HISTORY ADD MODIFIER_ID INTEGER DEFAULT -1 NOT NULL;

ALTER TABLE REQUEST_HISTORY ADD CONSTRAINT REQHIS_FK23 FOREIGN KEY (MODIFIER_ID)
	REFERENCES $NF_SCHEMA.RESOURCE (RESOURCE_ID);

SELECT 'CALL SYSPROC.DSNUTILU(''REPAIR'',''CURRENT'',''REPAIR SET TABLESPACE ' || 'RIDW' || '.' || TSNAME  || ' NOCHECKPEND'',?)' FROM SYSIBM.SYSTABLES WHERE NAME ='REQUEST_HISTORY' AND CREATOR='$CALM_SCHEMA' AND DBNAME='RIDW';

DROP VIEW VW_RQST_HISTORY;

CREATE VIEW VW_RQST_HISTORY (REQUEST_ID, ACTIVATE_DATE, ASSIGNED_DATE, CLOSED_DATE, COMPONENT_ID, COMPONENT_NAME, CREATION_DATE, CUSTOMER_PRIORITY, DUPLICATE_DATE, EXTERNAL_ID, FIXEDINRELEASE_ID, FIXED_IN_RELEASE_NAME, IS_BLOCKING, ITERATION_ID, ITERATION_NAME, TEAM_ID, TEAM_NAME, PLANNED_WORK, ACTUAL_WORK, COMMENT_COUNT, SUBSCRIBER_COUNT, STORY_POINTS, TAGS, NAME, PLATFORM, REQUEST_PRIORITY_ID, REQUEST_PRIORITY, REQUEST_PRIORITY_EXTERNAL_ID, PROJECT_ID, PROJECT_NAME, REFERENCE_ID, RELEASE_ID, FOUND_IN_RELEASE_NAME, REQUEST_CLASS_ID, REQUEST_CLASS, REQUEST_HISTORY_ID, OWNER_ID, REQUEST_RESPONSIBLE, REQUEST_SOURCE, REQUEST_STATE_ID, REQUEST_STATE, REQUEST_STATE_EXTERNAL_ID, REQUEST_RESOLUTION_ID, REQUEST_RESOLUTION, REQUEST_RESOLUTION_EXTERNAL_ID, RESOLVED_DATE, REQUEST_SEVERITY_ID, REQUEST_SEVERITY, REQUEST_SEVERITY_EXTERNAL_ID, SLOC_CHANGE, REQUEST_STATUS_ID, REQUEST_STATUS, REQUEST_STATUS_EXTERNAL_ID, SUBMIT_DATE, URL, 
DUE_DATE, CREATOR_ID, CREATOR_NAME, MODIFIER_ID, MODIFIER_NAME, BUILD_ID, BUILD_NAME, PHASE_ID, PHASE_NAME, PROJECT_CATEGORY_ID, PROJECT_CATEGORY_NAME, EXTERNAL_KEY1, EXTERNAL_KEY2, REQUEST_TYPE_ID, REQUEST_TYPE, REQUEST_TYPE_EXTERNAL_ID, REQUEST_CATEGORY_ID, REQUEST_CATEGORY_NAME, RESOLVER_ID, RESOLVER_NAME, SUMMARY, REC_DATETIME, ISSOFTDELETED, PREV_REQUEST_HISTORY_ID) AS
 (SELECT R.REQUEST_ID, R.ACTIVATE_DATE, R.ASSIGNED_DATE, R.CLOSED_DATE, R.COMPONENT_ID, C.NAME AS COMPONENT_NAME, R.CREATION_DATE, R.CUSTOMER_PRIORITY, R.DUPLICATE_DATE, R.EXTERNAL_ID, R.FIXEDINRELEASE_ID, RL.NAME AS FIXED_IN_RELEASE_NAME, R.IS_BLOCKING, R.ITERATION_ID, I.NAME AS ITERATION_NAME, R.TEAM_ID, T.NAME AS TEAM_NAME, R.PLANNED_WORK, R.ACTUAL_WORK, R.COMMENT_COUNT, R.SUBSCRIBER_COUNT, R.STORY_POINTS, R.TAGS, R.NAME, R.PLATFORM, R.REQUEST_PRIORITY_ID, RP.NAME AS REQUEST_PRIORITY, RP.EXTERNAL_ID AS REQUEST_PRIORITY_EXTERNAL_ID, R.PROJECT_ID, PJ.NAME AS PROJECT_NAME, R.REFERENCE_ID, R.RELEASE_ID, RL2.NAME AS FOUND_IN_RELEASE_NAME, 
 R.REQUEST_CLASS_ID, RQ.NAME AS REQUEST_CLASS, R.REQUEST_HISTORY_ID, R.OWNER_ID, PS.FULL_NAME AS REQUEST_RESPONSIBLE, R.REQUEST_SOURCE, R.REQUEST_STATE_ID, RST.NAME AS REQUEST_STATE, RST.EXTERNAL_ID AS REQUEST_STATE_EXTERNAL_ID, R.REQUEST_RESOLUTION_ID, RRES.NAME AS REQUEST_RESOLUTION, RRES.EXTERNAL_ID AS REQUEST_RESOLUTION_EXTERNAL_ID, R.RESOLVED_DATE, R.REQUEST_SEVERITY_ID, RSEV.NAME AS REQUEST_SEVERITY, RSEV.EXTERNAL_ID AS REQUEST_SEVERITY_EXTERNAL_ID, R.SLOC_CHANGE, R.REQUEST_STATUS_ID, RSTU.NAME AS REQUEST_STATUS, RSTU.EXTERNAL_ID AS  REQUEST_STATUS_EXTERNAL_ID, R.SUBMIT_DATE, R.URL, 
 R.DUE_DATE, R.CREATOR_ID, RES.FULL_NAME AS CREATOR_NAME, R.MODIFIER_ID, RM.FULL_NAME AS MODIFIER_NAME, R.BUILD_ID, B.NAME AS BUILD_NAME, R.PHASE_ID, PH.NAME AS PHASE_NAME, R.PROJECT_CATEGORY_ID, PC.NAME AS PROJECT_CATEGORY_NAME, R.EXTERNAL_KEY1, R.EXTERNAL_KEY2, R.REQUEST_TYPE_ID, RT.NAME REQUEST_TYPE, RT.EXTERNAL_ID AS REQUEST_TYPE_EXTERNAL_ID, R.REQUEST_CATEGORY_ID, RC.NAME AS REQUEST_CATEGORY_NAME, R.RESOLVER_ID, RS.FULL_NAME AS RESOLVER_NAME, R.SUMMARY, R.REC_DATETIME, R.ISSOFTDELETED, R.PREV_REQUEST_HISTORY_ID
  FROM $CALM_SCHEMA.REQUEST_HISTORY R 
  JOIN $NF_SCHEMA.ITERATION I ON I.ITERATION_ID=R.ITERATION_ID 
  JOIN $NF_SCHEMA.TEAM T ON T.TEAM_ID=R.TEAM_ID
  JOIN $NF_SCHEMA.PROJECT PJ ON PJ.PROJECT_ID=R.PROJECT_ID 
  JOIN $NF_SCHEMA.COMPONENT C ON C.COMPONENT_ID=R.COMPONENT_ID 
  JOIN $NF_SCHEMA.RELEASE RL ON RL.RELEASE_ID=R.FIXEDINRELEASE_ID 
  JOIN $NF_SCHEMA.RELEASE RL2 ON RL2.RELEASE_ID=R.RELEASE_ID 
  JOIN $NF_SCHEMA.REQUEST_CLASSIFICATION RQ ON RQ.REQUEST_CLASS_ID=R.REQUEST_CLASS_ID
  JOIN $NF_SCHEMA.REQUEST_CATEGORY RC ON RC.REQUEST_CATEGORY_ID=R.REQUEST_CATEGORY_ID
  JOIN $NF_SCHEMA.BUILD B ON B.BUILD_ID=R.BUILD_ID
  JOIN $NF_SCHEMA.PHASE PH ON PH.PHASE_ID=R.PHASE_ID
  JOIN $NF_SCHEMA.PROJECT_CATEGORY PC ON PC.PROJECT_CATEGORY_ID=R.PROJECT_CATEGORY_ID
  JOIN $NF_SCHEMA.RESOURCE PS ON PS.RESOURCE_ID=R.OWNER_ID
  JOIN $NF_SCHEMA.RESOURCE RS ON RS.RESOURCE_ID=R.RESOLVER_ID
  JOIN $NF_SCHEMA.RESOURCE RES ON RES.RESOURCE_ID=R.CREATOR_ID
  JOIN $NF_SCHEMA.RESOURCE RM ON RM.RESOURCE_ID=R.MODIFIER_ID
  JOIN $NF_SCHEMA.REQUEST_STATE RST ON RST.REQUEST_STATE_ID=R.REQUEST_STATE_ID
  JOIN $NF_SCHEMA.REQUEST_STATUS RSTU ON RSTU.REQUEST_STATUS_ID=R.REQUEST_STATUS_ID
  JOIN $NF_SCHEMA.REQUEST_PRIORITY RP ON RP.REQUEST_PRIORITY_ID=R.REQUEST_PRIORITY_ID
  JOIN $NF_SCHEMA.REQUEST_RESOLUTION RRES ON RRES.REQUEST_RESOLUTION_ID=R.REQUEST_RESOLUTION_ID
  JOIN $NF_SCHEMA.REQUEST_SEVERITY RSEV ON RSEV.REQUEST_SEVERITY_ID=R.REQUEST_SEVERITY_ID
  JOIN $NF_SCHEMA.REQUEST_TYPE RT ON RT.REQUEST_TYPE_ID=R.REQUEST_TYPE_ID);
  
GRANT SELECT ON $CALM_SCHEMA.VW_RQST_HISTORY TO $REP_USER;

CREATE TABLE REQUEST_APPROVAL_TYPE (
        REQUEST_APPROVAL_TYPE_ID INTEGER NOT NULL,
        NAME VARCHAR(255) DEFAULT 'Approval Type Name Missing' NOT NULL,
		REFERENCE_ID VARCHAR(50),
		EXTERNAL_ID VARCHAR(100),
		PROJECT_ID INTEGER DEFAULT -1 NOT NULL,
		URL VARCHAR(2048),
		EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,
		EXTERNAL_KEY2 CHAR(40) DEFAULT '-1' NOT NULL,
		SOURCE_ID VARCHAR (36) DEFAULT '-1' NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
) IN DATABASE $DBNAME;

CREATE TABLE REQUEST_APPROVAL_STATE (
        REQUEST_APPROVAL_STATE_ID INTEGER NOT NULL,
        NAME VARCHAR(255) DEFAULT 'Approval State Name Missing' NOT NULL,
		REFERENCE_ID VARCHAR(50),
		EXTERNAL_ID VARCHAR(100),
		PROJECT_ID INTEGER DEFAULT -1 NOT NULL,
		URL VARCHAR(2048),
		EXTERNAL_KEY1 INTEGER DEFAULT -1 NOT NULL,
		EXTERNAL_KEY2 CHAR(40) DEFAULT '-1' NOT NULL,
		SOURCE_ID VARCHAR (36) DEFAULT '-1' NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
) IN DATABASE $DBNAME;

CREATE TABLE REQUEST_APPROVAL_DESCRIPTOR (
        REQUEST_APPROVAL_DESCRIPTOR_ID INTEGER NOT NULL,
        REQUEST_ID INTEGER DEFAULT -1 NOT NULL,
        REQUEST_APPROVAL_TYPE_ID INTEGER DEFAULT -1 NOT NULL,
		CUMULATIVE_STATE_ID INTEGER DEFAULT -1 NOT NULL,
		NAME VARCHAR(255),
		DUE_DATE TIMESTAMP,
		CUMULATIVE_STATE_DATE TIMESTAMP,
		EXTERNAL_KEY1 INT  DEFAULT -1 NOT NULL,
		EXTERNAL_KEY2 CHAR(40) DEFAULT '-1' NOT NULL,
		SOURCE_ID VARCHAR (36) DEFAULT '-1' NOT NULL,
		URL VARCHAR(2048),
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
) IN DATABASE $DBNAME;

CREATE TABLE REQUEST_APPROVAL (
		REQUEST_APPROVAL_ID INTEGER NOT NULL,
        REQUEST_APPROVAL_DESCRIPTOR_ID INTEGER DEFAULT -1 NOT NULL,
        REQUEST_APPROVAL_STATE_ID INTEGER DEFAULT -1 NOT NULL,
		APPROVER_ID INTEGER DEFAULT -1 NOT NULL,
		STATE_DATE TIMESTAMP,
		EXTERNAL_KEY1 INT  DEFAULT -1 NOT NULL,
		EXTERNAL_KEY2 CHAR(40) DEFAULT '-1' NOT NULL,
		SOURCE_ID VARCHAR (36) DEFAULT '-1' NOT NULL,
		URL VARCHAR(2048),
		REC_DATETIME TIMESTAMP DEFAULT NOT NULL,
		ISSOFTDELETED SMALLINT DEFAULT NOT NULL
) IN DATABASE $DBNAME;

CREATE INDEX RQSAPDS_IDX1 ON REQUEST_APPROVAL_DESCRIPTOR (EXTERNAL_KEY2 ASC);

CREATE INDEX RQSAPPR_IDX1 ON REQUEST_APPROVAL (EXTERNAL_KEY2 ASC);

ALTER TABLE REQUEST_APPROVAL_TYPE ADD PRIMARY KEY (REQUEST_APPROVAL_TYPE_ID);

ALTER TABLE REQUEST_APPROVAL_STATE ADD PRIMARY KEY (REQUEST_APPROVAL_STATE_ID);

ALTER TABLE REQUEST_APPROVAL_DESCRIPTOR ADD PRIMARY KEY (REQUEST_APPROVAL_DESCRIPTOR_ID);

ALTER TABLE REQUEST_APPROVAL ADD PRIMARY KEY (REQUEST_APPROVAL_ID);

ALTER TABLE REQUEST_APPROVAL_TYPE ADD CONSTRAINT RQSAPTP_FK1 FOREIGN KEY (PROJECT_ID)
	REFERENCES $NF_SCHEMA.PROJECT (PROJECT_ID);

ALTER TABLE REQUEST_APPROVAL_STATE ADD CONSTRAINT RQSAPST_FK1 FOREIGN KEY (PROJECT_ID)
	REFERENCES $NF_SCHEMA.PROJECT (PROJECT_ID);

ALTER TABLE REQUEST_APPROVAL_DESCRIPTOR ADD CONSTRAINT RQSAPDS_FK1 FOREIGN KEY (REQUEST_ID)
	REFERENCES $NF_SCHEMA.REQUEST (REQUEST_ID);

ALTER TABLE REQUEST_APPROVAL_DESCRIPTOR ADD CONSTRAINT RQSAPDS_FK2 FOREIGN KEY (REQUEST_APPROVAL_TYPE_ID)
	REFERENCES $CALM_SCHEMA.REQUEST_APPROVAL_TYPE (REQUEST_APPROVAL_TYPE_ID);

ALTER TABLE REQUEST_APPROVAL_DESCRIPTOR ADD CONSTRAINT RQSAPDS_FK3 FOREIGN KEY (CUMULATIVE_STATE_ID)
	REFERENCES $CALM_SCHEMA.REQUEST_APPROVAL_STATE (REQUEST_APPROVAL_STATE_ID);

ALTER TABLE REQUEST_APPROVAL ADD CONSTRAINT RQSAPPR_FK1 FOREIGN KEY (REQUEST_APPROVAL_DESCRIPTOR_ID)
	REFERENCES $CALM_SCHEMA.REQUEST_APPROVAL_DESCRIPTOR (REQUEST_APPROVAL_DESCRIPTOR_ID) ON DELETE CASCADE;

ALTER TABLE REQUEST_APPROVAL ADD CONSTRAINT RQSAPPR_FK2 FOREIGN KEY (REQUEST_APPROVAL_STATE_ID)
	REFERENCES $CALM_SCHEMA.REQUEST_APPROVAL_STATE (REQUEST_APPROVAL_STATE_ID);

ALTER TABLE REQUEST_APPROVAL ADD CONSTRAINT RQSAPPR_FK3 FOREIGN KEY (APPROVER_ID)
	REFERENCES $NF_SCHEMA.RESOURCE (RESOURCE_ID);

CREATE TRIGGER TRG_RQSAPDS
	AFTER UPDATE OF REC_DATETIME ON $NF_SCHEMA.REQUEST
	REFERENCING  NEW AS NEWROW 
		OLD AS OLDROW 
	FOR EACH ROW MODE DB2SQL 
BEGIN ATOMIC 
	DELETE FROM REQUEST_APPROVAL_DESCRIPTOR WHERE REQUEST_ID=NEWROW.REQUEST_ID; END;

CREATE VIEW VW_REQUEST_APPROVAL_TYPE (REQUEST_APPROVAL_TYPE_ID, NAME, REFERENCE_ID, EXTERNAL_ID, PROJECT_ID, PROJECT_NAME, URL, EXTERNAL_KEY1, EXTERNAL_KEY2,
SOURCE_ID, REC_DATETIME, ISSOFTDELETED) AS
 (SELECT RT.REQUEST_APPROVAL_TYPE_ID, RT.NAME, RT.REFERENCE_ID, RT.EXTERNAL_ID, RT.PROJECT_ID, P.NAME AS PROJECT_NAME, RT.URL, RT.EXTERNAL_KEY1, RT.EXTERNAL_KEY2,
 RT.SOURCE_ID, RT.REC_DATETIME, RT.ISSOFTDELETED
  FROM $CALM_SCHEMA.REQUEST_APPROVAL_TYPE RT
  JOIN $NF_SCHEMA.PROJECT P ON RT.PROJECT_ID = P.PROJECT_ID);

CREATE VIEW VW_REQUEST_APPROVAL_STATE (REQUEST_APPROVAL_STATE_ID, NAME, REFERENCE_ID, EXTERNAL_ID, PROJECT_ID, PROJECT_NAME, URL, EXTERNAL_KEY1, EXTERNAL_KEY2,
SOURCE_ID, REC_DATETIME, ISSOFTDELETED) AS
 (SELECT RS.REQUEST_APPROVAL_STATE_ID, RS.NAME, RS.REFERENCE_ID, RS.EXTERNAL_ID, RS.PROJECT_ID, P.NAME AS PROJECT_NAME, RS.URL, RS.EXTERNAL_KEY1, RS.EXTERNAL_KEY2,
 RS.SOURCE_ID, RS.REC_DATETIME, RS.ISSOFTDELETED
  FROM $CALM_SCHEMA.REQUEST_APPROVAL_STATE RS
  JOIN $NF_SCHEMA.PROJECT P ON RS.PROJECT_ID = P.PROJECT_ID);
  
CREATE VIEW VW_REQUEST_APPROVAL_DESCRIPTOR (REQUEST_APPROVAL_DESCRIPTOR_ID, REQUEST_ID, SUMMARY, PROJECT_ID, PROJECT_NAME, REQUEST_APPROVAL_TYPE_ID, REQUEST_APPROVAL_TYPE_NAME,
CUMULATIVE_STATE_ID, CUMULATIVE_STATE_NAME, NAME, DUE_DATE, CUMULATIVE_STATE_DATE, EXTERNAL_KEY1, EXTERNAL_KEY2, SOURCE_ID, URL, REC_DATETIME, ISSOFTDELETED) AS
 (SELECT RAD.REQUEST_APPROVAL_DESCRIPTOR_ID, RAD.REQUEST_ID, R.SUMMARY, R.PROJECT_ID, P.NAME AS PROJECT_NAME, RAD.REQUEST_APPROVAL_TYPE_ID, RT.NAME AS REQUEST_APPROVAL_TYPE_NAME,
 RAD.CUMULATIVE_STATE_ID, RS.NAME AS CUMULATIVE_STATE_NAME, RAD.NAME, RAD.DUE_DATE, RAD.CUMULATIVE_STATE_DATE, RAD.EXTERNAL_KEY1,
 RAD.EXTERNAL_KEY2, RAD.SOURCE_ID, RAD.URL, RAD.REC_DATETIME, RAD.ISSOFTDELETED 
  FROM $CALM_SCHEMA.REQUEST_APPROVAL_DESCRIPTOR RAD
  JOIN $NF_SCHEMA.REQUEST R ON RAD.REQUEST_ID = R.REQUEST_ID
  JOIN $NF_SCHEMA.PROJECT P ON R.PROJECT_ID = P.PROJECT_ID
  JOIN $CALM_SCHEMA.REQUEST_APPROVAL_TYPE RT ON RAD.REQUEST_APPROVAL_TYPE_ID = RT.REQUEST_APPROVAL_TYPE_ID
  JOIN $CALM_SCHEMA.REQUEST_APPROVAL_STATE RS ON RAD.CUMULATIVE_STATE_ID = RS.REQUEST_APPROVAL_STATE_ID);

CREATE VIEW VW_REQUEST_APPROVAL (REQUEST_APPROVAL_ID, REQUEST_APPROVAL_DESCRIPTOR_ID, RQST_APPROVAL_DESCRIPTOR_NAME, CUMULATIVE_STATE_ID, 
CUMULATIVE_STATE_NAME, PROJECT_ID, PROJECT_NAME, REQUEST_APPROVAL_STATE_ID, REQUEST_APPROVAL_STATE_NAME, APPROVER_ID, APPROVER_NAME, STATE_DATE, EXTERNAL_KEY1, 
EXTERNAL_KEY2, SOURCE_ID, URL, REC_DATETIME, ISSOFTDELETED) AS
 (SELECT RA.REQUEST_APPROVAL_ID, RA.REQUEST_APPROVAL_DESCRIPTOR_ID, RAD.NAME AS RQST_APPROVAL_DESCRIPTOR_NAME, RAD.CUMULATIVE_STATE_ID, 
 RSD.NAME AS CUMULATIVE_STATE_NAME, R.PROJECT_ID, P.NAME AS PROJECT_NAME, RA.REQUEST_APPROVAL_STATE_ID, RS.NAME AS REQUEST_APPROVAL_STATE_NAME, RA.APPROVER_ID, RE.FULL_NAME AS APPROVER_NAME, 
 RA.STATE_DATE, RA.EXTERNAL_KEY1, RA.EXTERNAL_KEY2, RA.SOURCE_ID, RA.URL, RA.REC_DATETIME, RA.ISSOFTDELETED
  FROM $CALM_SCHEMA.REQUEST_APPROVAL RA
  JOIN $CALM_SCHEMA.REQUEST_APPROVAL_DESCRIPTOR RAD ON RA.REQUEST_APPROVAL_DESCRIPTOR_ID = RAD.REQUEST_APPROVAL_DESCRIPTOR_ID
  JOIN $NF_SCHEMA.REQUEST R ON RAD.REQUEST_ID = R.REQUEST_ID
  JOIN $NF_SCHEMA.PROJECT P ON R.PROJECT_ID = P.PROJECT_ID
  JOIN $CALM_SCHEMA.REQUEST_APPROVAL_STATE RSD ON RAD.CUMULATIVE_STATE_ID = RSD.REQUEST_APPROVAL_STATE_ID
  JOIN $CALM_SCHEMA.REQUEST_APPROVAL_STATE RS ON RA.REQUEST_APPROVAL_STATE_ID = RS.REQUEST_APPROVAL_STATE_ID
  JOIN $NF_SCHEMA.RESOURCE RE ON RA.APPROVER_ID = RE.RESOURCE_ID);

GRANT SELECT ON $CALM_SCHEMA.VW_REQUEST_APPROVAL_TYPE TO $REP_USER;
GRANT SELECT ON $CALM_SCHEMA.VW_REQUEST_APPROVAL_STATE TO $REP_USER;
GRANT SELECT ON $CALM_SCHEMA.VW_REQUEST_APPROVAL_DESCRIPTOR TO $REP_USER;
GRANT SELECT ON $CALM_SCHEMA.VW_REQUEST_APPROVAL TO $REP_USER;

INSERT INTO REQUEST_APPROVAL_TYPE (REQUEST_APPROVAL_TYPE_ID, NAME) VALUES (-1,'Info not available');
INSERT INTO REQUEST_APPROVAL_STATE (REQUEST_APPROVAL_STATE_ID, NAME) VALUES (-1,'Info not available');
INSERT INTO REQUEST_APPROVAL_DESCRIPTOR (REQUEST_APPROVAL_DESCRIPTOR_ID, NAME) VALUES (-1,'Info not available');

UPDATE $CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=26, CHAR_VALUE='4.0.3 M3' WHERE INFO_ID=17;
