SET CURRENT SCHEMA $CONFIG_SCHEMA;

INSERT INTO SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 6 AS INFO_ID,'VERSION' AS NAME,'Insight Warehouse Version' AS DISPLAY_NAME,1 AS INT_VALUE,'1.0' AS CHAR_VALUE FROM SYSIBM.SYSDUMMY1 WHERE NOT EXISTS(SELECT INFO_ID FROM SYSCONFIG_INFO WHERE INFO_ID=6);

INSERT INTO SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 7 AS INFO_ID,'UPDATE_TARGET' AS NAME,'Insight Warehouse Update' AS DISPLAY_NAME,0 AS INT_VALUE,'2.0' AS CHAR_VALUE FROM SYSIBM.SYSDUMMY1 WHERE NOT EXISTS(SELECT INFO_ID FROM SYSCONFIG_INFO WHERE INFO_ID=7);

UPDATE $CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0.5' WHERE INFO_ID=7;

MERGE INTO $CONFIG_SCHEMA.SYSCONFIG_INFO AS M USING (SELECT 8 AS INFO_ID,'MIGRATION_STATUS' AS NAME,'Insight Warehouse Migration Status' AS DISPLAY_NAME,0 AS INT_VALUE,'' AS CHAR_VALUE FROM SYSIBM.SYSDUMMY1) AS MM ON M.INFO_ID=MM.INFO_ID WHEN MATCHED THEN UPDATE SET M.NAME=MM.NAME,M.DISPLAY_NAME=MM.DISPLAY_NAME,M.INT_VALUE=MM.INT_VALUE,M.CHAR_VALUE=MM.CHAR_VALUE,M.REC_DATETIME=CURRENT TIMESTAMP WHEN NOT MATCHED THEN INSERT (INFO_ID,NAME,DISPLAY_NAME,INT_VALUE) VALUES(8,'MIGRATION_STATUS','Insight Warehouse Migration Status',0);
MERGE INTO $CONFIG_SCHEMA.SYSCONFIG_INFO AS M USING (SELECT  18 AS INFO_ID,'MINOR_VERSION' AS NAME,'Insight Warehouse Minor Version' AS DISPLAY_NAME,12 AS INT_VALUE,'2.0.5 S1' AS CHAR_VALUE FROM SYSIBM.SYSDUMMY1) AS MM ON M.INFO_ID=MM.INFO_ID WHEN MATCHED THEN UPDATE SET M.NAME=MM.NAME,M.DISPLAY_NAME=MM.DISPLAY_NAME,M.INT_VALUE=MM.INT_VALUE,M.CHAR_VALUE=MM.CHAR_VALUE,M.REC_DATETIME=CURRENT TIMESTAMP WHEN NOT MATCHED THEN INSERT (INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) VALUES (18,'MINOR_VERSION','Insight Warehouse Minor Version',12,'2.0.5 S1');
MERGE INTO $CONFIG_SCHEMA.SYSCONFIG_INFO AS M USING (SELECT  9 AS INFO_ID,'DATA_TRUNCATION' AS NAME,'Interpreted as do not compute or delete data with dates earlier or equal to the value set' AS DISPLAY_NAME,1 AS INT_VALUE,'1899-12-31' AS CHAR_VALUE FROM SYSIBM.SYSDUMMY1) AS MM ON M.INFO_ID=MM.INFO_ID WHEN MATCHED THEN UPDATE SET M.NAME=MM.NAME,M.DISPLAY_NAME=MM.DISPLAY_NAME,M.INT_VALUE=MM.INT_VALUE WHEN NOT MATCHED THEN INSERT (INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) VALUES (9,'DATA_TRUNCATION','Interpreted as do not compute or delete data with dates earlier or equal to the value set',1,'1899-12-31');

CREATE TABLE $NF_SCHEMA.REQUIREMENT_PTEXT (
		REQUIREMENT_ID INTEGER NOT NULL,
		PTEXT VARCHAR(4000) NOT NULL
) IN VNF_32K INDEX IN VNF_IDX;

ALTER TABLE $NF_SCHEMA.REQUIREMENT_PTEXT ADD CONSTRAINT RQRMENT_PT_PK PRIMARY KEY (REQUIREMENT_ID);

ALTER TABLE $NF_SCHEMA.REQUIREMENT_PTEXT ADD CONSTRAINT RQRMENT_PT_FK1 FOREIGN KEY (REQUIREMENT_ID)
	REFERENCES $NF_SCHEMA.REQUIREMENT (REQUIREMENT_ID);

DROP VIEW $STAR_SCHEMA.VW_REQUIREMENT;

CREATE VIEW $STAR_SCHEMA.VW_REQUIREMENT (COMPONENT_ID, COMPONENT_NAME, CREATION_DATE, CUSTOMER_PRIORITY, DIFFICULTY, EXTERNAL_ID, NAME, PLATFORM, PRIORITY, PROJECT_ID, PROJECT_NAME, REFERENCE_ID, RELEASE_ID, RELEASE_NAME, REQUIREMENT_CLASS_ID, REQUIREMENT_CLASS_NAME, REQUIREMENT_ID, OWNER_ID, RESPONSIBLE_NAME, REQUIREMENT_STATE, REVISION_NUMBER, STABILITY, STATUS, URL,
ACTUAL_ITERATION_ID,ACTUAL_ITERATION_NAME,PLANNED_ITERATION_ID,PLANNED_ITERATION_NAME,REQUIREMENT_TYPE,REVISION_DATE,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED, PRIMARY_TEXT) AS
 (SELECT R.COMPONENT_ID, C.NAME AS COMPONENT_NAME, R.CREATION_DATE, R.CUSTOMER_PRIORITY, R.DIFFICULTY, R.EXTERNAL_ID, R.NAME, R.PLATFORM, R.PRIORITY, R.PROJECT_ID, PJ.NAME AS PROJECT_NAME, R.REFERENCE_ID, R.RELEASE_ID, RL.NAME AS RELEASE_NAME, R.REQUIREMENT_CLASS_ID, RC.NAME AS REQUIREMENT_CLASS_NAME, R.REQUIREMENT_ID, R.OWNER_ID,P.FULL_NAME AS RESPONSIBLE_NAME, R.REQUIREMENT_STATE, R.REVISION_NUMBER, R.STABILITY, R.STATUS, R.URL,
 R.ACTUAL_ITERATION_ID,AC.NAME AS ACTUAL_ITERATION_NAME,R.PLANNED_ITERATION_ID,PL.NAME AS PLANNED_ITERATION_NAME,R.REQUIREMENT_TYPE,R.REVISION_DATE,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2,R.REC_DATETIME,R.ISSOFTDELETED, COALESCE(PT.PTEXT, 'No primary text')
  FROM $NF_SCHEMA.REQUIREMENT R
  JOIN $NF_SCHEMA.COMPONENT C ON C.COMPONENT_ID =R.COMPONENT_ID
  JOIN $NF_SCHEMA.PROJECT PJ ON PJ.PROJECT_ID=R.PROJECT_ID
  JOIN $NF_SCHEMA.RELEASE RL ON RL.RELEASE_ID=R.RELEASE_ID
  JOIN $NF_SCHEMA.REQUIREMENT_CLASSIFICATION RC ON RC.REQUIREMENT_CLASS_ID=R.REQUIREMENT_CLASS_ID
  JOIN $NF_SCHEMA.RESOURCE P ON P.RESOURCE_ID=R.OWNER_ID
  JOIN $NF_SCHEMA.ITERATION AC ON AC.ITERATION_ID=R.ACTUAL_ITERATION_ID
  JOIN $NF_SCHEMA.ITERATION PL ON PL.ITERATION_ID=R.PLANNED_ITERATION_ID
  LEFT JOIN $NF_SCHEMA.REQUIREMENT_PTEXT PT ON PT.REQUIREMENT_ID = R.REQUIREMENT_ID);

GRANT SELECT ON $STAR_SCHEMA.VW_REQUIREMENT TO USER REPUSER;

CREATE VIEW $STAR_SCHEMA.VW_COLL_MEMBER_RQRMNT (COLLECTION_ID, COLLECTION_NAME, CREATION_DATE, CUSTOMER_PRIORITY, DIFFICULTY, EXTERNAL_ID, NAME, PLATFORM, PRIORITY, REFERENCE_ID, RELEASE_ID, RELEASE_NAME, REQUIREMENT_CLASS_ID, REQUIREMENT_CLASS_NAME, REQUIREMENT_ID, OWNER_ID, RESPONSIBLE_NAME, REQUIREMENT_STATE, REVISION_NUMBER, STABILITY, STATUS, URL,
ACTUAL_ITERATION_ID,ACTUAL_ITERATION_NAME,PLANNED_ITERATION_ID,PLANNED_ITERATION_NAME,REQUIREMENT_TYPE,REVISION_DATE,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED, PRIMARY_TEXT) AS
 (SELECT RCOLL.REQUIREMENT_COLLECTION_ID AS COLLECTION_ID, RCOLL.NAME AS COLLECTION_NAME, R.CREATION_DATE, R.CUSTOMER_PRIORITY, R.DIFFICULTY, R.EXTERNAL_ID, R.NAME, R.PLATFORM, R.PRIORITY, R.REFERENCE_ID, R.RELEASE_ID, RL.NAME AS RELEASE_NAME, R.REQUIREMENT_CLASS_ID, RC.NAME AS REQUIREMENT_CLASS_NAME, R.REQUIREMENT_ID, R.OWNER_ID,P.FULL_NAME AS RESPONSIBLE_NAME, R.REQUIREMENT_STATE, R.REVISION_NUMBER, R.STABILITY, R.STATUS, R.URL,
 R.ACTUAL_ITERATION_ID,AC.NAME AS ACTUAL_ITERATION_NAME,R.PLANNED_ITERATION_ID,PL.NAME AS PLANNED_ITERATION_NAME,R.REQUIREMENT_TYPE,R.REVISION_DATE,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2,R.REC_DATETIME,R.ISSOFTDELETED, COALESCE(PT.PTEXT, 'No primary text')
  FROM $NF_SCHEMA.REQUIREMENT R
  JOIN $NF_SCHEMA.REQUICOL_REQUIREMENT_LOOKUP CLOOK ON CLOOK.REQUIREMENT_ID=R.REQUIREMENT_ID
  JOIN $NF_SCHEMA.REQUIREMENT_COLLECTION RCOLL ON RCOLL.REQUIREMENT_COLLECTION_ID=CLOOK.REQUIREMENT_COLLECTION_ID
  JOIN $NF_SCHEMA.RELEASE RL ON RL.RELEASE_ID=R.RELEASE_ID
  JOIN $NF_SCHEMA.REQUIREMENT_CLASSIFICATION RC ON RC.REQUIREMENT_CLASS_ID=R.REQUIREMENT_CLASS_ID
  JOIN $NF_SCHEMA.RESOURCE P ON P.RESOURCE_ID=R.OWNER_ID
  JOIN $NF_SCHEMA.ITERATION AC ON AC.ITERATION_ID=R.ACTUAL_ITERATION_ID
  JOIN $NF_SCHEMA.ITERATION PL ON PL.ITERATION_ID=R.PLANNED_ITERATION_ID
  LEFT JOIN $NF_SCHEMA.REQUIREMENT_PTEXT PT ON PT.REQUIREMENT_ID = R.REQUIREMENT_ID); 

 GRANT SELECT ON $STAR_SCHEMA.VW_COLL_MEMBER_RQRMNT TO USER REPUSER;

CREATE TABLE $STAR_SCHEMA.D_COLLECTION_TYPE(
		COLLECTION_TYPE_ID INTEGER NOT NULL,
		NAME VARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL
) IN VSTR_32K INDEX IN VSTR_IDX;

CREATE TABLE $STAR_SCHEMA.D_REQUIREMENT_COLLECTION(
		COLLECTION_ID INTEGER NOT NULL,
		NAME VARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL
) IN VSTR_32K INDEX IN VSTR_IDX;

ALTER TABLE $STAR_SCHEMA.D_REQUIREMENT_COLLECTION ADD CONSTRAINT D_RQRCOLL_PK PRIMARY KEY	(COLLECTION_ID);

ALTER TABLE $STAR_SCHEMA.D_COLLECTION_TYPE ADD CONSTRAINT D_COLLTYPE_PK PRIMARY KEY	(COLLECTION_TYPE_ID);

CREATE TABLE $STAR_SCHEMA.F_C_COLLECTION_METRICS (
		REQ_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		OWNER_ID INTEGER NOT NULL,
		COLLECTION_TYPE_ID INTEGER NOT NULL,
		TOTAL_COLLECTIONS INTEGER DEFAULT 0 NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL 
	)
	IN VSTR_32K INDEX IN VSTR_IDX;

CREATE TABLE $STAR_SCHEMA.F_COLLECTION_METRICS (
		REQ_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		PROJECT_ID INTEGER NOT NULL,
		OWNER_ID INTEGER NOT NULL,
		COLLECTION_TYPE_ID INTEGER NOT NULL,
		TOTAL_COLLECTIONS INTEGER DEFAULT 0 NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL 
	)
	IN VSTR_32K INDEX IN VSTR_IDX;

CREATE TABLE $STAR_SCHEMA.H_COLLECTION_METRICS (
		REQ_METRIC_ID INTEGER NOT NULL,
		COLLECTION_ID INTEGER NOT NULL 	
	)
	IN VSTR_32K INDEX IN VSTR_IDX;

ALTER TABLE $STAR_SCHEMA.F_C_COLLECTION_METRICS ADD CONSTRAINT F_C_COLLMET_PK PRIMARY KEY (REQ_METRIC_ID);

ALTER TABLE $STAR_SCHEMA.F_COLLECTION_METRICS ADD CONSTRAINT F_COLLMET_PK PRIMARY KEY (REQ_METRIC_ID);

ALTER TABLE $STAR_SCHEMA.H_COLLECTION_METRICS ADD CONSTRAINT H_COLLMET_PK PRIMARY KEY (REQ_METRIC_ID, COLLECTION_ID);

ALTER TABLE $STAR_SCHEMA.F_C_COLLECTION_METRICS ADD CONSTRAINT F_C_COLLMET_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES $STAR_SCHEMA.D_DATE (DATE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_COLLECTION_METRICS ADD CONSTRAINT F_C_COLLMET_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES $STAR_SCHEMA.D_PROJECT (PROJECT_ID);

ALTER TABLE $STAR_SCHEMA.F_C_COLLECTION_METRICS ADD CONSTRAINT F_C_COLLMET_FK3 FOREIGN KEY (OWNER_ID)
	REFERENCES $STAR_SCHEMA.D_RESOURCE (RESOURCE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_COLLECTION_METRICS ADD CONSTRAINT F_C_COLLMET_FK4 FOREIGN KEY (COLLECTION_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_COLLECTION_TYPE (COLLECTION_TYPE_ID);

ALTER TABLE $STAR_SCHEMA.F_COLLECTION_METRICS ADD CONSTRAINT F_COLLMET_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES $STAR_SCHEMA.D_DATE (DATE_ID);

ALTER TABLE $STAR_SCHEMA.F_COLLECTION_METRICS ADD CONSTRAINT F_COLLMET_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES $STAR_SCHEMA.D_PROJECT (PROJECT_ID);

ALTER TABLE $STAR_SCHEMA.F_COLLECTION_METRICS ADD CONSTRAINT F_COLLMET_FK3 FOREIGN KEY (OWNER_ID)
	REFERENCES $STAR_SCHEMA.D_RESOURCE (RESOURCE_ID);

ALTER TABLE $STAR_SCHEMA.F_COLLECTION_METRICS ADD CONSTRAINT F_COLLMET_FK4 FOREIGN KEY (COLLECTION_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_COLLECTION_TYPE (COLLECTION_TYPE_ID);

ALTER TABLE $STAR_SCHEMA.H_COLLECTION_METRICS ADD CONSTRAINT H_COLLMET_FK1 FOREIGN KEY (COLLECTION_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_COLLECTION (COLLECTION_ID) ON DELETE CASCADE;

ALTER TABLE $STAR_SCHEMA.H_COLLECTION_METRICS ADD CONSTRAINT H_COLLMET_FK2 FOREIGN KEY (REQ_METRIC_ID)
	REFERENCES $STAR_SCHEMA.F_COLLECTION_METRICS (REQ_METRIC_ID) ON DELETE CASCADE;

CREATE TABLE $STAR_SCHEMA.F_C_RQRMNT_REF_METRICS_BYCOLL (
		REQ_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		COLLECTION_ID INTEGER NOT NULL,
		OWNER_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		STABILITY_ID INTEGER NOT NULL,
		DIFFICULTY_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		REQUIREMENT_TYPE_ID INTEGER NOT NULL,
		TOTAL_REQUIREMENT_REFERENCES INTEGER DEFAULT 0 NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL
	)
	IN VSTR_32K INDEX IN VSTR_IDX;

CREATE TABLE $STAR_SCHEMA.F_RQRMNT_REF_METRICS_BYCOLL (
		REQ_METRIC_ID INTEGER NOT NULL,
		DATE_ID INTEGER NOT NULL,
		COLLECTION_ID INTEGER NOT NULL,
		OWNER_ID INTEGER NOT NULL,
		STATE_ID INTEGER NOT NULL,
		STATUS_ID INTEGER NOT NULL,
		STABILITY_ID INTEGER NOT NULL,
		DIFFICULTY_ID INTEGER NOT NULL,
		PRIORITY_ID INTEGER NOT NULL,
		REQUIREMENT_TYPE_ID INTEGER NOT NULL,
		TOTAL_REQUIREMENT_REFERENCES INTEGER DEFAULT 0 NOT NULL,
		REC_DATETIME TIMESTAMP DEFAULT CURRENT TIMESTAMP NOT NULL
	)
	IN VSTR_32K INDEX IN VSTR_IDX;

CREATE TABLE $STAR_SCHEMA.H_RQRMNT_REF_METRICS_BYCOLL (
		REQ_METRIC_ID INTEGER NOT NULL,
		REQUIREMENT_ID INTEGER NOT NULL
	)
	IN VSTR_32K INDEX IN VSTR_IDX;

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_C_RQRFMT_PK PRIMARY KEY (REQ_METRIC_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_RQRFMT_PK PRIMARY KEY (REQ_METRIC_ID);

ALTER TABLE $STAR_SCHEMA.H_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT H_RQRFMT_PK PRIMARY KEY (REQ_METRIC_ID, REQUIREMENT_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_C_RQRFMET_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES $STAR_SCHEMA.D_DATE (DATE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_C_RQRFMET_FK2 FOREIGN KEY (COLLECTION_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_COLLECTION (COLLECTION_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_C_RQRFMET_FK3 FOREIGN KEY (STATUS_ID)
	REFERENCES $STAR_SCHEMA.D_STATUS (STATUS_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_C_RQRFMET_FK4 FOREIGN KEY (STABILITY_ID)
	REFERENCES $STAR_SCHEMA.D_STABILITY (STABILITY_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_C_RQRFMET_FK5 FOREIGN KEY (DIFFICULTY_ID)
	REFERENCES $STAR_SCHEMA.D_DIFFICULTY (DIFFICULTY_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_C_RQRFMET_FK6 FOREIGN KEY (STATE_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_STATE (STATE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_C_RQRFMET_FK7 FOREIGN KEY (OWNER_ID)
	REFERENCES $STAR_SCHEMA.D_RESOURCE (RESOURCE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_C_RQRFMET_FK8 FOREIGN KEY (PRIORITY_ID)
	REFERENCES $STAR_SCHEMA.D_PRIORITY (PRIORITY_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_C_RQRFMET_FK9 FOREIGN KEY (REQUIREMENT_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_RQRFMET_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES $STAR_SCHEMA.D_DATE (DATE_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_RQRFMET_FK2 FOREIGN KEY (COLLECTION_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_COLLECTION (COLLECTION_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_RQRFMET_FK3 FOREIGN KEY (STATUS_ID)
	REFERENCES $STAR_SCHEMA.D_STATUS (STATUS_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_RQRFMET_FK4 FOREIGN KEY (STABILITY_ID)
	REFERENCES $STAR_SCHEMA.D_STABILITY (STABILITY_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_RQRFMET_FK5 FOREIGN KEY (DIFFICULTY_ID)
	REFERENCES $STAR_SCHEMA.D_DIFFICULTY (DIFFICULTY_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_RQRFMET_FK6 FOREIGN KEY (STATE_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_STATE (STATE_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_RQRFMET_FK7 FOREIGN KEY (OWNER_ID)
	REFERENCES $STAR_SCHEMA.D_RESOURCE (RESOURCE_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_RQRFMET_FK8 FOREIGN KEY (PRIORITY_ID)
	REFERENCES $STAR_SCHEMA.D_PRIORITY (PRIORITY_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_RQRFMET_FK9 FOREIGN KEY (REQUIREMENT_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID);

ALTER TABLE $STAR_SCHEMA.H_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT HRQRFMET_FK1 FOREIGN KEY (REQ_METRIC_ID)
	REFERENCES $STAR_SCHEMA.F_C_RQRMNT_REF_METRICS_BYCOLL (REQ_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE $STAR_SCHEMA.H_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT HRQRFMET_FK2 FOREIGN KEY (REQUIREMENT_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT (REQUIREMENT_ID) ON DELETE CASCADE;

CREATE INDEX $STAR_SCHEMA.F_COLL_METR_IDX1 ON $STAR_SCHEMA.F_COLLECTION_METRICS (DATE_ID);
CREATE INDEX $STAR_SCHEMA.F_RQRF_COLL_IDX1 ON $STAR_SCHEMA.F_RQRMNT_REF_METRICS_BYCOLL (DATE_ID);

GRANT SELECT ON TABLE $STAR_SCHEMA.D_COLLECTION_TYPE TO USER REPUSER;
GRANT SELECT ON TABLE $STAR_SCHEMA.D_REQUIREMENT_COLLECTION TO USER REPUSER;
GRANT SELECT ON TABLE $STAR_SCHEMA.F_C_COLLECTION_METRICS TO USER REPUSER;
GRANT SELECT ON TABLE $STAR_SCHEMA.F_COLLECTION_METRICS TO USER REPUSER;
GRANT SELECT ON TABLE $STAR_SCHEMA.H_COLLECTION_METRICS TO USER REPUSER;
GRANT SELECT ON TABLE $STAR_SCHEMA.F_RQRMNT_REF_METRICS_BYCOLL TO USER REPUSER;
GRANT SELECT ON TABLE $STAR_SCHEMA.F_C_RQRMNT_REF_METRICS_BYCOLL TO USER REPUSER;
GRANT SELECT ON TABLE $STAR_SCHEMA.H_RQRMNT_REF_METRICS_BYCOLL TO USER REPUSER;

INSERT INTO $STAR_SCHEMA.D_COLLECTION_TYPE(COLLECTION_TYPE_ID,NAME) VALUES  (-1,'Info not available');
INSERT INTO $STAR_SCHEMA.D_REQUIREMENT_COLLECTION (COLLECTION_ID,NAME) VALUES (-1,'Info not available'); 

UPDATE $CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0.5' WHERE INFO_ID=6;
UPDATE $CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=1  WHERE INFO_ID=8;
UPDATE $CONFIG_SCHEMA.SYSCONFIG_INFO SET CHAR_VALUE='2.0.5 S1',INT_VALUE=12 WHERE INFO_ID=18;
