INSERT INTO $(CONFIG_SCHEMA).SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 6 AS INFO_ID,'VERSION' AS NAME,'Insight Warehouse Version' AS DISPLAY_NAME,1 AS INT_VALUE,'1.0' AS CHAR_VALUE WHERE NOT EXISTS(SELECT INFO_ID FROM $(CONFIG_SCHEMA).SYSCONFIG_INFO WHERE INFO_ID=6)
GO
INSERT INTO $(CONFIG_SCHEMA).SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 7 AS INFO_ID,'UPDATE_TARGET' AS NAME,'Insight Warehouse Update' AS DISPLAY_NAME,0 AS INT_VALUE,'2.0' AS CHAR_VALUE WHERE NOT EXISTS(SELECT INFO_ID FROM $(CONFIG_SCHEMA).SYSCONFIG_INFO WHERE INFO_ID=7)
GO

UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0.5' WHERE INFO_ID=7
GO

IF NOT EXISTS (SELECT INFO_ID FROM $(CONFIG_SCHEMA).SYSCONFIG_INFO WHERE INFO_ID=8) INSERT INTO $(CONFIG_SCHEMA).SYSCONFIG_INFO (INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 8 AS INFO_ID,'MIGRATION_STATUS' AS NAME,'Insight Warehouse Migration Status' AS DISPLAY_NAME,0 AS INT_VALUE,'' AS CHAR_VALUE ELSE UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET NAME='MIGRATION_STATUS',DISPLAY_NAME='Insight Warehouse Migration Status',INT_VALUE=0,CHAR_VALUE='' WHERE INFO_ID=8
GO
IF NOT EXISTS (SELECT INFO_ID FROM $(CONFIG_SCHEMA).SYSCONFIG_INFO WHERE INFO_ID=18) INSERT INTO $(CONFIG_SCHEMA).SYSCONFIG_INFO (INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT  18 AS INFO_ID,'MINOR_VERSION' AS NAME,'Insight Warehouse Minor Version' AS DISPLAY_NAME,12 AS INT_VALUE,'2.0.5 S1' AS CHAR_VALUE ELSE UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET NAME='MINOR_VERSION',DISPLAY_NAME='Insight Warehouse Minor Version',INT_VALUE=12,CHAR_VALUE='2.0.5 S1' WHERE INFO_ID=18
GO
IF NOT EXISTS (SELECT INFO_ID FROM $(CONFIG_SCHEMA).SYSCONFIG_INFO WHERE INFO_ID=9) INSERT INTO $(CONFIG_SCHEMA).SYSCONFIG_INFO (INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT  9 AS INFO_ID,'DATA_TRUNCATION' AS NAME,'Interpreted as do not compute or delete data with dates earlier or equal to the value set' AS DISPLAY_NAME,1 AS INT_VALUE,'1899-12-31' AS CHAR_VALUE ELSE UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET NAME='DATA_TRUNCATION',DISPLAY_NAME='Interpreted as do not compute or delete data with dates earlier or equal to the value set' ,INT_VALUE=1 WHERE INFO_ID=9
GO

CREATE TABLE $(NF_SCHEMA).REQUIREMENT_PTEXT (
		REQUIREMENT_ID INT NOT NULL,
		PTEXT NVARCHAR(4000) NOT NULL
) ON VNF_32K
GO

ALTER TABLE $(NF_SCHEMA).REQUIREMENT_PTEXT ADD CONSTRAINT RQRMENT_PT_PK PRIMARY KEY (REQUIREMENT_ID) ON  VNF_IDX
GO

ALTER TABLE $(NF_SCHEMA).REQUIREMENT_PTEXT ADD CONSTRAINT RQRMENT_PT_FK1 FOREIGN KEY (REQUIREMENT_ID)
	REFERENCES $(NF_SCHEMA).REQUIREMENT (REQUIREMENT_ID)
GO

DROP VIEW $(STAR_SCHEMA).VW_REQUIREMENT
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUIREMENT (COMPONENT_ID, COMPONENT_NAME, CREATION_DATE, CUSTOMER_PRIORITY, DIFFICULTY, EXTERNAL_ID, NAME, PLATFORM, PRIORITY, PROJECT_ID, PROJECT_NAME, REFERENCE_ID, RELEASE_ID, RELEASE_NAME, REQUIREMENT_CLASS_ID, REQUIREMENT_CLASS_NAME, REQUIREMENT_ID, OWNER_ID, RESPONSIBLE_NAME, REQUIREMENT_STATE, REVISION_NUMBER, STABILITY, STATUS, URL,
ACTUAL_ITERATION_ID,ACTUAL_ITERATION_NAME,PLANNED_ITERATION_ID,PLANNED_ITERATION_NAME,REQUIREMENT_TYPE,REVISION_DATE,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED, PRIMARY_TEXT) AS
 (SELECT R.COMPONENT_ID, C.NAME AS COMPONENT_NAME, R.CREATION_DATE, R.CUSTOMER_PRIORITY, R.DIFFICULTY, R.EXTERNAL_ID, R.NAME, R.PLATFORM, R.PRIORITY, R.PROJECT_ID, PJ.NAME AS PROJECT_NAME, R.REFERENCE_ID, R.RELEASE_ID, RL.NAME AS RELEASE_NAME, R.REQUIREMENT_CLASS_ID, RC.NAME AS REQUIREMENT_CLASS_NAME, R.REQUIREMENT_ID, R.OWNER_ID,P.FULL_NAME AS RESPONSIBLE_NAME, R.REQUIREMENT_STATE, R.REVISION_NUMBER, R.STABILITY, R.STATUS, R.URL,
 R.ACTUAL_ITERATION_ID,AC.NAME AS ACTUAL_ITERATION_NAME,R.PLANNED_ITERATION_ID,PL.NAME AS PLANNED_ITERATION_NAME,R.REQUIREMENT_TYPE,R.REVISION_DATE,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2,R.REC_DATETIME,R.ISSOFTDELETED, COALESCE(PT.PTEXT, 'No primary text')
  FROM  $(NF_SCHEMA).REQUIREMENT R
  JOIN  $(NF_SCHEMA).COMPONENT C ON C.COMPONENT_ID =R.COMPONENT_ID
  JOIN  $(NF_SCHEMA).PROJECT PJ ON PJ.PROJECT_ID=R.PROJECT_ID
  JOIN  $(NF_SCHEMA).RELEASE RL ON RL.RELEASE_ID=R.RELEASE_ID
  JOIN  $(NF_SCHEMA).REQUIREMENT_CLASSIFICATION RC ON RC.REQUIREMENT_CLASS_ID=R.REQUIREMENT_CLASS_ID
  JOIN  $(NF_SCHEMA).RESOURCE P ON P.RESOURCE_ID=R.OWNER_ID
  JOIN  $(NF_SCHEMA).ITERATION AC ON AC.ITERATION_ID=R.ACTUAL_ITERATION_ID
  JOIN  $(NF_SCHEMA).ITERATION PL ON PL.ITERATION_ID=R.PLANNED_ITERATION_ID
  LEFT JOIN $(NF_SCHEMA).REQUIREMENT_PTEXT PT ON PT.REQUIREMENT_ID = R.REQUIREMENT_ID)
GO

GRANT SELECT ON $(STAR_SCHEMA).VW_REQUIREMENT TO REPUSER
GO

CREATE VIEW $(STAR_SCHEMA).VW_COLL_MEMBER_RQRMNT (COLLECTION_ID, COLLECTION_NAME, CREATION_DATE, CUSTOMER_PRIORITY, DIFFICULTY, EXTERNAL_ID, NAME, PLATFORM, PRIORITY, REFERENCE_ID, RELEASE_ID, RELEASE_NAME, REQUIREMENT_CLASS_ID, REQUIREMENT_CLASS_NAME, REQUIREMENT_ID, OWNER_ID, RESPONSIBLE_NAME, REQUIREMENT_STATE, REVISION_NUMBER, STABILITY, STATUS, URL,
ACTUAL_ITERATION_ID,ACTUAL_ITERATION_NAME,PLANNED_ITERATION_ID,PLANNED_ITERATION_NAME,REQUIREMENT_TYPE,REVISION_DATE,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED, PRIMARY_TEXT) AS
 (SELECT RCOLL.REQUIREMENT_COLLECTION_ID AS COLLECTION_ID, RCOLL.NAME AS COLLECTION_NAME, R.CREATION_DATE, R.CUSTOMER_PRIORITY, R.DIFFICULTY, R.EXTERNAL_ID, R.NAME, R.PLATFORM, R.PRIORITY, R.REFERENCE_ID, R.RELEASE_ID, RL.NAME AS RELEASE_NAME, R.REQUIREMENT_CLASS_ID, RC.NAME AS REQUIREMENT_CLASS_NAME, R.REQUIREMENT_ID, R.OWNER_ID,P.FULL_NAME AS RESPONSIBLE_NAME, R.REQUIREMENT_STATE, R.REVISION_NUMBER, R.STABILITY, R.STATUS, R.URL,
 R.ACTUAL_ITERATION_ID,AC.NAME AS ACTUAL_ITERATION_NAME,R.PLANNED_ITERATION_ID,PL.NAME AS PLANNED_ITERATION_NAME,R.REQUIREMENT_TYPE,R.REVISION_DATE,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2,R.REC_DATETIME,R.ISSOFTDELETED, COALESCE(PT.PTEXT, 'No primary text')
  FROM $(NF_SCHEMA).REQUIREMENT R
  JOIN $(NF_SCHEMA).REQUICOL_REQUIREMENT_LOOKUP CLOOK ON CLOOK.REQUIREMENT_ID=R.REQUIREMENT_ID
  JOIN $(NF_SCHEMA).REQUIREMENT_COLLECTION RCOLL ON RCOLL.REQUIREMENT_COLLECTION_ID=CLOOK.REQUIREMENT_COLLECTION_ID
  JOIN $(NF_SCHEMA).RELEASE RL ON RL.RELEASE_ID=R.RELEASE_ID
  JOIN $(NF_SCHEMA).REQUIREMENT_CLASSIFICATION RC ON RC.REQUIREMENT_CLASS_ID=R.REQUIREMENT_CLASS_ID
  JOIN $(NF_SCHEMA).RESOURCE P ON P.RESOURCE_ID=R.OWNER_ID
  JOIN $(NF_SCHEMA).ITERATION AC ON AC.ITERATION_ID=R.ACTUAL_ITERATION_ID
  JOIN $(NF_SCHEMA).ITERATION PL ON PL.ITERATION_ID=R.PLANNED_ITERATION_ID
  LEFT JOIN $(NF_SCHEMA).REQUIREMENT_PTEXT PT ON PT.REQUIREMENT_ID = R.REQUIREMENT_ID)
GO 

GRANT SELECT ON $(STAR_SCHEMA).VW_COLL_MEMBER_RQRMNT TO REPUSER
GO


CREATE TABLE $(STAR_SCHEMA).D_COLLECTION_TYPE(
		COLLECTION_TYPE_ID INT NOT NULL,
		NAME NVARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL
) ON VSTR_32K
GO

CREATE TABLE $(STAR_SCHEMA).D_REQUIREMENT_COLLECTION(
		COLLECTION_ID INT NOT NULL,
		NAME NVARCHAR(255),
		ISSOFTDELETED SMALLINT DEFAULT 0 NOT NULL
) ON VSTR_32K
GO

CREATE TABLE $(STAR_SCHEMA).F_C_COLLECTION_METRICS (
		REQ_METRIC_ID INT NOT NULL,
		DATE_ID INT NOT NULL,
		PROJECT_ID INT NOT NULL,
		OWNER_ID INT NOT NULL,
		COLLECTION_TYPE_ID INT NOT NULL,
		TOTAL_COLLECTIONS INT DEFAULT 0 NOT NULL,
		REC_DATETIME DATETIME DEFAULT GETDATE() NOT NULL 
	)
 ON VSTR_32K
GO

CREATE TABLE $(STAR_SCHEMA).F_COLLECTION_METRICS (
		REQ_METRIC_ID INT NOT NULL,
		DATE_ID INT NOT NULL,
		PROJECT_ID INT NOT NULL,
		OWNER_ID INT NOT NULL,
		COLLECTION_TYPE_ID INT NOT NULL,
		TOTAL_COLLECTIONS INT DEFAULT 0 NOT NULL,
		REC_DATETIME DATETIME DEFAULT GETDATE() NOT NULL 
	)
 ON VSTR_32K
GO

CREATE TABLE $(STAR_SCHEMA).H_COLLECTION_METRICS (
		REQ_METRIC_ID INT NOT NULL,
		COLLECTION_ID INT NOT NULL 	
	)
 ON VSTR_32K
GO

CREATE TABLE $(STAR_SCHEMA).F_C_RQRMNT_REF_METRICS_BYCOLL (
		REQ_METRIC_ID INT NOT NULL,
		DATE_ID INT NOT NULL,
		COLLECTION_ID INT NOT NULL,
		OWNER_ID INT NOT NULL,
		STATE_ID INT NOT NULL,
		STATUS_ID INT NOT NULL,
		STABILITY_ID INT NOT NULL,
		DIFFICULTY_ID INT NOT NULL,
		PRIORITY_ID INT NOT NULL,
		REQUIREMENT_TYPE_ID INT NOT NULL,
		TOTAL_REQUIREMENT_REFERENCES INT DEFAULT 0 NOT NULL,
		REC_DATETIME DATETIME DEFAULT GETDATE() NOT NULL
	)
 ON VSTR_32K
GO

CREATE TABLE $(STAR_SCHEMA).F_RQRMNT_REF_METRICS_BYCOLL (
		REQ_METRIC_ID INT NOT NULL,
		DATE_ID INT NOT NULL,
		COLLECTION_ID INT NOT NULL,
		OWNER_ID INT NOT NULL,
		STATE_ID INT NOT NULL,
		STATUS_ID INT NOT NULL,
		STABILITY_ID INT NOT NULL,
		DIFFICULTY_ID INT NOT NULL,
		PRIORITY_ID INT NOT NULL,
		REQUIREMENT_TYPE_ID INT NOT NULL,
		TOTAL_REQUIREMENT_REFERENCES INT DEFAULT 0 NOT NULL,
		REC_DATETIME DATETIME DEFAULT GETDATE() NOT NULL
	)
 ON VSTR_32K
GO

CREATE TABLE $(STAR_SCHEMA).H_RQRMNT_REF_METRICS_BYCOLL (
		REQ_METRIC_ID INT NOT NULL,
		REQUIREMENT_ID INT NOT NULL
	)
 ON VSTR_32K
GO

CREATE INDEX F_COLL_METR_IDX1 ON $(STAR_SCHEMA).F_COLLECTION_METRICS (DATE_ID)  ON  VSTR_IDX
GO
CREATE INDEX F_RQRF_COLL_IDX1 ON $(STAR_SCHEMA).F_RQRMNT_REF_METRICS_BYCOLL (DATE_ID)  ON  VSTR_IDX
GO

ALTER TABLE $(STAR_SCHEMA).D_REQUIREMENT_COLLECTION ADD CONSTRAINT D_RQRCOLL_PK PRIMARY KEY	(COLLECTION_ID)
GO

ALTER TABLE $(STAR_SCHEMA).D_COLLECTION_TYPE ADD CONSTRAINT D_COLLTYPE_PK PRIMARY KEY	(COLLECTION_TYPE_ID) ON  VSTR_IDX
GO

ALTER TABLE $(STAR_SCHEMA).F_C_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_C_RQRFMT_PK PRIMARY KEY (REQ_METRIC_ID) ON  VSTR_IDX
GO

ALTER TABLE $(STAR_SCHEMA).F_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_RQRFMT_PK PRIMARY KEY (REQ_METRIC_ID) ON  VSTR_IDX
GO

ALTER TABLE $(STAR_SCHEMA).H_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT H_RQRFMT_PK PRIMARY KEY (REQ_METRIC_ID, REQUIREMENT_ID) ON  VSTR_IDX
GO

ALTER TABLE $(STAR_SCHEMA).F_C_COLLECTION_METRICS ADD CONSTRAINT F_C_COLLMET_PK PRIMARY KEY (REQ_METRIC_ID) ON  VSTR_IDX
GO

ALTER TABLE $(STAR_SCHEMA).F_COLLECTION_METRICS ADD CONSTRAINT F_COLLMET_PK PRIMARY KEY (REQ_METRIC_ID) ON  VSTR_IDX
GO

ALTER TABLE $(STAR_SCHEMA).H_COLLECTION_METRICS ADD CONSTRAINT H_COLLMET_PK PRIMARY KEY (REQ_METRIC_ID, COLLECTION_ID) ON  VSTR_IDX
GO

ALTER TABLE $(STAR_SCHEMA).F_C_COLLECTION_METRICS ADD CONSTRAINT F_C_COLLMET_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES $(STAR_SCHEMA).D_DATE (DATE_ID)
GO

ALTER TABLE $(STAR_SCHEMA).F_C_COLLECTION_METRICS ADD CONSTRAINT F_C_COLLMET_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES $(STAR_SCHEMA).D_PROJECT (PROJECT_ID)
GO

ALTER TABLE $(STAR_SCHEMA).F_C_COLLECTION_METRICS ADD CONSTRAINT F_C_COLLMET_FK3 FOREIGN KEY (OWNER_ID)
	REFERENCES $(STAR_SCHEMA).D_RESOURCE (RESOURCE_ID)
GO

ALTER TABLE $(STAR_SCHEMA).F_C_COLLECTION_METRICS ADD CONSTRAINT F_C_COLLMET_FK4 FOREIGN KEY (COLLECTION_TYPE_ID)
	REFERENCES $(STAR_SCHEMA).D_COLLECTION_TYPE (COLLECTION_TYPE_ID)
GO

ALTER TABLE $(STAR_SCHEMA).F_COLLECTION_METRICS ADD CONSTRAINT F_COLLMET_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES $(STAR_SCHEMA).D_DATE (DATE_ID)
GO

ALTER TABLE $(STAR_SCHEMA).F_COLLECTION_METRICS ADD CONSTRAINT F_COLLMET_FK2 FOREIGN KEY (PROJECT_ID)
	REFERENCES $(STAR_SCHEMA).D_PROJECT (PROJECT_ID)
GO

ALTER TABLE $(STAR_SCHEMA).F_COLLECTION_METRICS ADD CONSTRAINT F_COLLMET_FK3 FOREIGN KEY (OWNER_ID)
	REFERENCES $(STAR_SCHEMA).D_RESOURCE (RESOURCE_ID)
GO

ALTER TABLE $(STAR_SCHEMA).F_COLLECTION_METRICS ADD CONSTRAINT F_COLLMET_FK4 FOREIGN KEY (COLLECTION_TYPE_ID)
	REFERENCES $(STAR_SCHEMA).D_COLLECTION_TYPE (COLLECTION_TYPE_ID)
GO

ALTER TABLE $(STAR_SCHEMA).H_COLLECTION_METRICS ADD CONSTRAINT H_COLLMET_FK1 FOREIGN KEY (COLLECTION_ID)
	REFERENCES $(STAR_SCHEMA).D_REQUIREMENT_COLLECTION (COLLECTION_ID) ON DELETE CASCADE
GO

ALTER TABLE $(STAR_SCHEMA).H_COLLECTION_METRICS ADD CONSTRAINT H_COLLMET_FK2 FOREIGN KEY (REQ_METRIC_ID)
	REFERENCES $(STAR_SCHEMA).F_COLLECTION_METRICS (REQ_METRIC_ID) ON DELETE CASCADE
GO

ALTER TABLE $(STAR_SCHEMA).F_C_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_C_RQRFMET_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES $(STAR_SCHEMA).D_DATE (DATE_ID)
GO

ALTER TABLE $(STAR_SCHEMA).F_C_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_C_RQRFMET_FK2 FOREIGN KEY (COLLECTION_ID)
	REFERENCES $(STAR_SCHEMA).D_REQUIREMENT_COLLECTION (COLLECTION_ID)
GO

ALTER TABLE $(STAR_SCHEMA).F_C_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_C_RQRFMET_FK3 FOREIGN KEY (STATUS_ID)
	REFERENCES $(STAR_SCHEMA).D_STATUS (STATUS_ID)
GO

ALTER TABLE $(STAR_SCHEMA).F_C_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_C_RQRFMET_FK4 FOREIGN KEY (STABILITY_ID)
	REFERENCES $(STAR_SCHEMA).D_STABILITY (STABILITY_ID)
GO

ALTER TABLE $(STAR_SCHEMA).F_C_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_C_RQRFMET_FK5 FOREIGN KEY (DIFFICULTY_ID)
	REFERENCES $(STAR_SCHEMA).D_DIFFICULTY (DIFFICULTY_ID)
GO

ALTER TABLE $(STAR_SCHEMA).F_C_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_C_RQRFMET_FK6 FOREIGN KEY (STATE_ID)
	REFERENCES $(STAR_SCHEMA).D_REQUIREMENT_STATE (STATE_ID)
GO

ALTER TABLE $(STAR_SCHEMA).F_C_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_C_RQRFMET_FK7 FOREIGN KEY (OWNER_ID)
	REFERENCES $(STAR_SCHEMA).D_RESOURCE (RESOURCE_ID)
GO

ALTER TABLE $(STAR_SCHEMA).F_C_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_C_RQRFMET_FK8 FOREIGN KEY (PRIORITY_ID)
	REFERENCES $(STAR_SCHEMA).D_PRIORITY (PRIORITY_ID)
GO

ALTER TABLE $(STAR_SCHEMA).F_C_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_C_RQRFMET_FK9 FOREIGN KEY (REQUIREMENT_TYPE_ID)
	REFERENCES $(STAR_SCHEMA).D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID)
GO

ALTER TABLE $(STAR_SCHEMA).F_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_RQRFMET_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES $(STAR_SCHEMA).D_DATE (DATE_ID)
GO

ALTER TABLE $(STAR_SCHEMA).F_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_RQRFMET_FK2 FOREIGN KEY (COLLECTION_ID)
	REFERENCES $(STAR_SCHEMA).D_REQUIREMENT_COLLECTION (COLLECTION_ID)
GO

ALTER TABLE $(STAR_SCHEMA).F_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_RQRFMET_FK3 FOREIGN KEY (STATUS_ID)
	REFERENCES $(STAR_SCHEMA).D_STATUS (STATUS_ID)
GO

ALTER TABLE $(STAR_SCHEMA).F_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_RQRFMET_FK4 FOREIGN KEY (STABILITY_ID)
	REFERENCES $(STAR_SCHEMA).D_STABILITY (STABILITY_ID)
GO

ALTER TABLE $(STAR_SCHEMA).F_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_RQRFMET_FK5 FOREIGN KEY (DIFFICULTY_ID)
	REFERENCES $(STAR_SCHEMA).D_DIFFICULTY (DIFFICULTY_ID)
GO

ALTER TABLE $(STAR_SCHEMA).F_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_RQRFMET_FK6 FOREIGN KEY (STATE_ID)
	REFERENCES $(STAR_SCHEMA).D_REQUIREMENT_STATE (STATE_ID)
GO

ALTER TABLE $(STAR_SCHEMA).F_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_RQRFMET_FK7 FOREIGN KEY (OWNER_ID)
	REFERENCES $(STAR_SCHEMA).D_RESOURCE (RESOURCE_ID)
GO

ALTER TABLE $(STAR_SCHEMA).F_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_RQRFMET_FK8 FOREIGN KEY (PRIORITY_ID)
	REFERENCES $(STAR_SCHEMA).D_PRIORITY (PRIORITY_ID)
GO

ALTER TABLE $(STAR_SCHEMA).F_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT F_RQRFMET_FK9 FOREIGN KEY (REQUIREMENT_TYPE_ID)
	REFERENCES $(STAR_SCHEMA).D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID)
GO

ALTER TABLE $(STAR_SCHEMA).H_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT HRQRFMET_FK1 FOREIGN KEY (REQ_METRIC_ID)
	REFERENCES $(STAR_SCHEMA).F_C_RQRMNT_REF_METRICS_BYCOLL (REQ_METRIC_ID) ON DELETE CASCADE
GO

ALTER TABLE $(STAR_SCHEMA).H_RQRMNT_REF_METRICS_BYCOLL ADD CONSTRAINT HRQRFMET_FK2 FOREIGN KEY (REQUIREMENT_ID)
	REFERENCES $(STAR_SCHEMA).D_REQUIREMENT (REQUIREMENT_ID) ON DELETE CASCADE
GO

 GRANT SELECT ON $(STAR_SCHEMA).D_COLLECTION_TYPE TO REPUSER
GO

 GRANT SELECT ON $(STAR_SCHEMA).D_REQUIREMENT_COLLECTION TO REPUSER
GO

 GRANT SELECT ON $(STAR_SCHEMA).F_C_COLLECTION_METRICS TO REPUSER
GO

 GRANT SELECT ON $(STAR_SCHEMA).F_C_RQRMNT_REF_METRICS_BYCOLL TO REPUSER
GO

 GRANT SELECT ON $(STAR_SCHEMA).F_COLLECTION_METRICS TO REPUSER
GO

 GRANT SELECT ON $(STAR_SCHEMA).F_RQRMNT_REF_METRICS_BYCOLL TO REPUSER
GO

 GRANT SELECT ON $(STAR_SCHEMA).H_COLLECTION_METRICS TO REPUSER
GO

 GRANT SELECT ON $(STAR_SCHEMA).H_RQRMNT_REF_METRICS_BYCOLL TO REPUSER
GO

INSERT INTO $(STAR_SCHEMA).D_COLLECTION_TYPE(COLLECTION_TYPE_ID,NAME) VALUES  (-1,'Info not available')
GO

INSERT INTO $(STAR_SCHEMA).D_REQUIREMENT_COLLECTION (COLLECTION_ID,NAME) VALUES (-1,'Info not available')
GO

UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0.5' WHERE INFO_ID=6
GO
UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET INT_VALUE=1  WHERE INFO_ID=8
GO
UPDATE $(CONFIG_SCHEMA).SYSCONFIG_INFO SET CHAR_VALUE='2.0.5 S1',INT_VALUE=12 WHERE INFO_ID=18
GO
