SET CURRENT SCHEMA $CONFIG_SCHEMA;

INSERT INTO SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 6 AS INFO_ID,'VERSION' AS NAME,'Insight Warehouse Version' AS DISPLAY_NAME,1 AS INT_VALUE,'1.0' AS CHAR_VALUE FROM SYSIBM.SYSDUMMY1 WHERE NOT EXISTS(SELECT INFO_ID FROM SYSCONFIG_INFO WHERE INFO_ID=6);

INSERT INTO SYSCONFIG_INFO(INFO_ID,NAME,DISPLAY_NAME,INT_VALUE,CHAR_VALUE) SELECT 7 AS INFO_ID,'UPDATE_TARGET' AS NAME,'Insight Warehouse Update' AS DISPLAY_NAME,0 AS INT_VALUE,'2.0' AS CHAR_VALUE FROM SYSIBM.SYSDUMMY1 WHERE NOT EXISTS(SELECT INFO_ID FROM SYSCONFIG_INFO WHERE INFO_ID=7);

UPDATE $CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0.5' WHERE INFO_ID=7;

INSERT INTO $CONFIG_SCHEMA.SYSCONFIG_INFO SELECT 8 AS INFO_ID,'MIGRATION_STATUS' AS NAME,'Insight Warehouse Migration Status' AS DISPLAY_NAME,0 AS INT_VALUE,'' AS CHAR_VALUE, CURRENT TIMESTAMP AS REC_DATETIME from SYSIBM.SYSDUMMY1 WHERE NOT EXISTS (SELECT INFO_ID FROM $CONFIG_SCHEMA.SYSCONFIG_INFO WHERE INFO_ID=8);
INSERT INTO $CONFIG_SCHEMA.SYSCONFIG_INFO SELECT  18 AS INFO_ID,'MINOR_VERSION' AS NAME,'Insight Warehouse Minor Version' AS DISPLAY_NAME,14 AS INT_VALUE,'2.0.5 RC1' AS CHAR_VALUE, CURRENT TIMESTAMP AS REC_DATETIME from SYSIBM.SYSDUMMY1 WHERE NOT EXISTS (SELECT INFO_ID FROM $CONFIG_SCHEMA.SYSCONFIG_INFO WHERE INFO_ID=18);
INSERT INTO $CONFIG_SCHEMA.SYSCONFIG_INFO SELECT 9 AS INFO_ID,'DATA_TRUNCATION' AS NAME,'Interpreted as do not compute or delete data with dates earlier or equal to the value set' AS DISPLAY_NAME,1 AS INT_VALUE,'1899-12-31' AS CHAR_VALUE, CURRENT TIMESTAMP AS REC_DATETIME  from SYSIBM.SYSDUMMY1 WHERE NOT EXISTS (SELECT INFO_ID FROM $CONFIG_SCHEMA.SYSCONFIG_INFO WHERE INFO_ID=9);

DROP VIEW $STAR_SCHEMA.VW_RQRMNT_COVERAGE_LOOKUP;

DROP TABLE $STAR_SCHEMA.F_C_RQRMNT_COVERAGE_BYCOLL;

DROP TABLE $STAR_SCHEMA.F_RQRMNT_COVERAGE_BYCOLL;

CREATE TABLE $STAR_SCHEMA.F_C_RQRMNT_COVERAGE_BYCOLL (
	REQ_METRIC_ID INTEGER NOT NULL,
	DATE_ID INTEGER NOT NULL,
	PROJECT_ID INTEGER NOT NULL,
	REQUIREMENT_TYPE_ID INTEGER NOT NULL,
	LINK_TYPE_ID INTEGER NOT NULL,
	COVERAGE_ID INTEGER NOT NULL,
	TOTAL_LOWER_RQRMNTS INTEGER DEFAULT NOT NULL,
	TOTAL_UPPER_RQRMNTS INTEGER DEFAULT NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	) IN DATABASE $DBNAME;

CREATE TABLE $STAR_SCHEMA.F_RQRMNT_COVERAGE_BYCOLL (
	REQ_METRIC_ID INTEGER NOT NULL,
	DATE_ID INTEGER NOT NULL,
	PROJECT_ID INTEGER NOT NULL,
	REQUIREMENT_TYPE_ID INTEGER NOT NULL,
	LINK_TYPE_ID INTEGER NOT NULL,
	COVERAGE_ID INTEGER NOT NULL,
	TOTAL_LOWER_RQRMNTS INTEGER DEFAULT NOT NULL,
	TOTAL_UPPER_RQRMNTS INTEGER DEFAULT NOT NULL,
	REC_DATETIME TIMESTAMP DEFAULT NOT NULL
	) IN DATABASE $DBNAME;

CREATE TABLE $STAR_SCHEMA.H_RQRMNT_COVERAGE_UPPER (
	REQ_METRIC_ID INTEGER NOT NULL,
	UPPER_REQUIREMENT_ID INTEGER NOT NULL
	) IN DATABASE $DBNAME;

CREATE TABLE $STAR_SCHEMA.H_RQRMNT_COVERAGE_LOWER (
	REQ_METRIC_ID INTEGER NOT NULL,
	LOWER_REQUIREMENT_ID INTEGER NOT NULL
	) IN DATABASE $DBNAME;

CREATE UNIQUE INDEX $STAR_SCHEMA.F_C_RQRCOV_PK ON $STAR_SCHEMA.F_C_RQRMNT_COVERAGE_BYCOLL (REQ_METRIC_ID);
CREATE UNIQUE INDEX $STAR_SCHEMA.F_RQRCOV_PK ON $STAR_SCHEMA.F_RQRMNT_COVERAGE_BYCOLL (REQ_METRIC_ID);
CREATE UNIQUE INDEX $STAR_SCHEMA.H_RQRCOVUP_PK ON $STAR_SCHEMA.H_RQRMNT_COVERAGE_UPPER (REQ_METRIC_ID, UPPER_REQUIREMENT_ID);
CREATE UNIQUE INDEX $STAR_SCHEMA.H_RQRCOVLOW_PK ON $STAR_SCHEMA.H_RQRMNT_COVERAGE_LOWER (REQ_METRIC_ID, LOWER_REQUIREMENT_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_COVERAGE_BYCOLL ADD PRIMARY KEY (REQ_METRIC_ID);
ALTER TABLE $STAR_SCHEMA.F_RQRMNT_COVERAGE_BYCOLL ADD PRIMARY KEY (REQ_METRIC_ID);
ALTER TABLE $STAR_SCHEMA.H_RQRMNT_COVERAGE_UPPER ADD PRIMARY KEY (REQ_METRIC_ID, UPPER_REQUIREMENT_ID);
ALTER TABLE $STAR_SCHEMA.H_RQRMNT_COVERAGE_LOWER ADD PRIMARY KEY (REQ_METRIC_ID, LOWER_REQUIREMENT_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_COVERAGE_BYCOLL ADD CONSTRAINT F_C_RQRCOV_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES $STAR_SCHEMA.D_DATE (DATE_ID);
	
ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_COVERAGE_BYCOLL ADD CONSTRAINT F_C_RQRCOV_FK2 FOREIGN KEY (LINK_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_LINK_TYPE (LINK_TYPE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_COVERAGE_BYCOLL ADD CONSTRAINT F_C_RQRCOV_FK3 FOREIGN KEY (REQUIREMENT_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID);
	
ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_COVERAGE_BYCOLL ADD CONSTRAINT F_C_RQRCOV_FK4 FOREIGN KEY (COVERAGE_ID)
	REFERENCES $STAR_SCHEMA.D_COVERAGE (COVERAGE_ID);

ALTER TABLE $STAR_SCHEMA.F_C_RQRMNT_COVERAGE_BYCOLL ADD CONSTRAINT F_C_RQRCOV_FK5 FOREIGN KEY (PROJECT_ID)
	REFERENCES $STAR_SCHEMA.D_PROJECT (PROJECT_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_COVERAGE_BYCOLL ADD CONSTRAINT F_RQRCOV_FK1 FOREIGN KEY (DATE_ID)
	REFERENCES $STAR_SCHEMA.D_DATE (DATE_ID);
	
ALTER TABLE $STAR_SCHEMA.F_RQRMNT_COVERAGE_BYCOLL ADD CONSTRAINT F_RQRCOV_FK2 FOREIGN KEY (LINK_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_LINK_TYPE (LINK_TYPE_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_COVERAGE_BYCOLL ADD CONSTRAINT F_RQRCOV_FK3 FOREIGN KEY (REQUIREMENT_TYPE_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT_TYPE (REQUIREMENT_TYPE_ID);
	
ALTER TABLE $STAR_SCHEMA.F_RQRMNT_COVERAGE_BYCOLL ADD CONSTRAINT F_RQRCOV_FK4 FOREIGN KEY (COVERAGE_ID)
	REFERENCES $STAR_SCHEMA.D_COVERAGE (COVERAGE_ID);

ALTER TABLE $STAR_SCHEMA.F_RQRMNT_COVERAGE_BYCOLL ADD CONSTRAINT F_RQRCOV_FK5 FOREIGN KEY (PROJECT_ID)
	REFERENCES $STAR_SCHEMA.D_PROJECT (PROJECT_ID);

CREATE INDEX $STAR_SCHEMA.F_RQRCOV_IDX1 ON $STAR_SCHEMA.F_RQRMNT_COVERAGE_BYCOLL (DATE_ID);

ALTER TABLE $STAR_SCHEMA.H_RQRMNT_COVERAGE_UPPER ADD CONSTRAINT H_RQRCOVUP_FK1 FOREIGN KEY (REQ_METRIC_ID)
	REFERENCES $STAR_SCHEMA.F_RQRMNT_COVERAGE_BYCOLL (REQ_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE $STAR_SCHEMA.H_RQRMNT_COVERAGE_LOWER ADD CONSTRAINT H_RQRCOVLOW_FK1 FOREIGN KEY (REQ_METRIC_ID)
	REFERENCES $STAR_SCHEMA.F_RQRMNT_COVERAGE_BYCOLL (REQ_METRIC_ID) ON DELETE CASCADE;

ALTER TABLE $STAR_SCHEMA.H_RQRMNT_COVERAGE_LOWER ADD CONSTRAINT H_RQRCOVLOW_FK2 FOREIGN KEY (LOWER_REQUIREMENT_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT (REQUIREMENT_ID) ON DELETE CASCADE;

ALTER TABLE $STAR_SCHEMA.H_RQRMNT_COVERAGE_UPPER ADD CONSTRAINT H_RQRCOVUP_FK2 FOREIGN KEY (UPPER_REQUIREMENT_ID)
	REFERENCES $STAR_SCHEMA.D_REQUIREMENT (REQUIREMENT_ID) ON DELETE CASCADE;

CREATE VIEW $STAR_SCHEMA.VW_RQRMNT_COVERAGE_LOOKUP (PROJECT_ID, LOW_ID, LOW_REF_ID, LOW_NAME, LOW_URL, LOW_TYPE, LOW_STATUS, LOW_PRIORITY, LOW_STABILITY, LOW_DIFFICULTY, LOW_STATE, UP_ID, UP_REF_ID, UP_NAME, UP_URL, UP_TYPE, UP_STATUS, UP_PRIORITY, UP_STABILITY, UP_DIFFICULTY, UP_STATE, LINK_TYPE_ID, LINK_TYPE) AS
(SELECT COALESCE(LT.PROJECT_ID, LR.PROJECT_ID) AS PROJECT_ID, LR.REQUIREMENT_ID AS LOW_ID, LR.REFERENCE_ID AS LOW_REF_ID, LR.NAME AS LOW_NAME, LR.URL AS LOW_URL, LR.REQUIREMENT_TYPE AS LOW_TYPE, LR.STATUS AS LOW_STATUS, LR.PRIORITY AS LOW_PRIORITY, LR.STABILITY AS LOW_STABILITY, LR.DIFFICULTY AS LOW_DIFFICULTY, LR.REQUIREMENT_STATE AS LOW_STATE, 
		COALESCE(UR.REQUIREMENT_ID,-1) AS UP_ID, UR.REFERENCE_ID AS UP_REF_ID, UR.NAME AS UP_NAME, UR.URL AS UP_URL, UR.REQUIREMENT_TYPE AS UP_TYPE, UR.STATUS AS UP_STATUS, UR.PRIORITY AS UP_PRIORITY, UR.STABILITY AS UP_STABILITY, UR.DIFFICULTY AS UP_DIFFICULTY, UR.REQUIREMENT_STATE AS UP_STATE, 
		COALESCE(LT.LINK_TYPE_ID,-1) AS LINK_TYPE_ID, LT.NAME AS LINK_TYPE
FROM $NF_SCHEMA.REQUIREMENT LR 
LEFT JOIN $NF_SCHEMA.REQUIREMENT_HIERARCHY H ON H.PRED_REQUIREMENT_ID = LR.REQUIREMENT_ID
LEFT JOIN $NF_SCHEMA.REQUIREMENT_LINK_TYPE LT ON H.LINK_TYPE_ID = LT.LINK_TYPE_ID
LEFT JOIN $NF_SCHEMA.REQUIREMENT UR ON H.SUCC_REQUIREMENT_ID = UR.REQUIREMENT_ID
WHERE LR.REQUIREMENT_ID > -1 AND LR.ISSOFTDELETED = 0
UNION ALL
SELECT COALESCE(LT.PROJECT_ID, UR.PROJECT_ID) AS PROJECT_ID, COALESCE(LR.REQUIREMENT_ID,-1) AS LOW_ID, LR.REFERENCE_ID AS LOW_REF_ID, LR.NAME AS LOW_NAME, LR.URL AS LOW_URL, LR.REQUIREMENT_TYPE AS LOW_TYPE, LR.STATUS AS LOW_STATUS, LR.PRIORITY AS LOW_PRIORITY, LR.STABILITY AS LOW_STABILITY, LR.DIFFICULTY AS LOW_DIFFICULTY, LR.REQUIREMENT_STATE AS LOW_STATE, 
		UR.REQUIREMENT_ID AS UP_ID, UR.REFERENCE_ID AS UP_REF_ID, UR.NAME AS UP_NAME, UR.URL AS UP_URL, UR.REQUIREMENT_TYPE AS UP_TYPE, UR.STATUS AS UP_STATUS, UR.PRIORITY AS UP_PRIORITY, UR.STABILITY AS UP_STABILITY, UR.DIFFICULTY AS UP_DIFFICULTY, UR.REQUIREMENT_STATE AS UP_STATE, 
		COALESCE(LT.LINK_TYPE_ID,-1) AS LINK_TYPE_ID, LT.NAME AS LINK_TYPE
FROM $NF_SCHEMA.REQUIREMENT UR 
LEFT JOIN $NF_SCHEMA.REQUIREMENT_HIERARCHY H ON H.SUCC_REQUIREMENT_ID = UR.REQUIREMENT_ID
LEFT JOIN $NF_SCHEMA.REQUIREMENT_LINK_TYPE LT ON H.LINK_TYPE_ID = LT.LINK_TYPE_ID
LEFT JOIN $NF_SCHEMA.REQUIREMENT LR ON H.PRED_REQUIREMENT_ID = LR.REQUIREMENT_ID
WHERE UR.REQUIREMENT_ID > -1 AND UR.ISSOFTDELETED = 0);

CREATE VIEW $STAR_SCHEMA.VW_RQRMNT_DOWNGAP_NOCOVERAGE (UPPER_COLLECTION_ID, UP_ID, UP_REF_ID, UP_NAME, UP_URL, UP_TYPE, UP_STATUS, UP_PRIORITY, UP_STABILITY, UP_DIFFICULTY, UP_STATE) AS
(SELECT DISTINCT UPC.REQUIREMENT_COLLECTION_ID AS UPPER_COLLECTION_ID, UP.REQUIREMENT_ID AS UP_ID, UP.REFERENCE_ID AS UP_REF_ID, UP.NAME AS UP_NAME,
	UP.URL AS UP_URL, UP.REQUIREMENT_TYPE AS UP_TYPE, UP.STATUS UP_STATUS,
	UP.PRIORITY AS UP_PRIORITY, UP.STABILITY AS UP_STABILITY, 
	UP.DIFFICULTY AS UP_DIFFICULTY, UP.REQUIREMENT_STATE AS UP_STATE
	FROM $NF_SCHEMA.REQUIREMENT UP 
JOIN $NF_SCHEMA.REQUICOL_REQUIREMENT_LOOKUP UPC ON UP.REQUIREMENT_ID = UPC.REQUIREMENT_ID
LEFT JOIN $NF_SCHEMA.REQUIREMENT_HIERARCHY H ON H.SUCC_REQUIREMENT_ID = UP.REQUIREMENT_ID
LEFT JOIN $NF_SCHEMA.REQUICOL_REQUIREMENT_LOOKUP LOWC ON LOWC.REQUIREMENT_ID = H.PRED_REQUIREMENT_ID
LEFT JOIN $NF_SCHEMA.REQUIREMENT LOW ON H.PRED_REQUIREMENT_ID = LOW.REQUIREMENT_ID
WHERE UP.REQUIREMENT_ID > -1 AND UP.ISSOFTDELETED = 0 
AND (
(H.SUCC_REQUIREMENT_ID IS NULL)
OR
(UPC.REQUIREMENT_COLLECTION_ID = LOWC.REQUIREMENT_COLLECTION_ID
AND NOT EXISTS (
	SELECT 1
	FROM $NF_SCHEMA.REQUICOL_REQUIREMENT_LOOKUP UC 
		JOIN $NF_SCHEMA.REQUIREMENT_HIERARCHY H ON H.SUCC_REQUIREMENT_ID = UC.REQUIREMENT_ID
		JOIN $NF_SCHEMA.REQUICOL_REQUIREMENT_LOOKUP LC ON LC.REQUIREMENT_ID = H.PRED_REQUIREMENT_ID
		WHERE UC.REQUIREMENT_COLLECTION_ID = UPC.REQUIREMENT_COLLECTION_ID
		AND LC.REQUIREMENT_COLLECTION_ID <> LOWC.REQUIREMENT_COLLECTION_ID
		AND H.SUCC_REQUIREMENT_ID = UP.REQUIREMENT_ID
		AND H.PRED_REQUIREMENT_ID <> LOW.REQUIREMENT_ID ))
));

CREATE VIEW $STAR_SCHEMA.VW_RQRMNT_DOWNGAP_LOOKUP (UPPER_COLLECTION_ID, UP_ID, UP_REF_ID, UP_NAME, UP_URL, UP_TYPE, UP_STATUS, UP_PRIORITY, UP_STABILITY, UP_DIFFICULTY, UP_STATE, LINK_TYPE_ID, LINK_TYPE, LOW_ID, LOW_REF_ID, LOW_NAME, LOW_URL, LOW_TYPE, LOW_STATUS, LOW_PRIORITY, LOW_STABILITY, LOW_DIFFICULTY, LOW_STATE) AS
(SELECT DISTINCT UPC.REQUIREMENT_COLLECTION_ID AS UPPER_COLLECTION_ID, UP.REQUIREMENT_ID AS UP_ID, UP.REFERENCE_ID AS UP_REF_ID, UP.NAME AS UP_NAME, UP.URL AS UP_URL, UP.REQUIREMENT_TYPE AS UP_TYPE, UP.STATUS AS UP_STATUS, UP.PRIORITY AS UP_PRIORITY, UP.STABILITY AS UP_STABILITY, UP.DIFFICULTY AS UP_DIFFICULTY, UP.REQUIREMENT_STATE AS UP_STATE, 
		LT.LINK_TYPE_ID, LT.NAME AS LINK_TYPE,
		LOW.REQUIREMENT_ID AS LOW_ID, LOW.REFERENCE_ID AS LOW_REF_ID, LOW.NAME AS LOW_NAME, LOW.URL AS LOW_URL, LOW.REQUIREMENT_TYPE AS LOW_TYPE, LOW.STATUS AS LOW_STATUS, LOW.PRIORITY AS LOW_PRIORITY, LOW.STABILITY AS LOW_STABILITY, LOW.DIFFICULTY AS LOW_DIFFICULTY, LOW.REQUIREMENT_STATE AS LOW_STATE
	FROM $NF_SCHEMA.REQUIREMENT_HIERARCHY H
JOIN $NF_SCHEMA.REQUIREMENT UP ON H.SUCC_REQUIREMENT_ID = UP.REQUIREMENT_ID
JOIN $NF_SCHEMA.REQUIREMENT LOW ON H.PRED_REQUIREMENT_ID = LOW.REQUIREMENT_ID
JOIN $NF_SCHEMA.REQUICOL_REQUIREMENT_LOOKUP UPC ON UP.REQUIREMENT_ID = UPC.REQUIREMENT_ID
JOIN $NF_SCHEMA.REQUICOL_REQUIREMENT_LOOKUP LOWC ON LOW.REQUIREMENT_ID = LOWC.REQUIREMENT_ID
JOIN $NF_SCHEMA.REQUIREMENT_LINK_TYPE LT ON H.LINK_TYPE_ID = LT.LINK_TYPE_ID
WHERE UP.REQUIREMENT_ID > -1 AND LOW.REQUIREMENT_ID > -1 AND UP.ISSOFTDELETED = 0 AND LOW.ISSOFTDELETED = 0
AND UPC.REQUIREMENT_COLLECTION_ID <> LOWC.REQUIREMENT_COLLECTION_ID
AND NOT EXISTS (
	SELECT 1
	FROM $NF_SCHEMA.REQUICOL_REQUIREMENT_LOOKUP UC 
		JOIN $NF_SCHEMA.REQUIREMENT_HIERARCHY H ON H.SUCC_REQUIREMENT_ID = UC.REQUIREMENT_ID
		JOIN $NF_SCHEMA.REQUICOL_REQUIREMENT_LOOKUP LC ON LC.REQUIREMENT_ID = H.PRED_REQUIREMENT_ID
		WHERE UC.REQUIREMENT_COLLECTION_ID = LC.REQUIREMENT_COLLECTION_ID
		AND LC.REQUIREMENT_COLLECTION_ID = UPC.REQUIREMENT_COLLECTION_ID
		AND H.SUCC_REQUIREMENT_ID = UP.REQUIREMENT_ID
		AND H.PRED_REQUIREMENT_ID = LOW.REQUIREMENT_ID )
);

CREATE VIEW $STAR_SCHEMA.VW_RQRMNT_UPSTREAM_NOCOVERAGE (LOWER_COLLECTION_ID, LOW_ID, LOW_REF_ID, LOW_NAME, LOW_URL, LOW_TYPE, LOW_STATUS, LOW_PRIORITY, LOW_STABILITY, LOW_DIFFICULTY, LOW_STATE) AS
(SELECT LOWC.REQUIREMENT_COLLECTION_ID AS LOWER_COLLECTION_ID, LOW.REQUIREMENT_ID AS LOW_ID, LOW.REFERENCE_ID AS LOW_REF_ID, LOW.NAME AS LOW_NAME,
	LOW.URL AS LOW_URL, LOW.REQUIREMENT_TYPE AS LOW_TYPE, LOW.STATUS LOW_STATUS,
	LOW.PRIORITY AS LOW_PRIORITY, LOW.STABILITY AS LOW_STABILITY, 
	LOW.DIFFICULTY AS LOW_DIFFICULTY, LOW.REQUIREMENT_STATE AS LOW_STATE
	FROM $NF_SCHEMA.REQUIREMENT LOW 
JOIN $NF_SCHEMA.REQUICOL_REQUIREMENT_LOOKUP LOWC ON LOW.REQUIREMENT_ID = LOWC.REQUIREMENT_ID
LEFT JOIN $NF_SCHEMA.REQUIREMENT_HIERARCHY H ON H.PRED_REQUIREMENT_ID = LOW.REQUIREMENT_ID
LEFT JOIN $NF_SCHEMA.REQUICOL_REQUIREMENT_LOOKUP UPC ON UPC.REQUIREMENT_ID = H.SUCC_REQUIREMENT_ID
LEFT JOIN $NF_SCHEMA.REQUIREMENT UP ON H.SUCC_REQUIREMENT_ID = UP.REQUIREMENT_ID
WHERE LOW.REQUIREMENT_ID > -1 AND LOW.ISSOFTDELETED = 0 
AND (
(H.PRED_REQUIREMENT_ID IS NULL)
OR
(UPC.REQUIREMENT_COLLECTION_ID = LOWC.REQUIREMENT_COLLECTION_ID
AND NOT EXISTS (
	SELECT 1
	FROM $NF_SCHEMA.REQUICOL_REQUIREMENT_LOOKUP UC 
		JOIN $NF_SCHEMA.REQUIREMENT_HIERARCHY H ON H.SUCC_REQUIREMENT_ID = UC.REQUIREMENT_ID
		JOIN $NF_SCHEMA.REQUICOL_REQUIREMENT_LOOKUP LC ON LC.REQUIREMENT_ID = H.PRED_REQUIREMENT_ID
		WHERE UC.REQUIREMENT_COLLECTION_ID <> UPC.REQUIREMENT_COLLECTION_ID
		AND LC.REQUIREMENT_COLLECTION_ID = LOWC.REQUIREMENT_COLLECTION_ID
		AND H.SUCC_REQUIREMENT_ID <> UP.REQUIREMENT_ID
		AND H.PRED_REQUIREMENT_ID = LOW.REQUIREMENT_ID ))
));

CREATE VIEW $STAR_SCHEMA.VW_RQRMNT_UPSTREAM_LOOKUP (LOWER_COLLECTION_ID, LOW_ID, LOW_REF_ID, LOW_NAME, LOW_URL, LOW_TYPE, LOW_STATUS, LOW_PRIORITY, LOW_STABILITY, LOW_DIFFICULTY, LOW_STATE, LINK_TYPE_ID, LINK_TYPE, UP_ID, UP_REF_ID, UP_NAME, UP_URL, UP_TYPE, UP_STATUS, UP_PRIORITY, UP_STABILITY, UP_DIFFICULTY, UP_STATE) AS
SELECT DISTINCT LOWC.REQUIREMENT_COLLECTION_ID AS LOWER_COLLECTION_ID, LOW.REQUIREMENT_ID AS LOW_ID, LOW.REFERENCE_ID AS LOW_REF_ID, LOW.NAME AS LOW_NAME, LOW.URL AS LOW_URL, LOW.REQUIREMENT_TYPE AS LOW_TYPE, LOW.STATUS AS LOW_STATUS, LOW.PRIORITY AS LOW_PRIORITY, LOW.STABILITY AS LOW_STABILITY, LOW.DIFFICULTY AS LOW_DIFFICULTY, LOW.REQUIREMENT_STATE AS LOW_STATE, 
				LT.LINK_TYPE_ID, LT.NAME AS LINK_TYPE,
				UP.REQUIREMENT_ID AS UP_ID, UP.REFERENCE_ID AS UP_REF_ID, UP.NAME AS UP_NAME, UP.URL AS UP_URL, UP.REQUIREMENT_TYPE AS UP_TYPE, UP.STATUS AS UP_STATUS, UP.PRIORITY AS UP_PRIORITY, UP.STABILITY AS UP_STABILITY, UP.DIFFICULTY AS UP_DIFFICULTY, UP.REQUIREMENT_STATE AS UP_STATE
	FROM $NF_SCHEMA.REQUIREMENT_HIERARCHY H
JOIN $NF_SCHEMA.REQUIREMENT LOW ON H.PRED_REQUIREMENT_ID = LOW.REQUIREMENT_ID
JOIN $NF_SCHEMA.REQUIREMENT UP ON H.SUCC_REQUIREMENT_ID = UP.REQUIREMENT_ID
JOIN $NF_SCHEMA.REQUICOL_REQUIREMENT_LOOKUP UPC ON UP.REQUIREMENT_ID = UPC.REQUIREMENT_ID
JOIN $NF_SCHEMA.REQUICOL_REQUIREMENT_LOOKUP LOWC ON LOW.REQUIREMENT_ID = LOWC.REQUIREMENT_ID
JOIN $NF_SCHEMA.REQUIREMENT_LINK_TYPE LT ON H.LINK_TYPE_ID = LT.LINK_TYPE_ID
WHERE UP.REQUIREMENT_ID > -1 AND LOW.REQUIREMENT_ID > -1 AND UP.ISSOFTDELETED = 0 AND LOW.ISSOFTDELETED = 0
AND UPC.REQUIREMENT_COLLECTION_ID <> LOWC.REQUIREMENT_COLLECTION_ID
AND NOT EXISTS (
	SELECT 1
	FROM $NF_SCHEMA.REQUICOL_REQUIREMENT_LOOKUP UC 
		JOIN $NF_SCHEMA.REQUIREMENT_HIERARCHY H ON H.SUCC_REQUIREMENT_ID = UC.REQUIREMENT_ID
		JOIN $NF_SCHEMA.REQUICOL_REQUIREMENT_LOOKUP LC ON LC.REQUIREMENT_ID = H.PRED_REQUIREMENT_ID
		WHERE UC.REQUIREMENT_COLLECTION_ID = LC.REQUIREMENT_COLLECTION_ID
		AND LC.REQUIREMENT_COLLECTION_ID = LOWC.REQUIREMENT_COLLECTION_ID
		AND H.SUCC_REQUIREMENT_ID = UP.REQUIREMENT_ID
		AND H.PRED_REQUIREMENT_ID = LOW.REQUIREMENT_ID );

 GRANT SELECT ON TABLE $STAR_SCHEMA.H_RQRMNT_COVERAGE_LOWER TO $REP_USER;
 GRANT SELECT ON TABLE $STAR_SCHEMA.H_RQRMNT_COVERAGE_UPPER TO $REP_USER;
 GRANT SELECT ON $STAR_SCHEMA.VW_RQRMNT_DOWNGAP_NOCOVERAGE TO $REP_USER;
 GRANT SELECT ON $STAR_SCHEMA.VW_RQRMNT_UPSTREAM_NOCOVERAGE TO $REP_USER;
 GRANT SELECT ON $STAR_SCHEMA.VW_RQRMNT_DOWNGAP_LOOKUP TO $REP_USER;
 GRANT SELECT ON $STAR_SCHEMA.VW_RQRMNT_UPSTREAM_LOOKUP TO $REP_USER;


UPDATE $CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=2,CHAR_VALUE='2.0.5' WHERE INFO_ID=6;
UPDATE $CONFIG_SCHEMA.SYSCONFIG_INFO SET INT_VALUE=1  WHERE INFO_ID=8;
UPDATE $CONFIG_SCHEMA.SYSCONFIG_INFO SET CHAR_VALUE='2.0.5 RC1',INT_VALUE=14 WHERE INFO_ID=18;