/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.process.web.ui.accessgroup.AccessGroup"); //$NON-NLS-1$

(function(){
	
	/**
	 * Represents a member of an Access Group.
	 * 
	 * PROVISIONAL: This API is considered provisional and may be changed or removed in the
	 * future with minimal or no warning.
	 * 
	 * @name com.ibm.team.process.web.ui.accessgroup.AccessGroupMember
	 */ 
	dojo.declare("com.ibm.team.process.web.ui.accessgroup.AccessGroupMember", null, { //$NON-NLS-1$
		
		/**
		 * The UUID item id of the member.
		 * @type String
		 */
		itemId : null,
		
		/**
		 * The Uname of the member.
		 * @type String
		 */
		name : null,
		
		/**
		 * The type of the member.
		 * @type one of the values in com.ibm.team.process.web.ui.accessgroup.memberType
		 */
		type : null,
		
		/**
		 * The context type of the member.
		 * @type one of the values in com.ibm.team.process.web.ui.accessgroup.contextType
		 */
		contextType: null
	});

	/**
	 * Represents an Access Group.
	 * 
	 * PROVISIONAL: This API is considered provisional and may be changed or removed in the
	 * future with minimal or no warning.
	 * 
	 * @name com.ibm.team.process.web.ui.accessgroup.AccessGroup
	 */ 
	dojo.declare("com.ibm.team.process.web.ui.accessgroup.AccessGroup", null, { //$NON-NLS-1$
		
		/**
		 * The UUID item id of the access group.
		 * @type String
		 */
		itemId : null,
		
		/**
		 * The UUID state id of the access group.
		 * @type String
		 */
		stateId : null,

		/**
		 * The UUID context id that represents the read access context for 
		 * the members of the access group.
		 * @type String
		 */
		contextId : null,
		
		/**
		 * The name the access group.
		 * @type String
		 */
		name : null,
		
		/**
		 * The description of the access group.
		 * @type String
		 */
		description: null,
		
		/**
		 * Indicates if the access group is archived.
		 * @type String
		 */
		archived : false,
		
		/**
		 * The members that make up the access group.
		 * @type com.ibm.team.process.web.ui.accessgroup.AccessGroupMember[]
		 */
		members : null
	});

	/**
	 * Represents the types of the members that make up and access group.
	 * 
	 * PROVISIONAL: This API is considered provisional and may be changed or removed in the
	 * future with minimal or no warning.
	 * 
	 */ 
	dojo.setObject("com.ibm.team.process.web.ui.accessgroup.memberType", { //$NON-NLS-1$
		PROJECT_AREA  : 0,
		TEAM_AREA : 1,
		CONTRIBUTOR : 2
	});
	
	/**
	 * Represents the context type of the members that make up and access group.
	 * 
	 * PROVISIONAL: This API is considered provisional and may be changed or removed in the
	 * future with minimal or no warning.
	 * 
	 */ 
	dojo.setObject("com.ibm.team.process.web.ui.accessgroup.contextType", { //$NON-NLS-1$
		/**
		 * A context representing a single contributor
		 */
		CONTRIBUTOR: "com.ibm.team.process.access.group.contributorContext", //$NON-NLS-1$
		
		/**
		 * A context of only the direct members and administrators of a process area
		 */
		MEMBERS: "com.ibm.team.process.access.group.processAreaMemberContext" //$NON-NLS-1$
	});
	
	
})();

