/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.web.ui.internal.CatalogDrawer");

dojo.require("dojo.i18n"); 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.team.dashboard.web.ui.internal.catalog.DashboardCatalog");
dojo.require("jazz.ui.MenuPopup");

dojo.requireLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardCatalogMessages");

(function() {

dojo.declare("com.ibm.team.dashboard.web.ui.internal.CatalogDrawer", [dijit._Widget, dijit._Templated], {

	// Properties //----------------------------------------------------------->

	onAddWidget: null,
	
	onCloseCatalog: null,

	// ------------------------------------------------------------------------>

	/*
 	 * Template
 	 */
	templatePath: dojo.moduleUrl("com.ibm.team.dashboard.web", "ui/internal/templates/CatalogDrawer.html"),
	
	widgetsInTemplate: true,
	/*
 	 * @param Object args
 	 * 
 	 * @return CatalogDrawer 
 	 */
	constructor: function(args) {
		this.msg = dojo.i18n.getLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardCatalogMessages");
		if (args.catalogClass) {
			this._catalogClass = args.catalogClass;
		} else {
			this._catalogClass = "com.ibm.team.dashboard.web.ui.internal.catalog.DashboardCatalog";
		}
	},

	/*
 	 * @param void
 	 * 
 	 * @return void
 	 * @overrides super
 	 */		
	postCreate: function() {
		this._catalog.set("onAddWidget", this.onAddWidget);
	},

	/*
 	 * @param Event event
 	 * 
 	 * @return Boolean
 	 */	
	_onClickClose: function(event) {
		dojo.stopEvent(event);
		jazz.ui.MenuPopup.closeAll();

		// Close catalog
		if (this.onCloseCatalog) {
			this.onCloseCatalog();
		}
		
		return true;
	},

	/*
 	 * @param Event event
 	 * 
 	 * @return Boolean
 	 */	
	_onMouseOverClose: function(event) {
		dojo.stopEvent(event);

		dojo.addClass(this._closeButton, "hover");
		
		return true;
	},

	/*
 	 * @param Event event
 	 * 
 	 * @return Boolean
 	 */	
	_onMouseOutClose: function(event) {
		dojo.stopEvent(event);

		dojo.removeClass(this._closeButton, "hover");
		
		return true;
	}
});
})();