/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2014. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.reports.web.ui.internal.ReportsAdditionalTasks");

dojo.require("dojo.i18n");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.team.reports.web.client.internal.ReportsClient");
dojo.require("com.ibm.team.repository.web.client.internal.ServerStatusClient");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");

dojo.requireLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");

(function() {

var ReportsClient = com.ibm.team.reports.web.client.internal.ReportsClient;
var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;
var ServerStatusClient = com.ibm.team.repository.web.client.internal.ServerStatusClient;
var AUTHOR_CUSTOM_REPORT_URI = "#action=com.ibm.team.reports.authorCustomReport";
var QUERY_STUDIO_URI = "#action=com.ibm.team.reports.queryStudio";
var REPORT_STUDIO_URI = "#action=com.ibm.team.reports.reportStudio";

dojo.declare("com.ibm.team.reports.web.ui.internal.ReportsAdditionalTasks",
	[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.team.reports.web", "ui/internal/templates/ReportsAdditionalTasks.html"),
		
		constructor: function(args) {
			this.rrdiConfigured = args.rrdiConfigured;
			this.messages = dojo.i18n.getLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");
		},
		
		postCreate: function() {
			var srh = new ServiceResponseHandler(this, "_handleFetchJTSUrl", "_handleFetchJTSUrlError");
			ServerStatusClient.getJazzTeamServerURI(srh);
			
		},
		_handleFetchJTSUrl : function(response){
			if(response == null){
				this._handleFetchJTSUrlError();
				return;
			}
			var url = response;
			var indexOfCharAfterDoubleSlash = url.indexOf("//") + 2;
			var indexOfSlashBeforeAppName = url.indexOf("/", indexOfCharAfterDoubleSlash);
			url = url.substring(0, indexOfSlashBeforeAppName + 1);
			this.devIntelligenceLink.href = url +  
			 	"clmhelp/topic/com.ibm.rational.rrdi.usage.doc/topics/t_customizesamplereport.html";
			this.documentStyleLink.href = url + 
				"clmhelp/topic/com.ibm.rational.rrdg.usage.doc/topics/t_author_docstyle_report.html";
		},
		
		_handleFetchJTSUrlError : function(){
			this.devIntelligenceLink.href = url +  
		 		"clmhelp/topic/com.ibm.rational.rrdi.usage.doc/topics/t_customizesamplereport.html";
			this.documentStyleLink.href = url + 
				"clmhelp/topic/com.ibm.rational.rrdg.usage.doc/topics/t_author_docstyle_report.html";
		}
	}
);

})();