/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2014. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.reports.web.ui.internal.ReportsWelcome");

dojo.require("dojo.i18n");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("net.jazz.ajax.infoCenterRoot");

dojo.requireLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");

(function() {

var AUTHOR_CUSTOM_REPORT_URI = "#action=com.ibm.team.reports.authorCustomReport";
var SHOW_ADDITIONAL_TASKS_URI = "#action=com.ibm.team.reports.showAdditionalTasks";

dojo.declare("com.ibm.team.reports.web.ui.internal.ReportsWelcome",
	[dijit._Widget, dijit._Templated],
	{
		templatePath: dojo.moduleUrl("com.ibm.team.reports.web", "ui/internal/templates/ReportsWelcome.html"),
		
		constructor: function(args) {
			this.rrdiConfigured = args.rrdiConfigured;
			this.messages = dojo.i18n.getLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");
		},
		
		postCreate: function() {
			if (this.rrdiConfigured == true) {
				this.additionalTasks.setAttribute("href", SHOW_ADDITIONAL_TASKS_URI);
				this.additionalTasksImage.setAttribute("href", SHOW_ADDITIONAL_TASKS_URI);
				this.rrdiDescription.innerHTML = this.messages.additionalReportingDescription;
				dojo.removeClass(this.additionalTasks, "disabled");
				dojo.removeClass(this.additionalTasksImage, "disabled");
			} else {
				this.additionalTasks.removeAttribute("href");
				this.additionalTasksImage.removeAttribute("href");
				this.rrdiDescription.innerHTML = this.messages.rrdiRequired;
				dojo.addClass(this.additionalTasks, "disabled");
				dojo.addClass(this.additionalTasksImage, "disabled");
			}
			var infoCenterRoot = net.jazz.ajax.infoCenterRoot() == null ? "/clmhelp" : net.jazz.ajax.infoCenterRoot();
			this._learnLink.href = infoCenterRoot +  
					"/topic/com.ibm.rational.reporting.overview.doc/topics/c_ovr_overview.html";
			var dashboardHelpLink = infoCenterRoot + "/topic/com.ibm.jazz.dashboard.doc/topics/c_about_dash_mini.html";
			var linkText = dojo.string.substitute(this.messages.trackResourcesAvailable, [dashboardHelpLink]);
			//need to set inner HTML directly instead of creating a text node; the message contains HTML tags to display
			this.trackResourceText.innerHTML = linkText;
		}
	}
);

})();