/*******************************************************************************
 * Licensed Materials - Property of IBM (c) Copyright IBM Corporation 2005, 2011,
 * 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights: Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.team.reports.web.ui.internal.ValidatingTextBox");

dojo.require("dojo.i18n");

dojo.requireLocalization("com.ibm.team.reports.web.ui.internal",
		"ReportsManagementMessages");

(function() {
	dojo
			.declare(
					"com.ibm.team.reports.web.ui.internal.ValidatingTextBox",
					[ dijit._Widget, dijit._Templated ],
					{

						templatePath : dojo.moduleUrl(
								"com.ibm.team.reports.web",
								"ui/internal/templates/ValidatingTextBox.html"),

						constructor : function() {
							this.messages = dojo.i18n.getLocalization(
									"com.ibm.team.reports.web.ui.internal",
									"ReportsManagementMessages");
						},

						postCreate : function() {
							com.ibm.team.reports.web.ui.internal.ValidatingTextBox.superclass.postCreate
									.apply(this);
							this._errIcon = document.createElement("img");
							this._errIcon.className = "errIcon";
							this._errIcon.src = dojo.moduleUrl(
									"com.ibm.team.reports.web",
									"ui/internal/images/inline-error.gif");
							this._errIcon.style.visibility = "hidden";
							this._container.appendChild(this._errIcon);
							this.inputNode = this._createInputNode();
							this._container.appendChild(this.inputNode);
							this._invalidValueMsg = document
									.createElement("span");
							this._invalidValueMsg.className = "invalidMsg";
							this._container
									.appendChild(this._invalidValueMsg);
							this.connect(this.inputNode, "onkeyup",
									function(e) {
										this._handleKeyUp(e);
									});
						},

						setErrorMessage : function(message) {
							this._errorMessage = message;
						},
						
						isValid : function(){
							return !this._invalid;
						},

						_createInputNode : function() {
							var node;
							node = document.createElement("input");
							node._propertyElement = this;
							node.type = "text";
							node.value = this._currentValue ? this._currentValue : "";

							return node;
						},

						_checkValidity : function() {
							if (this.validate(this.inputNode.value) == true) {
								this._markValid();
							} else {
								this._markInvalid("error");
							}
						},

						_markValid : function() {
							while (this._invalidValueMsg.childNodes.length > 0) {
								this._invalidValueMsg
										.removeChild(this._invalidValueMsg.firstChild);
							}
							this._errIcon.style.display = "";
							this._errIcon.style.visibility = "hidden";
							this._invalid = false;
						},

						_markInvalid : function() {
							this._invalid = true;
							while (this._invalidValueMsg.childNodes.length > 0) {
								this._invalidValueMsg
										.removeChild(this._invalidValueMsg.firstChild);
							}

							if (this._errorMessage) {
								this._invalidValueMsg.appendChild(document
										.createTextNode(this._errorMessage));
							}
							this._invalidValueMsg.className = "invalidMsg";
							this._errIcon.style.visibility = "visible";
						},
						
						_handleKeyUp : function(e) {
							if (e.target && e.target.tagName === "INPUT") {
								if (this.onKeyUpTimout) {
									clearTimeout(this.onKeyUpTimout);
								}
								var f = dojo.hitch(this, function() {
									this._checkValidity();
								});
								var timeout = 500;

								this.onKeyUpTimout = setTimeout(f, timeout);
							}

						}

					});

})();