/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.ui.internal.admin.projects.TimelineModel"); //$NON-NLS-1$
	dojo.require("dijit.tree.TreeStoreModel"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.PermissionsScopeModel"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	
	dojo.declare("com.ibm.team.process.web.ui.internal.admin.projects.TimelineModel", //$NON-NLS-1$
			[dijit.tree.TreeStoreModel, com.ibm.team.process.web.ui.internal.admin.projects.PermissionsScopeModelMixin], {
	
		childrenAttrs: ["items"], //$NON-NLS-1$
		
		/*
		 * Constructs the Timeline model
		 * @param {Object} args The args are expected to contain the following:
		 *  {
		 *    store: the store the model should use for it's data
		 *    developmentLineId: [optional] if this model should be scoped to a
		 *    	single timeline
		 *  }
		 */
		constructor: function(args) {
            this._parentNodeId = ProcessConstants.PermissionsScopeContext.DEV_LINES;
            if (this.developmentLineId !== undefined && this.developmentLineId !== null) {
            	this._parentNodeId = this.developmentLineId; 
            }
		},
		
		getRoot: function(onItem, onError) {
			if (this.root) {
				onItem(this.root);
			} else {
				this.store.fetchItemByIdentity({
					identity: this._parentNodeId,
					onItem: dojo.hitch(this, function(item) {
						this.root = item;
						onItem(this.root);
					})
				});
			}
		}
		
	});
	
})();
