/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
(function(){
    dojo.provide("com.ibm.team.repository.web.ui.internal.admin.server.LicenseQuickConnectStep");
    
    dojo.require("dijit._Widget");
    dojo.require("dijit._Templated");
    dojo.require("net.jazz.ajax.ui.PlatformUI");
    dojo.require("dojo.i18n");
    dojo.require("jazz.ui.wizard.WizardStep");
    dojo.require("jazz.ui.MessageBox");
	dojo.require("jazz.ui.StyledBox");

    var MessageBox = jazz.ui.MessageBox;
    var WizardStep = jazz.ui.wizard.WizardStep;
	var TrimStyles = jazz.ui.StyledBox.TrimStyles;
    var messages;

    dojo.declare("com.ibm.team.repository.web.ui.internal.admin.server.LicenseQuickConnectStep", [WizardStep, dijit._Widget, dijit._Templated], {
    
        templatePath: dojo.moduleUrl("com.ibm.team.repository.web", "ui/internal/admin/server/templates/LicenseQuickConnectStep.html"),
		widgetsInTemplate: true,
		innerBoxTrim:  TrimStyles.EDITOR,
        
        constructor: function(){
            this.messages = messages = dojo.i18n.getLocalization("com.ibm.team.repository.web.ui.internal.admin.server", "LicenseEditorMessages");
        },
        
        postCreate: function(){
			this.header = new MessageBox();
			this.headerText.innerHTML = this.stepTitle;
            this.stepHeaderArea.appendChild(this.header.domNode);
			this.checkboxFloatingServer.checked = this.initialVal;
			this.sb_header.innerHTML = this.messages.floatingConnectOption + ":";
        },
		
		canFinish: function(){
            return this.finalStep();
        }
				
	});

})();