/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
(function(){
    dojo.provide("com.ibm.team.repository.web.ui.internal.admin.server.LicenseWizard");
    
    dojo.require("dojo.date");
    dojo.require("dojo.date.locale");
    dojo.require("dojo.date.stamp");
    dojo.require("dojo.number");
    dojo.require("dijit._Widget");
    dojo.require("dijit._Templated");
    dojo.require("dojox.xml.parser");
    
    dojo.require("net.jazz.ajax.contextRoot");
    dojo.require("net.jazz.ajax.ui.PlatformUI");
	dojo.require("jazz.ui.StyledBox");
    
    dojo.require("com.ibm.team.repository.web.client.internal.licensing");
	dojo.require("com.ibm.team.repository.web.client.internal.ServerStatusClient");
    dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
    dojo.require("com.ibm.team.repository.web.ui.internal.admin.server.FileUploader");
    dojo.require("com.ibm.team.repository.web.ui.internal.admin.server.ConfigUtility");
    dojo.require("com.ibm.team.repository.web.client.init.InitializationData");
    dojo.require("com.ibm.team.repository.web.ui.internal.Util");
	dojo.require("com.ibm.team.repository.web.ui.internal.events");
	
    dojo.require("dojo.i18n");
    
    dojo.require("com.ibm.team.repository.web.ui.internal.admin.server.LicenseHelper");
    dojo.require("com.ibm.team.repository.web.ui.internal.admin.server.LicenseQuickConnectStep");
	dojo.require("com.ibm.team.repository.web.ui.internal.admin.server.LicenseAgreementStep");
	dojo.require("jazz.ui.wizard.WizardStep");
    dojo.require("jazz.ui.MessageBox");
    
    
    //
    // Aliases
    //
    
    var FileUploader = com.ibm.team.repository.web.ui.internal.admin.server.FileUploader;
	var ServerStatusClient = com.ibm.team.repository.web.client.internal.ServerStatusClient;
    var InitializationData = com.ibm.team.repository.web.client.init.InitializationData;
    var LIC_P = com.ibm.team.repository.web.client.internal.licensing;
    var formatCALTypeDescription = LIC_P.formatCALTypeDescription;
    var getLicenseInfo = LIC_P.getLicenseInfo;
    var getUsedLicenseInfo = LIC_P.getUsedLicenseInfo;
    var getExpirationInfo = LIC_P.getExpirationInfo;
    var getLicenseAgreement = LIC_P.getLicenseAgreement;
	var hasExpiredTrial = LIC_P.hasExpiredTrial;
    var sortCALs = LIC_P.sortCALs;
    var postLicenseInfo = LIC_P.postLicenseInfo;
    var removeChildren = dojox.xml.parser.removeChildren;
    var SRH = com.ibm.team.repository.web.transport.ServiceResponseHandler;
    var UPLOAD_URI = LIC_P.FILE_UPLOAD_URI;
    var FLOATING_LICENSE_SERVICE_NAME = "com.ibm.team.repository.service.internal.license.LicenseService";
    var FLOATING_SUPPORT_OPERATION_ID = "com.ibm.team.repository.support.floatingLicenses";
    var LicenseHelper = com.ibm.team.repository.web.ui.internal.admin.server.LicenseHelper;
	var LicenseQuickConnectStep = com.ibm.team.repository.web.ui.internal.admin.server.LicenseQuickConnectStep;
	var LicenseAgreementStep = com.ibm.team.repository.web.ui.internal.admin.server.LicenseAgreementStep;
    var MessageBox = jazz.ui.MessageBox;
    var WizardStep = jazz.ui.wizard.WizardStep;
	var TrimStyles = jazz.ui.StyledBox.TrimStyles;
    var STATUS_TYPES = MessageBox.STATUS_TYPES;
    var ConfigUtility = com.ibm.team.repository.web.ui.internal.admin.server.ConfigUtility;
	var DEFAULT_LICENSE_SERVICE = "com.ibm.team.repository.service.internal.license.DefaultLicenseProviderService";
	
    var messages;
    //
    // Widget definition
    //
    
    dojo.declare("com.ibm.team.repository.web.ui.internal.admin.server.LicenseWizard", [WizardStep, LicenseHelper, dijit._Widget, dijit._Templated], {
    
        templatePath: dojo.moduleUrl("com.ibm.team.repository.web", "ui/internal/admin/server/templates/LicenseWizard.html"),
		widgetsInTemplate: true,
		innerBoxTrim:  TrimStyles.EDITOR,
        
        constructor: function(){
            this.messages = messages = dojo.i18n.getLocalization("com.ibm.team.repository.web.ui.internal.admin.server", "LicenseEditorMessages");
        },
        
        postCreate: function(){
            com.ibm.team.repository.web.ui.internal.admin.server.LicenseWizard.superclass.postCreate.apply(this);
            
            this._setInfopopHeading(this.limitHeader, "limitHeader", "limitHeaderInfo");
            this._setInfopopHeading(this.includedHeader, "includedHeader", "includedHeaderInfo");
            this._setInfopopHeading(this.totalHeader, "totalHeader", "totalHeaderInfo");
            this._setInfopopHeading(this.previewUsersHeader, "usersHeader", "usersHeaderInfo");
            
            this.header = new MessageBox();
			this.headerText.innerHTML = this.stepTitle;
            this.stepHeaderArea.appendChild(this.header.domNode);
			
			//Secondary Message Box
			this.previewMsgHandler = new MessageBox();
			this.previewMessageBox.appendChild(this.previewMsgHandler.domNode);
			
			this.styledBox2_header.innerHTML =  this.messages.enterNumberCALS + ":";
   
            this.configUtil = new ConfigUtility();
            
            this.maxCounts = [];
            this.newUploads = new Array();
			this.declinedAgreements = new Array();
            this.agreements = new Array();
            
            this.initialLicenseInfo = this.licenseInfo;
			
			this.setFloatingUrl();   
            
            if (this.mode == "upload") {
                this.uploadMode.style.display = "block";
                this.reset(this.licenseInfo);
                this.loadForms();
            }
			else if(this.mode == "setDefault") {
				this.setDefaultMode.style.display = "block";
                this.loadDefault();
			}
            else {
                this.editCountMode.style.display = "block";
                this.loadCALTable();
            }
        },
		
		loadDefault: function() {
			this.licenseInputs = [];
			this.defaultLicenseDescription.innerHTML = this.messages.defaultWizardDescription;
			var types = this.licenseInfo.types;
			if (types) {
				var licenses = sortCALs(types);
				var lastdiv; //to remove bottom border
				for (var i = 0; i < licenses.length; i++) {
					var licenseInfo = LIC_P.getClientAccessLicenseInfo(this.licenseInfo, licenses[i]);
					var div = dojo.create("div", { className: "checkboxDiv" }, this.licensesDiv);
					lastdiv = div;
					var checkbox = dojo.create("input", { type: "checkbox", id: "checkBox_" + licenses[i].id, value: licenses[i].id }, div);
					this.connect(checkbox,"onclick", dojo.hitch(this, function(e) {
						this.triggerButtonStateUpdate();
					}));
					
					checkbox.savedValue = false;
					if(this.defaultLicenses && this.defaultLicenses.length > 0) {
						var inArray = dojo.some(this.defaultLicenses, function(type){ return type === licenses[i].id; }, this);	
						if(inArray) {
							checkbox.checked = true;
							checkbox.savedValue = true;
						}
					}
					
					this.licenseInputs.push(checkbox);
					var txtDiv = dojo.create("div", { className: "labelContainer"}, div);
					var curLabel = dojo.create("label", { htmlFor: checkbox.id, innerHTML: licenseInfo.name + " " }, txtDiv);
					
					var availableLicenses = licenseInfo.available;
					var variantAndCount = dojo.create("div", { className: "variantAndCount" }, txtDiv);
					var licenseCountSpan = dojo.create("span");
					if (availableLicenses != -1) {
						licenseCountSpan.appendChild(document.createTextNode(licenseInfo.simpleAvailabilityString));
					}
					
					licenseCountSpan.licenseCount = availableLicenses;
					licenseCountSpan.assignableToUserWithCALs = licenseInfo.assignableToUserWithCALs;
					licenseCountSpan.assignableToUserWithoutCALs = licenseInfo.assignableToUserWithoutCALs;
					checkbox.licenseCountSpan = licenseCountSpan;
					variantAndCount.appendChild(licenseCountSpan);

					if(licenseInfo.variantName) {
						if (availableLicenses != -1) {
							variantAndCount.appendChild(document.createTextNode(" - "));
						}
						variantAndCount.appendChild(document.createTextNode(licenseInfo.variantName));
					}
					
					if (licenses[i].expirationTime) {
						var obj = getExpirationInfo(licenses[i].expirationTime);
						variantAndCount.appendChild(document.createTextNode(" (" + obj.expiresOnString + ")"));
					}
				}
				lastdiv.style.border = "none";
			} else {
				var div = dojo.create("div", { className: "checkboxDiv", style: { "border": "none" } }, this.licensesDiv);
				var checkbox = dojo.create("input", { type: "checkbox", id: "checkBox_none", value: "" }, div);
				this.connect(checkbox,"onclick", dojo.hitch(this, function(e) {
					this.triggerButtonStateUpdate();
				}));
				this.licenseInputs.push(checkbox);
				var txtDiv = dojo.create("div", { className: "labelContainer"}, div);
				var curLabel = dojo.create("label", { htmlFor: checkbox.id, innerHTML: this.messages.noDefault }, txtDiv);
					
				this.defaultLicenseDescription.innerHTML = this.messages.noLicensesInstalled;
			}
		},
		
		hasDefaultChanged: function() {
			if (this.licenseInputs) {
				for (var i=0; i < this.licenseInputs.length; i++) {
					if (this.licenseInputs[i].checked != this.licenseInputs[i].savedValue) {
						return true;
					}
				}
			}
			return false;
		},
		
		getAllDefaultLicenses: function() {
			var licenseChanges = [];
			if (this.licenseInputs) {
				for (var i=0; i < this.licenseInputs.length; i++) {
					if (this.licenseInputs[i].checked) {
						licenseChanges.push(this.licenseInputs[i].value);
					}
				}
			}
			return licenseChanges;
		},
		
		testLicenseSelections: function() {
			var licenseChanges = this.getAllDefaultLicenses();
			if(licenseChanges.length > 0 && licenseChanges[0] != "") { //exception for the "None" case
				var args = { licenseIds: licenseChanges }
				LIC_P.postTestLicenseAssignments(new SRH(this, "saveDefaultLicense", "handleLicenseTestFailed"), args);	
			} else {
				this.saveDefaultLicense();
			}
		},
		
		handleLicenseTestFailed: function(errorObject) {
			this.header.showMessage({
                errorObject: errorObject,
                summary: this.messages.conflictingLicensesError
            });
		},
		
		saveDefaultLicense: function() {
			var value = this.getAllDefaultLicenses().toString();
			if(value) value = "[" + value + "]"
			var changes = [{
                "name":"default.licenseid.list",
				"value": value,
				"serviceImplementationName": DEFAULT_LICENSE_SERVICE
            }];
            var changeList = {
                "changes": changes,
                "properties": []
            };
			this.configUtil.save(changeList, this, "cbSave", "cbSaveError");
		},
		
		_forAllKeys: function(types, f) {
			dojo.forEach(types, function(type) {
				dojo.forEach(type.keys, function(key) {
					f(key,type);	//type is optionally passed as a second parameter. f() does not need to use it.
				});
			});
		},
        
        loadCALTable: function(){
			this.isCALCountDirty = false;
			
            var tbody = this.EditCALTable;
            var self = this;
            removeChildren(tbody);
            
            if (this.floatingOn) {
                var types = this.licenseInfo.floatingLicenseTypes || [];
            }
            else {
                var types = this.licenseInfo.types || [];
            }
            types = sortCALs(types);
            
            var isTrial = this.licenseInfo.serverLicense.trial;
            this._setPurchasesOrTrialTableHeader(this.purchasedOrTrialHeader);
			
			var someHaveEditions = false;
			this._forAllKeys(types, function(key){
                //Use this check to prevent acquired floating CALs to show in edit view
                if (self.floatingOn || key.floating == false) {

                    var icon = d.ce("div");
                    var status = d.ce("span");
                    
                    var row = d.ce("tr");
                    tbody.appendChild(row);
                    
                    var nameLink = self._getInfopopLink(key.name, formatCALTypeDescription(key));

					var isDisabled = key.disabledReason != null;
					var hasUnactivatedTrial = key.hasUnactivatedTrial;
					var isExpiredTrial = hasExpiredTrial(key);
					
					if (isExpiredTrial || hasUnactivatedTrial || isDisabled) {
		                row.className = "disabledCAL";
						icon.className = "icon-warning";
						dojo.addClass(nameLink,"disabledCAL");
						dojo.addClass(status,"WARNINGcolor");
						if(isExpiredTrial) {
							status.innerHTML = self.messages.expiredTrial;	
						} else if(hasUnactivatedTrial) {
							var durationOfTrial = getExpirationInfo(key.unactivatedTrialExpirationTime).daysRemaining;
							status.innerHTML = dojo.string.substitute(self.messages.trialNotStarted, [durationOfTrial]);
						} else {
							status.innerHTML = dojo.string.substitute(self.messages.deactivatedReason, [key.disabledReason]);
						}
		            } else {
						icon.className = "icon-ok";
						status.innerHTML = self.messages.activated;
					}
					
					if(key.editionName) {
						someHaveEditions = true;
					}
					var variantString = LIC_P.getVariantString(key) || null; //IE7
                    
                    var limit = getCountOrUnlimited(key.max);
                    var included = getCountOrUnlimited(key.free);
                    var total = getCountOrUnlimited(key.total);
					
					var isTrialCAL = key.trial;
                    
                    if (isTrialCAL || (isTrial && key.floating == false)) {
                        var purchase = key.max === -1 ? self.messages.notApplicable : key.max - key.free;
                        var total = getCountOrUnlimited(key.max);
                    }
                    else {
                        var purchase = key.free === -1 ? self.messages.notApplicable : key.total - key.free;
                    }
					
					var calVersion = key.version ? dojo.create("span", { innerHTML: key.version }) : null;
					if (calVersion) calVersion._className = "num"; 
                    
                    var nodes = [key.productName, calVersion, nameLink, variantString, limit, included, purchasedOrTrialCol(self, key, isTrial, purchase, key.floating), total, icon, status];
                    
                    dojo.forEach(nodes, function(node){
                        col(row, node);
                    });
                } // end floating check
            });

			this.parentPointer._changeColumnLabel(this.EditTable, /* column index */ 3, someHaveEditions ? this.messages.edition : this.messages.variant );
            this.validateCALPurchaseCounts();
        },
        
        saveEditor: function(currentStepWidget) {
			this.currentStepWidget = currentStepWidget;	//keep a reference to this widget so we can push messages to it's MessageBox if needed.
			this.header.showMessage({
                type: STATUS_TYPES.INFO,
                summary: this.messages.savingLicenseInfo
            });
            var args = dojo.mixin(this.getEditorData(), {
                commit: true
            });
            postLicenseInfo(new SRH(this, "cbSave", "cbSaveError"), args);
        },
		
		warnBeforeOverwrite: function() {
			if(this.step2.checkboxFloatingServer.checked == true) {
				if(this.currentFloatingUrl != "" && this.currentFloatingUrl != this.serverFloatingUrl) { 
					this.step2.header.showMessage({
		                type: STATUS_TYPES.WARNING,
		                summary: dojo.string.substitute(this.messages.warnOnFloatingUrlChange,
								 [ this.currentFloatingUrl, this.serverFloatingUrl ])
		            });
				}			
			} else {
				this.step2.header.hideMessage();
			}
		},
		
		setFloatingUrl: function() {
			var contextRoot = net.jazz.ajax.contextRoot();
			var port = window.location.port;
			this.serverFloatingUrl = window.location.protocol + "//" + window.location.hostname;
			if( port ){
				this.serverFloatingUrl += ":" + port;
			 }
			 this.serverFloatingUrl += contextRoot + "/";
		},
        
        /**
         * Success callback from 'Save' action; resets editor based on newly
         * persisted state.
         */
        cbSave: function(licenseInfo){
			if(licenseInfo) {
				this.reset(licenseInfo);
				dojo.publish(com.ibm.team.repository.web.ui.internal.events.licenseChange, [licenseInfo]);	
			}
            this.parentPointer.reload();
            var self = this;
            function f(){
                self.header.hideMessage();
				self.parentPointer.wizard.contentArgs.container.close();
            }
            this.showEventOutcomeMessage("ok", this.messages.saveComplete, f, 700);
       },
        
        cbSaveError: function(errObj) {
			if(this.wizard && this.wizard.wizardFinishButton) {
				this.wizard.wizardFinishButton.disabled = false;
			}
            this.cbRemoteError(errObj, this.messages.saveError);
        },
        //
        // Upload-related methods
        //
        
        cbUpload: function(obj, widgetPropName){
            this.markDirtyLicenseInfo();
            this.lastUploadType = obj;			
			//If the object is a batch of keys (ZIP), batch process them 
			if(obj.licenses) {
				var self = this;
				dojo.forEach(obj.licenses,function(item) {
					self._uploadedCALFiles[item.policy.id] = item.fileName; //**do we need this? or is it just 1 file?? ***
					if (dojo.indexOf(self.newUploads, item.policy.id) == -1) {
						self.newUploads.push(item.policy.id);
					}
					self.agreements[item.policy.id] = item.agreement;
				});
				
			} else {
				//If obj.policy does not exist, this means the upload ran into server problems. Throw error
				if(!obj.policy) {
					this.showEventOutcomeMessage("error", this.messages.serverError);
					return;
				}
			
				//This is a single CAL in a JAR file. Process normally.	
				var keyId = obj.policy.id;
				if (obj.policy.keys)
					keyId = obj.policy.keys[0].id;
	            this._uploadedCALFiles[keyId] = obj.fileName;
	            this.agreements[keyId] = obj.agreement;
	            if (dojo.indexOf(this.newUploads, keyId) == -1) {
	                this.newUploads.push(keyId);
	            }
			}
            this.showEventOutcomeMessage("ok", this.messages.successfulUpload, dojo.hitch(this, this.fetchToBeState), 1000);
        },
        
        cbUploadFailure: function(errObj){
            this.header.showMessage({
                type: STATUS_TYPES.ERROR,
                summary: this.messages.errorUpload,
				details: [{
					message: errObj.errorMessage
				}]
            });
        },
        
        deletePreviewEntry: function(e){
	
            var verifyDelete = confirm(this.messages.confirmDelete);
            if (verifyDelete) {
				var loc = e.target;
                var index = dojo.indexOf(this.newUploads, loc.id);
                if (index != -1) {
                    this.newUploads.splice(index, 1);
					//We need to remove the additional steps if the last uploaded key was deleted
					if(!this.lastUploadType.licenses && this.lastUploadType.policy.id == loc.id ) {
						this.editCountBox.style.display = "none";
					}
					//Remove the uploaded file from the array
					if (this._uploadedCALFiles[loc.id]) {
						delete this._uploadedCALFiles[loc.id];
					}
					//also discard any changes that may have been made in these steps
					if (this.maxCounts[loc.id]) {
						delete this.maxCounts[loc.id];
					}
					this.buildPreviewTable();
                }
            }
        },
        
        showUploadPreview: function(){        
            this.header.hideMessage();
			this.previewMsgHandler.hideMessage();
            this.editCountBox.style.display = "none";
            this.buildPreviewTable();
        },
        
        buildPreviewTable: function(){
        
            removeChildren(this.uploadQueue);
            var self = this;
			var someHaveEditions = false;
            dojo.forEach(this.newUploads, function(licId){
                //Lookup the object that relates to this id.
                var licInfo, licType;
                //First see if it is a server key.. easy case
                if (self.licenseInfo.serverLicense.id == licId) {
                    licInfo = self.licenseInfo.serverLicense;
                    licType = "sever";
                }
                else {
                    //Have to handle types array separately to filter out floating keys
                    var types = self.licenseInfo.types || [];
					self._forAllKeys(types, function(key,type) {
                        if (!key.floating && key.id == licId) {
                            licInfo = key;
							licInfo.disabledReason = type.disabledReason;
                            licType = "CAL";
                        }
					});
                    //Only traverse floatingTypes if we haven't found the key yet
                    if (licInfo == null || licType == null) {
                        var floatingTypes = self.licenseInfo.floatingLicenseTypes || [];
                        self._forAllKeys(floatingTypes, function(key,type){
                            if (key.id == licId) {
                                licInfo = key;
								licInfo.disabledReason = type.disabledReason;
                                licType = "CAL";
                            }
                        });
                    }
                }
                
                //If we don't have enough information to build this row. Skip it.
                if (licInfo != null && licType != null) {
                
                    var icon = dojo.create("div");
                    var status = dojo.create("span");
                    var row = dojo.create("tr");
                    self.uploadQueue.appendChild(row);
					
					//Set the Status
					var isDisabled = licInfo.disabledReason != null;
					var hasUnactivatedTrial = licInfo.hasUnactivatedTrial;
					var isExpiredTrial = hasExpiredTrial(licInfo);
					if (isExpiredTrial || hasUnactivatedTrial || isDisabled) {
		                row.className = "disabledCAL";
						icon.className = "icon-warning";
						dojo.addClass(status,"WARNINGcolor");
						if(isExpiredTrial) {
							status.innerHTML = self.messages.expiredTrial;	
						} else if(hasUnactivatedTrial) {
							var durationOfTrial = getExpirationInfo(licInfo.unactivatedTrialExpirationTime).daysRemaining;
							status.innerHTML = dojo.string.substitute(self.messages.trialNotStarted, [durationOfTrial]);
						} else {
							status.innerHTML = dojo.string.substitute(self.messages.deactivatedReason, [licInfo.disabledReason]);
						}
		            } else {
						icon.className = "icon-ok";
						status.innerHTML = self.messages.activated;
					}
                    
                    var total = dojo.create("div");
                    total.setAttribute('id', "total-" + licInfo.id);
                    row.setAttribute('id', "row-" + licInfo.id)
                    
                    //Build delete button
                    var del = dojo.create("img");
                    var removeIconSrc = dojo.moduleUrl("com.ibm.team.repository.web", "ui/internal/admin/users/images/remove.gif").toString();
                    del.setAttribute('src', removeIconSrc);
                    del.setAttribute('title', self.messages.removeKey);
                    del.setAttribute('id', licInfo.id);
                    del.setAttribute('style', "cursor:pointer;");
                    self.connect(del,"onclick", self.deletePreviewEntry);
					
					if(licInfo.editionName) {
						someHaveEditions = true;
					}			
					var variantString = LIC_P.getVariantString(licInfo) || null; //IE7
					
                    if (licType == "CAL") {
                        var nameLink = self._getInfopopLink(licInfo.name, formatCALTypeDescription(licInfo));
                        if (isExpiredTrial || hasUnactivatedTrial || isDisabled) {
							dojo.addClass(nameLink, "disabledCAL");
						}
                        var serverLicense = self.licenseInfo.serverLicense;
						var isTrialCAL = licInfo.trial;
                        
                        if (self.maxCounts[licInfo.id]) {
                            total.innerHTML = self.maxCounts[licInfo.id] + licInfo.free;
                        }
                        else {
                            total.innerHTML = isTrialCAL ? getCountOrUnlimited(licInfo.max) : getCountOrUnlimited(licInfo.total);
                        }
						
						var calVersion = licInfo.version ? dojo.create("span", { innerHTML: licInfo.version }) : null;
						if (calVersion) calVersion._className = "num"; 

                        var nodes = [licInfo.productName, calVersion, nameLink, variantString, total, icon, status, del];
                        
                    }
                    else {
						//Server key
                        total.innerHTML = licInfo.maxContributors !== -1 ? licInfo.maxContributors : self.messages.unlimited;
						var isTrial = licInfo.trial;
                        if (licInfo.disabledReason) {
                            status.innerHTML = licInfo.disabledReason;
                        }
                        else {
							if (isTrial) {
								var expirationInfo = getExpirationInfo(licInfo.expirationTime);
								if (expirationInfo.isExpired) {
									status.innerHTML = self.messages.expiredTrial;
									icon.className = "icon-error";
                        			row.className = "disabledCAL";
								}
								else {
									status.innerHTML = self.messages.trial;
								}
							}
							else {
								status.innerHTML = self.messages.permanent;
							}

                        }
						
						var calVersion = licInfo.version ? dojo.create("span", { innerHTML: licInfo.version }) : null;
						if (calVersion) calVersion._className = "num"; 
						
                        var nodes = [licInfo.productName, calVersion, "Server Key", variantString, total, icon, status, del];
                        
                    } //endif - licType=='CAL' check
                    dojo.forEach(nodes, function(node){
                        col(row, node);
                    });
                    
                } //endif - only build row if we have licInfo != null
            });
			
			this.parentPointer._changeColumnLabel(this.PreviewTable, /* column index */ 3, someHaveEditions ? this.messages.edition : this.messages.variant );
        },
        
        highlightNode: function(node){
            var fx = dojo.animateProperty({
                node: node,
                duration: 1000,
                properties: {
                    backgroundColor: {
                        start: "#FF7",
                        end: "#FFF"
                    }
                }
            });
            fx.play();
        },
        
        connectToMyself: function(){
			//Don't bother adding a step if it already exists.
			var numSteps = this.parentPointer.wizard.contentWidget._steps.length;
			if (!this.connectStepIncluded && this.parentPointer.licenseInfo.floatingSetupStatus) {
                this.connectStepIncluded = true;
                this.currentFloatingUrl = this.parentPointer.licenseInfo.floatingSetupStatus.serverURL || "";
				
				//Only add the second step if we need it...
				// (1) no floating url exists
				// (2) floating url exists but is not pointing to this server.
				
				if(this.currentFloatingUrl != this.serverFloatingUrl) {
		            this.step2 = new LicenseQuickConnectStep({
						stepTitle: this.messages.step2Title,
						//If no floating URL is set, check the box by default. If a different server is currently configured, leave box unchecked.
						initialVal: (this.currentFloatingUrl === "")
		            });	
					this.connect(this.step2.checkboxFloatingServer,"onclick","warnBeforeOverwrite");
					this.parentPointer.wizard.contentWidget.showStepList();	
					this.parentPointer.wizard.addStep(this.step2);	
					this.hasFloatingStep = true;
				}
			}       
        },
					
		saveFloatingConnection: function(currentStepWidget){
			this.header.showMessage({
                type: STATUS_TYPES.INFO,
                summary: this.messages.savingLicenseInfo
            });
			
			var chkbox = this.step2.checkboxFloatingServer;
			if(chkbox.checked == true && this.serverFloatingUrl && this.serverFloatingUrl != "") {		
				var changes = [{
	                "name": "licenseService.floatingLicenseServerURI",
	                "serviceImplementationName": "com.ibm.team.repository.service.internal.license.LicenseService",
	                "value": this.serverFloatingUrl
	            }];
	            
	            var changeList = {
	                "changes": changes,
	                "properties": []
	            };
				
				var handler = {
					success: dojo.hitch(this, function() {
						this.saveEditor(currentStepWidget);	
					}),
					error: dojo.hitch(this, function(err) {
						this.cbSaveError(err);	
					})
				};
				
	            this.configUtil.save(changeList, handler, "success", "error");
				
			} else {
				//Leave the floating server url unchanged
				this.saveEditor(currentStepWidget);
			}  
        },
		    
		_findKeyInLicenseInfo: function(key){
            var types = this.licenseInfo.types || [];
            var floatingTypes = this.licenseInfo.floatingLicenseTypes || [];
            var combined = types.concat(floatingTypes);
            
            var type;
            this._forAllKeys(combined, function(t){
                if (t.id == key.id) {
                    type = t;
                }
            });
            
            return type;
		},
		    
        updatePurchaseCounts: function(){
            var errors = [];
            var isTrial = this.licenseInfo.trial;
            var self = this;
            var type = self._findKeyInLicenseInfo(self.lastUploadType.policy.keys[0]);
			
			if(!type) return;

            var limit = getCountOrUnlimited(type.max);
            var included = getCountOrUnlimited(type.free);
			
			var isTrialCAL = type.trial;
			      
            if (isTrialCAL || (isTrial && type.floating == false)) {
                var purchase = type.max === -1 ? self.messages.notApplicable : type.max - type.free;
            }
			else {
                var purchase = type.free === -1 ? self.messages.notApplicable : type.total - type.free;
            }
            
            // Remove the existing input box from previous CAL if necessary
            var input = dojo.byId('inputCalCount');
            if (input != null) 
                removeChildren(this.purchaseCounts);
            
            // Display input box for user to enter # of purchased CALs
            var elem = purchasedOrTrialCol(self, type, isTrial, purchase, /*isFloating */ type.floating);
            //Only show input box if purchase count is editable
            if (elem[0].tagName == "INPUT") {
            
                if (this.maxCounts[type.id]) {
                    this.totalCount.innerHTML = this.maxCounts[type.id] + type.free;
                }
                else {
                    this.totalCount.innerHTML = isTrialCAL ? getCountOrUnlimited(type.max) : getCountOrUnlimited(type.total);
                }
                
                this.includedCount.innerHTML = included;
                this.purchaseCounts.appendChild(elem[0]);
                this.purchaseCounts.appendChild(elem[1]);
                this.editCountBox.style.display = "block";
                //Highlight the column these settings apply to.
                var row = dojo.byId("row-" + type.id);
                if (row) dojo.addClass(row.childNodes[4], "selected");
            }
            
            return errors;
        },
        
        onPurchasedCountKeyUp: function(e){
            var input = e.target;
            if (!input || input.__jazzOrigValue === undefined) {
                return; // early return
            }
            if (input.value !== input.__jazzOrigValue) {
                this.markDirtyLicenseInfo();
            }
            // Run a validation after the user stops typing for half a second
            if (this._calKeyStrokeTimout) {
                clearTimeout(this._calKeyStrokeTimout);
            }
            this._calKeyStrokeTimout = setTimeout(dojo.hitch(this, this.validate), 500);
        },
        
        // Utility methods
        //
        
        /**
         * General purpose error callback for remote methods.
         */
        cbRemoteError: function(errorObj, msg){
            if (!msg) {
                msg = this.messages.serverError;
            }
            if (errorObj.status === 0) {
                msg += this.messages.serverUnreachable;
            }
            else {
                msg += " (" + errorObj.message + ")";
            }
            this.showEventOutcomeMessage("error", msg);
        },
        
        
        /**
         * Resets both the object and UI state of this editor, based on the
         * <code>licenseInfo</code> parameter (short-op).
         */
        reset: function(licenseInfo){
            // reset object state
            this.initialLicenseInfo = this.licenseInfo = licenseInfo;
            this.usedLicenseInfo = null;
            this._uploadedCALFiles = [];
            this.lastFloatingCount = licenseInfo.floatingLicenseTypes && licenseInfo.floatingLicenseTypes.length ? licenseInfo.floatingLicenseTypes.length : 0;
            this.isDirtyLicenseInfo = false;
            
            // reset UI state
            this.header.hideMessage();
            this.checkDirty();
            
            this.previewMsgHandler.hideMessage();
            var self = this;
            var floatHelper = {
                yes: function(status){
                    //	self.addLicenseUsageDetails();
                },
                no: function(s){
                    self.usedLicenseInfo = null;
                },
                error: function(err){
                    self.cbRemoteError(err);
                }
            }
            
            LIC_P.checkFloatingLicensesSupported(floatHelper.yes, floatHelper.no, floatHelper.error);
        },
        
        
        /**
         * Fetches the most recent saved license information from the server and
         * resets the editor with this information (long-op).
         */
        reload: function(){
            if (this._isDirty && !confirm(this.messages.refreshDirty)) {
                return;
            }
            var self = this;
            var o = {
                s: function(licenseInfo){
                
                    self.reset(licenseInfo);
                    self.initialLicenseInfo = self.licenseInfo = licenseInfo;
                    
                    // reset UI state
                    self.header.hideMessage();
                    self.checkDirty();
                },
                f: function(err){
                    self.cbRemoteError(err);
                }
            }
            getLicenseInfo(new SRH(o, "s", "f"));
        },
        updateLicenseInfo: function(){
            var self = this;
            var o = {
                s: function(licenseInfo){
                    self.initialLicenseInfo = self.licenseInfo = licenseInfo;
                },
                f: function(err){
                    self.cbRemoteError(err);
                }
            }
            getLicenseInfo(new SRH(o, "s", "f"));
        },
        
        
        //
        // UI Status and State reporting
        //
        
        showEventOutcomeMessage: function(type, message, cb, duration){
            if (cb) {
                setTimeout(cb, duration || 3000);
            }
            else 
                if (duration) {
                    setTimeout(function(){
                        this.header.hideMessage()
                    }, duration);
                }
            var t = STATUS_TYPES.OK;
            if (type == "error") 
                t = STATUS_TYPES.ERROR;
            this.header.showMessage({
                type: t,
                summary: message
            });
			
			//We should surface any errors on the step that the user clicked "Finish" on, otherwise
			//the user will not see the errors on previous steps.
			if(this.currentStepWidget && this.currentStepWidget.header) {
				this.currentStepWidget.header.showMessage({
	                type: t,
	                summary: message
	            });	
			}
        },
        
        updateStatusMessage: function(){
			var hasErrors = this.status.errors.length > 0;
            var hasWarnings = this.status.warnings.length > 0;
            var hasPendingAction = this.status.pending.length > 0;
			if (hasErrors || hasWarnings) {
                if (hasErrors) {
                    var numErrors = this.status.errors.length;
					if(numErrors && numErrors > 1) {
						//Break up multiple messages
						var errDetails = [];
						for (var i = 0; i < this.status.errors.length; i++) {
							warnDetails.push({message: this.status.errors[i], code: STATUS_TYPES.ERROR});
						}
						this.header.showMessage({
	                        type: STATUS_TYPES.ERROR,
	                        summary: dojo.string.substitute(this.messages.multipleErrors, [numErrors]),
							details: errDetails
	                    });
					} else {
						this.header.showMessage({
	                        type: STATUS_TYPES.ERROR,
	                        summary: this.status.errors[0]
	                    });
					}			
				//hasWarnings
                } else {	
					var numWarnings = this.status.warnings.length;
					if(numWarnings && numWarnings > 1) {
						//Break up multiple messages
						var warnDetails = [];
						for (var i = 0; i < this.status.warnings.length; i++) {
							warnDetails.push({message: this.status.warnings[i], code: STATUS_TYPES.WARNING});
						}
						this.header.showMessage({
	                        type: STATUS_TYPES.WARNING,
	                        summary: dojo.string.substitute(messages.multipleWarnings, [numWarnings]),
							details: warnDetails
	                    });
					} else {
						this.header.showMessage({
	                        type: STATUS_TYPES.WARNING,
	                        summary: this.status.warnings[0]
	                    });
					}

                }
            }
            else 
                if (this._isDirty) {
                
                    if (hasPendingAction) {
                        this.header.showMessage({
                            type: STATUS_TYPES.INFO,
                            summary: this.status.pending
                        });
                    }
                    else {
                        var pendingMsg = this.mode == "upload" ? this.messages.pendingChangesInfo : this.messages.pendingChangesEditMode;
                        this.header.showMessage({
                            type: STATUS_TYPES.INFO,
                            summary: pendingMsg
                        });
                    }
                    
                }
                else {
                    this.header.hideMessage();
                }
        },
        
        //
        // UI data binding and querying
        //
        
        loadForms: function(){
            var formName1 = "newCALUploadForm";
            this[formName1] = this.createForm("unknown", formName1);
            this._uploadedCALFiles = [];
        },
        
        createForm: function(typeCode, formName){
            var self = this;
            var args = {
                formElements: [{
                    name: "licenseType",
                    value: typeCode
                }],
                formLabel: self.messages.uploadFormLabel,
                onBeginUpload: function(){
                    self.header.showMessage({
                        type: STATUS_TYPES.INFO,
                        summary: self.messages.uploadingFile
                    });
                },
                onUpload: function(o){
                    self.cbUpload(o, formName);
                },
                onUploadFailure: function(errObj){
                    self.cbUploadFailure(errObj);
                },
                postURI: UPLOAD_URI
            }
			this._FileUploader = new FileUploader(args, this[formName]);
            return this._FileUploader;
        },
        
        /**
         * Validate does the following:
         *
         * 1) Compares the state of the CALs in the dirty editor vs. the CALs'
         *    original state. The purpose of this validation is to generate warnings
         *    if the user is about to disable users that were previously enabled.
         * 2) Ensures that editable CAL 'purchased' counts are >= 0 and less than
         *    the maximum purchasable count for the CAL.
         *
         * 3) Validates the License Server Configuration property value.
         */
        validate: function(){
            var warnings = this.validateCALStates();
            warnings = warnings.concat(this.validateFloatingLicenseChanges());
            
            var errors = this.validateServerLicense();
            errors = errors.concat(this.validateCALPurchaseCounts());

            // CAL purchase counts can have errors, 
            // CAL state changes can produce warnings,
            // Server License Configuration can produce errors or warnings.
            this.status = {
                errors: errors,
                warnings: warnings,
                pending: []
            };
			
            this.triggerButtonStateUpdate();
            this.updateStatusMessage();
        },
        
        validateFloatingLicenseChanges: function(){
            var floatingIssues = false;
            var supportsFloating = findOperationCheckResults(this.licenseInfo, FLOATING_SUPPORT_OPERATION_ID);
            
            if (this.usedLicenseInfo && this.usedLicenseInfo.activeLeases) {
                var numActiveLeases = this.usedLicenseInfo.activeLeases.length;
                if (numActiveLeases > 0) {
                    if (!supportsFloating) {
                        floatingIssues = true;
                    }
                }
            }
            
            if (this.usedLicenseInfo && this.initialLicenseInfo.floatingLicenseTypes) {
                var numInstalledFloatingCALs = this.initialLicenseInfo.floatingLicenseTypes.length;
                if (numInstalledFloatingCALs > 0) {
                    if (!supportsFloating) {
                        floatingIssues = true;
                    }
                }
            }
            
            var warnings = [];
            
            if (!supportsFloating && this.lastUploadType.keyType == "server") {
                //If the user just uploaded a server license that no longer supports floating lic files...
				this.previewMsgHandler.showMessage({type: STATUS_TYPES.WARNING, summary: this.messages.noFloatSupport});
            }
            
            if (floatingIssues) {
                warnings.push(this.messages.noFloatMismatch);
            }
            if (this.lastFloatingCount === 0 && this.licenseInfo.floatingLicenseTypes && this.licenseInfo.floatingLicenseTypes.length > 0) {
                warnings.push(this.messages.convertToFloatingWarning);
            }
            
            return warnings;
        },
        
        validateCALStates: function(){
            var warnings = [];
            var origGood = {};
			var notNew = {};
            var origTypes = this.initialLicenseInfo.types;
            dojo.forEach(origTypes, function(type){
				notNew[type.id] = true; //keep track of existing keys
                if (!type.disabledReason) {
                    origGood[type.id] = true;
                }
            });
            var dirtyTypes = this.licenseInfo.types;
            var self = this;
            this._forAllKeys(dirtyTypes, function(key) {
				var keyname = key.productName ? key.productName + " " : "";
				keyname += key.name ? key.name : "";
                if (key.disabledReason && origGood[key.id]) {
                    warnings.push(dojo.string.substitute(self.messages.pendingCalDeactivation, [ keyname ]));
                }
				//Warn the user when a purchased CAL includes more than the maximum allows
				if(key.max !== -1 && key.free > key.max && notNew[key.id] == null) {
					warnings.push(dojo.string.substitute(self.messages.warnIncludesMoreThanMax, [keyname, key.free, key.max ]));
				}
				//Check to see if the CAL has a activationNotificationURL specified
				if(key.activationNotificationURL && notNew[key.id] == null) {
					var msg;
					if(key.activationNotificationMessage && key.activationNotificationMessage != "") {
						msg = key.activationNotificationMessage;
					} else {
						//show a generic message
						msg = dojo.string.substitute(self.messages.activationURLWarning, [ keyname, key.activationNotificationURL ]);
					}
					warnings.push(msg);
				}
            });
            return warnings;
        },
        
        validateCALPurchaseCounts: function(){
            var errors = [];
            if (this.mode == "upload") {
            
                //Upload mode	
                var input = dojo.byId('inputCalCount');
                if (input && input.tagName == "INPUT") {
                    var result = validateCALInput(input);
                    if (!result.valid) {
                        errors = [this.messages.purchaseCountError];
                    }
                    else {
                        this.maxCounts[input.__jazzCALId] = toInt(input.value);
                    }
                }
                
            }
            else {
            
                //Edit CAL counts mode
                var isValid = true;
                var inputs = this.EditCALTable.getElementsByTagName("input");
                for (var i = 0; i < inputs.length; i++) {
                    if (inputs[i].disabled) {
                        continue;
                    }
                    var result = validateCALInput(inputs[i]);
					if(result.changed) {
						this.isCALCountDirty = true;
					}
                    if (!result.valid) {
                        errors = [this.messages.purchaseCountError];
                    }
                }
            }
            
            return errors;
        },
        
        validateServerLicense: function(){
            var errors = [];
            if (this.licenseInfo.serverLicense && this.licenseInfo.serverLicense.disabledReason) {
                errors = [this.messages.serverLicenseError];
            }
            return errors;
        },
        
        //
        // General UI code
        //
        
        //
        // Validation logic and UI - validation can be triggered in two ways:
        // 1) User uploads a file (cbUpload calls fetchToBeState)
        // 2) User enters a new purchased count for a CAL (onPurchasedCountKeyUp)
        //
        
        fetchToBeState: function(){
            var args = dojo.mixin(this.getEditorData(), {
                commit: false
            });
			
            postLicenseInfo(new SRH(this, "cbFetchToBeState", "cbErrorPreviewing"), args);
        },
		
		cbErrorPreviewing: function(error) {
			this.cbRemoteError(error, this.parentPointer.messages.previewError);
		},
        
        cbFetchToBeState: function(licenseInfo){
        
            this.header.hideMessage();
            this.licenseInfo = licenseInfo;
			
			//User accidentally uploads the Activation zip (containing a single JAR) from the license key center
			if (this.lastUploadType.licenses && this.lastUploadType.licenses.length === 1) {
				this.lastUploadType = this.lastUploadType.licenses[0];
			}
			
            var type = this.lastUploadType.keyType;
            this.showUploadPreview();
            if (type == "CAL") {
                //Display "Step 1" to update purchase counts
                this.updatePurchaseCounts();
            }
			
			var self = this;
			this._forEachUploadedKey(function(currentKey) {				
				if (currentKey.floating == true) {
					//Also, Display "Step 2" to offer admin to connect to own server
	                self.connectToMyself();
				}
				var agreement = self.agreements[currentKey.id];
				if(agreement && currentKey.hasUnactivatedTrial == false) {
					//We need to append a License Agreement for this step.
					self.agreementStep = new LicenseAgreementStep({
						licenseKey: currentKey,
						agreementText : agreement,
						onAgreement: dojo.hitch(self, "_handleAgreementResponse")
					});
					self.parentPointer.wizard.contentWidget.showStepList();	
					self.parentPointer.wizard.addStep(self.agreementStep);
				}
			});
			
            
            this.validate();
            if (licenseInfo.floatingLicenseTypes && licenseInfo.floatingLicenseTypes.length != this.lastFloatingCount) {
                if (this.lastFloatingCount === 0) {
					this.previewMsgHandler.showMessage({type: STATUS_TYPES.WARNING, summary: this.messages.convertToFloatingWarning});
                }
            }
            
        },
        	
		_forEachUploadedKey: function(keyHandler) {
			var typeHandler = function(licenseType) {
				var licensePolicy = licenseType.policy;
				if(licensePolicy.keys && licensePolicy.keys.length > 0) {
					dojo.forEach(licensePolicy.keys, keyHandler);
				} else {
					keyHandler(licensePolicy);
				}
			}
			 
			
			if (this.lastUploadType.licenses) {
				dojo.forEach(this.lastUploadType.licenses, typeHandler);	
			} else {
				typeHandler(this.lastUploadType);
			}
		},
		
		
		_handleAgreementResponse: function(licenseId, hasAgreed) {
			if(!hasAgreed) {
				this.declinedAgreements.push(licenseId);
			} else {
				//Make sure we don't have this ID in the declined array
				var index = dojo.indexOf(this.declinedAgreements, licenseId);
				if (index != -1) {
					//Ah, looks like the user changed their mind. Remove it.
					this.declinedAgreements.splice(index, 1);
				}
			}
		},
        
        /**
         * Returns the current data associated with the editor needed to call
         * <code>postLicenseInfo()</code>.
         */
        getEditorData: function(){
            var calFiles = [];
            var self = this;
			
			//Make sure we don't save a CAL that was declined
          	for (var key in this._uploadedCALFiles) {
				var isDeclined = this._wasKeyDeclined(key);
				if(!isDeclined) {
					calFiles.push(this._uploadedCALFiles[key]);
				}
            }

            var args = {
                serverFile: null,
                calFiles: calFiles,
                maxCounts: [],
                operationIds: [FLOATING_SUPPORT_OPERATION_ID]
            };
            
            // if this is not a trial, possibly update the purchased counts
            if (this.mode != "upload") {
                var inputs = this.EditCALTable.getElementsByTagName("input");
                dojo.forEach(inputs, function(input){
                    if (!input.disabled) {
                        args.maxCounts.push({
                            id: input.__jazzCALId,
                            max: toInt(input.value)
                        });
                    }
                });
            }
            else {
                //Need to restructure the maxCount array before sending it back
                for (var key in this.maxCounts) {
					var isDeclined = this._wasKeyDeclined(key);
					if(!isDeclined) {
						args.maxCounts.push({
	                        id: key,
	                        max: this.maxCounts[key]
	                    });
					}
                }
            }
            return args;
        },
		
		_wasKeyDeclined: function(keyId) {
		    for(var i = 0; i < this.declinedAgreements.length; i++) {
		        if(this.declinedAgreements[i] == keyId) {
					return true;
				}
		    }
			return false;
		},
        
        //
        // UI state manipulation methods
        //
        
        markDirtyLicenseInfo: function(){
            this.isDirtyLicenseInfo = true;
            this.checkDirty();
        },
        
        checkDirty: function(){
            var dirty = false;
            if (this.isDirtyLicenseInfo || this.isCALCountDirty || this.hasDefaultChanged()) {
                dirty = true;
            }
            this._isDirty = dirty;
			return dirty;
        },
        
        clearDirty: function(){
            this._isDirty = false;
        },
		
		cancelRequested: function(){
			var verifyCancel = this.checkDirty() ? confirm(this.parentPointer.messages.cancelWizard) : true; 
			if (verifyCancel) {
				this.parentPointer.wizard.contentArgs.container.close();
			}
		},
        
        updateConfigState: function(){
            this.checkDirty();
            this.validate();
        },
        updateNextButton: function(){
            return this._isDirty && this.status.errors.length <= 0;
            
        },
        canFlipToNextPage: function(){
            return this.updateNextButton();
        },
        canFinish: function(){
            return this.finalStep() && (this._isDirty || this.hasDefaultChanged()) && (!this.status || this.status.errors.length <= 0);
        },
		
		uninitialize: function() {
			this.header.destroyRecursive();
			this.previewMsgHandler.destroyRecursive();
			if(this._FileUploader) {
				this._FileUploader.destroyRecursive();
			}
			this.inherited(arguments);
		}
        
    });
    var NUM_REGEX = /[0-9]+/g;
    var d = document;
    d.ce = document.createElement;
    
    function toInt(text){
        var match = text.match(NUM_REGEX);
        return match && parseInt(text, 10);
    }
    function validateCALInput(input){
        //Prevents values like "1a7" from being valid...
        var onlyNum = new RegExp(/^\s*\d+\s*$/);
        var numVal = toInt(input.value);
        if (numVal !== null && numVal <= input.__jazzMaxPurchasable && numVal >= 0 && String(input.value).search(onlyNum) != -1) {
            isValid = true;
            input.__jazzMsgArea.innerHTML = "";
        }
        else {
            var isValid = false;
			if(input.__jazzMaxPurchasable == Infinity) {
				var invalidMsg = messages.invalidCountInfinity;
			} else {
				var invalidMsg = dojo.string.substitute(messages.invalidCount, [input.__jazzMaxPurchasable]);
			}
            
            input.__jazzMsgArea.innerHTML = invalidMsg;
        }
        var node = input;
        node.className = isValid ? "num inputCol" : "inputCol";
        
        if (isValid) {
            dojo.removeClass(node, "hasError");
            dojo.removeClass(input.__jazzMsgArea, "errorMsg");
            
            var node = dojo.byId("total-" + input.__jazzCALId);
            var step1Total = dojo.byId("step1-total");
            if (node) {
                //highlightNode(node);
                node.innerHTML = step1Total.innerHTML = numVal + input.__jazzIncluded;
            }
            
        }
        else {
            dojo.addClass(node, "hasError");
            dojo.addClass(input.__jazzMsgArea, "errorMsg");
        }
        
        return {
            changed: input.value !== input.__jazzOrigValue,
            valid: isValid
        };
    }
    function findOperationCheckResults(licenseInfo, operationId){
        var result = null;
        if (licenseInfo.operationCheckResults) {
            dojo.forEach(licenseInfo.operationCheckResults, function(operationResult){
                if (operationResult.operationId == operationId) {
                    result = operationResult.allowed;
                }
            })
        }
        return result;
    }
    
    function getUsedLink(calType){
        if (calType.used === 0) {
            return 0;
        }
        else {
            var a = document.createElement("a");
            a.href = "#action=com.ibm.team.repository.manageUserCALs&licenseType=" + calType.id;
            a.innerHTML = calType.used;
            a.className = "num";
            return a;
        }
    }
    function col(row, node){
		if (node === null || node === undefined) {
            var td = dojo.create("td", { }, row);
			td.appendChild(document.createTextNode(" ")); //IE7
			return;
        }
        if (dojo.isString(node) && node.indexOf("null") != -1) {
            node = node.replace("null", "");
        }
        var td = d.ce("td");
        var isNumber = typeof node == 'number' || node instanceof Number;
        var isNumberCol = isNumber || node === messages.notApplicable || node === messages.unlimited;
        if (isNumberCol) {
            td.className = "num";
        }
        if (isNumber) {
            node = dojo.number.format("" + node);
        }
		if(node._className) {
			//Allow the node to force it's className
			dojo.addClass(td, node._className);
		}
        var isArray = !dojo.isString(node) && dojo.isArrayLike(node);
        if (node.tagName === "A" && node.className === "num") {
            td.className = "num";
        }
        else 
            if (isArray) {
                td.className = "num inputCol";
            }
        row.appendChild(td);
        var nodeArr = isArray ? node : [node];
        dojo.forEach(nodeArr, function(node){
            if (dojo.isString(node)) {
                node = document.createTextNode(node);
            }
            td.appendChild(node);
        });
    }
	function purchasedOrTrialCol(widget, type, isTrial, purchasedOrTrial, isFloatingForm){
    
        var msgDiv = d.ce("div");
        msgDiv.className = "errorMsg";
        
        if (LIC_P.allowsPurchaseCountUpdates(type, isTrial, isFloatingForm)) {
			var elem = dojo.create("input", {className: "num", id: "inputCalCount"});
            elem.value = elem.__jazzOrigValue = "" + purchasedOrTrial;
            if (elem.value == "" && isFloatingForm) {
				elem.value = 0;
			}     
            elem.__jazzChgEvt = widget.connect(elem, "onchange", widget.validate);			
			 // works for all cases except bogus data max a number and free -1, yields max purchase max + 1
	        elem.__jazzMaxPurchasable = type.max === -1 ? Infinity : type.max - type.free;
	        elem.__jazzIncluded = type.free;
	        elem.__jazzMsgArea = msgDiv;
        	elem.__jazzCALId = type.id; 
        	return [elem, msgDiv];
        }
        else {
			var elem = dojo.create("span", {className: "num"});
			elem.__jazzCALId = type.id; 
            elem.innerHTML = elem.__jazzOrigValue = "" + purchasedOrTrial;
            if (elem.innerHTML == "" && isFloatingForm) {
				elem.innerHTML = "0";
			}
			return [elem];
        }   
    }
    function getCountOrUnlimited(count){
        return count === -1 ? messages.unlimited : count;
    }
    
    function getCountString(count){
        return count === -1 ? messages.unlimited : (dojo.number.format(count));
    }
    
    
    
})();

