/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.dashboard.web.ui.internal.catalog.WidgetCatalogDialog");

dojo.require("jazz.ui.Dialog");
dojo.require("com.ibm.team.dashboard.web.ui.internal.catalog.DashboardCatalog");

dojo.requireLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardCatalogMessages");

(function() {

var _messages = dojo.i18n.getLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardCatalogMessages");

dojo.declare("com.ibm.team.dashboard.web.ui.internal.catalog.WidgetCatalogDialog", jazz.ui.Dialog, {
	
	compatibilityMode: false,  // if true, requests backward-compatible URLs
	iconPath: dojo.moduleUrl("com.ibm.team.dashboard.web", "graphics/WidgetCatalogDialog/icons/dialog-icon.gif").toString(),
	primaryTitle: _messages.addWidget,
	width: "900px",
	
	constructor: function(args) {
		this.contentNode = dojo.create("div", {"class": "com-ibm-team-dashboard-WidgetCatalogDialog"});
		this._catalog = new com.ibm.team.dashboard.web.ui.internal.catalog.DashboardCatalog({
			compatibilityMode: args.compatibilityMode,
			onAddWidget: args.onAddWidget
		}).placeAt(this.contentNode);
		dojo.create("input", {
			type: "submit",
			value: _messages.close,
			"class": "close",
			onclick: dojo.hitch(this, this.close)
		}, dojo.create("div", {"class": "button-bar"}, this.contentNode));
	},
	
	destroy: function() {
		this._catalog.destroy();
		this.inherited(arguments);
	}
});
})();