/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2014. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.UIHelper"); //$NON-NLS-1$
	dojo.provide("com.ibm.team.process.authoring.web.common.ui.internal.editors.GeneralInputFieldEditor"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants"); //$NON-NLS-1$
	var ProcessAuthoringConstants = com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants;
	var UIHelper = com.ibm.team.process.authoring.web.common.common.internal.UIHelper;
	
	dojo.declare("com.ibm.team.process.authoring.web.common.ui.internal.editors.GeneralInputFieldEditor", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "ui/internal/editors/templates/GeneralInputFieldEditor.html"), //$NON-NLS-1$ //$NON-NLS-2$
		field: null,
		fieldViewHandle: null,
		
		item: null,
		initializedCallback: null,
		isSharedElement: false,
		isOutlineElement: false,
		messageBox: null,
		
		constructor: function(args) {
		
			if (!args) {
				return;
			}
			
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
			if (args.item) {
				this.item = args.item;
			}
			this.initializedCallback = new dojo.Deferred();
			this.isSharedElement = args.item.root ? args.item.isSharedElement : args.item._S.getValue(args.item, "isSharedElement"); //$NON-NLS-1$
			this.isOutlineElement = args.item.root ? args.item.isOutlineElement : args.item._S.getValue(args.item, "isOutlineElement"); //$NON-NLS-1$ 
		},
		
		postCreate: function() {
			this.inherited(arguments);
			
			this.connect(this.fieldInput, "onchange", "_onFieldChange"); //$NON-NLS-1$ //$NON-NLS-2$
			this.connect(this.fieldInput, "onkeyup", "_onFieldChange"); //$NON-NLS-1$ //$NON-NLS-2$
			this.fieldLabel.innerHTML = this.messages.GeneralInputFieldEditor_0;
			this.fieldInput.value = this.field;
			
			if (this.viewOnly) {
				this.fieldInput.style.display = "none"; //$NON-NLS-1$
				this.fieldView.style.display = "block"; //$NON-NLS-1$
				this.fieldView.innerHTML = this.field;
			} else {
				this.connect(this.previewEditLink, "onclick", function(e) { //$NON-NLS-1$
					dojo.stopEvent(e);
					this._togglePreview(true);
				});
				
				if (!this.isViewMode()) {
					this.fieldViewHandle = this.connect(this.fieldView, "onclick", this.onFieldViewClick); //$NON-NLS-1$ //$NON-NLS-2$
				}
			}
			
			this._setupWarning();
			this.subscribe(ProcessAuthoringConstants.PUBLISHTYPE_VIEWMODE, this._toViewMode); //$NON-NLS-1$
			this.subscribe(ProcessAuthoringConstants.PUBLISHTYPE_EDITMODE, this._toEditMode); //$NON-NLS-1$
			this._togglePreview(this.isViewOnly() || this.isViewMode());

			setTimeout(dojo.hitch(this, function() {
				this.initializedCallback.callback();
				if (this.isNew) {
					this.viewOnly = false;
                	this.fieldInput.focus();
					this.fieldInput.select();
                }
			}), 100);
		},
		
		addInitializedCallback: function(callback) {
			this.initializedCallback.addCallback(callback);
		},
		
		onCategoryChange: function(item) {
		},
		
		isViewOnly: function() {
			return this.viewOnly;
		},
		
		isViewMode: function() {
			return this.controller.viewMode;
		},
		
		_toEditMode: function() {
			if (!this.isViewOnly()) {
				this.fieldViewHandle = this.connect(this.fieldView, "onclick", this.onFieldViewClick); //$NON-NLS-1$ //$NON-NLS-2$
			}
			this._togglePreview(this.isViewOnly());
		},
		
		_toViewMode: function() {
			if (!this.isViewOnly()) {
				this.disconnect(this.fieldViewHandle);
			}
			this._togglePreview(true);
		},
		
		onFieldViewClick: function(e) {
			dojo.stopEvent(e);
			this._togglePreview(false);
		},
		
		_setupWarning: function() {
			if (this.isOutlineElement) {
				this.warningMessageSpan.innerHTML = this.messages.GeneralInputFieldEditor_2;
			}
			this.messageBox = new jazz.ui.MessageBox();
			UIHelper.setReadOnlyWarning(this);
			this.longMessageBox.appendChild(this.messageBox.domNode);
		},
		
		onNavigateSharedPractice: function(e) {
			dojo.stopEvent(e);
			this.controller.onNavigateSharedPractice(this.practiceResource);
			
		},
		
		
		_togglePreview: function(toPreview) {
			//shared element in PLM should display message in edit mode
			//process description editor is viewOnly only when it's associated to a project area
			if (this.isViewOnly() && (this.isSharedElement || this.isOutlineElement) && !this.controller.viewOnly) {
				dojo.toggleClass(this.longMessageBox, ProcessAuthoringConstants.CSS_HIDE, this.isViewMode());
			}
			
			//change to edit mode
			if (!toPreview) {
				dojo.toggleClass(this.previewEditLink, ProcessAuthoringConstants.CSS_HIDE, false);
				this.fieldInput.style.display = "block"; //$NON-NLS-1$
				this.fieldView.style.display = "none"; //$NON-NLS-1$
			} else {
				dojo.toggleClass(this.previewEditLink, ProcessAuthoringConstants.CSS_HIDE, true);
				this.fieldInput.style.display = "none"; //$NON-NLS-1$
				this.fieldView.style.display = "block"; //$NON-NLS-1$
				dojo.toggleClass(this.fieldView, "previewField", !this.isViewMode() && !this.isViewOnly()); //$NON-NLS-1$
				if (this._isEmptyText(this.fieldInput.value) && !this.isViewMode() && !this.isViewOnly()) {
					dojo.html.set(this.fieldView, this.messages.TextField_0);
					dojo.toggleClass(this.fieldView, "novalueField", true); //$NON-NLS-1$
				} else {
					dojo.html.set(this.fieldView, this.fieldInput.value);
					dojo.toggleClass(this.fieldView, "novalueField", false); //$NON-NLS-1$
				}
			}
		},
		
		_isEmptyText: function(text) {
			return !text || dojo.string.trim(text).length == 0;
		},
		
		_onFieldChange: function(evt) {
			this.item._S.setValue(this.item, "label", this.fieldInput.value); //$NON-NLS-1$
			this.onCategoryChange(this.item);
		},
		
		uninitialize: function() {
			this.inherited(arguments);
			
			// See work item: 305416, It might be a bug of IE 11(10 is returned by dojo.isIE). 
			// We need manually trigger the blur event to release the focus so that other editor can get it properly.
			if (dojo.isIE >= 10 && this.fieldInput) {
				this.fieldInput.blur();
			}
			
			if (this.messageBox) {
				this.messageBox.destroyRecursive();
			}
		}
		
	});
})();
