/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2013. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.authoring.web.common.ui.internal.editors.PracticeEditor"); //$NON-NLS-1$
	
	dojo.require("com.ibm.team.process.authoring.web.common.client.internal.ProcessAuthoringClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.PracticeElement"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.UIHelper"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.AbstractPracticesEditor"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.AttachmentManager"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.CollapsibleSection"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.ContentEditor"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.dialogs.ExportDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.GeneralInputFieldEditor"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.PracticeLanguageDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.PracticeTreePane"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.ProcessDescriptionDetailEditor"); //$NON-NLS-1$

	dojo.require("dijit.layout.AccordionContainer"); //$NON-NLS-1$
	dojo.require("dijit.layout.BorderContainer"); //$NON-NLS-1$
	dojo.require("dijit.layout.ContentPane"); //$NON-NLS-1$
	dojo.require("dijit.Tree"); //$NON-NLS-1$
	dojo.require("dijit.tree.ForestStoreModel"); //$NON-NLS-1$
	
	dojo.require("dojo.data.ItemFileReadStore"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	
	dojo.require("dojox.uuid.Uuid"); //$NON-NLS-1$
	
	dojo.require("jazz.ui.Toolbar"); //$NON-NLS-1$
	dojo.require("jazz.ui.toolbar.Button"); //$NON-NLS-1$
	dojo.require("jazz.ui.toolbar.Separator"); //$NON-NLS-1$
	
	dojo.requireLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var ExportDialog = com.ibm.team.process.authoring.web.common.ui.internal.dialogs.ExportDialog;
	var ContentEditor = com.ibm.team.process.authoring.web.common.ui.internal.editors.ContentEditor;
	var ProcessAuthoringClient = com.ibm.team.process.authoring.web.common.client.internal.ProcessAuthoringClient;
	var ProcessDescriptionDetailEditor = com.ibm.team.process.authoring.web.common.ui.internal.editors.ProcessDescriptionDetailEditor;
	var UIHelper = com.ibm.team.process.authoring.web.common.common.internal.UIHelper;
	var PracticeTreePane = com.ibm.team.process.authoring.web.common.ui.internal.editors.PracticeTreePane;
	var ProcessAuthoringConstants = com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants;
	var GeneralInputFieldEditor = com.ibm.team.process.authoring.web.common.ui.internal.editors.GeneralInputFieldEditor;
	var CollapsibleSection = com.ibm.team.process.authoring.web.common.ui.internal.editors.CollapsibleSection;
	var AttachmentManager = com.ibm.team.process.authoring.web.common.ui.internal.editors.AttachmentManager;
	var PracticeLanguageDialog = com.ibm.team.process.authoring.web.common.ui.internal.editors.PracticeLanguageDialog;
	var PracticeElement = com.ibm.team.process.authoring.web.common.common.internal.PracticeElement;
	var PRACTICE_EDIT_ACTION_PREFIX = "#action=com.ibm.team.process.authoring.editPractice&resource="; //$NON-NLS-1$
	
	dojo.declare("com.ibm.team.process.authoring.web.common.ui.internal.editors.PracticeEditor", [com.ibm.team.process.authoring.web.common.ui.internal.editors.AbstractPracticesEditor], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "ui/internal/editors/templates/PracticeEditor.html"), //$NON-NLS-1$ //$NON-NLS-2$
		practicePane: null,
		resource: null,
		practiceName: null,
		practiceDescription: null,
		practiceETag: null,
		editPractice: true,
		detailEditor: null,
		practiceId: null,
		breadcrumblink: "#action=com.ibm.team.process.authoring.managePractices", //$NON-NLS-1$
		
		constructor: function(args) {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
			this.breadcrumbText = this.messages.PracticeEditor_4;
			this.resource = args.resource;
			if (this.resource == ProcessAuthoringConstants.STATUS_NEW) {
				this.isNew = true;
			}
            this._exportIconSrc = "com.ibm.team.process.authoring.web.common/graphics/icons/export-practice_co.gif"; //$NON-NLS-1$
            this._practiceIconSrc = dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/practice_obj.gif"); //$NON-NLS-1$ //$NON-NLS-2$ 
            this._refreshIconSrc = "com.ibm.team.process.authoring.web.common/graphics/icons/refresh16.gif"; //$NON-NLS-1$
            this._editModeIconSrc = "com.ibm.team.process.authoring.web.common/graphics/icons/edit-button.gif"; //$NON-NLS-1$
            this._viewModeIconSrc = "com.ibm.team.process.authoring.web.common/graphics/icons/preview-button.gif"; //$NON-NLS-1$
            this._discardIconSrc = "com.ibm.team.process.authoring.web.common/graphics/icons/delete-button.gif"; //$NON-NLS-1$
            this._copyUrlIconSrc = "com.ibm.team.process.authoring.web.common/graphics/icons/copyurl-button.gif"; //$NON-NLS-1$
		},
		
		exportPractice: function(evt) {
			dojo.stopEvent(evt);
			var dialog = new ExportDialog({
				resourceUrl: this.resource,
				message: dojo.string.substitute(this.messages.PracticeListPage_15, [this.practiceName])
			});
		},
		
		getPracticeName: function() {
			return dojo.trim(this.name.value);
		},
		
		setPracticeName: function(name) {
			//setup Name field
			this.name.value = name;
			this.name.style.display = "none"; //$NON-NLS-1$
			dojo.html.set(this.previewName, UIHelper.escapeXML(name));
			this.previewName.style.display = "block"; //$NON-NLS-1$
		},
		
		setPracticeLanguage: function(lang) {
			//setup Name field
			this.detailEditor.setLanguage(this.getFullLanguage(lang));
		},
		
		getPracticeDescription: function() {
			return this.detailEditor.getDescription();
		},
		
		setPracticeDescription: function(description) {
			this.detailEditor.setDescription(description);
		},
		
		togglePrimaryField: function(mode) {
			if (mode === ProcessAuthoringConstants.EditorMode.PREVIEW) {
				this.name.style.display = ProcessAuthoringConstants.NONE;
				dojo.empty(this.previewName);
				this.name.value = dojo.trim(this.name.value);
				if (!this.name.value) {
					this.clearCanSave();
				} else {
					this.setCanSave();
				}
				this.previewName.appendChild(document.createTextNode(this.name.value || this.messages.PracticeEditor_5));
				this.previewName.style.display = ProcessAuthoringConstants.EMPTY;
			} else if (mode === ProcessAuthoringConstants.EditorMode.EDIT) {
				this.previewName.style.display = ProcessAuthoringConstants.NONE;
				this.name.style.display = ProcessAuthoringConstants.EMPTY;
				this.name.focus();
				this.name.select();
			}
		},
		
		_toggleHiddenButtons: function(isHide) {
			if (this.copyUrlButton) {
				dojo.toggleClass(this.copyUrlButton.domNode, ProcessAuthoringConstants.CSS_HIDE, isHide);
			}
			if (this.exportPracticeButton) {
				dojo.toggleClass(this.exportPracticeButton.domNode, ProcessAuthoringConstants.CSS_HIDE, isHide);
			}
		},
		
		postCreate: function() {
			this.inherited(arguments);
			
			this.isFirstLoad = true;
			
			if (!this.isNew) {
				if (!this.attachmentManager) {
					this.attachmentManager = this.createAttachmentSection(this.resource, this.attachmentWrapper, this.viewOnly);
				}
			}
			if (!this.viewOnly) {
				this._connectTitleEventHandles();				
				
				this.connect(this.name, "onblur", function(e) { //$NON-NLS-1$
					this.togglePrimaryField(ProcessAuthoringConstants.EditorMode.PREVIEW);
				});
				this.connect(this.name, "onchange", "handlePracticeChange"); //$NON-NLS-1$ //$NON-NLS-2$
				this.connect(this.name, "onkeyup", "handlePracticeChange"); //$NON-NLS-1$ //$NON-NLS-2$
			} else {
				dojo.addClass(this.name, "hide"); //$NON-NLS-1$
				dojo.addClass(this.saveButton, "hide"); //$NON-NLS-1$
			}
			
			if (this.isNew) {
				this.detailEditor = new ProcessDescriptionDetailEditor({
					viewOnly: false,
					descriptionContent: "", //$NON-NLS-1$
					hideLanguage: true,
					container: this,
					onSize: dojo.hitch(this, this.resizeEditor),
					isNew: true
				});
				this._toggleHiddenButtons(true);
			} else {
				this.detailEditor = new ProcessDescriptionDetailEditor({
					descriptionContent: "", //$NON-NLS-1$
					onSize: dojo.hitch(this, this.resizeEditor),
					container: this,
					viewMode: this.viewMode,
					viewOnly: this.viewOnly
				});
			}
			
			this.detailWrapper.appendChild(this.detailEditor.domNode);
			
			if (!this.viewOnly) {
				this.connect(this.detailEditor.description, "onchange", "handlePracticeChange"); //$NON-NLS-1$ //$NON-NLS-2$
				this.connect(this.detailEditor.description, "onkeyup", "handlePracticeChange"); //$NON-NLS-1$ //$NON-NLS-2$
				this.connect(this.detailEditor.defaultField, "onclick", "handlePracticeChange"); //$NON-NLS-1$ //$NON-NLS-2$
			}
			this.practicePane = new dijit.layout.ContentPane({
				title: this.messages.PracticeEditor_6,
				selected: "true" //$NON-NLS-1$
			}, document.createElement("DIV")); //$NON-NLS-1$
			this.leftNavigator.addChild(this.practicePane);
			this.container.startup();
			if (this.isNew) {
				dojo.toggleClass(this.practiceWrapper, "hide", true); //$NON-NLS-1$
				this.practiceName = this.messages.PracticeEditor_7;
				this.setPracticeName(this.practiceName);
				this.togglePrimaryField(ProcessAuthoringConstants.EditorMode.EDIT);
			} else {
				this._toggleViewEditMode();				
				this.refresh();
			}
			
			this.editButton.set("pressed", !this.viewMode); //$NON-NLS-1$
			
			//register navigator handler
			this.registerNavigatorHandler();
		},
		
		setupCommandBar: function() {
			this.commandBar = new jazz.ui.Toolbar();
			this.editButton = new jazz.ui.toolbar.TwoStateButton({
				href : "#", //$NON-NLS-1$
               	imgSrc: this._editModeIconSrc,
               	title: this.messages.AbstractPracticesEditor_12,
				onClick : dojo.hitch(this, this.toggleViewEditMode)
			});
			this.commandBar.addChild(this.editButton);
			
			this.copyUrlButton = new jazz.ui.toolbar.Button({
    			imgSrc: this._copyUrlIconSrc, //$NON-NLS-1$ $
    			title: this.messages.PracticeEditor_16,
    			onClick: dojo.hitch(this, function(evt) {
    				dojo.stopEvent(evt);
    				this.onCopyResourceUrl(this.resource); //$NON-NLS-1$
    			})
    		});
			this.commandBar.addChild(this.copyUrlButton);
			
			this.exportPracticeButton = new jazz.ui.toolbar.Button({
				href : "#", //$NON-NLS-1$
               	imgSrc: this._exportIconSrc,
               	title: this.messages.PracticeEditorHTML_4,
				onClick : dojo.hitch(this, this.exportPractice)
			});
			this.commandBar.addChild(this.exportPracticeButton);
			
			this.commandBar.addChild(new jazz.ui.toolbar.Button({
				href : "#", //$NON-NLS-1$
               	imgSrc: this._refreshIconSrc,
               	title: this.messages.PracticeEditorHTML_0,
				onClick : dojo.hitch(this, this.doRefresh)
			}));
			
			this.saveButton = dojo.create("button", { //$NON-NLS-1$
					"innerHTML": this.messages.PracticeEditorHTML_1,  //$NON-NLS-1$
					onClick: dojo.hitch(this, this.doSave),
					disabled: true,
					tabindex: 4
				}, this.commandBar.domNode);
			this.connect(this.saveButton, "onclick", this.doSave);				 //$NON-NLS-1$
			this.commandsContainer.appendChild(this.commandBar.domNode);
			
		},
		
		_toggleViewEditMode: function() {
			this.inherited(arguments);
			
			//toggle view/edit mode in practiceTreePane, if target mode is view, hide the action buttons
            if (this.editToolBar_PracticeEdit) {
            	dojo.toggleClass(this.editToolBar_PracticeEdit.domNode, ProcessAuthoringConstants.CSS_HIDE_OCCUPY, this.viewMode);
            }
		},
		
		linkAction: function(url) {
			var resourceId = url.substring(url.lastIndexOf("/") + 1); //$NON-NLS-1$
			var isInPracticeTreePane = false;
			if (UIHelper.isPracticeElementURL(url)) { //practice elements
				if (this.practiceTreePane) {
					dojo.some(this.practiceTreePane.trees, function(tree) {
						if (resourceId) {
							tree.model.store.fetchItemByIdentity({
								identity: resourceId,
								onItem: dojo.hitch(this, function(item) {
									if (item) {
										this.populatePracticeElement(item, url, true);
										var path = this.workingCopy.getNodePath(this.workingCopy.currentItem);
										this.practiceTreePane.selectTree(tree);
										tree.set("path", path); //$NON-NLS-1$
										isInPracticeTreePane = true;
										return true;
									}
								})
							});
						}
						return false;
					}, this);
				}
				if (!isInPracticeTreePane && this.confirmNavigate()) {
					window.location.href = url;
				}
			} else {
				if (url !== this.resource) {
					 if (this.confirmNavigate()) {
					 	window.location.href = url;
					 }
				} else {
					if (confirm(this.messages.PracticeEditor_15) && this.confirmNavigate()) {
						window.location.href = url;
					}
				}
			}
		},
		
		handlePracticeChange: function(e) {
			if (e.currentTarget.type == "checkbox" && e.currentTarget.name == "default") { //$NON-NLS-1$ //$NON-NLS-2$
				this.setChangesPending();
				this._setDefaultLanguage(e);
				return;
			}
			var hasUpdate = !((this.getPracticeName() === this.practiceName) && (this.getPracticeDescription() === this.practiceDescription));
			if (hasUpdate) {
				this.setChangesPending();
				if (!this.isNew) {
					this.practiceName = this.getPracticeName();
					this.practiceDescription = this.getPracticeDescription();
					this.workingCopy.updatePracticeSummary(this.getPracticeName(), this.getPracticeDescription(), this.resource);
				}
			}
		},
		
		setChangesPending: function() {
			this.inherited(arguments);
			dojo.toggleClass(this.modifiedFlag, "hide", false); //$NON-NLS-1$
		},
		
		clearChangesPending: function() {
			this.inherited(arguments);
			dojo.toggleClass(this.modifiedFlag, "hide", true); //$NON-NLS-1$
		},
		
		loadError: function() {
		},
		
		refresh: function() {
			this.registerNavigatorHandler();
			this._clearMessage();
			this.displayWaitingMessage(this.messages.PracticeEditor_18);
			this.inherited(arguments);
			this.workingCopy.clean();
			this.practicePane.set('content', ""); //$NON-NLS-1$ //$NON-NLS-2$
			this.initializeNavigator();
            // refresh attachment section only if the resource is a practice
            // if the resource is a practice element, initializeNavigator() 
			// will refresh it after it found out what practice is the owner
			// of the practice element. 
			if (this.resource.indexOf("elements") === -1) { //$NON-NLS-1$
				this.attachmentManager.refresh();
			}
		},
		
		doRefresh: function(evt) {
			dojo.stopEvent(evt);
			if (this.isNew) {
				return;
			}
			if (this.changesPending()) {
				if (confirm(this.messages.PracticeEditor_8)) {
					this.refresh();
				}
			} else {
				this.refresh();
			}
		},
		
		switchLanguage: function(evt) {
			dojo.stopEvent(evt);
			var languageDialog = new PracticeLanguageDialog({
				controller: this,
				resource: this.resource,
				title: UIHelper.escapeXML(this.getPracticeName()),
				description: UIHelper.escapeXML(this.getPracticeDescription()),
				viewOnly: this.viewOnly,
				workingCopy: this.workingCopy
			});
			
		},
		
		initializeNavigator: function() {
			var self = this;
			var languageParameter = this.workingCopy.currentLanguage ? "?lang=" + this.workingCopy.currentLanguage : ""; //$NON-NLS-1$ //$NON-NLS-2$
			if (this.resource.indexOf("elements") === -1) { //practice //$NON-NLS-1$
				ProcessAuthoringClient.getPractice({
					lastModified: this.workingCopy.lastModified,
					url: this.resource + languageParameter,
					load: function(data, ioArgs) {
						self.practiceETag = ioArgs.xhr.getResponseHeader("ETag"); //$NON-NLS-1$
						self._loadPracticeData(data);
					},
					error: function(error, ioArgs) {
						//TODO report error bug 104182
						error.headerMessage = self.messages.PracticeEditor_17;
						self._handleResponseError(error, ioArgs, true);
					}
				});
			} else { //opening a practice editor to show a practice element
				var split = this.resource.split('/'); //$NON-NLS-1$
				var id = split[split.length - 1];
				this.workingCopy.currentItem = id;
				
				ProcessAuthoringClient.getPracticeElementOwner({
					url: this.resource + "?owner=true", //$NON-NLS-1$
					load: dojo.hitch(this, function(data, ioArgs) {
						//figure out the owning practice
						var owningPractice = UIHelper.getPracticeElementOwner(data);
						ProcessAuthoringClient.getPractice({
							lastModified: this.workingCopy.lastModified,
							url: owningPractice,
							load: function(data, ioArgs) {
								self.practiceETag = ioArgs.xhr.getResponseHeader("ETag"); //$NON-NLS-1$
								self.resource = owningPractice;
								self._loadPracticeData(data);
								if(self.attachmentManager) {
									self.attachmentManager.practiceResource = owningPractice;
									self.attachmentManager.refresh();
								}
							},
							error: function(error, ioArgs) {
								//TODO report error bug 104182
								error.headerMessage = self.messages.PracticeEditor_17;
								self._handleResponseError(error, ioArgs, true);
							}
						});
					}),
					error: function(error, ioArgs) {
						//TODO report error bug 104182
						error.headerMessage = self.messages.PracticeEditor_17;
						self._handleResponseError(error, ioArgs, true);
					}
				});
			}
			
			if (!this.viewOnly && this.isFirstLoad) {
				this.editToolBar_PracticeEdit = new jazz.ui.Toolbar();
				var nodeList = dojo.query('.dijitAccordionTitle', this.domNode); //$NON-NLS-1$
				dojo.place(this.editToolBar_PracticeEdit.domNode, nodeList[0], "first"); //$NON-NLS-1$
				this.isFirstLoad = false;
			
				dojo.addClass(this.editToolBar_PracticeEdit.domNode, "float-right"); //$NON-NLS-1$	
				this.editToolBar_AddElementButton = new jazz.ui.toolbar.Button({
					imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/add-practice-element-co.gif"), //$NON-NLS-1$ //$NON-NLS-2$
					title: this.messages.PracticeTreePane_1,
					onClick: dojo.hitch(this, this._onAddPracticeElementButtonClick)
				});
				this.editToolBar_PracticeEdit.addChild(this.editToolBar_AddElementButton);
				
				this.editToolBar_AddCategoryButton = new jazz.ui.toolbar.Button({
					imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/add-category_co.gif"), //$NON-NLS-1$ //$NON-NLS-2$
					title: this.messages.PracticeTreePane_2,
					onClick: dojo.hitch(this, this._onAddCategoryButtonClick)
				});
				this.editToolBar_PracticeEdit.addChild(this.editToolBar_AddCategoryButton);
				
				if ( this.viewMode ) {
					dojo.addClass(this.editToolBar_PracticeEdit.domNode, ProcessAuthoringConstants.CSS_HIDE_OCCUPY);
				}
			}
		},
		
		_loadPracticeData: function(practiceData) {
			var practice = new PracticeElement({
				xml: practiceData
			});
			this.practiceName = practice.title;
			this.practiceDescription = practice.description;
			var practiceLanguage = practice.language;
			this.workingCopy.currentLanguage = practiceLanguage;
			this.setPracticeName(this.practiceName);
			this.setPracticeDescription(this.practiceDescription);
			this.setPracticeLanguage(practiceLanguage);
			if (this.isNew) {
				this.detailEditor.toggleViewEditMode(ProcessAuthoringConstants.EditorMode.EDIT);
			} else {
				this._toggleHiddenButtons(false);
				if (!this.switchLanguageToolbar) {				
					this._switchLanguageButton = new jazz.ui.toolbar.Button({
						imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/language-button.gif"), //$NON-NLS-1$ //$NON-NLS-2$
						title: this.messages.PracticeEditor_14,
						onClick: dojo.hitch(this, this.switchLanguage)
					});
					
					this.switchLanguageToolbar = new jazz.ui.Toolbar();
					this.switchLanguageToolbar.addChild(this._switchLanguageButton);
					this.detailEditor.switchLanguageButtonContainer.appendChild(this.switchLanguageToolbar.domNode);
					dojo.addClass(this.detailEditor.switchLanguageButtonContainer, "float-left"); //$NON-NLS-1$
				}
				this.detailEditor.displayLanguage(true);
				if (this.viewMode) {
					this.detailEditor.toggleViewEditMode(ProcessAuthoringConstants.EditorMode.PREVIEW);
				} else {
					this.detailEditor.toggleViewEditMode(ProcessAuthoringConstants.EditorMode.EDIT);
				}
			}
			
			this.practiceTreePane = new PracticeTreePane({
				editPractice: true,
				viewOnly: this.viewOnly,
				onAddPracticeElement: dojo.hitch(this, this.onNewRootPracticeElement),
				onAddCategory: dojo.hitch(this, this.onNewRootNode)
			});
			
			this.practicePane.set('content', this.practiceTreePane); //$NON-NLS-1$
			this.loadPracticeTree(practiceData, this.practiceTreePane);
			this.detailEditor.defaultField.checked = this._isDefaultLanguage();
			this.openCurrentItem(this.practiceTreePane, false);
			dojo.publish(ProcessAuthoringConstants.PUBLISHTYPE_PRACTICES_LOAD_DONE);
			
			this.checkForSuccessMsg();
		},
		
		_isDefaultLanguage: function() {
			return this.workingCopy.currentLanguage == this.workingCopy.practiceList[0].defaultLanguage;
		},
		
		_setDefaultLanguage: function(evt) {
			this.workingCopy.setPracticeDefaultLanguage(this.workingCopy.practiceList[0], evt.target.checked ? this.workingCopy.currentLanguage : null);
		},
			
		loadPracticeTree: function(practiceData, treeContainer) {
			var practiceJsonData = this.convertXMLtoJsonData(practiceData, this.practiceETag);
			this.workingCopy.addPractice(dojo.clone(practiceJsonData));
			dojo.publish(ProcessAuthoringConstants.PUBLISHTYPE_PRACTICE_LOADED_IN_WORKINGCOPY);
			this.practiceId = practiceJsonData.practiceId;
			var tree = this.doCreateTree(practiceJsonData, treeContainer, false, false, this.messages.AbstractPracticesEditor_9, ProcessAuthoringConstants.SHARED_PRACTICE_ICON_CLASS);
			treeContainer.addPracticeTree(tree);
		},
		
		handleLock: function(lockRequest, byForce) {
			this._handleLock(lockRequest, byForce, true);
		},
		
		getResult: function(results) {
			var success = this.inherited(arguments);
			if (success) {
				this.isNew = false;
				//TODO more details for save failure bug 104182
				this.displaySuccessMessage(this.messages.PracticeEditor_2);
			}
			return success;
		},
		
		validateData: function() {
			if (this.workingCopy.practiceList && this.workingCopy.practiceList.length > 0 && !this.workingCopy.practiceList[0].defaultLanguage) {
				return this.messages.ProcessDescriptionEditor_27;
			}
		},
		
		doSave: function() {
			this.autoCommitEditor();
			
			var msg = this.validateData();
			if (msg) {
				this.displayErrorMessage(msg);
				return;
			}

			this.displayWaitingMessage(this.messages.PracticeEditor_11);
			if (this.isNew) {
				var deferred = ProcessAuthoringClient.createSharedPractice({
					title: UIHelper.escapeXML(this.getPracticeName()),
					description: this.getPracticeDescription(),
					load: dojo.hitch(this, function(data, ioArgs) {
						this.resource = ioArgs.xhr.getResponseHeader("Location"); //$NON-NLS-1$
						if (this.isNew) {
							if (!this.attachmentManager) {
								this.attachmentManager = this.createAttachmentSection(this.resource, this.attachmentWrapper, this.viewOnly);
							}
						}
						this.isNew = false;
						dojo.toggleClass(this.practiceWrapper, "hide", false); //$NON-NLS-1$
                        
						// set the save success message in cookie and change the URL of practice editor in PL  
						dojo.cookie(this.msgCookieName, this.messages.PracticeEditor_0);
				        this._unregisterHandlers();
				        document.location.href = PRACTICE_EDIT_ACTION_PREFIX + this.resource; 
					}),
					error: dojo.hitch(this, function(error, ioArgs) {
						//TODO more details for save failure bug 104182
						this.saveButton.disabled = false;
						error.headerMessage = this.messages.PracticeError_1;
						this._handleResponseError(error, ioArgs);
					})
				});
			} else {
				this.inherited(arguments);
			}
		},
		
		getModelETag: function() {
			return this.workingCopy.practiceList[0].model.ETag;
		},
		
		setETag: function(ETag) {
			this.practiceETag = ETag;
			if (this.workingCopy.practiceList.length > 0) {
				this.workingCopy.practiceList[0].model.ETag = UIHelper.extractETag(ETag).modelETag;
			}
		},
		
		getResourceID: function() {
			return this.practiceId;
		},
		
		uninitialize: function() {
			if (this.detailEditor) {
				this.detailEditor.destroyRecursive();
			}
			
			if (this.editToolBar_AddCategoryButton) {
				this.editToolBar_AddCategoryButton.destroyRecursive();
			}
			
			if (this.editToolBar_AddElementButton) {
				this.editToolBar_AddElementButton.destroyRecursive();
			}
			
			if (this.editToolBar_PracticeEdit) {
				this.editToolBar_PracticeEdit.destroyRecursive();
			}
			
			if (this._switchLanguageButton) {
				this._switchLanguageButton.destroyRecursive();
			}
			
			if (this.switchLanguageToolbar) {
				this.switchLanguageToolbar.destroyRecursive();
			}
			
			if (this.attachmentManager) {
				this.attachmentManager.destroyRecursive();
			}
			
			this.inherited(arguments);
		},
		
		_onAddPracticeElementButtonClick: function(evt) {
			dojo.stopEvent(evt);
			this.onNewRootPracticeElement(this.practiceTreePane.trees[0]);
		},
		
		_onAddCategoryButtonClick: function(evt) {
			dojo.stopEvent(evt);
			this.onNewRootNode(this.practiceTreePane.trees[0]);
		},
		
		onNewRootPracticeElement: function(tree) {
			this.autoCommitEditor();
			
			var uuid = dojox.uuid.generateTimeBasedUuid();
			var rootItem = tree.model.root;
			var practiceResource = tree.practiceResource;
			var newItem = rootItem.store.store.newItem({
				id: uuid,
				label: this.messages.PracticeEditor_9,
				type: ProcessAuthoringConstants.NAVIGATORTYPE_ELEMENT,
				resource: null
			}, {
				parent: rootItem
			});
			
			var contentEditor = new ContentEditor({
				isNewNode: true,
				controller: this,
				workingCopy: this.workingCopy,
				item: newItem,
				practiceElementLanguage: this.workingCopy.currentLanguage,
				practiceURL: this.getPracticeURL(practiceResource),
				onChange: dojo.hitch(this, function(item, data) {
					this.workingCopy.updatePracticeElement(item.id, data);
				})
			});
			
			contentEditor.addInitializedCallback(dojo.hitch(this, function() {
				this.rightContent.set('content', contentEditor); //$NON-NLS-1$
				this.resizeEditor(contentEditor);				
			}));
			this.workingCopy.addPracticeElement(practiceResource, rootItem.id, uuid, contentEditor.getXML());
			this.setChangesPending();
			this.workingCopy.currentItem = uuid;
			
			if (newItem) {
				tree.selectNode(newItem);
			}
		},
		
		onNewRootNode: function(tree) {
			this.autoCommitEditor();
			
			var f = dojo.hitch(this, function(groupingName) {
				var rootItem = tree.model.root;
				var practiceResource = tree.practiceResource;
				var uuid = dojox.uuid.generateTimeBasedUuid();
				var newCategory = rootItem.store.store.newItem({
					id: uuid,
					label: groupingName,
					type: ProcessAuthoringConstants.NAVIGATORTYPE_CATEGORY,
					children: []
				}, {
					parent: rootItem
				});
				this.workingCopy.addCategory(practiceResource, rootItem.id, uuid, groupingName);
				var categoryEditor = new GeneralInputFieldEditor({
					controller: this,
					isNew: true,
					viewOnly: false,
					item: newCategory,
					field: newCategory.label,
					onCategoryChange: dojo.hitch(this, this.onCategoryChange)
				});
				
				categoryEditor.addInitializedCallback(dojo.hitch(this, function() {
					this.rightContent.set('content', categoryEditor); //$NON-NLS-1$
					this.resizeEditor(categoryEditor);
				}));
				this.setChangesPending();
				this.workingCopy.currentItem = uuid;
				
				if (newCategory) {
					tree.selectNode(newCategory);
				}
			});
			
			f(this.messages.PracticeEditor_10);
		},
		
		/**
		 * Overrides AbstractPracticesEditor.loadPractice
		 */
		loadPractice: function(item, practice, viewOnly) {
			// refresh the title and description of the practice
			this._refreshBasicInfo(this.workingCopy.practiceList[0], false);
						
			this.inherited(arguments);
		},
		
		/**
         * Refreshes basic information (title, description, language) for the given practice for the current language.
         * 
         * @param {Object} practice the practice data used to refresh the basic information
         * @param {boolean} refreshLanguage if true, the current language information will be refreshed
         */
		_refreshBasicInfo: function(practice, refreshLanguage) {
			var basicInformation = this.workingCopy.getPracticeBasicInformationForCurrentLangugage(this.workingCopy.practiceList[0]);
			this.practiceName = basicInformation.label;
			this.setPracticeName(basicInformation.label);
			this.practiceDescription = basicInformation.description;
			this.setPracticeDescription(basicInformation.description);
			if (refreshLanguage) {
				this.detailEditor.defaultField.checked = this._isDefaultLanguage();
				this.setPracticeLanguage(this.workingCopy.currentLanguage);
			}
		},
		
		/**
		 * Reloads the editor.
		 * 
		 * @param {Object} treeData the data used to create the practice navigation tree
		 * @see WorkingCopy.getTreeJsonArray
		 * @see AbstractPracticesEditor.createTree
		 */
		reload: function(treeData) {
			this._refreshBasicInfo(this.workingCopy.practiceList[0], true);
			this.practiceTreePane.removePracticeTrees();
			var tree = this.doCreateTree(treeData, this.practiceTreePane, false, false, this.messages.AbstractPracticesEditor_9, ProcessAuthoringConstants.SHARED_PRACTICE_ICON_CLASS);
			this.practiceTreePane.addPracticeTree(tree);
			this.initializedContentEditor = false;
			this.openCurrentItem(this.practiceTreePane, false);
			dojo.publish(ProcessAuthoringConstants.PUBLISHTYPE_PRACTICES_LOAD_DONE);
		}
		
	});
})();
