/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.authoring.web.common.ui.internal.editors.ProcessDescriptionDetailEditor"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$
	dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
	dojo.require("jazz.ui.ResourceLink");//$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants"); //$NON-NLS-1$ 
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.UIHelper"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var ResourceLink = jazz.ui.ResourceLink;
	var ProcessAuthoringConstants = com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants;
	var UIHelper = com.ibm.team.process.authoring.web.common.common.internal.UIHelper;
	 
	dojo.declare("com.ibm.team.process.authoring.web.common.ui.internal.editors.ProcessDescriptionDetailEditor", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "ui/internal/editors/templates/ProcessDescriptionDetailEditor.html"), //$NON-NLS-1$ //$NON-NLS-2$
		descriptionContent: "", //$NON-NLS-1$
		isNew: false,
		subscriptionHandles: null,
		editViewFields: null,
		editViewHandler: null,
		ownerURL: "", //$NON-NLS-1$
		hideLanguage: false,
		sharingCheckType: 0, //0: hidden, 1-check 2-uncheck
		containerType: ProcessAuthoringConstants.DETAILEDITOR_CONTAINER_DEFAULT,
		container: null,
		PLMSHARED_TARGET: "IsPLMShared", //$NON-NLS-1$
		
		constructor: function(args) {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate: function() {
			this.description.viewElement = this.descriptionContentView;
			this.description.value = this.descriptionContent;
			
			if (this.languageText) {
				this.languageView.appendChild(document.createTextNode(this.languageText));
			}
			this.editViewFields = [];
			this.editViewFields.push(this.description);
			this.displayLanguage(!this.hideLanguage);
			this.displayCheckBox()
			
			//if the field is not in the shared pane or outline pane, register event handlers
			if (!this.viewOnly) {
				this.connect(this.previewEditLink, "onclick", function(e) { //$NON-NLS-1$
					dojo.stopEvent(e);
					if (e.target.mode === ProcessAuthoringConstants.EditorMode.PREVIEW) {
						this.toggleViewEditMode(ProcessAuthoringConstants.EditorMode.EDIT);
					} else {
						this.toggleViewEditMode(ProcessAuthoringConstants.EditorMode.PREVIEW);
					}
				});
                
                this.subscribe(ProcessAuthoringConstants.PUBLISHTYPE_VIEWMODE, this._toViewMode); //$NON-NLS-1$
                this.subscribe(ProcessAuthoringConstants.PUBLISHTYPE_EDITMODE, this._toEditMode); //$NON-NLS-1$
			} else {
				dojo.toggleClass(this.previewEditLink, ProcessAuthoringConstants.CSS_HIDE, true); //$NON-NLS-1$
			}
			
			this.viewMode || this.viewOnly ? this._toViewMode() : this._toEditMode();
		},
		
		//click on edit/view switch button to switch to edit mode
		_toEditMode: function() {
			dojo.toggleClass(this.header, "hide", false); //$NON-NLS-1$
			dojo.toggleClass(this.detailEditor, "hide", false); //$NON-NLS-1$

			this.sharingField.disabled = false;
			this.defaultField.disabled = false;
            this.editViewHandler = this.connect(this.descriptionField, "onclick", this._onClickDescriptionField); //$NON-NLS-1$
            this.toggleViewEditMode(ProcessAuthoringConstants.EditorMode.EDIT);
		},

		//click on edit/view switch button to switch to view mode
		_toViewMode: function() {
            this.sharingField.disabled = true;
			this.defaultField.disabled = true;
            // hide header if it's in content editor
            if (this.containerType === ProcessAuthoringConstants.DETAILEDITOR_CONTAINER_PRACTICECONTENT) {
            	dojo.toggleClass(this.header, ProcessAuthoringConstants.CSS_HIDE, true);
            	// hide the description field if it is empty
            	if (dojo.trim(this.description.value).length == 0 && this.containerType === ProcessAuthoringConstants.DETAILEDITOR_CONTAINER_PRACTICECONTENT) {
            		dojo.toggleClass(this.detailEditor, ProcessAuthoringConstants.CSS_HIDE, true); //$NON-NLS-1$	
            	}
            }
            
            this.disconnect(this.editViewHandler);
			this.toggleViewEditMode(ProcessAuthoringConstants.EditorMode.PREVIEW);
		},
		
		//toggle view/edit presentation 
		toggleViewEditMode: function(mode) {
			this.previewEditLink.mode = mode; 
			//preview mode: show data only
			if (mode === ProcessAuthoringConstants.EditorMode.PREVIEW) {
				var containerViewMode;
				if (this.container.controller) {
					containerViewMode = this.container.isViewMode()
				} else {
					containerViewMode = this.container.viewMode;
				}
				dojo.forEach(this.editViewFields, function(field) {
					dojo.toggleClass(field, ProcessAuthoringConstants.CSS_HIDE, true);
					dojo.empty(field.viewElement);
					if (this._isEmptyText(field.value) && !containerViewMode && !this.viewOnly) {
						dojo.html.set(field.viewElement, this.messages.TextField_0);
						dojo.toggleClass(field.viewElement, "novalueField", true); //$NON-NLS-1$
					} else {
						field.viewElement.innerHTML = UIHelper.escapeHTMLWithoutSpace(field.value);
						dojo.toggleClass(field.viewElement, "novalueField", false); //$NON-NLS-1$
					}
					dojo.toggleClass(field.viewElement, ProcessAuthoringConstants.CSS_HIDE, false);
				}, this);
				dojo.toggleClass(this.previewEditLink, ProcessAuthoringConstants.CSS_HIDE, true);
				dojo.toggleClass(this.descriptionView, "previewField", !containerViewMode && !this.viewOnly); //$NON-NLS-1$
			} else { //clicking on edit button, open the editor 
				dojo.forEach(this.editViewFields, function(field) {
					if (!field.readOnly) {
						dojo.toggleClass(field, ProcessAuthoringConstants.CSS_HIDE, false);
						dojo.toggleClass(field.viewElement, ProcessAuthoringConstants.CSS_HIDE, true);
					}
				}, this);
				dojo.toggleClass(this.previewEditLink, ProcessAuthoringConstants.CSS_HIDE, false);
				dojo.toggleClass(this.descriptionView, "previewField", false); //$NON-NLS-1$
			}
			
			if (this.onSize) {
				this.onSize();
			}
		},
		
		_isEmptyText: function(text) {
			return !text || dojo.string.trim(text).length == 0;
		},
		
		_onClickDescriptionField: function(e) {
            if (e.target.name !== this.PLMSHARED_TARGET) {
            	dojo.stopEvent(e);
	            this.toggleViewEditMode(ProcessAuthoringConstants.EditorMode.EDIT);
            } 
		},
		
		getDescription: function() {
			return this.description.value;
		},
		
		setDescription: function(description) {
			this.description.value = description;
			dojo.empty(this.description.viewElement);
			this.description.viewElement.innerHTML = UIHelper.escapeHTMLWithoutSpace(this.description.value);
		},
		
		setLanguage: function(language) {
			this.languageText = language;
			
			dojo.empty(this.languageView);
			this.languageView.appendChild(document.createTextNode(language));
		},
		
		getLanguage: function(language) {
			return this.languageText;
		},
		
		displayLanguage: function(display) {
			if (display) {
				this.languageField.style.display = ""; //$NON-NLS-1$
			} else {
				this.languageField.style.display = "none"; //$NON-NLS-1$
			}
		},
		
		displayCheckBox: function() {
			//handle check box
			if ( this.sharingCheckType === ProcessAuthoringConstants.DETAILEDITOR_CHECKBOXTYPE_HIDE ) {
				dojo.addClass(this.sharingFieldWrapper, ProcessAuthoringConstants.CSS_HIDE);
			} else {
				this.sharingField.checked = (this.sharingCheckType === ProcessAuthoringConstants.DETAILEDITOR_CHECKBOXTYPE_CHECKED);  
			}
		},	
		
		uninitialize: function() {
			if (this._resourceLink) {
				this._resourceLink.destroyRecursive();
			}
			this.inherited(arguments);
		}
		
	});
	
})();

