/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2013. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.authoring.web.common.ui.internal.editors.ProcessDescriptionListPage"); //$NON-NLS-1$
	
	dojo.require("com.ibm.team.process.authoring.web.common.client.internal.ProcessAuthoringClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.UIHelper");//$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.dialogs.ExportDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.dialogs.ImportDialog"); //$NON-NLS-1$
	
	dojo.require("dijit._Templated"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	
	dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
	dojo.require("jazz.ui.PaginationControl"); //$NON-NLS-1$
	dojo.require("jazz.ui.ResourceLink");//$NON-NLS-1$
	dojo.require("jazz.ui.Toolbar"); //$NON-NLS-1$
	dojo.require("jazz.ui.toolbar.Button"); //$NON-NLS-1$
	
	dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$
	
	dojo.requireLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$	
	
	var ImportDialog = com.ibm.team.process.authoring.web.common.ui.internal.dialogs.ImportDialog;
	var ExportDialog = com.ibm.team.process.authoring.web.common.ui.internal.dialogs.ExportDialog;
	var ProcessAuthoringClient = com.ibm.team.process.authoring.web.common.client.internal.ProcessAuthoringClient;
	var ProcessAuthoringConstants = com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants;
	var ResourceLink = jazz.ui.ResourceLink;
	var UIHelper = com.ibm.team.process.authoring.web.common.common.internal.UIHelper;
	var PaginationControl = jazz.ui.PaginationControl;
	var MessageBox = jazz.ui.MessageBox;
	var PROCESS_DESCRIPTIONS_PER_PAGE = 10;
	var PROCESS_DESCRIPTION_EDIT_ACTION_PREFIX = "#action=com.ibm.team.process.authoring.editProcessDescription&resource="; //$NON-NLS-1$
	var PROCESS_DESCRIPTION_CREATE_ACTION = "#action=com.ibm.team.process.authoring.editProcessDescription"; //$NON-NLS-1$
	dojo.declare("com.ibm.team.process.authoring.web.common.ui.internal.editors.ProcessDescriptionListPage", //$NON-NLS-1$
 [dijit._Widget, dijit._Templated], {
		sharedProcessDescriptionLength: -1,
		keepStatusMessage: false,
		lastModified: null,
		editToolBars: null,
		_editToolBarButtons: null,
		resourceLinks: null,
		sharedPaginationControl: null,
		templatePath: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "ui/internal/editors/templates/ProcessDescriptionListPage.html"), //$NON-NLS-1$ //$NON-NLS-2$
		constructor: function() {
			this.editToolBars = [];
			this._editToolBarButtons = [];
			this.resourceLinks = [];
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
			this._createProcessDescriptionIconSrc = dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/create-process-description_co.gif"); //$NON-NLS-1$ //$NON-NLS-2$ 
			this._importProcessDescriptionIconSrc = dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/import-process-description_co.gif"); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate: function() {
			this.promptMsg = new MessageBox();
			this.messageBox.appendChild(this.promptMsg.domNode);
			this.refresh();
		},
		
		refresh: function() {
			this.clearState();
			this.displayWaitingMessage(this.messages.ProcessDescriptionListPage_13);
			
		},
		
		clearState: function() {
			this.promptMsg.hideMessage();
		},
		
		removeMessages: function() {
			this.promptMsg.hideMessage();
		},
		
		showProcessDescriptions: function() {
			ProcessAuthoringClient.getAllPLMProcessDescriptions({
				lastModified: this.lastModified,
				load: dojo.hitch(this, function(data) {
					this._getAllProcessDescriptions(data);
					
					var firstShowSharedProcessUpperBound;
					if (this.sharedProcessDescriptionLength > PROCESS_DESCRIPTIONS_PER_PAGE) {
						firstShowSharedProcessUpperBound = PROCESS_DESCRIPTIONS_PER_PAGE;
					} else {
						firstShowSharedProcessUpperBound = this.sharedProcessDescriptionLength;
					}
					this._showProcessDescriptionsInRange(0, firstShowSharedProcessUpperBound, false);
					
					var newSharedPaginationControl = new PaginationControl({
						total: this.sharedProcessDescriptionLength,
						increment: PROCESS_DESCRIPTIONS_PER_PAGE,
						onNextClick: dojo.hitch(this, function(widget, start, end) {
							this._showProcessDescriptionsInRange(start - 1, end, false);
						}),
						onPreviousClick: dojo.hitch(this, function(widget, start, end) {
							this._showProcessDescriptionsInRange(start - 1, end, false);
						})
					});
					dojo.empty(this.sharedPagingContainer);
					if (this.sharedPaginationControl) {
						this.sharedPaginationControl.destroyRecursive();
					}
					this.sharedPaginationControl = newSharedPaginationControl;
					this.sharedPagingContainer.appendChild(this.sharedPaginationControl.domNode);
				}),
				error: dojo.hitch(this, this.error)
			});
		},
		
		_getAllProcessDescriptions: function(descriptionsListingXML) {
			if (!descriptionsListingXML) {
				return descriptionsListingXML;
			}
			
			var descriptionsNode = UIHelper.getNode(descriptionsListingXML.childNodes, ProcessAuthoringConstants.XMLELEMENT_RDF, ProcessAuthoringConstants.NAMESPACE_RDF);
			if (descriptionsNode) {
				var allProcessDescriptionNodes = UIHelper.getNodes(descriptionsNode.childNodes, ProcessAuthoringConstants.XMLELEMENT_PROCESSDESCRIPTION_ROOT, ProcessAuthoringConstants.NAMESPACE_JTP);
				this.allProcessDescriptions = [];
				dojo.forEach(allProcessDescriptionNodes, function(processDescriptionNode) {
					var aboutAttribute = UIHelper.getAttributeNode(processDescriptionNode, ProcessAuthoringConstants.XMLATTRIBUTE_ABOUT, ProcessAuthoringConstants.NAMESPACE_RDF);
					var uri = aboutAttribute.value;
					//var descriptionItemId = uri.substring(uri.lastIndexOf('/') + 1); //$NON-NLS-1$
					var nameNode = UIHelper.getNode(processDescriptionNode.childNodes, ProcessAuthoringConstants.XMLELEMENT_TITLE, ProcessAuthoringConstants.NAMESPACE_DC);
					var name = nameNode.firstChild.data;
					
					var descriptionNode = UIHelper.getNode(processDescriptionNode.childNodes, ProcessAuthoringConstants.XMLELEMENT_DESCRIPTION, ProcessAuthoringConstants.NAMESPACE_DC);
					var description = ""; //$NON-NLS-1$
					if (descriptionNode && descriptionNode.firstChild) {
						description = descriptionNode.firstChild.data;
					}
					
					var xmlOwnerNode = UIHelper.getNode(processDescriptionNode.childNodes, ProcessAuthoringConstants.XMLELEMENT_OWNER, ProcessAuthoringConstants.NAMESPACE_JTP); //$NON-NLS-1$
					if (xmlOwnerNode) {
						var ownerAttribute = UIHelper.getAttributeNode(xmlOwnerNode, ProcessAuthoringConstants.XMLATTRIBUTE_RESOURCE, ProcessAuthoringConstants.NAMESPACE_RDF);
						var ownerURI = ownerAttribute.value;
						var labelAttr = UIHelper.getAttributeNode(xmlOwnerNode, ProcessAuthoringConstants.XMLATTRIBUTE_LABEL, ""); //$NON-NLS-1$
						var ownerLabel = labelAttr ? labelAttr.value : ownerURI;
					}

                    var xmlPLMSharedNode = UIHelper.getNode(processDescriptionNode.childNodes, ProcessAuthoringConstants.XMLELEMENT_SHARED, ProcessAuthoringConstants.NAMESPACE_JTP);
					var isPLMShared = false;
                    if (xmlPLMSharedNode) {
                    	if (xmlPLMSharedNode && xmlPLMSharedNode.firstChild) {
                    		var value = xmlPLMSharedNode.firstChild.data;
                    		isPLMShared = (value == ProcessAuthoringConstants.VALUE_TRUE);
                    	}
                    }
					var processDescription = {};
					processDescription.uri = uri;
					processDescription.name = UIHelper.unescapeXML(name);
					processDescription.description = description;
					processDescription.ownerURI = ownerURI;
					processDescription.ownerLabel = ownerLabel;
					processDescription.isPLMShared = isPLMShared;
					this.allProcessDescriptions.push(processDescription);
				}, this);
				
				this.allProcessDescriptions = this.allProcessDescriptions.sort(function(a, b) {
					return a.name.toLowerCase().localeCompare(b.name.toLowerCase());
				});
				
				this.sharedProcessDescriptionLength = this.allProcessDescriptions.length;
				this.sharedProcessDescriptions = this.allProcessDescriptions;
				
				if (this.sharedProcessDescriptionLength === 0) {
					if (dojo.hasClass(this.noSharedProcessDescriptionsMessage, "hidden")) { //$NON-NLS-1$
						dojo.toggleClass(this.noSharedProcessDescriptionsMessage, "hidden", false); //$NON-NLS-1$
					}
				} else {
					if (!dojo.hasClass(this.noSharedProcessDescriptionsMessage, "hidden")) { //$NON-NLS-1$
						dojo.toggleClass(this.noSharedProcessDescriptionsMessage, "hidden", true); //$NON-NLS-1$
					}
				}
				
			} else {
				this.messageBox.appendChild(document.createTextNode(this.messages.ProcessDescriptionListPage_2));
			}
			return descriptionsListingXML;
		},
		
		_showProcessDescriptionsInRange: function(start, end) {
			var processDescriptions = this.sharedProcessDescriptions.slice(start, end);
			
			dojo.empty(this.sharedProcessDescriptionsList);
			dojo.forEach(processDescriptions, function(processDescription) {
				var row = this.createProcessDescriptionRow(processDescription);
				this.addLinks(processDescription, row);
				this.sharedProcessDescriptionsList.appendChild(row);
			}, this);
			
			if (!this.keepStatusMessage) {
				this.removeMessages();
			}
		},
		
		addLinks: function(processDescription, row) {
			ProcessAuthoringClient.checkAssociationForProcessDescription({
				'sourceUrl': processDescription.uri, //$NON-NLS-1$
				'load': dojo.hitch(this, function(data, ioArgs) { //$NON-NLS-1$
					var location = ioArgs.xhr.getResponseHeader("Location"); //$NON-NLS-1$
					ProcessAuthoringClient.getAssociation({
						'url': location, //$NON-NLS-1$
						'load': dojo.hitch(this, function(data, ioArgs) { //$NON-NLS-1$
							var targets = UIHelper.getAssociationTargets(data);
							this.createLinkNodes(processDescription, row, targets);
						})
					});
				})
			
			});
		},
		
		createLinkNodes: function(processDescription, row, links) {
			if (links && links.length > 0) {
				if (processDescription.description !== "") { //$NON-NLS-1$ //$NON-NLS-2$
					row.appendChild(document.createElement("br")); //$NON-NLS-1$
					row.appendChild(document.createElement("br")); //$NON-NLS-1$
				}
				
				var node = document.createElement("SPAN"); //$NON-NLS-1$
				node.className = "secondaryHeading"; //$NON-NLS-1$
				var label = document.createTextNode(this.messages.ProcessDescriptionListPage_7);
				node.appendChild(label);
				row.appendChild(node);
				
				dojo.forEach(links, function(link) {
					row.appendChild(document.createElement("br")); //$NON-NLS-1$
					row.appendChild(this._getLinkImage());
					
					var relationshipLink = document.createElement("a"); //$NON-NLS-1$
					relationshipLink.appendChild(document.createTextNode(link.name));
					relationshipLink.href = link.target;
					relationshipLink.className = "secondaryLink"; //$NON-NLS-1$
					var rl = new ResourceLink({
						'presentationUri': relationshipLink.href, //$NON-NLS-1$
						'lazyFetch': true //$NON-NLS-1$
					}, relationshipLink);
					this.resourceLinks.push(rl);
					row.appendChild(relationshipLink);
				}, this);
			}
		},
		
		
		createProcessDescriptionRow: function(processDescription, links) {
			var row = document.createElement("div"); //$NON-NLS-1$
			row.className = "processDescription"; //$NON-NLS-1$
			var linkDescription = document.createElement("h3"); //$NON-NLS-1$
			var link = document.createElement("a"); //$NON-NLS-1$
			var descriptionLabel = processDescription.name;
			if (!processDescription.isPLMShared) {
				descriptionLabel = dojo.string.substitute(this.messages.ProcessDescriptionListPage_18, [processDescription.name]);
			}
            link.appendChild(document.createTextNode(descriptionLabel));
			linkDescription.appendChild(link);
			
			var presentationUri = processDescription.uri;
			link.href = processDescription.uri;
			var rl = new ResourceLink({
				'presentationUri': presentationUri, //$NON-NLS-1$
				'lazyFetch': true //$NON-NLS-1$
			}, link);
			this.resourceLinks.push(rl);
			row.appendChild(linkDescription);
			
			var handleKeyNavigateIn = function(e) { //$NON-NLS-1$
				var section = e.target;
				
				while (section && !dojo.hasClass(section, "processDescription")) { //$NON-NLS-1$
					section = section.parentNode;
				}
				if (section) {
					dojo.toggleClass(section, "selected", true); //$NON-NLS-1$
				}
			};
			
			var handleKeyNavigateOut = function(e) { //$NON-NLS-1$
				var section = e.target;
				
				while (section && !dojo.hasClass(section, "processDescription")) { //$NON-NLS-1$
					section = section.parentNode;
				}
				if (section) {
					dojo.toggleClass(section, "selected", false); //$NON-NLS-1$
				}
			};
			
			this.connect(link, "onfocus", handleKeyNavigateIn); //$NON-NLS-1$
			this.connect(link, "onblur", handleKeyNavigateOut); //$NON-NLS-1$
			if (processDescription.description) { //$NON-NLS-1$
				row.appendChild(document.createTextNode(processDescription.description));
			}
			
			var actionArea = document.createElement("div"); //$NON-NLS-1$
			dojo.addClass(actionArea, "actionToolBar"); //$NON-NLS-1$
			var editToolBar = new jazz.ui.Toolbar({});
			this.editToolBars.push(editToolBar);
			
			var actionButton = new jazz.ui.toolbar.Button({
				imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/export-process-description_co.gif"), //$NON-NLS-1$ //$NON-NLS-2$
				title: this.messages.ProcessDescriptionListPage_15,
				onClick: dojo.hitch(this, function(event) {
					dojo.stopEvent(event);
					this.exportProcessDescription(processDescription);
				})
			});
			actionButton.connect(actionButton.focusNode, "onfocus", handleKeyNavigateIn); //$NON-NLS-1$
			actionButton.connect(actionButton.focusNode, "onblur", handleKeyNavigateOut); //$NON-NLS-1$
			this._editToolBarButtons.push(actionButton);
			editToolBar.addChild(actionButton);
			
			var actionButton = new jazz.ui.toolbar.Button({
				imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/delete-button.gif"), //$NON-NLS-1$ //$NON-NLS-2$
				title: this.messages.ProcessDescriptionListPage_0,
				onClick: dojo.hitch(this, function(event) {
					dojo.stopEvent(event);
					if (confirm(this.messages.ProcessDescriptionListPage_1)) {
						this.deleteProcessDescription(processDescription);
					}
				})
			});
			actionButton.connect(actionButton.focusNode, "onfocus", handleKeyNavigateIn); //$NON-NLS-1$
			actionButton.connect(actionButton.focusNode, "onblur", handleKeyNavigateOut); //$NON-NLS-1$
			this._editToolBarButtons.push(actionButton);
			editToolBar.addChild(actionButton);

			actionArea.appendChild(editToolBar.domNode);
			row.appendChild(actionArea);
			this.connect(row, "onmouseover", dojo.hitch(this, function() { //$NON-NLS-1$
				dojo.toggleClass(row, "selected", true); //$NON-NLS-1$
			}));
			this.connect(row, "onmouseout", dojo.hitch(this, function() { //$NON-NLS-1$
				dojo.toggleClass(row, "selected", false); //$NON-NLS-1$
			}));
			
			return row;
		},
		
		exportProcessDescription: function(processDescription) {
			new ExportDialog({
				resourceUrl: processDescription.uri,
				message: dojo.string.substitute(this.messages.ProcessDescriptionListPage_16, [processDescription.name])
			});
		},
		
		deleteProcessDescription: function(processDescription) {
			this.displayWaitingMessage(this.messages.ProcessDescriptionListPage_3);
			ProcessAuthoringClient.deleteProcessDescription({
				uri: processDescription.uri,
				load: dojo.hitch(this, function(data, ioArgs) {
					this.lastModified = ioArgs.xhr.getResponseHeader(ProcessAuthoringConstants.HEADER_LASTMODIFIED);
					this.refresh();
					this.displaySuccessMessage(this.messages.ProcessDescriptionListPage_4);
				}),
				error: dojo.hitch(this, function(err, ioArgs) {
					if (err.responseText) {
						err.message = err.responseText;
					}
					var licenseWarning = UIHelper.getLicenseWarning(ioArgs);
					err.headerMessage = licenseWarning ? licenseWarning : this.messages.ProcessDescriptionListPage_5;
					err.errorObject = err;
					this.displayErrorMessage(err);
				})
			});
		},
		
		_getLinkImage: function() {
			var img = document.createElement("img"); //$NON-NLS-1$
			var module = "com.ibm.team.process.authoring.web.common"; //$NON-NLS-1$
			img.className = "linkImage"; //$NON-NLS-1$
			img.src = dojo.moduleUrl(module, "graphics/icons/link-icon.gif"); //$NON-NLS-1$
			return img;
		},
		
		createProcessDescription: function() {
			window.location.href = PROCESS_DESCRIPTION_CREATE_ACTION;
		},
		
		importProcessDescriptions: function(e) {
			dojo.stopEvent(e);
			var dialog = new ImportDialog({
				isSharedProcessDescriptionImporting: true
			});
			this.connect(dialog, "onSuccess", "handleImportSuccess");//$NON-NLS-1$ //$NON-NLS-2$
		},
		
		handleImportSuccess: function(args) {
			this.lastModified = args.lastModified;
			this.refresh();
		},
		
		displayMessage: function(msg, cssClass) {
			if (msg instanceof Error) {
				this.promptMsg.showMessage({
					type: cssClass,
					summary: msg.headerMessage,
					errorObject: msg
				});
			} else {
				this.promptMsg.showMessage({
					type: cssClass,
					summary: msg
				});
			}
		},
		
		displaySuccessMessage: function(msg) {
			this.displayMessage(msg, "OK"); //$NON-NLS-1$
		},
		
		displayErrorMessage: function(msg) {
			this.displayMessage(msg, "ERROR"); //$NON-NLS-1$
		},
		
		displayWaitingMessage: function(msg) {
			this.displayMessage(msg, "INFO"); //$NON-NLS-1$
		},
		
		
		uninitialize: function() {
			dojo.forEach(this._editToolBarButtons, function(button) {
				if (button) {
					button.destroyRecursive();
				}
			}, this);
			
			dojo.forEach(this.editToolBars, function(editToolBar) {
				if (editToolBar) {
					editToolBar.destroyRecursive();
				}
			}, this);
			
			dojo.forEach(this.resourceLinks, function(resourceLink) {
				if (resourceLink) {
					resourceLink.destroyRecursive();
				}
			}, this);
			
			if (this.sharedPaginationControl) {
				this.sharedPaginationControl.destroyRecursive();
			}
			
			if (this.promptMsg) {
				this.promptMsg.destroyRecursive();
			}
			
			this.inherited(arguments);
		},
		
		error: function(error, ioArgs) {
			this.keepStatusMessage = true;
			if (error.status === ProcessAuthoringConstants.SC_GATEWAY_TIMEOUT) {
				this.displayErrorMessage(this.messages.ProcessDescriptionListPage_14);
			} else {
				if (error.responseText) {
					error.message = error.responseText;
				}
				var licenseWarning = UIHelper.getLicenseWarning(ioArgs);
				error.headerMessage = licenseWarning ? licenseWarning : this.messages.ProcessDescriptionListPage_6;
				error.errorObject = error;
				if (licenseWarning) {
					this.displayMessage(error, "WARNING"); //$NON-NLS-1$
				} else {
					this.displayErrorMessage(error);
				}
			}
			
		}
	});
	
})();
