/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2013. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.authoring.web.common.ui.internal.editors.ResourceLinkPickerTooltipDialog"); //$NON-NLS-1$
	dojo.require("dijit._Widget"); //$NON-NLS-1$
	dojo.require("dijit._Templated"); //$NON-NLS-1$
	dojo.require("dijit._editor._Plugin"); //$NON-NLS-1$
	dojo.require("dijit.TooltipDialog"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("dojo.string"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.ResourceLinkPickerDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.UIHelper"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var ResourceLinkPickerDialog = com.ibm.team.process.authoring.web.common.ui.internal.editors.ResourceLinkPickerDialog;
	var UIHelper = com.ibm.team.process.authoring.web.common.common.internal.UIHelper;
	
	dojo.declare("com.ibm.team.process.authoring.web.common.ui.internal.editors.ResourceLinkPickerTooltipDialog", [ResourceLinkPickerDialog, dijit._editor._Plugin], { //$NON-NLS-1$
		// summary:
		//		This plugin provides the basis for an 'anchor' (link) dialog 
		//
		// description:
		//		The command provided by this plugin is:
		//		* createLink
		
		// Override _Plugin.buttonClass.   This plugin is controlled by a DropDownButton
		// (which triggers a TooltipDialog).
		buttonClass: dijit.form.DropDownButton,
		
		// Override _Plugin.useDefaultCommand... processing is handled by this plugin, not by dijit.Editor.
		useDefaultCommand: false,
		
		htmlTemplate: "<a href=\"${resourceUrl}\" _djrealurl=\"${resourceUrl}\">${name}</a>", //$NON-NLS-1$
		setupObjects: function() {
			var _self = this;
			var widget = new com.ibm.team.process.authoring.web.common.ui.internal.editors.ResouceLinkPickerWidget();
			
			this.dialog = new dijit.TooltipDialog({
				title: this.dialogTitle,
				onCancel: function() {
					setTimeout(dojo.hitch(_self, "_onClose"), 0); //$NON-NLS-1$
				}
			});
			
			this.searchText = widget.searchText;
			this.selectionTitle = widget.selectionTitle;
			this.resourceTypeSelector = widget.resourceTypeSelector;
			this.resourceSelector = widget.resourceSelector;
			this.addCloseButton = widget.addCloseButton;
			this.addButton = widget.addButton;
			this.status = widget.status;
			this.closeButton = widget.closeButton;
			this.dialogFooter = widget.dialogFooter;
			this.dropDown = this.dialog;
			this.dropDown.set('content', widget.domNode); //$NON-NLS-1$
			this.dropDown.startup();
		},
		
		setupConnections: function() {
			this.connect(this.closeButton, "onclick", function(e) { //$NON-NLS-1$
				dojo.stopEvent(e);
				this.dialog.onCancel();
			});
			
			this.inherited(arguments);
		},
		
		_initButton: function() {
			// Override _Plugin._initButton() to initialize DropDownButton and TooltipDialog.
			var messages = dojo.i18n.getLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
			this.init();
			this.iconClassPrefix = "processAuthoringEditorIcon"; //$NON-NLS-1$
			this.inherited(arguments);
		},
		
		getLabel: function() {
			return this.messages.ResourceLinkPickerTooltipDialog_0;
		},
		
		onAdd: function(args) {
			dojo.forEach(args, function(arg) {
				arg.name = UIHelper.escapeXML(arg.name);
				this.editor.execCommand('inserthtml', dojo.string.substitute(this.htmlTemplate, arg) + "&nbsp;"); //$NON-NLS-1$ //$NON-NLS-2$
			}, this);
		},
		
		_onAddClose: function(e) {
			// We should close the picker dialog first, then focus on rich text editor and add links, see defect 264020.
			this.dialog.onCancel();
			this.editor.focus();
			this._onAdd(e);
		},
		
		_onClose: function() {
			dojo.forEach(this.resourceGroups, function(resourceGroup) {
				resourceGroup.list = [];
			}, this);
			this.inherited(arguments);
		}
		
	});
	
	dojo.declare("com.ibm.team.process.authoring.web.common.ui.internal.editors.ResouceLinkPickerWidget", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "ui/internal/editors/templates/ResourcePickerDialog.html"), //$NON-NLS-1$ //$NON-NLS-2$
		constructor: function() {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate: function() {
			this.inherited(arguments);
			dojo.style(this.dialogBody, "backgroundColor", "#ffffff"); //$NON-NLS-1$ //$NON-NLS-2$
			dojo.style(this.dialogFooter, "backgroundColor", "#ffffff"); //$NON-NLS-1$ //$NON-NLS-2$
		}
		
	});
})();