/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2013. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.process.authoring.web.common.ui.internal.editors.RichTextField"); //$NON-NLS-1$
	
	dojo.require("com.ibm.team.process.authoring.web.common.client.internal.ProcessAuthoringClient"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.common.internal.UIHelper"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.ImgLinkDialogInRichTextEditor"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.InlineEditor"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.LinkDialogInRichTextEditor"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.ResourceLinkPickerTooltipDialog"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.authoring.web.common.ui.internal.editors.UploadAttachmentPlugin"); //$NON-NLS-1$
	
	dojo.require("dijit._editor.plugins.AlwaysShowToolbar"); //$NON-NLS-1$
	dojo.require("dijit.Editor"); //$NON-NLS-1$
	
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	
	dojo.require("jazz.client.xhr"); //$NON-NLS-1$
	dojo.require("jazz.ui.ResourceLink");//$NON-NLS-1$
	dojo.require("jazz.ui.Toolbar"); //$NON-NLS-1$
	dojo.require("jazz.ui.toolbar.Button"); //$NON-NLS-1$
	dojo.require("jazz.util.html"); //$NON-NLS-1$
	
	dojo.requireLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	var UIHelper = com.ibm.team.process.authoring.web.common.common.internal.UIHelper;
	var ProcessAuthoringConstants = com.ibm.team.process.authoring.web.common.common.internal.ProcessAuthoringConstants;
	var InlineEditor = com.ibm.team.process.authoring.web.common.ui.internal.editors.InlineEditor;
	var ResourceLink = jazz.ui.ResourceLink;
	var UploadAttachmentPlugin = com.ibm.team.process.authoring.web.common.ui.internal.editors.UploadAttachmentPlugin;
	var ProcessAuthoringClient = com.ibm.team.process.authoring.web.common.client.internal.ProcessAuthoringClient;
	
	dojo.declare("com.ibm.team.process.authoring.web.common.ui.internal.editors.RichTextField", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		templatePath: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "ui/internal/editors/templates/RichTextField.html"), //$NON-NLS-1$ //$NON-NLS-2$
		isEditing: false,
		controller: null,
		textEditor: null,
		fieldData: null,
		name: null,
		editToolBar: null,
		resourceLinks: null,
		newCreated: false,
		friendLinkPrefix: null,
		editHandler: null,
		keyupHandler: null,
		plainTextCopy: null,
		htmlTemplate: "<a href=\"${resourceUrl}\" _djrealurl=\"${resourceUrl}\">${name}</a>", //$NON-NLS-1$
		
		constructor: function(args) {
			if (!args) {
				return;
			}
			
			this.resourceLinks = [];
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.authoring.web.common.ui.internal.editors", "Messages");//$NON-NLS-1$ //$NON-NLS-2$
		},
		
		postCreate: function() {
			this.inherited(arguments);
			
			this.titleArea = new InlineEditor({
				noValueIndicator: this.messages.RichTextField_4,
				onChange: dojo.hitch(this, this._titleOnChange)
			}, this.titleArea);
			
			if (this.fieldData) {
				this.newCreated = UIHelper.isNewCreated(this.fieldData);
				this.name = UIHelper.getFieldName(this.fieldData);
				this.fieldID = UIHelper.getNodeId(this.fieldData);
				this.titleArea.set("value", UIHelper.getFieldLabel(this.fieldData)); //$NON-NLS-1$
				this.titleArea.set('disabled', this.isViewMode() || this.isViewOnly()); //$NON-NLS-1$
				this.pristineTextHTML = UIHelper.unescapeXML(UIHelper.getFieldText(this.fieldData));
				this._setPreviewField(true);
				this._createResourceLinks();
				this._createImageEvent();
			} else {//a new richtext field or switched from a new created plain text field
				this.pristineTextHTML = this.previewArea.innerHTML;
				this._setPreviewField(false);
			}

			if (!this.isViewOnly() ) {
                this.initialToolbar();
                this.connect(this.switchField, ProcessAuthoringConstants.EVENT_CLICK, this._onSwitchField);
                this.subscribe(ProcessAuthoringConstants.PUBLISHTYPE_VIEWMODE, this._previewMode); //$NON-NLS-1$
                this.subscribe(ProcessAuthoringConstants.PUBLISHTYPE_EDITMODE, this._editMode); //$NON-NLS-1$
                //open the editor directly when creating a new field
                
                if (this.newCreated && !this.fieldData) {
                	this.edit();
                	this.editHandler = this.connect(this.previewArea, ProcessAuthoringConstants.EVENT_CLICK, this._onEdit);
                } else {
                	this.isViewMode() ? this._previewMode() : this._editMode();
                } 
			}else {
				this._previewMode();	
			}
		},
		
		getPracticeURL: function() {
			return this.controller.controller.practiceURL;
		},
		
		_titleOnChange: function(value) {
			this._setChange();
		},
		
		_getJtsUriPrefix: function() {
			return ProcessAuthoringClient.getJtsProcessAuthoringRoot();
		},
		
		_doCreateResouceLinks: function(linkPrefix) {
			var query = dojo.string.substitute("a[href*='${0}']", [linkPrefix]);//$NON-NLS-1$ //$NON-NLS-2$
			var links = dojo.query(query, this.previewArea);
			links.forEach(function(link) {
				var url = link.href;
				if (ProcessAuthoringClient.isPracticeURL(url) || UIHelper.isPracticeElementURL(url) || ProcessAuthoringClient.isProcessDescriptionURL(url)) {
					url = UIHelper.appendLangParamToURL(url, this.controller.controller.workingCopy.currentLanguage);
					var rl = new ResourceLink({
						uri: url,
						presentationUri: url,
						'lazyFetch': true //$NON-NLS-1$
					}, link);
					this.resourceLinks.push(rl);
				}
			}, this);
		},
		
		_createResourceLinks: function() {
			// create ResourceLinks for all links to process authoring resources
			
			var jtsUriPrefix = this._getJtsUriPrefix();
			if (jtsUriPrefix) {
				this._doCreateResouceLinks(jtsUriPrefix);
			}
		},
		
		_createImageEvent: function() {
			var imgs = dojo.query("img[src*=]", this.previewArea);  //$NON-NLS-1$
			imgs.forEach(function(img) {
				this.connect(img, "onload", dojo.hitch(this, function() { //$NON-NLS-1$
					this.controller.resizeEditor();
				}));
			}, this);
		},
		
		edit: function() {

			if (this.textEditor) {
				dojo.disconnect(this.keyupHandler);
				this.textEditor.destroyRecursive();
			}
			var div = document.createElement(ProcessAuthoringConstants.DIV);
			this.editArea.appendChild(div);
			this.textEditor = new dijit.Editor({
				plugins: [
				{
					name: 'dijit._editor.plugins.AlwaysShowToolbar', //$NON-NLS-1$
					height: "100%" //$NON-NLS-1$
				}, {
					name: 'com.ibm.team.process.authoring.web.common.ui.internal.editors.LinkDialogInRichTextEditor', //$NON-NLS-1$
					command: 'createLink', //$NON-NLS-1$
					generic: true
				}, {
					name: 'com.ibm.team.process.authoring.web.common.ui.internal.editors.ResourceLinkPickerTooltipDialog', //$NON-NLS-1$
					command: 'createLink', //$NON-NLS-1$
					generic: true,
					sharedSupport: this.controller.controller.controller ? this.controller.controller.controller.sharedSupport : true,
					privatePracticeList: this.controller.controller.controller ? this.controller.controller.controller.workingCopy.getPrivatePracticeList() : null
				}, {
					name: 'com.ibm.team.process.authoring.web.common.ui.internal.editors.UploadAttachmentPlugin', //$NON-NLS-1$
					command: 'insertImage', //$NON-NLS-1$
					practiceURL: this.getPracticeURL(),
					generic: true,
					workingCopy: this.controller.controller.workingCopy
				}, {
					name: 'com.ibm.team.process.authoring.web.common.ui.internal.editors.ImgLinkDialogInRichTextEditor', //$NON-NLS-1$
					command: 'insertImage', //$NON-NLS-1$
					generic: true
				}, '|', 'undo', 'redo', '|', 'delete', 'selectAll', 'removeFormat', '|', 'cut', 'copy', 'paste', '|', 'bold', 'italic', 'underline', 'strikethrough', '|', 'insertHorizontalRule', '|', 'insertOrderedList', 'insertUnorderedList', 'indent', 'outdent', '|', 'justifyLeft', 'justifyRight', 'justifyCenter', 'justifyFull', '|', 'subscript', 'superscript'] //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$ //$NON-NLS-7$ //$NON-NLS-8$ //$NON-NLS-9$ //$NON-NLS-10$ //$NON-NLS-11$ //$NON-NLS-12$ //$NON-NLS-13$ //$NON-NLS-14$ //$NON-NLS-15$ //$NON-NLS-16$ //$NON-NLS-17$ //$NON-NLS-18$ //$NON-NLS-19$ //$NON-NLS-20$ //$NON-NLS-21$ //$NON-NLS-22$ //$NON-NLS-23$ //$NON-NLS-24$ //$NON-NLS-25$ //$NON-NLS-26$ //$NON-NLS-27$ //$NON-NLS-28$ //$NON-NLS-29$ //$NON-NLS-30$ //$NON-NLS-31$
			}, div);

			//remove scripts for security consideration
			this.textEditor.contentPreFilters.push(jazz.util.html.removeStyleAndScript);	
			this.textEditor.contentPostFilters.push(jazz.util.html.removeStyleAndScript);
			dojo.toggleClass(this.previewArea, "hide", true); //$NON-NLS-1$
			dojo.toggleClass(this.editArea, "hide", false); //$NON-NLS-1$
			dojo.toggleClass(this.editBar, "hide", true); //$NON-NLS-1$
			dojo.toggleClass(this.saveBar, "hide", false); //$NON-NLS-1$
			this.textEditor.setValue(this.pristineTextHTML);
			this.isEditing = true;
			// show save/cancel button in editing mode
			dojo.toggleClass(this.toobarArea, "hide", false); //$NON-NLS-1$
			setTimeout(dojo.hitch(this, function() {
                this.connect(this.textEditor, "onChange", this._setChange);//$NON-NLS-1$
				this.resizeEditor();
				this.controller.resizeEditor();
				this.textEditor.placeCursorAtStart();
				this.keyupHandler = dojo.connect(this.textEditor.iframe.contentWindow.document, "onkeyup", this, "_onInput"); //$NON-NLS-1$ //$NON-NLS-2$
			}), 500);
		},
		
		_onEdit: function(evt) {
			this.edit();
			dojo.stopEvent(evt);
		},
		
		_onSwitchField: function(e) {
			dojo.stopEvent(e);
            if (confirm(this.messages.RichTextField_6)) {
				this.controller.switchField(this);
			}
		},
		
		_onSave: function(evt) {
			this.commitChange();
			dojo.stopEvent(evt);
		},
		
		_onInput: function(evt) {
			this.resizeEditor();
		},

		resizeEditor: function() {
			if (this.textEditor.iframe.contentWindow.document.body.scrollHeight + "px" === dojo.style(this.textEditor.iframe, "height")) { //$NON-NLS-1$ //$NON-NLS-2$
				return;
			}
			if (this.textEditor.iframe.contentWindow.document.body.scrollHeight > 300) {
				dojo.style(this.textEditor.iframe, "height", this.textEditor.iframe.contentWindow.document.body.scrollHeight + "px"); //$NON-NLS-1$ //$NON-NLS-2$
			}
			this.controller.resizeEditor();
		},
		
		commitChange: function() {
			dojo.toggleClass(this.previewArea, "hide", false); //$NON-NLS-1$
			dojo.toggleClass(this.previewArea, "previewField", !this.isViewMode()); //$NON-NLS-1$
			dojo.toggleClass(this.editArea, "hide", true); //$NON-NLS-1$
			dojo.toggleClass(this.editBar, "hide", false); //$NON-NLS-1$
			dojo.toggleClass(this.saveBar, "hide", true); //$NON-NLS-1$
			var textEditorContent = this.textEditor.getValue(false);
			dojo.disconnect(this.keyupHandler);
			this.textEditor.destroyRecursive();
			this.textEditor = null;
			if (this.pristineTextHTML != textEditorContent) {
                this.pristineTextHTML = textEditorContent;
                this._setPreviewField(false);
                this._createResourceLinks();
				this._setChange();
			}
			this.isEditing = false;
			this.plainTextCopy = null; //invalidate plaintext copy once apply button is clicked
			dojo.toggleClass(this.toobarArea, "hide", true); //$NON-NLS-1$
			this.controller.resizeEditor();
		},
		
		insertResourceLink: function(args) {
			dojo.forEach(args, function(arg) {
				this.textEditor.execCommand('inserthtml', dojo.string.substitute(this.htmlTemplate, arg)); //$NON-NLS-1$
			}, this);
		},
		
		
		_setPreviewField: function(checkingScript) {
            
            if (checkingScript) {
            	this.pristineTextHTML = jazz.util.html.removeStyleAndScript(this.pristineTextHTML);
            }
            if (this._isEmptyText()) {
            	dojo.toggleClass(this.previewArea, "novalueField", true); //$NON-NLS-1$
            	dojo.html.set(this.previewArea, this.messages.TextField_0);
            } else {
            	dojo.toggleClass(this.previewArea, "novalueField", false); //$NON-NLS-1$
            	dojo.html.set(this.previewArea, this.pristineTextHTML);
            }
		},
		
		_onCancel: function(evt) {
			this.cancelEditing();
			dojo.stopEvent(evt);
			this.controller.resizeEditor();
		},
		
		cancelEditing: function() {
			dojo.toggleClass(this.previewArea, "hide", false); //$NON-NLS-1$
			dojo.toggleClass(this.previewArea, "previewField", !this.isViewMode()); //$NON-NLS-1$
			dojo.toggleClass(this.editArea, "hide", true); //$NON-NLS-1$
			dojo.toggleClass(this.editBar, "hide", false); //$NON-NLS-1$
			dojo.toggleClass(this.saveBar, "hide", true); //$NON-NLS-1$
			this.isEditing = false;
			dojo.toggleClass(this.toobarArea, "hide", true); //$NON-NLS-1$
			if (this.textEditor) {
				dojo.disconnect(this.keyupHandler);
				this.textEditor.destroyRecursive();
				this.textEditor = null;
			}
		},
		
		_onMoveUpButtonClick: function(evt) {
			this.controller.moveUpField(this);
			dojo.stopEvent(evt);
		},
		_onMoveDownButtonClick: function(evt) {
			this.controller.moveDownField(this);
			dojo.stopEvent(evt);
		},
		
		_onDeleteButtonClick: function(evt) {
			this.controller.removeField(this);
			dojo.stopEvent(evt);
		},
		initialToolbar: function() {
			this.editToolBar = new jazz.ui.Toolbar({});
			this.editBar.appendChild(this.editToolBar.domNode);
			
			this.editToolBar_UpButton = new jazz.ui.toolbar.Button({
				imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/up-button.gif"), //$NON-NLS-1$ //$NON-NLS-2$
				title: this.messages.RichTextField_0,
				onClick: dojo.hitch(this, this._onMoveUpButtonClick)
			});
			this.editToolBar.addChild(this.editToolBar_UpButton);
			
			this.editToolBar_DownButton = new jazz.ui.toolbar.Button({
				imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/down-button.gif"), //$NON-NLS-1$ //$NON-NLS-2$
				title: this.messages.RichTextField_1,
				onClick: dojo.hitch(this, this._onMoveDownButtonClick)
			});
			this.editToolBar.addChild(this.editToolBar_DownButton);
			
			this.editToolBar_DeleteButton = new jazz.ui.toolbar.Button({
				imgSrc: dojo.moduleUrl("com.ibm.team.process.authoring.web.common", "graphics/icons/delete-button.gif"), //$NON-NLS-1$ //$NON-NLS-2$
				title: this.messages.RichTextField_3,
				onClick: dojo.hitch(this, this._onDeleteButtonClick)
			});
			this.editToolBar.addChild(this.editToolBar_DeleteButton);
		},
		
		isEmpty: function() {
			return this._isEmptyTitle() && this._isEmptyText();
		},
		
		_isEmptyTitle: function() {
			return !this.titleArea.value || dojo.string.trim(this.titleArea.value).lenth == 0;
		},
		
		_isEmptyText: function() {
			if (this.pristineTextHTML) {
				var text = dojo.string.trim(this.pristineTextHTML);
				// dijit.Editor still returns "<br />" even it has been cleared
				if (text.length == 0 || text == "<br />") { //$NON-NLS-1$
					return true;
				} else {
					return false;
				}
			} else {
				return true;
			}
		},
		
		isViewMode: function() {
			return this.controller.isViewMode();
		},
		
		isViewOnly: function() {
			return this.controller.isViewOnly();
		},
		
		_previewMode: function() {
			if (this.isEditing) {
				this.cancelEditing();
			}
			
			// hide this rich text if it is empty
			var isEmptyText = this._isEmptyText();
			var isEmptyTitle = this._isEmptyTitle();
			if (isEmptyTitle && isEmptyText) {
				dojo.toggleClass(this.fieldArea, "hide", true); //$NON-NLS-1$
			} else {
				dojo.toggleClass(this.domNode, "preview", true); //$NON-NLS-1$
				
				// hide content area if the text is empty
				if (isEmptyText) {
					dojo.toggleClass(this.contentSection, "hide", true); //$NON-NLS-1$
				} else {
					dojo.toggleClass(this.contentSection, "content", false); //$NON-NLS-1$
					dojo.toggleClass(this.contentSection, "contentPreview", true); //$NON-NLS-1$
				}
				// hide title if it is empty
				if (isEmptyTitle) {
					dojo.toggleClass(this.headerSection, "hide", true); //$NON-NLS-1$
				}
			}

			dojo.toggleClass(this.editBar, "hide", true); //$NON-NLS-1$
			dojo.toggleClass(this.saveBar, "hide", true); //$NON-NLS-1$
			this.disconnect(this.editHandler);
			this.titleArea.set("disabled", true); //$NON-NLS-1$
		},
		
		_editMode: function() {
			dojo.toggleClass(this.domNode, "preview", false); //$NON-NLS-1$		
			dojo.toggleClass(this.headerSection, "hide", false); //$NON-NLS-1$
			dojo.toggleClass(this.contentSection, "hide", false); //$NON-NLS-1$
			dojo.toggleClass(this.contentSection, "contentPreview", false); //$NON-NLS-1$
			dojo.toggleClass(this.contentSection, "content", true); //$NON-NLS-1$
				
			dojo.toggleClass(this.fieldArea, "hide", false); //$NON-NLS-1$
			dojo.toggleClass(this.editBar, "hide", false); //$NON-NLS-1$
			dojo.toggleClass(this.saveBar, "hide", true); //$NON-NLS-1$
			this.editHandler = this.connect(this.previewArea, ProcessAuthoringConstants.EVENT_CLICK, this._onEdit); 
			dojo.toggleClass(this.previewArea, "previewField", !this.isViewMode()); //$NON-NLS-1$
			this.titleArea.set("disabled", false); //$NON-NLS-1$
		},
		
		_onMouseOver: function(evt) {
			dojo.toggleClass(this.toobarArea, "hide", false); //$NON-NLS-1$
		},
		
		_onMouseOut: function(evt) {
			if (!this.isEditing) {
				dojo.toggleClass(this.toobarArea, "hide", true); //$NON-NLS-1$
			}
		},
		
		_setChange: function() {
			this.controller._setChange();
		},
		
		doCommit: function() {
			if (this.isEditing) {
				this.commitChange();
			}
		},
		
		getXML: function() {
			// we don't need to generate uuid every time for the unsaved field, 
			// we can simply set a variable to remember it. 
			var rdfID, uuid;
			if(this.fieldID){
				rdfID = " rdf:ID=\"" + this.fieldID + "\" "; //$NON-NLS-1$ //$NON-NLS-2$
			} else {
				uuid = "ID-" + dojox.uuid.generateTimeBasedUuid();  //$NON-NLS-1$
				rdfID = " rdf:ID=\"" + uuid + "\" "; //$NON-NLS-1$ //$NON-NLS-2$
				this.fieldID = uuid;
			}
			var newCreated = this.newCreated ? " newCreated=\"true\"" : ""; //$NON-NLS-1$ //$NON-NLS-2$
			var data = "<field name=\"" + this.name + "\" label=\"" + UIHelper.escapeXML(this.titleArea.get("value")) + "\" type=\"rich-text\" localized=\"true\"" + rdfID + newCreated + ">" + UIHelper.escapeXML(jazz.util.html.escape(this.pristineTextHTML)) + "</field>"; //$NON-NLS-5$ //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
			return data;
		},
		
		getEditing: function() {
			return this.isEditing;
		},
		
		uninitialize: function() {
			if (this.editToolBar_UpButton) {
				this.editToolBar_UpButton.destroyRecursive();
			}
			if (this.editToolBar_DownButton) {
				this.editToolBar_DownButton.destroyRecursive();
			}
			if (this.editToolBar_DeleteButton) {
				this.editToolBar_DeleteButton.destroyRecursive();
			}
			if (this.editToolBar) {
				this.editToolBar.destroyRecursive();
			}			
			if (this.textEditor) {
				dojo.disconnect(this.keyupHandler);
				this.textEditor.destroyRecursive();
			}
			if (this.titleArea) {
				this.titleArea.destroyRecursive();
			}
			dojo.forEach(this.resourceLinks, function(resourceLink) {
				if (resourceLink) {
					resourceLink.destroyRecursive();
				}
			}, this);
			
			delete this.controller;
			
			this.inherited(arguments);
		}
	});
	
})();
