/*******************************************************************************
 * Licensed Materials - Property of IBM (c) Copyright IBM Corporation 2008, 2014,
 * 2009, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights: Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
// NLS_CHARSET=UTF-8
( {
	// navigation labels
	'dataCollection' : "Data Collection",
	'configuration' : "Configuration",
	'etl' : "Data Collection Jobs",
	'etlStatus' : "Data Collection Job Status",
	'downloads' : "Downloads", 
	'refresh' : "Refresh",
	'reports' : "Reports",
	'runningReports' : "Running Reports",	

	'admin' : "Admin",
	'waitingForResponse' : "Waiting for response.",
	'errorInResponse' : "Error in response last request failed.",
	'updateSnapshotData' : "Run data collection job",
	'updateAllRemoteSnapshotData' : "Run all data warehouse collection jobs",
	'updateAllLocalSnapshotData' : "Run all data mart collection jobs",
	'startRemoteScheduledTask' : "Run all data warehouse collection jobs for all applications",
	'runSnapshot' : "Run data collection job",
	'testSnapshot' : "Test connection",
	'save' : "Save",
	'run' : "Run",
	'saveSuccessful' : "Changes successfully saved.",
	'pingSuccess' : "Connection test successful.",
	'pingFailed' : "Connection test unsuccessful. Check your credentials and try again.",
	'snapshotStarted' : "Request submitted. Check the Data Collection Job Status page for details.",
	'snapshotStartedDataMart' : "Request submitted. Check the Active Services page for details.",
	'enabled' : "Enabled",
	'dataCollectionJob' : "Data Collection Job",
	'application' : "Application",
	'startTime' : "Hour of the day to run jobs (1-24)",
	'delay' : "Delay between running jobs (in hours):",
	'userId' : "User ID",
	'password' : "Password",
	'consumerKey' : "Consumer Key",
	'consumerSecret' : "Consumer Secret",
	'actions' : "Actions",
	'state' : "State",
	'running' : "Running",
	'idle' : "Idle",
	'remote' : "Data Warehouse Collection Jobs",
	'local' : "Data Mart Collection Jobs",
	'remoteRadio' : "Data warehouse. Use this setting for new installations.",
	'localRadio' : "Data mart. Use this setting after you upgrade from a previous version.",
	'savePageBeforeRunning' : "There are unsaved changes on the page. All changes must be saved before running a data warehouse collection job.",
	'runFullSnapshot' : "Run Full Data Collection Job",
	'confirmRunFullJob' : "This will perform a full load of this data collection job's data into the data warehouse.",
	'confirmRunFullJob2' : "This can significantly longer than the scheduled jobs which only load data that has been modified since the last successful job. Are you sure you want to continue?",
	'confirmRunFullJob3' : "Press OK to continue running the full data collection job or Cancel to return to the page.",
	'dccInstalled' : "The Data Collection Component is installed. Go <a href='${0}'>here</a> to view collection job configuration and status.",
	'dccNotInstalled' : "The Data Collection Component is designed to improve the performance of your data collection jobs with easier set up, configuration and deployment. <a href='${0}'>Learn More</a>",
	
	'diagnostics' : "Diagnostics",
	'nonJtsDiagnostics' : "Diagnostics can only be run from the JTS.",
	'errorPerformingDiagnostics' : "There was an error performing diagnostics",
	'location' : "Location",
	'valid' : "Valid",
	'diagnosticHelp' : "Ensure that the failing applications are running and that the Inbound Consumer corresponding to the JTS has a Functional User Id set.",
	
	'provider' : "Data Warehouse Configuration",
	'jobScheduling' : "Job Scheduling",
	
	'xdcLink' : "Configuration Files for Rational Reporting data sources",
	'xdcLinkDescription' : "The zip file provided by this link contains files to configure IBM Rational XML ODBC Driver instances. For products which support live reporting using Rational Reporting for Development Intelligence, or to integrate this product with Rational Insight, download these files to configure these driver instances. These files are auto-generated for your server setup, and include the user name and password provided in the Data Collection Jobs page. If using Data Manager to integrate with Rational Insight, you should disable the Data Collection Jobs provided by this application.",
	
	'archiveLink' : "Archive Files for Rational Reporting",
	'archiveLinkDescription' : "The archive files provided by the following link contain sample reports, data model definitions, and live reporting configuration files for use by Rational Reporting. Please see the Rational Reporting documentation for more details on how to import these archives into the reporting server. The archive also includes sources for these files that can be used with Rational Insight for customization of data collection jobs and report models.",
	
	'invalidSaveValues' : "Cannot perform save page contains invalid entries. Correct validation errors to save.",
	'delayValidationError' : "Value must be numeric and greater than 0",
	'startTimeValidationError' : "Value must be numeric and between 1 and 24 inclusive",
	
	'etlDescription' : "Use this page to configure the data collection jobs.",
	
	'remoteHistoryWarning' : "The data warehouse is configured to use the data mart provider. Job history cannot be shown for the data mart provider. The provider can be changed on the Data Collection Jobs page.",
	'jobListTitle' : "Data Collection Job History",
	'statusDescription' : "This page displays the status of data collection jobs.",
	'numberOfJobs' : "Number of previous jobs to display data for ",
	'numberOfJobsValidationError' : "Must be an integer between 1 and 1000",
	'noJobHistory' : "No job history found.",
	'loadingJobHistory' : "Loading Job History",
	'loadingRunningJobs' : "Loading Running Jobs",
	
	'startTime' : "Start Time:",
	'endTime' : "End Time",
	'status' : "Status",
	'succeeded' : "Succeeded",
	'failed' : "Failed",
	'interrupted' : "Interrupted",
	'inProgress' : "In Progress",
	'didNotFinish' : "Did Not Finish",
	'na' : "Not Applicable",
	'totalTime' : "Time Taken",
	'runningTime' : "Running Time",
	'jobHistory' : "Job History",
	'runningJobs' : "Currently Running Jobs",
	
	'etlHistoryError' : "Error fetching job history, ensure the data warehouse is properly configured.",
	'runningJobsError' : "Error fetching currently running jobs. Refresh the page to try again.",
	'stillRunning' : "Currently Running",
	'noRunningJobs' : "There are currently no running data warehouse collection jobs.",
	
	//data warehouse connection properties
	'dataWarehouseTableHeading' : "Connection Properties",
	'internalDataWarehouseTableHeading' : "Internal Connection Properties",
	'remoteSnapshotManagerTaskHeading' : "Remote Data Collection Job Manager Task",
	'loading': "Loading...",
	'dataWarehouseHeading': "Data Warehouse Connection", 
	'noProperties': "There are no properties that match your selection criteria.",
	'serviceError': "CRJAZ1515E Error fetching configuration properties",
	'correctInvalid': "There are some properties with invalid values. Please correct any properties flagged below and attempt to save again",
	'saveSuccess': "Configuration changes saved successfully.", 
	'saveRestart': "  However, some of your changes will require a server restart before they take effect.",
	'saveError': "CRJAZ1513E An error occurred while saving the configuration properties.  Please check your server log for more details",
	'serverUnreachable': "CRJAZ1514E The server is unreachable.  Check network connectivity.",
	
	'cognosReportServiceTableHeading' : "Custom Reports",
	'customReportsHeading' : "Custom Reports Connection",
		
	//reports status messages
	'reportStatusTitle' : "Running Reports",
	'reportStatusAdminDescription' : "This page displays all report tasks currently running on the server.",
	'reportStatusDescription' : "This page displays all running report tasks in the current project requested by the current user.",
	'noReportsMessage' : "No reports currently running",
	'reportColumnLabel' : "Report Resource",
	'projectColumnLabel' : "Project Area",
	'userColumnLabel' : "Requested By",
	'timeColumnLabel' : "Running Time",
	'statusColumnLabel' : "Status",
	'taskColumnLabel' : "Task",
	'actionColumnLabel' : "Actions",
	'cancelSuccessMessage' : "Cancellation request received",
	'cancelUnsuccessfulMessage' : "Report could not be cancelled; it may have already finished or been cancelled",
	'reportStatusCancelledLabel' : "Cancel requested",
	'reportStatusRunningLabel' : "Running",
	'cancelButtonText' : "Cancel",
	'refreshButtonText' : "Refresh",
	'daysElapsedLabel' : "${0} days"
		
		
})