/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
dojo.provide("com.ibm.team.reports.web.util.ReportsUtil");

dojo.require("com.ibm.team.reports.web.ui.ReportsConstants");

(function() {

/*
 * Aliases
 */
var ReportsConstants = com.ibm.team.reports.web.ui.ReportsConstants;

/*
 * Public utility methods.
 */
com.ibm.team.reports.web.util.ReportsUtil = {
		
	getReportsListHref: function(shared) {
		var href = ["#action=", ReportsConstants.ACTION_VIEW_REPORTS, "&", ReportsConstants.SHARED, "=", shared];
		return href.join("");
	},
	
	getResourcesListHref: function() {
		var href = ["#action=", ReportsConstants.ACTION_VIEW_RESOURCES];
		return href.join("");
	},
	
	getReportsWelcomeHref: function() {
		var href = ["#action=", ReportsConstants.ACTION_VIEW_DEFAULT];
		return href.join("");
	},
	
	getReportHref: function(name, queryUUID, shared) {
		if(shared != "") {
			shared = "&shared=" + shared;
		}
		var href = ["#action=", ReportsConstants.ACTION_VIEW_QUERY, "&name=" , encodeURIComponent(name), "&queryUUID=", queryUUID, shared];
		return href.join("");
	},
	
	getReportTemplateHref: function(reportUUID) {
		var href = ["#action=", ReportsConstants.ACTION_EDIT_TEMPLATE, "&reportUUID=", reportUUID];
		return href.join("");
	},
	
	getReportUri: function(scope, name, itemUUID, shared) {
		
		projectName = jazz.app.context.get().name;
		var href = "/web/projects/" + projectName;
		
		switch(scope) {
			case ReportsConstants.VIEWER_TYPE_ID:
				href += this.getReportHref(name, itemUUID, shared);
				break;
			case ReportsConstants.TEMPLATE_TYPE_ID:
				href += this.getReportTemplateHref(itemUUID);
				break;
		}
		
		return net.jazz.ajax.contextRoot() + href;
	},
	
	/*
	 * Returns current project area item
	 */
	getProjectArea: function() {
		return jazz.app.context.get();
	},
};

})();