--******************************************************************************************************************************
--* Licensed Materials - Property of IBM                                                                                       *
--* (c) Copyright IBM Corp. 2008, 2013 All Rights Reserved.                                                                    *
--*                                                                                                                            *
--*US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp*
--******************************************************************************************************************************

--=============  Add views to the STAR model... views are added for optimization purpose and also to join cross-schema's

USE $(DBNAME)
 GO
CREATE SCHEMA AUTHORIZATION $(STAR_SCHEMA)
GO


CREATE VIEW $(STAR_SCHEMA).VW_TASK_DETAIL (ACTUAL_WORK, ACTUAL_FINISH, ACTUAL_START, PLANNED_WORK, PLANNED_FINISH, PLANNED_START, PRIORITY, TASK_ID, URL, NAME, ACTUAL_COST, ACTUAL_OVT_COST, ACTUAL_OVT_WORK, ACWP, BASELINE_COST, BASELINE_DURATION, BASELINE_FINISH, BASELINE_START, BASELINE_WORK, BCWP, BCWS, CONSTRAINT_DATE, CONSTRAINT_TYPE, DEADLINE, DURATION_VARIANCE, EAC, EARLY_FINISH, EARLY_START, FINISH_VARIANCE, LATE_FINISH, LATE_START, PERCENT_COMPLETE, PERCENT_WORK_COMPLETE, PLANNED_COST, PLANNED_DURATION, PLANNED_OVT_COST, PLANNED_OVT_WORK, REGULAR_WORK, REMAINING_COST, REMAINING_DURATION, REMAINING_OVT_COST, REMAINING_OVT_WORK, REMAINING_WORK, START_VARIANCE, VAC, WBS_CODE, ACTUAL_FINISH_VARIANCE, BASELINE_FINISH_VARIANCE, ACTUAL_WORK_VARIANCE, BASELINE_WORK_VARIANCE, ACTUAL_START_VARIANCE, BASELINE_START_VARIANCE, WORK_VARIANCE, EXTERNAL_KEY1, EXTERNAL_KEY2, REC_DATETIME) AS
 ( SELECT T.ACTUAL_WORK, T.ACTUAL_FINISH, T.ACTUAL_START, T.PLANNED_WORK, T.PLANNED_FINISH, T.PLANNED_START, TS.PRIORITY, T.TASK_ID, TS.URL, TS.NAME, T.ACTUAL_COST,T.ACTUAL_OVT_COST,T.ACTUAL_OVT_WORK,T.ACWP,T.BASELINE_COST,T.BASELINE_DURATION,T.BASELINE_FINISH,T.BASELINE_START, T.BASELINE_WORK,T.BCWP,T.BCWS,T.CONSTRAINT_DATE,T.CONSTRAINT_TYPE,T.DEADLINE,T.DURATION_VARIANCE,T.EAC,T.EARLY_FINISH,T.EARLY_START,T.FINISH_VARIANCE,T. LATE_FINISH,T.LATE_START,T.PERCENT_COMPLETE,T.PERCENT_WORK_COMPLETE,T.PLANNED_COST,T.PLANNED_DURATION,T.PLANNED_OVT_COST,T.PLANNED_OVT_WORK,T.REGULAR_WORK,T. REMAINING_COST,T.REMAINING_DURATION,T.REMAINING_OVT_COST,T.REMAINING_OVT_WORK,T.REMAINING_WORK,T.START_VARIANCE,T.VAC,T.WBS_CODE, T.ACTUAL_FINISH_VARIANCE, T.BASELINE_FINISH_VARIANCE, T.ACTUAL_WORK_VARIANCE, T.BASELINE_WORK_VARIANCE,T.ACTUAL_START_VARIANCE, T.BASELINE_START_VARIANCE, T.WORK_VARIANCE, TS.EXTERNAL_KEY1,TS.EXTERNAL_KEY2, TS.REC_DATETIME FROM  $(NF_SCHEMA).TASK_DETAIL T JOIN  $(NF_SCHEMA).TASK TS ON TS.TASK_ID=T.TASK_ID)
GO

CREATE VIEW $(STAR_SCHEMA).D_WEEK (DATE_ID, PERIOD_START_DATE, WEEK_OF_MONTH, WEEK_OF_YEAR, WEEK_NO, MONTH_OF_YEAR, MONTH_NAME, MONTH_NO, QUARTER_OF_YEAR, QUARTER_NO, YEAR_OF) AS
 (SELECT DATE_ID, PERIOD_START_DATE, WEEK_OF_MONTH, WEEK_OF_YEAR, WEEK_NO, MONTH_OF_YEAR, MONTH_NAME, MONTH_NO, QUARTER_OF_YEAR, QUARTER_NO, YEAR_OF FROM D_DATE WHERE DAY_OF_WEEK=1)
GO
CREATE VIEW $(STAR_SCHEMA).D_WEEK_ISO (DATE_ID, PERIOD_START_DATE, WEEK_OF_MONTH, WEEK_OF_YEAR, WEEK_NO, MONTH_OF_YEAR, MONTH_NAME, MONTH_NO, QUARTER_OF_YEAR, QUARTER_NO, YEAR_OF) AS
 (SELECT DATE_ID, PERIOD_START_DATE, WEEK_OF_MONTH_ISO, WEEK_OF_YEAR_ISO, WEEK_NO_ISO, MONTH_OF_YEAR, MONTH_NAME, MONTH_NO, QUARTER_OF_YEAR, QUARTER_NO, YEAR_OF FROM D_DATE WHERE DAY_OF_WEEK_ISO=1)
GO

CREATE VIEW $(STAR_SCHEMA).D_MONTH (DATE_ID, PERIOD_START_DATE, MONTH_OF_YEAR, MONTH_NAME, MONTH_NO, QUARTER_OF_YEAR, QUARTER_NO, YEAR_OF) AS
 (SELECT DATE_ID, PERIOD_START_DATE, MONTH_OF_YEAR, MONTH_NAME, MONTH_NO, QUARTER_OF_YEAR, QUARTER_NO, YEAR_OF FROM D_DATE WHERE DAY_OF_MONTH=1)
GO
CREATE VIEW $(STAR_SCHEMA).D_QUARTER (DATE_ID, PERIOD_START_DATE, QUARTER_OF_YEAR, QUARTER_NO, YEAR_OF) AS
 (SELECT DATE_ID, PERIOD_START_DATE, QUARTER_OF_YEAR, QUARTER_NO, YEAR_OF FROM D_DATE WHERE MONTH_OF_YEAR IN (1,4,7,10) AND DAY_OF_MONTH=1)
GO
CREATE VIEW $(STAR_SCHEMA).D_YEAR (DATE_ID, PERIOD_START_DATE, YEAR_OF) AS
 (SELECT DATE_ID, PERIOD_START_DATE, YEAR_OF FROM D_DATE WHERE MONTH_OF_YEAR =1 AND DAY_OF_MONTH=1)
GO
CREATE VIEW $(STAR_SCHEMA).VW_BUILD (BUILD_ID, BUILD_CLASS_ID, BUILD_CLASS_NAME,ITERATION_ID, ITERATION_NAME,TEAM_ID,TEAM_NAME,BUILD_STATE, COMPONENT_ID, COMPONENT_NAME, END_TIME, EXTERNAL_ID, NAME, REFERENCE_ID, START_TIME, STATUS, BUILD_TYPE,URL,
BASELINE_ID,BASELINE_NAME,OWNER_ID,OWNER_NAME,PROJECT_ID,PROJECT_NAME,PROJECT_TYPE_ID,PROJECT_TYPE_NAME,CREATION_DATE,WAITING_TIME,BUILDING_TIME,ENGINE,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT B.BUILD_ID, B.BUILD_CLASS_ID, BC.NAME AS BUILD_CLASS_NAME,B.ITERATION_ID, I.NAME AS ITERATION_NAME,B.TEAM_ID,T.NAME AS TEAM_NAME,B.BUILD_STATE, B.COMPONENT_ID,D1.NAME AS COMPONENT_NAME, B.END_TIME, B.EXTERNAL_ID, B.NAME, B.REFERENCE_ID, B.START_TIME, B.STATUS, B.BUILD_TYPE, B.URL,
 B.BASELINE_ID,BS.NAME AS BASELINE_NAME,B.OWNER_ID,R.FULL_NAME AS OWNER_NAME,B.PROJECT_ID,P.NAME AS PROJECT_NAME,B.PROJECT_TYPE_ID,PT.NAME AS PROJECT_TYPE_NAME,B.CREATION_DATE,B.WAITING_TIME,B.BUILDING_TIME,B.ENGINE,B.EXTERNAL_KEY1,B.EXTERNAL_KEY2, B.REC_DATETIME, B.ISSOFTDELETED
 FROM  $(NF_SCHEMA).BUILD B
 JOIN  $(NF_SCHEMA).BUILD_CLASSIFICATION BC ON BC.BUILD_CLASS_ID =B.BUILD_CLASS_ID
 JOIN  $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID=B.ITERATION_ID
 JOIN  $(NF_SCHEMA).TEAM T ON T.TEAM_ID=B.TEAM_ID
 JOIN  $(NF_SCHEMA).COMPONENT D1 ON D1.COMPONENT_ID=B.COMPONENT_ID
 JOIN  $(NF_SCHEMA).PROJECT_BASELINE BS ON BS.BASELINE_ID=B.BASELINE_ID
 JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID =B.OWNER_ID
 JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=B.PROJECT_ID
 JOIN  $(NF_SCHEMA).PROJECT_TYPE PT ON PT.PROJECT_TYPE_ID=B.PROJECT_TYPE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_COMPONENT (COMPONENT_ID, EXTERNAL_ID, NAME, PRODUCT_ID, PRODUCT_NAME, PROJECT_ID, PROJECT_NAME, REFERENCE_ID, URL,EXTERNAL_KEY1,EXTERNAL_KEY2,COMPONENT_CLASS_ID,COMPONENT_CLASS_NAME,PARENT_COMPONENT_ID,PARENT_COMPONENT_NAME,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT C.COMPONENT_ID, C.EXTERNAL_ID, C.NAME, C.PRODUCT_ID, D1.NAME AS PRODUCT_NAME, COALESCE(D.PROJECT_ID,-1) AS PROJECT_ID, D2.NAME AS PROJECT_NAME, C.REFERENCE_ID, C.URL,C.EXTERNAL_KEY1,C.EXTERNAL_KEY2,C.COMPONENT_CLASS_ID,CL.NAME AS COMPONENT_CLASS_NAME,C.PARENT_COMPONENT_ID,CP.NAME AS PARENT_COMPONENT_NAME,C.REC_DATETIME,C.ISSOFTDELETED
 FROM  $(NF_SCHEMA).COMPONENT C
 JOIN  $(NF_SCHEMA).COMPONENT CP ON CP.COMPONENT_ID=C.PARENT_COMPONENT_ID
 JOIN  $(NF_SCHEMA).PRODUCT D1 ON D1.PRODUCT_ID=C.PRODUCT_ID
 LEFT JOIN  $(NF_SCHEMA).PROJECT_COMPONENT_LOOKUP D ON D.COMPONENT_ID=C.COMPONENT_ID
 LEFT JOIN  $(NF_SCHEMA).PROJECT D2 ON D2.PROJECT_ID=D.PROJECT_ID
 JOIN  $(NF_SCHEMA).COMPONENT_CLASSIFICATION CL ON CL.COMPONENT_CLASS_ID=C.COMPONENT_CLASS_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TEAM (EXTERNAL_ID, NAME, REFERENCE_ID, TEAM_ID,PROJECT_ID,PROJECT_NAME,PARENT_TEAM_ID, PARENT_TEAM_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT C.EXTERNAL_ID, C.NAME, C.REFERENCE_ID, C.TEAM_ID,C.PROJECT_ID,P.NAME AS PROJECT_NAME,C.PARENT_TEAM_ID, PT.NAME AS PARENT_TEAM_NAME,C.EXTERNAL_KEY1,C.EXTERNAL_KEY2,C.REC_DATETIME,C.ISSOFTDELETED
 FROM  $(NF_SCHEMA).TEAM C
 JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=C.PROJECT_ID
 JOIN  $(NF_SCHEMA).TEAM PT ON C.PARENT_TEAM_ID=PT.TEAM_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TEAM_MEMBER_LOOKUP(TEAM_ID,TEAM_NAME,RESOURCE_ID,RESOURCE_NAME) AS
(SELECT TR.TEAM_ID,T.NAME AS TEAM_NAME,TR.RESOURCE_ID,R.FULL_NAME AS RESOURCE_NAME
 FROM  $(NF_SCHEMA).TEAM_MEMBER_LOOKUP TR
 JOIN  $(NF_SCHEMA).TEAM T ON T.TEAM_ID=TR.TEAM_ID
 JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=TR.RESOURCE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TEAM_ROLE_MEMBER_LOOKUP(TEAM_ROLE_ID,TEAM_NAME,TEAM_ROLE_NAME,RESOURCE_ID,FULL_NAME) AS
(SELECT TRM.TEAM_ROLE_ID,T.NAME AS TEAM_NAME, TR.NAME AS TEAM_ROLE_NAME,TRM.RESOURCE_ID,R.FULL_NAME
 FROM  $(NF_SCHEMA).TEAM_ROLE_MEMBER_LOOKUP TRM
 JOIN  $(NF_SCHEMA).TEAM_ROLE TR ON TR.TEAM_ROLE_ID=TRM.TEAM_ROLE_ID
 JOIN  $(NF_SCHEMA).TEAM T ON T.TEAM_ID=TR.TEAM_ID
 JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=TRM.RESOURCE_ID)
GO


CREATE VIEW $(STAR_SCHEMA).VW_CURRENCY (CURRENCY_ID, DEFAULT_CURRENCY, EXCHANGE_RATE, EXTERNAL_ID, NAME, REFERENCE_ID, URL, VALID_FINISH_DATE, VALID_START_DATE,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT C.CURRENCY_ID, CASE WHEN C.DEFAULT_CURRENCY=1 THEN 'True' ELSE 'False' END AS DEFAULT_CURRENCY, C.EXCHANGE_RATE, C.EXTERNAL_ID, C.NAME, C.REFERENCE_ID, C.URL, C.VALID_FINISH_DATE, C.VALID_START_DATE,C.EXTERNAL_KEY1,C.EXTERNAL_KEY2,C.REC_DATETIME,C.ISSOFTDELETED
 FROM  $(NF_SCHEMA).CURRENCY C)
GO

CREATE VIEW $(STAR_SCHEMA).VW_CUSTOMER (COMPANY_NAME, CONTACT_ADDRESS, CONTACT_EMAIL, CONTACT_FAX, CONTACT_PHONE, CUSTOMER_ID, CUST_REFID, EXTERNAL_ID, GEO_LOCATION, NAME, REFERENCE_ID, URL,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT C.COMPANY_NAME, C.CONTACT_ADDRESS, C.CONTACT_EMAIL, C.CONTACT_FAX, C.CONTACT_PHONE, C.CUSTOMER_ID, C.CUST_REFID, C.EXTERNAL_ID, C.GEO_LOCATION, C.NAME, C.REFERENCE_ID, C.URL,C.EXTERNAL_KEY1,C.EXTERNAL_KEY2,C.REC_DATETIME,C.ISSOFTDELETED
 FROM  $(NF_SCHEMA).CUSTOMER C)
GO

CREATE VIEW $(STAR_SCHEMA).VW_FACTOR (EXTERNAL_ID, FACTOR_ID, MITIGATION_COST, NAME, REFERENCE_ID, RISK_ID, RISK_NAME, URL,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED,PRIORITY ,DESCRIPTION,WEIGHT,PROBABILITY,PROBABILITY_RANK,MITIGATION_ACTION) AS
 (SELECT F.EXTERNAL_ID, F.FACTOR_ID, F.MITIGATION_COST, F.NAME, F.REFERENCE_ID, F.RISK_ID, R.NAME AS RISK_NAME, F.URL,F.EXTERNAL_KEY1,F.EXTERNAL_KEY2,F.REC_DATETIME,F.ISSOFTDELETED,F.PRIORITY ,F.DESCRIPTION,WEIGHT,F.PROBABILITY,F.PROBABILITY_RANK,F.MITIGATION_ACTION
 FROM  $(NF_SCHEMA).FACTOR F JOIN  $(NF_SCHEMA).RISK R ON R.RISK_ID=F.RISK_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_FILE (EXTERNAL_ID, FILE_CLASS_ID,FILE_ID, NAME, REFERENCE_ID, URL,COMPONENT_ID,COMPONENT_NAME,NUM_SLOC,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT F.EXTERNAL_ID, F.FILE_CLASS_ID,F.FILE_ID, F.NAME, F.REFERENCE_ID, F.URL,
F. COMPONENT_ID,C.NAME AS COMPONENT_NAME,F.NUM_SLOC,F.EXTERNAL_KEY1,F.EXTERNAL_KEY2,F.REC_DATETIME,F.ISSOFTDELETED
  FROM  $(NF_SCHEMA).[FILE] F
  JOIN  $(NF_SCHEMA).COMPONENT C ON C.COMPONENT_ID=F.COMPONENT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_FILE_BASELINE (EXTERNAL_ID, FILE_BASELINE_ID, NAME, REFERENCE_ID, URL,COMPONENT_ID,COMPONENT_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT F.EXTERNAL_ID, F.FILE_BASELINE_ID, F.NAME, F.REFERENCE_ID, F.URL,F.COMPONENT_ID,C.NAME AS COMPONENT_NAME,F.EXTERNAL_KEY1,F.EXTERNAL_KEY2,F.REC_DATETIME,F.ISSOFTDELETED
 FROM  $(NF_SCHEMA).FILE_BASELINE F
 JOIN  $(NF_SCHEMA).COMPONENT C ON C.COMPONENT_ID=F.COMPONENT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_FILE_STREAM (EXTERNAL_ID, FILE_STREAM_CLASS_ID,FILE_STREAM_ID, NAME, REFERENCE_ID, URL,PROJECT_ID,PROJECT_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT F.EXTERNAL_ID, F.FILE_STREAM_CLASS_ID,F.FILE_STREAM_ID,F.NAME, F.REFERENCE_ID, F.URL,F.PROJECT_ID,P.NAME AS PROJECT_NAME,F.EXTERNAL_KEY1,F.EXTERNAL_KEY2,F.REC_DATETIME,F.ISSOFTDELETED
 FROM  $(NF_SCHEMA).FILE_STREAM F
 JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=F.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_RESOURCE (EXTERNAL_ID, FIRST_NAME, FULL_NAME, LAST_NAME, MIDDLE_INITIAL, NAME, RESOURCE_ID, REFERENCE_ID, URL,
OVERTIME_RATE,TIME_PER_DAY,POOL_ID,POOL_NAME,RESOURCE_TYPE,STANDARD_RATE,EFFECTIVE_DATE,DISCONTINUE_DATE,EXTERNAL_KEY1,EXTERNAL_KEY2,CITY_ID,CITY_NAME,ORGANIZATION_ID,ORGANIZATION_NAME,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT P.EXTERNAL_ID, P.FIRST_NAME, P.FULL_NAME, P.LAST_NAME, P.MIDDLE_INITIAL, P.NAME, P.RESOURCE_ID, P.REFERENCE_ID, P.URL,
 P.OVERTIME_RATE,P.TIME_PER_DAY,P.POOL_ID,PL.NAME AS POOL_NAME,P.RESOURCE_TYPE,P.STANDARD_RATE,P.EFFECTIVE_DATE,P.DISCONTINUE_DATE,P.EXTERNAL_KEY1,P.EXTERNAL_KEY2,P.CITY_ID,C.NAME AS CITY_NAME,P.ORGANIZATION_ID,O.NAME AS ORGANIZATION_NAME,P.REC_DATETIME,P.ISSOFTDELETED
  FROM  $(NF_SCHEMA).RESOURCE P
  JOIN  $(NF_SCHEMA).POOL PL ON PL.POOL_ID=P.POOL_ID
  JOIN  $(NF_SCHEMA).CITY C ON C.CITY_ID=P.CITY_ID
  JOIN  $(NF_SCHEMA).ORGANIZATION O ON O.ORGANIZATION_ID=P.ORGANIZATION_ID)
GO


CREATE VIEW $(STAR_SCHEMA).VW_PRODUCT (EXTERNAL_ID, NAME, PRODUCT_ID, REFERENCE_ID, URL,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT P.EXTERNAL_ID, P.NAME, P.PRODUCT_ID, P.REFERENCE_ID, P.URL,P.EXTERNAL_KEY1,P.EXTERNAL_KEY2,P.REC_DATETIME,P.ISSOFTDELETED FROM  $(NF_SCHEMA).PRODUCT P)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJECT (EXTERNAL_ID, NAME, PROJECT_ID, PROGRAM_ID, PROGRAM_NAME, PROJECT_MANAGER, MANAGER_NAME, REFERENCE_ID, URL,
END_DATE,START_DATE,PROJECT_CATEGORY_ID,PROJECT_CATEGORY_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,PROJECT_CLASS_ID,PROJECT_CLASS_NAME,SHIP_DATE,PRIORITY,STATUS,FEASIBILITY,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT  P.EXTERNAL_ID, P.NAME, P.PROJECT_ID, P.PROGRAM_ID, PR.NAME, P.PROJECT_MANAGER,R.FULL_NAME AS MANAGER_NAME, P.REFERENCE_ID, P.URL,
 P.END_DATE,P.START_DATE,P.PROJECT_CATEGORY_ID,PC.NAME AS PROJECT_CATEGORY_NAME,P.EXTERNAL_KEY1,P.EXTERNAL_KEY2,P.PROJECT_CLASS_ID,PL.NAME AS PROJECT_CLASS_NAME,P.SHIP_DATE,P.PRIORITY,P.STATUS,P.FEASIBILITY,P.REC_DATETIME,P.ISSOFTDELETED
  FROM  $(NF_SCHEMA).PROJECT P
  JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=P.PROJECT_MANAGER
  JOIN  $(NF_SCHEMA).PROJECT_CATEGORY PC ON PC.PROJECT_CATEGORY_ID=P.PROJECT_CATEGORY_ID
  JOIN  $(NF_SCHEMA).PROJECT_CLASSIFICATION PL ON PL.PROJECT_CLASS_ID=P.PROJECT_CLASS_ID
  JOIN  $(NF_SCHEMA).PROGRAM PR ON PR.PROGRAM_ID=P.PROGRAM_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJECT_DETAIL (ACTUAL_BUDGET, ACTUAL_FINISH, ACTUAL_START, ACTUAL_VARIANCE, ACWP, BAC, BASELINE_COST, BASELINE_ESTIMATED_COST, BASELINE_ESTIMATED_FINISH, BASELINE_ESTIMATED_START, BASELINE_FINISH, BASELINE_START, BASELINE_VARIANCE, BCWP, BCWS, CURRENCY_ID, CURRENT_BUDGET, EAC, EV_ETC, EV_FLAG, PLANNED_BUDGET, PLANNED_FINISH, PLANNED_START, PROJECT_ID, ACTUAL_DURATION, ACTUAL_WORK, ACTUAL_WORK_VARIANCE, ACTUAL_START_VARIANCE, ACTUAL_FINISH_VARIANCE, ACTUAL_COST, ACTUAL_COST_VARIANCE, BASELINE_DURATION, BASELINE_WORK, BASELINE_WORK_VARIANCE, BASELINE_START_VARIANCE, BASELINE_FINISH_VARIANCE, BASELINE_COST_VARIANCE, PLANNED_COST, COST_VARIANCE, PLANNED_DURATION, PLANNED_WORK, WORK_VARIANCE, START_VARIANCE, FINISH_VARIANCE, DURATION_VARIANCE, PROJECT_NAME, URL, EXTERNAL_KEY1, EXTERNAL_KEY2,PERCENT_COMPLETE,PERCENT_WORK_COMPLETE,BUDGETED_REVENUE,PLANNED_REVENUE,ACTUAL_REVENUE,BUDGETED_COST,NET_PRESENT_VALUE,INTERNAL_RATE_OF_RETURN) AS
 (SELECT  P.ACTUAL_BUDGET, P.ACTUAL_FINISH, P.ACTUAL_START, P.ACTUAL_VARIANCE, P.ACWP, P.BAC, P.BASELINE_COST, P.BASELINE_ESTIMATED_COST, P.BASELINE_ESTIMATED_FINISH, P.BASELINE_ESTIMATED_START, P.BASELINE_FINISH, P.BASELINE_START, P.BASELINE_VARIANCE, P.BCWP, P.BCWS, P.CURRENCY_ID, P.CURRENT_BUDGET, P.EAC, P.EV_ETC, P.EV_FLAG, P.PLANNED_BUDGET, P.PLANNED_FINISH, P.PLANNED_START, P.PROJECT_ID,P.ACTUAL_DURATION, P.ACTUAL_WORK, P.ACTUAL_WORK_VARIANCE, P.ACTUAL_START_VARIANCE ,P.ACTUAL_FINISH_VARIANCE, P.ACTUAL_COST ,P.ACTUAL_COST_VARIANCE, P.BASELINE_DURATION ,P.BASELINE_WORK ,P.BASELINE_WORK_VARIANCE ,P.BASELINE_START_VARIANCE ,	P.BASELINE_FINISH_VARIANCE ,P.BASELINE_COST_VARIANCE,P.PLANNED_COST ,P.COST_VARIANCE,P.PLANNED_DURATION ,P.PLANNED_WORK ,P.WORK_VARIANCE,P.START_VARIANCE ,	P.FINISH_VARIANCE ,P.DURATION_VARIANCE,  R.NAME AS PROJECT_NAME, R.URL,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2,P.PERCENT_COMPLETE,P.PERCENT_WORK_COMPLETE,P.BUDGETED_REVENUE,P.PLANNED_REVENUE,P.ACTUAL_REVENUE,P.BUDGETED_COST,P.NET_PRESENT_VALUE,P.INTERNAL_RATE_OF_RETURN FROM  $(NF_SCHEMA).PROJECT_DETAIL P JOIN  $(NF_SCHEMA).PROJECT R ON R.PROJECT_ID=P.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJECT_CATEGORY (PROJECT_CATEGORY_ID, EXTERNAL_ID, REFERENCE_ID, NAME, PROJECT_ID, PROJECT_NAME, CATEGORY_TYPE, OWNER_ID, MANAGER_NAME, URL,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT PC.PROJECT_CATEGORY_ID, PC.EXTERNAL_ID, PC.REFERENCE_ID, PC.NAME, P.PROJECT_ID, P.NAME AS PROJECT_NAME, PC.CATEGORY_TYPE, PC.OWNER_ID,R.FULL_NAME AS MANAGER_NAME, PC.URL,PC.EXTERNAL_KEY1,PC.EXTERNAL_KEY2,PC.REC_DATETIME,PC.ISSOFTDELETED FROM  $(NF_SCHEMA).PROJECT_CATEGORY PC JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=PC.OWNER_ID JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_CATEGORY_ID=PC.PROJECT_CATEGORY_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PHASE (PHASE_ID, NAME, REFERENCE_ID, EXTERNAL_ID, PROJECT_ID, PROJECT_NAME, STATUS, START_DATE, END_DATE, URL,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT PP.PHASE_ID, PP.NAME, PP.REFERENCE_ID, PP.EXTERNAL_ID, PP.PROJECT_ID, P.NAME AS PROJECT_NAME, PP.STATUS, PP.START_DATE, PP.END_DATE , PP.URL,PP.EXTERNAL_KEY1,PP.EXTERNAL_KEY2,PP.REC_DATETIME,PP.ISSOFTDELETED FROM  $(NF_SCHEMA).PHASE PP JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=PP.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ITERATION (ITERATION_ID, NAME, REFERENCE_ID, EXTERNAL_ID, ASSETREGISTRY_ID,ASSETREGISTRY_NAME,PROJECT_ID, PROJECT_NAME,PHASE_ID, PHASE_NAME,OWNER_ID,OWNER_NAME,PARENT_ITERATION_ID,PARENT_ITERATION_NAME,TIMELINE_ID,TIMELINE_NAME,STATUS, DESCRIPTION, START_DATE, END_DATE, EXPECTED_START_DATE, EXPECTED_END_DATE,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,EXPECTED_TOTAL_POINTS,EXPECTED_DEFECTS,EXPECTED_VALIDITY_RATE,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT I.ITERATION_ID, I.NAME, I.REFERENCE_ID, I.EXTERNAL_ID, I.ASSETREGISTRY_ID,A.NAME,I.PROJECT_ID, P.NAME AS PROJECT_NAME,I.PHASE_ID,PH.NAME,I.OWNER_ID,R.FULL_NAME AS OWNER_NAME,I.PARENT_ITERATION_ID,PI.NAME AS PARENT_ITERATION_NAME,I.TIMELINE_ID,T.NAME AS TIMELINE_NAME,I.STATUS,I.DESCRIPTION,I.START_DATE, I.END_DATE , I.EXPECTED_START_DATE, I.EXPECTED_END_DATE,I.URL,I.EXTERNAL_KEY1,I.EXTERNAL_KEY2,
I.EXPECTED_TOTAL_POINTS,I.EXPECTED_DEFECTS,I.EXPECTED_VALIDITY_RATE,I.REC_DATETIME,I.ISSOFTDELETED
FROM  $(NF_SCHEMA).ITERATION I
 JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=I.PROJECT_ID
 JOIN  $(NF_SCHEMA).PHASE PH ON PH.PHASE_ID=I.PHASE_ID
  JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=I.OWNER_ID
 JOIN  $(NF_SCHEMA).ASSETREGISTRY A ON A.ASSETREGISTRY_ID=I.ASSETREGISTRY_ID
 JOIN  $(NF_SCHEMA).ITERATION PI ON PI.ITERATION_ID=I.PARENT_ITERATION_ID
 JOIN  $(NF_SCHEMA).TIMELINE T ON T.TIMELINE_ID=I.TIMELINE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJECT_ROLE (PROJECT_ROLE_ID, NAME, REFERENCE_ID, EXTERNAL_ID, PROJECT_ID, PROJECT_NAME, OWNER_ID, MANAGER_NAME, URL,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT PR.PROJECT_ROLE_ID, PR.NAME, PR.REFERENCE_ID, PR.EXTERNAL_ID, PR.PROJECT_ID, P.NAME AS PROJECT_NAME, PR.OWNER_ID,R.FULL_NAME AS MANAGER_NAME, PR.URL,PR.EXTERNAL_KEY1,PR.EXTERNAL_KEY2,PR.REC_DATETIME,PR.ISSOFTDELETED FROM  $(NF_SCHEMA).PROJECT_ROLE PR JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=PR.OWNER_ID JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=PR.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJECT_WORKCONFIGURATION (PROJECT_WKCFG_ID, NAME, REFERENCE_ID, EXTERNAL_ID, PROJECT_ID, PROJECT_NAME, RECORD_TYPE, URL,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT PWC.PROJECT_WKCFG_ID, PWC.NAME, PWC.REFERENCE_ID, PWC.EXTERNAL_ID, PWC.PROJECT_ID, P.NAME AS PROJECT_NAME, PWC.RECORD_TYPE, PWC.URL,PWC.EXTERNAL_KEY1,PWC.EXTERNAL_KEY2,PWC.REC_DATETIME,PWC.ISSOFTDELETED FROM  $(NF_SCHEMA).PROJECT_WORKCONFIGURATION PWC JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=PWC.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJECT_TYPE (PROJECT_TYPE_ID, EXTERNAL_ID, REFERENCE_ID, NAME, PROJECT_ID, PROJECT_NAME, PROJECT_WKCFG_ID, PROJECT_WORKCONFIGURATION_NAME, RECORD_TYPE, URL,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT PT.PROJECT_TYPE_ID, PT.EXTERNAL_ID, PT.REFERENCE_ID, PT.NAME, PT.PROJECT_ID, P.NAME AS PROJECT_NAME, COALESCE(PWC.PROJECT_WKCFG_ID,-1) AS PROJECT_WKCFG_ID, COALESCE(PWC.NAME,'Info not available') AS PROJECT_WORKCONFIGURATION_NAME, PT.RECORD_TYPE, PT.URL,PT.EXTERNAL_KEY1,PT.EXTERNAL_KEY2,PT.REC_DATETIME,PT.ISSOFTDELETED FROM  $(NF_SCHEMA).PROJECT_TYPE PT JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=PT.PROJECT_ID LEFT JOIN  $(NF_SCHEMA).PROJECT_WORKCONFIGURATION PWC ON P.PROJECT_ID=PWC.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ACTIVITY (ACTIVITY_ID, EXTERNAL_ID, REFERENCE_ID, NAME, TASK_ID, TASK_NAME,OWNER_ID, OWNER_FULLNAME, PROFILE_ID, PROFILE_NAME, FAILED_BUILD, VALIDATION_BUILD, NOTEST_BUILD, FILE_STREAM_ID, FILE_STREAM_NAME, RESOLUTION_CODE, CHARGECODE_ID, CHARGECODE_NAME, URL,
ACTIVITY_STATE,ACTIVITY_TYPE,CREATION_DATE,PRIORITY,PROJECT_ID,PROJECT_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,ACTIVITY_CLASS_ID,ACTIVITY_CLASS_NAME,STATUS,RESOLUTION,REC_DATETIME,ISSOFTDELETED) AS
(SELECT A.ACTIVITY_ID, A.EXTERNAL_ID, A.REFERENCE_ID, A.NAME, A.TASK_ID, T.NAME AS TASK_NAME,A.OWNER_ID,R.FULL_NAME AS OWNER_FULLNAME, PR.PROFILE_ID, PR.NAME AS PROFILE_NAME, A.FAILED_BUILD, A.VALIDATION_BUILD, A.NOTEST_BUILD, A.FILE_STREAM_ID, S.NAME AS FILE_STREAM_NAME, A.RESOLUTION_CODE, C.CHARGECODE_ID, C.NAME,A.URL,
A.ACTIVITY_STATE,A.ACTIVITY_TYPE,A.CREATION_DATE,A.PRIORITY,A.PROJECT_ID,P.NAME AS PROJECT_NAME,A.EXTERNAL_KEY1,A.EXTERNAL_KEY2,A.ACTIVITY_CLASS_ID,AC.NAME AS ACTIVITY_CLASS_NAME,A.STATUS,A.RESOLUTION,A.REC_DATETIME,A.ISSOFTDELETED
 FROM  $(NF_SCHEMA).ACTIVITY A
 JOIN  $(NF_SCHEMA).TASK T ON T.TASK_ID=A.TASK_ID
 JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=A.OWNER_ID
 JOIN  $(NF_SCHEMA).PROFILE PR ON PR.PROFILE_ID=A.PROFILE_ID
 JOIN  $(NF_SCHEMA).FILE_STREAM S ON S.FILE_STREAM_ID=A.FILE_STREAM_ID
 JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=A.PROJECT_ID
 JOIN  $(NF_SCHEMA).ACTIVITY_CLASSIFICATION AC ON AC.ACTIVITY_CLASS_ID=A.ACTIVITY_CLASS_ID
 JOIN $(NF_SCHEMA).CHARGECODE C ON C.CHARGECODE_ID=A.CHARGECODE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_ACTIVITY_LOOKUP (REQUEST_ID,REQUEST_NAME,ACTIVITY_ID,ACTIVITY_NAME) AS
(SELECT RA.REQUEST_ID, R.NAME AS REQUEST_NAME,RA.ACTIVITY_ID, A.NAME AS ACTIVITY_NAME
FROM  $(NF_SCHEMA).REQUEST_ACTIVITY_LOOKUP RA
JOIN  $(NF_SCHEMA).REQUEST R ON R.REQUEST_ID =RA.REQUEST_ID
JOIN  $(NF_SCHEMA). ACTIVITY A ON A.ACTIVITY_ID=RA.ACTIVITY_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_COMMENT (COMMENT_ID, RESPONSE_COMMENT_ID, REQUEST_ID, REQUEST_NAME, TASK_ID, TASK_NAME, ACTIVITY_ID, ACTIVITY_NAME, OWNER_ID, AUTHOR, CREATION_DATE, URL,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT C.COMMENT_ID, C.RESPONSE_COMMENT_ID, C.REQUEST_ID, CR.NAME AS REQUEST_NAME, C.TASK_ID, T.NAME AS TASK_NAME, C.ACTIVITY_ID, A.NAME AS ACTIVITY_NAME, C.OWNER_ID, R.FULL_NAME AS AUTHOR, C.CREATION_DATE, C.URL,C.EXTERNAL_KEY1,C.EXTERNAL_KEY2,C.REC_DATETIME,C.ISSOFTDELETED FROM  $(NF_SCHEMA).COMMENT C JOIN  $(NF_SCHEMA).REQUEST CR ON CR.REQUEST_ID=C.REQUEST_ID JOIN  $(NF_SCHEMA).TASK T ON T.TASK_ID=C.TASK_ID JOIN  $(NF_SCHEMA).ACTIVITY A ON A.ACTIVITY_ID=C.ACTIVITY_ID JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=C.OWNER_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_RELEASE (AVAILABILITY_DATE, DECOMISSION_DATE, EXTERNAL_ID, ITERATION_ID, ITERATION_NAME, NAME, PRODUCT_ID, PRODUCT_NAME, REFERENCE_ID, RELEASE_ID, URL,EXTERNAL_KEY1,EXTERNAL_KEY2,PROJECT_ID,PROJECT_NAME,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT R.AVAILABILITY_DATE, R.DECOMISSION_DATE, R.EXTERNAL_ID, R.ITERATION_ID, I.NAME AS ITERATION_NAME, R.NAME, R.PRODUCT_ID, P.NAME AS PRODUCT_NAME, R.REFERENCE_ID, R.RELEASE_ID, R.URL,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2,R.PROJECT_ID,PR.NAME AS PROJECT_NAME,R.REC_DATETIME,R.ISSOFTDELETED
 FROM  $(NF_SCHEMA).RELEASE R
 JOIN  $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID=R.ITERATION_ID
 JOIN  $(NF_SCHEMA).PROJECT PR ON PR.PROJECT_ID=R.PROJECT_ID
 JOIN  $(NF_SCHEMA).PRODUCT P ON P.PRODUCT_ID=R.PRODUCT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST (ACTIVATE_DATE, ASSIGNED_DATE, CLOSED_DATE, COMPONENT_ID, COMPONENT_NAME, CREATION_DATE, CUSTOMER_PRIORITY, DUPLICATE_DATE, EXTERNAL_ID, FIXEDINRELEASE_ID, FIXED_IN_RELEASE_NAME, IS_BLOCKING, ITERATION_ID, ITERATION_NAME, TEAM_ID, TEAM_NAME, PLANNED_WORK, ACTUAL_WORK, COMMENT_COUNT, SUBSCRIBER_COUNT, STORY_POINTS, TAGS, NAME, PLATFORM, REQUEST_PRIORITY_ID,REQUEST_PRIORITY,REQUEST_PRIORITY_EXTERNAL_ID, PROJECT_ID, PROJECT_NAME, REFERENCE_ID, RELEASE_ID, FOUND_IN_RELEASE_NAME, REQUEST_CLASS_ID, REQUEST_CLASS, REQUEST_ID, OWNER_ID, REQUEST_RESPONSIBLE, REQUEST_SOURCE, REQUEST_STATE_ID,REQUEST_STATE,REQUEST_STATE_EXTERNAL_ID, REQUEST_RESOLUTION_ID,REQUEST_RESOLUTION, REQUEST_RESOLUTION_EXTERNAL_ID,RESOLVED_DATE, REQUEST_SEVERITY_ID, REQUEST_SEVERITY,REQUEST_SEVERITY_EXTERNAL_ID,SLOC_CHANGE, REQUEST_STATUS_ID, REQUEST_STATUS,REQUEST_STATUS_EXTERNAL_ID,SUBMIT_DATE, URL,
DUE_DATE,CREATOR_ID,CREATOR_NAME,BUILD_ID,BUILD_NAME,PHASE_ID,PHASE_NAME,PROJECT_CATEGORY_ID, PROJECT_CATEGORY_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,REQUEST_TYPE_ID,REQUEST_TYPE,REQUEST_TYPE_EXTERNAL_ID,REQUEST_CATEGORY_ID,REQUEST_CATEGORY_NAME,RESOLVER_ID,RESOLVER_NAME,SUMMARY,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT R.ACTIVATE_DATE, R.ASSIGNED_DATE, R.CLOSED_DATE, R.COMPONENT_ID,C.NAME AS COMPONENT_NAME, R.CREATION_DATE, R.CUSTOMER_PRIORITY, R.DUPLICATE_DATE, R.EXTERNAL_ID, R.FIXEDINRELEASE_ID,RL.NAME AS FIXED_IN_RELEASE_NAME, R.IS_BLOCKING, R.ITERATION_ID,I.NAME AS ITERATION_NAME, R.TEAM_ID, T.NAME AS TEAM_NAME, R.PLANNED_WORK, R.ACTUAL_WORK, R.COMMENT_COUNT, R.SUBSCRIBER_COUNT, R.STORY_POINTS, R.TAGS, R.NAME, R.PLATFORM, R.REQUEST_PRIORITY_ID,RP.NAME AS REQUEST_PRIORITY, RP.EXTERNAL_ID AS REQUEST_PRIORITY_EXTERNAL_ID,R.PROJECT_ID, PJ.NAME AS PROJECT_NAME,R.REFERENCE_ID, R.RELEASE_ID, RL2.NAME AS FOUND_IN_RELEASE_NAME,
 R.REQUEST_CLASS_ID,RQ.NAME AS REQUEST_CLASS, R.REQUEST_ID, R.OWNER_ID,PS.FULL_NAME AS REQUEST_RESPONSIBLE, R.REQUEST_SOURCE, R.REQUEST_STATE_ID, RST.NAME AS REQUEST_STATE,RST.EXTERNAL_ID AS REQUEST_STATE_EXTERNAL_ID,R.REQUEST_RESOLUTION_ID,RRES.NAME AS REQUEST_RESOLUTION, RRES.EXTERNAL_ID AS REQUEST_RESOLUTION_EXTERNAL_ID,R.RESOLVED_DATE, R.REQUEST_SEVERITY_ID, RSEV.NAME AS REQUEST_SEVERITY, RSEV.EXTERNAL_ID AS REQUEST_SEVERITY_EXTERNAL_ID,R.SLOC_CHANGE, R.REQUEST_STATUS_ID,RSTU.NAME AS REQUEST_STATUS,RSTU.EXTERNAL_ID AS  REQUEST_STATUS_EXTERNAL_ID,R.SUBMIT_DATE, R.URL,
 R.DUE_DATE,R.CREATOR_ID,RES.FULL_NAME AS CREATOR_NAME,R.BUILD_ID,B.NAME AS BUILD_NAME,R.PHASE_ID,PH.NAME AS PHASE_NAME,R.PROJECT_CATEGORY_ID,PC.NAME AS PROJECT_CATEGORY_NAME,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2,R.REQUEST_TYPE_ID,RT.NAME REQUEST_TYPE,RT.EXTERNAL_ID AS REQUEST_TYPE_EXTERNAL_ID,R.REQUEST_CATEGORY_ID,RC.NAME AS REQUEST_CATEGORY_NAME,R.RESOLVER_ID,RS.FULL_NAME AS RESOLVER_NAME,R.SUMMARY,R.REC_DATETIME,R.ISSOFTDELETED
  FROM  $(NF_SCHEMA).REQUEST R
  JOIN  $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID=R.ITERATION_ID
  JOIN  $(NF_SCHEMA).TEAM T ON T.TEAM_ID=R.TEAM_ID
  JOIN  $(NF_SCHEMA).PROJECT PJ ON PJ.PROJECT_ID=R.PROJECT_ID
  JOIN  $(NF_SCHEMA).COMPONENT C ON C.COMPONENT_ID=R.COMPONENT_ID
  JOIN  $(NF_SCHEMA).RELEASE RL ON RL.RELEASE_ID=R.FIXEDINRELEASE_ID
  JOIN  $(NF_SCHEMA).RELEASE RL2 ON RL2.RELEASE_ID=R.RELEASE_ID
  JOIN  $(NF_SCHEMA).REQUEST_CLASSIFICATION RQ ON RQ.REQUEST_CLASS_ID=R.REQUEST_CLASS_ID
  JOIN  $(NF_SCHEMA).REQUEST_CATEGORY RC ON RC.REQUEST_CATEGORY_ID=R.REQUEST_CATEGORY_ID
  JOIN  $(NF_SCHEMA).BUILD B ON B.BUILD_ID=R.BUILD_ID
  JOIN  $(NF_SCHEMA).PHASE PH ON PH.PHASE_ID=R.PHASE_ID
  JOIN  $(NF_SCHEMA).PROJECT_CATEGORY PC ON PC.PROJECT_CATEGORY_ID=R.PROJECT_CATEGORY_ID
  JOIN  $(NF_SCHEMA).RESOURCE PS ON PS.RESOURCE_ID=R.OWNER_ID
  JOIN  $(NF_SCHEMA).RESOURCE RS ON RS.RESOURCE_ID=R.RESOLVER_ID
  JOIN  $(NF_SCHEMA).RESOURCE RES ON RES.RESOURCE_ID=R.CREATOR_ID
  JOIN  $(NF_SCHEMA).REQUEST_STATE RST ON RST.REQUEST_STATE_ID=R.REQUEST_STATE_ID
  JOIN  $(NF_SCHEMA).REQUEST_STATUS RSTU ON RSTU.REQUEST_STATUS_ID=R.REQUEST_STATUS_ID
  JOIN  $(NF_SCHEMA).REQUEST_PRIORITY RP ON RP.REQUEST_PRIORITY_ID=R.REQUEST_PRIORITY_ID
  JOIN  $(NF_SCHEMA).REQUEST_RESOLUTION RRES ON RRES.REQUEST_RESOLUTION_ID=R.REQUEST_RESOLUTION_ID
  JOIN  $(NF_SCHEMA).REQUEST_SEVERITY RSEV ON RSEV.REQUEST_SEVERITY_ID=R.REQUEST_SEVERITY_ID
  JOIN  $(NF_SCHEMA).REQUEST_TYPE RT ON RT.REQUEST_TYPE_ID=R.REQUEST_TYPE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUIREMENT (COMPONENT_ID, COMPONENT_NAME, CREATION_DATE, CUSTOMER_PRIORITY, DIFFICULTY, EXTERNAL_ID, NAME, PLATFORM, PRIORITY, PROJECT_ID, PROJECT_NAME, REFERENCE_ID, RELEASE_ID, RELEASE_NAME, REQUIREMENT_CLASS_ID, REQUIREMENT_CLASS_NAME, REQUIREMENT_ID, OWNER_ID, RESPONSIBLE_NAME, REQUIREMENT_STATE, REVISION_NUMBER, STABILITY, STATUS, URL,
ACTUAL_ITERATION_ID,ACTUAL_ITERATION_NAME,PLANNED_ITERATION_ID,PLANNED_ITERATION_NAME,REQUIREMENT_TYPE,REVISION_DATE,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED, PRIMARY_TEXT) AS
 (SELECT R.COMPONENT_ID, C.NAME AS COMPONENT_NAME, R.CREATION_DATE, R.CUSTOMER_PRIORITY, R.DIFFICULTY, R.EXTERNAL_ID, R.NAME, R.PLATFORM, R.PRIORITY, R.PROJECT_ID, PJ.NAME AS PROJECT_NAME, R.REFERENCE_ID, R.RELEASE_ID, RL.NAME AS RELEASE_NAME, R.REQUIREMENT_CLASS_ID, RC.NAME AS REQUIREMENT_CLASS_NAME, R.REQUIREMENT_ID, R.OWNER_ID,P.FULL_NAME AS RESPONSIBLE_NAME, R.REQUIREMENT_STATE, R.REVISION_NUMBER, R.STABILITY, R.STATUS, R.URL,
 R.ACTUAL_ITERATION_ID,AC.NAME AS ACTUAL_ITERATION_NAME,R.PLANNED_ITERATION_ID,PL.NAME AS PLANNED_ITERATION_NAME,R.REQUIREMENT_TYPE,R.REVISION_DATE,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2,R.REC_DATETIME,R.ISSOFTDELETED, COALESCE(PT.PTEXT, 'No primary text')
  FROM  $(NF_SCHEMA).REQUIREMENT R
  JOIN  $(NF_SCHEMA).COMPONENT C ON C.COMPONENT_ID =R.COMPONENT_ID
  JOIN  $(NF_SCHEMA).PROJECT PJ ON PJ.PROJECT_ID=R.PROJECT_ID
  JOIN  $(NF_SCHEMA).RELEASE RL ON RL.RELEASE_ID=R.RELEASE_ID
  JOIN  $(NF_SCHEMA).REQUIREMENT_CLASSIFICATION RC ON RC.REQUIREMENT_CLASS_ID=R.REQUIREMENT_CLASS_ID
  JOIN  $(NF_SCHEMA).RESOURCE P ON P.RESOURCE_ID=R.OWNER_ID
  JOIN  $(NF_SCHEMA).ITERATION AC ON AC.ITERATION_ID=R.ACTUAL_ITERATION_ID
  JOIN  $(NF_SCHEMA).ITERATION PL ON PL.ITERATION_ID=R.PLANNED_ITERATION_ID
  LEFT JOIN $(NF_SCHEMA).REQUIREMENT_PTEXT PT ON PT.REQUIREMENT_ID = R.REQUIREMENT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUIREMENT_COLLECTION (REQUIREMENT_COLLECTION_ID, NAME,REFERENCE_ID,EXTERNAL_ID, PROJECT_ID, PROJECT_NAME,  RELEASE_ID, RELEASE_NAME, PLANNED_ITERATION_ID, PLANNED_ITERATION_NAME,
 ACTUAL_ITERATION_ID, ACTUAL_ITERATION_NAME, STATUS, COLLECTION_ORIGIN, COLLECTION_TYPE, COLLECTION_IMPACT, COLLECTION_TARGET,
 CREATION_DATE, URL, EXTERNAL_KEY1, EXTERNAL_KEY2, SOURCE_ID, REC_DATETIME, ISSOFTDELETED) AS
 (SELECT RC.REQUIREMENT_COLLECTION_ID, RC.NAME, RC.REFERENCE_ID,RC.EXTERNAL_ID,RC.PROJECT_ID, PJ.NAME AS PROJECT_NAME,  RC.RELEASE_ID, RL.NAME AS RELEASE_NAME, RC.PLANNED_ITERATION_ID, PL.NAME AS PLANNED_ITERATION_NAME,
 RC.ACTUAL_ITERATION_ID, AC.NAME AS ACTUAL_ITERATION_NAME, RC.STATUS, RC.COLLECTION_ORIGIN, RC.COLLECTION_TYPE, RC.COLLECTION_IMPACT, RC.COLLECTION_TARGET,
 RC.CREATION_DATE, RC.URL, RC.EXTERNAL_KEY1, RC.EXTERNAL_KEY2, RC.SOURCE_ID, RC.REC_DATETIME, RC.ISSOFTDELETED
	FROM  $(NF_SCHEMA).REQUIREMENT_COLLECTION RC
  JOIN  $(NF_SCHEMA).PROJECT PJ ON PJ.PROJECT_ID=RC.PROJECT_ID
  JOIN  $(NF_SCHEMA).RELEASE RL ON RL.RELEASE_ID=RC.RELEASE_ID
  JOIN  $(NF_SCHEMA).ITERATION AC ON AC.ITERATION_ID=RC.ACTUAL_ITERATION_ID
  JOIN  $(NF_SCHEMA).ITERATION PL ON PL.ITERATION_ID=RC.PLANNED_ITERATION_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUICOL_REQUIREMENT_LOOKUP (REQUIREMENT_COLLECTION_ID, NAME, REQUIREMENT_ID, REQUIREMENT_NAME) AS
 ( SELECT RR.REQUIREMENT_COLLECTION_ID, RC.NAME, RR.REQUIREMENT_ID, R.NAME AS REQUIREMENT_NAME
	FROM  $(NF_SCHEMA).REQUICOL_REQUIREMENT_LOOKUP RR
	JOIN  $(NF_SCHEMA).REQUIREMENT_COLLECTION RC ON RC.REQUIREMENT_COLLECTION_ID=RR.REQUIREMENT_COLLECTION_ID
	JOIN  $(NF_SCHEMA).REQUIREMENT R ON R.REQUIREMENT_ID=RR.REQUIREMENT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_COLL_MEMBER_RQRMNT (COLLECTION_ID, COLLECTION_NAME, CREATION_DATE, CUSTOMER_PRIORITY, DIFFICULTY, EXTERNAL_ID, NAME, PLATFORM, PRIORITY, REFERENCE_ID, RELEASE_ID, RELEASE_NAME, REQUIREMENT_CLASS_ID, REQUIREMENT_CLASS_NAME, REQUIREMENT_ID, OWNER_ID, RESPONSIBLE_NAME, REQUIREMENT_STATE, REVISION_NUMBER, STABILITY, STATUS, URL,
ACTUAL_ITERATION_ID,ACTUAL_ITERATION_NAME,PLANNED_ITERATION_ID,PLANNED_ITERATION_NAME,REQUIREMENT_TYPE,REVISION_DATE,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED, PRIMARY_TEXT) AS
 (SELECT RCOLL.REQUIREMENT_COLLECTION_ID AS COLLECTION_ID, RCOLL.NAME AS COLLECTION_NAME, R.CREATION_DATE, R.CUSTOMER_PRIORITY, R.DIFFICULTY, R.EXTERNAL_ID, R.NAME, R.PLATFORM, R.PRIORITY, R.REFERENCE_ID, R.RELEASE_ID, RL.NAME AS RELEASE_NAME, R.REQUIREMENT_CLASS_ID, RC.NAME AS REQUIREMENT_CLASS_NAME, R.REQUIREMENT_ID, R.OWNER_ID,P.FULL_NAME AS RESPONSIBLE_NAME, R.REQUIREMENT_STATE, R.REVISION_NUMBER, R.STABILITY, R.STATUS, R.URL,
 R.ACTUAL_ITERATION_ID,AC.NAME AS ACTUAL_ITERATION_NAME,R.PLANNED_ITERATION_ID,PL.NAME AS PLANNED_ITERATION_NAME,R.REQUIREMENT_TYPE,R.REVISION_DATE,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2,R.REC_DATETIME,R.ISSOFTDELETED, COALESCE(PT.PTEXT, 'No primary text')
  FROM $(NF_SCHEMA).REQUIREMENT R
  JOIN $(NF_SCHEMA).REQUICOL_REQUIREMENT_LOOKUP CLOOK ON CLOOK.REQUIREMENT_ID=R.REQUIREMENT_ID
  JOIN $(NF_SCHEMA).REQUIREMENT_COLLECTION RCOLL ON RCOLL.REQUIREMENT_COLLECTION_ID=CLOOK.REQUIREMENT_COLLECTION_ID
  JOIN $(NF_SCHEMA).RELEASE RL ON RL.RELEASE_ID=R.RELEASE_ID
  JOIN $(NF_SCHEMA).REQUIREMENT_CLASSIFICATION RC ON RC.REQUIREMENT_CLASS_ID=R.REQUIREMENT_CLASS_ID
  JOIN $(NF_SCHEMA).RESOURCE P ON P.RESOURCE_ID=R.OWNER_ID
  JOIN $(NF_SCHEMA).ITERATION AC ON AC.ITERATION_ID=R.ACTUAL_ITERATION_ID
  JOIN $(NF_SCHEMA).ITERATION PL ON PL.ITERATION_ID=R.PLANNED_ITERATION_ID
  LEFT JOIN $(NF_SCHEMA).REQUIREMENT_PTEXT PT ON PT.REQUIREMENT_ID = R.REQUIREMENT_ID)
GO 

CREATE VIEW $(STAR_SCHEMA).VW_REQUICOL_TESTPLAN_LOOKUP (REQUIREMENT_COLLECTION_ID, REQUIREMENT_COLLECTION_NAME, TESTPLAN_ID, TESTPLAN_NAME, LINK_TYPE) AS
 (SELECT RT.REQUIREMENT_COLLECTION_ID, RC.NAME AS REQUIREMENT_COLLECTION_NAME, RT.TESTPLAN_ID, T.NAME AS TESTPLAN_NAME, RT.LINK_TYPE
	FROM  $(NF_SCHEMA).REQUICOL_TESTPLAN_LOOKUP RT
	JOIN  $(NF_SCHEMA).REQUIREMENT_COLLECTION RC ON RC.REQUIREMENT_COLLECTION_ID=RT.REQUIREMENT_COLLECTION_ID
	JOIN  $(NF_SCHEMA).TESTPLAN T ON T.TESTPLAN_ID=RT.TESTPLAN_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUIREMENT_CUSTOMER_LOOKUP (REQUIREMENT_ID, NAME, CUSTOMER_ID, CUSTOMER_NAME) AS
 ( SELECT R.REQUIREMENT_ID, R1.NAME,R.CUSTOMER_ID,C.NAME AS CUSTOMER_NAME FROM  $(NF_SCHEMA).REQUIREMENT_CUSTOMER_LOOKUP R JOIN  $(NF_SCHEMA).REQUIREMENT R1 ON R1.REQUIREMENT_ID=R.REQUIREMENT_ID JOIN  $(NF_SCHEMA).CUSTOMER C ON C.CUSTOMER_ID=R.CUSTOMER_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TASK (PRIORITY,TASK_TYPE,EXTERNAL_ID, NAME, REFERENCE_ID, TASK_ID, PROJECT_ID, PROJECT_NAME, OWNER_ID, TASK_RESPONSIBLE_NAME, TASK_STATE, URL,EXTERNAL_KEY1,EXTERNAL_KEY2,TASK_CLASS_ID,TASK_CLASS_NAME, ITERATION_ID,ITERATION_NAME,STATUS,RESOLUTION,REC_DATETIME,ISSOFTDELETED) AS
 ( SELECT T.PRIORITY,T.TASK_TYPE,T.EXTERNAL_ID, T.NAME, T.REFERENCE_ID, T.TASK_ID, T.PROJECT_ID, P.NAME AS PROJECT_NAME, T.OWNER_ID, PR.FULL_NAME AS TASK_RESPONSIBLE_NAME, T.TASK_STATE, T.URL,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.TASK_CLASS_ID,TL.NAME AS TASK_CLASS_NAME,T.ITERATION_ID,I.NAME AS ITERATION_NAME,T.STATUS,T.RESOLUTION,T.REC_DATETIME,T.ISSOFTDELETED FROM  $(NF_SCHEMA).TASK T JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=T.PROJECT_ID JOIN  $(NF_SCHEMA).RESOURCE PR ON PR.RESOURCE_ID=T.OWNER_ID JOIN  $(NF_SCHEMA).TASK_CLASSIFICATION TL ON TL.TASK_CLASS_ID=T.TASK_CLASS_ID JOIN  $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID=T.ITERATION_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TASK_BASELINE (BASELINE_ID, NAME, REFERENCE_ID, EXTERNAL_ID, TASK_ID, BASELINE_DATE, PLANNED_START, PLANNED_FINISH, PLANNED_WORK, PLANNED_COST, PLANNED_DURATION, URL, EXTERNAL_KEY1, EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
(SELECT T.BASELINE_ID, T.NAME, T.REFERENCE_ID, T.EXTERNAL_ID, T.TASK_ID, T.BASELINE_DATE, T.PLANNED_START, T.PLANNED_FINISH, T.PLANNED_WORK, T.PLANNED_COST, T.PLANNED_DURATION, T.URL, T.EXTERNAL_KEY1, T.EXTERNAL_KEY2, T.REC_DATETIME, T.ISSOFTDELETED FROM  $(NF_SCHEMA).TASK_BASELINE T)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTSUITELOG (BUILD_ID, TESTSUITELOG_NAME,END_DATE, EXTERNAL_ID, ITERATION_ID, ITERATION_NAME, REFERENCE_ID, START_DATE, TESTSUITELOG_ID, TESTSUITE_ID, TESTSUITE_NAME, URL, VERDICT,OWNER_ID, OWNER_NAME,TESTPLAN_ID,TESTPLAN_NAME,WEIGHT,POINTS_PASSED,POINTS_FAILED,POINTS_BLOCKED,POINTS_INCONCLUSIVE,POINTS_ATTEMPTED,POINTS_PERMFAILED,POINTS_DEFERRED,EXTERNAL_KEY1,EXTERNAL_KEY2,TESTSUITELOG_CLASS_ID,TESTSUITELOG_CLASS_NAME,TESTSUITE_EXECRECORD_ID,TESTSUITE_EXECRECORD_NAME,REC_DATETIME,ISSOFTDELETED,
TESTSUITELOG_STATE,TESTSUITELOG_STATE_ID,TESTSUITELOG_STATE_EXTERNAL_ID,TESTSUITELG_STATE_REFERENCE_ID,TEST_STATUS_ID,TEST_STATUS_NAME,TEST_STATUS_EXTERNAL_ID,TEST_STATUS_REFERENCE_ID,TOTAL_TESTCASE_COUNT,NOTSTARTED_TESTCASE_COUNT) AS
 (SELECT S.BUILD_ID, S.NAME AS TESTSUITELOG_NAME, S.END_DATE, S.EXTERNAL_ID, S.ITERATION_ID,I.NAME AS ITERATION_NAME, S.REFERENCE_ID, S.START_DATE, S.TESTSUITELOG_ID, S.TESTSUITE_ID, T.NAME AS TESTSUITE_NAME, S.URL, S.VERDICT,S.OWNER_ID,R.FULL_NAME AS  OWNER_NAME ,S.TESTPLAN_ID,TP.NAME AS TESTPLAN_NAME,S.WEIGHT,S.POINTS_PASSED,S.POINTS_FAILED,S.POINTS_BLOCKED,S.POINTS_INCONCLUSIVE,S.POINTS_ATTEMPTED,S.POINTS_PERMFAILED,S.POINTS_DEFERRED,S.EXTERNAL_KEY1,S.EXTERNAL_KEY2,S.TESTSUITELOG_CLASS_ID,TL.NAME AS TESTSUITELOG_CLASS_NAME,S.TESTSUITE_EXECRECORD_ID,TEX.NAME AS TESTSUITE_EXECRECORD_NAME,S.REC_DATETIME,S.ISSOFTDELETED,
 TS.NAME AS TESTSUITELOG_STATE,S.TESTSUITELOG_STATE_ID,TS.EXTERNAL_ID AS TESTSUITELOG_STATE_EXTERNAL_ID,TS.REFERENCE_ID AS TESTSUITELG_STATE_REFERENCE_ID,TS.TEST_STATUS_ID,TU.NAME AS TEST_STATUS_NAME,TU.EXTERNAL_ID AS TEST_STATUS_EXTERNAL_ID,TU.REFERENCE_ID AS TEST_STATUS_REFERENCE_ID,S.TOTAL_TESTCASE_COUNT,S.NOTSTARTED_TESTCASE_COUNT
 FROM  $(NF_SCHEMA).TESTSUITELOG S
 JOIN  $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID=S.ITERATION_ID
 JOIN  $(NF_SCHEMA).TESTSUITE T ON T.TESTSUITE_ID=S.TESTSUITE_ID
 JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=S.OWNER_ID
 JOIN  $(NF_SCHEMA).TESTSUITELOG_CLASSIFICATION TL ON TL.TESTSUITELOG_CLASS_ID=S.TESTSUITELOG_CLASS_ID
 JOIN  $(NF_SCHEMA).TESTPLAN TP ON TP.TESTPLAN_ID=S.TESTPLAN_ID
 JOIN  $(NF_SCHEMA).TESTSUITE_EXECUTION_RECORD TEX ON TEX.TESTSUITE_EXECRECORD_ID=S.TESTSUITE_EXECRECORD_ID
 JOIN  $(NF_SCHEMA).TESTSUITELOG_STATE TS ON TS.TESTSUITELOG_STATE_ID=S.TESTSUITELOG_STATE_ID
JOIN  $(NF_SCHEMA).TEST_STATUS TU ON TU.TEST_STATUS_ID=TS.TEST_STATUS_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTCASE (EXTERNAL_ID,IS_BLOCKING,NAME,REFERENCE_ID,TESTCASE_ID,TESTCASE_STATE,TESTPLAN_ID,TESTPLAN_NAME,URL,OWNER_ID,OWNER_NAME,REGRESSION_TEST,WEIGHT,LAST_UPDATED,
COMPONENT_ID,COMPONENT_NAME,TESTCASE_STATE_ID,TESTCASE_STATE_EXTERNAL_ID,TESTCASE_STATE_REFERENCE_ID,TEST_STATUS_ID,TEST_STATUS_NAME,TEST_STATUS_EXTERNAL_ID,TEST_STATUS_REFERENCE_ID,EXTERNAL_KEY1,EXTERNAL_KEY2,
TESTCASE_CLASS_ID,TESTCASE_CLASS_NAME,TESTCASE_FOLDER,PROJECT_ID,PROJECT_NAME,TEST_PRIORITY_ID,TEST_PRIORITY_NAME,TEST_PRIORITY_EXTERNAL_ID,TEST_PRIORITY_REFERENCE_ID,ESTIMATE,CREATION_DATE,REC_DATETIME,ISSOFTDELETED) AS
(SELECT T.EXTERNAL_ID,T.IS_BLOCKING,T.NAME,T.REFERENCE_ID,T.TESTCASE_ID,TS.NAME AS TESTCASE_STATE,T.TESTPLAN_ID,TP.NAME AS TESTPLAN_NAME, T.URL,T.OWNER_ID,R.FULL_NAME AS OWNER_NAME,T.REGRESSION_TEST,
T.WEIGHT,T.LAST_UPDATED,T.COMPONENT_ID,C.NAME AS COMPONENT_NAME,T.TESTCASE_STATE_ID,TS.EXTERNAL_ID AS TESTCASE_STATE_EXTERNAL_ID,TS.REFERENCE_ID AS TESTCASE_STATE_REFERENCE_ID,TS.TEST_STATUS_ID,TU.NAME AS TEST_STATUS_NAME,
TU.EXTERNAL_ID AS TEST_STATUS_EXTERNAL_ID,TU.REFERENCE_ID AS TEST_STATUS_REFERENCE_ID,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.TESTCASE_CLASS_ID,TL.NAME AS TESTCASE_CLASS_NAME,T.TESTCASE_FOLDER,T.PROJECT_ID,P.NAME AS PROJECT_NAME,
T.TEST_PRIORITY_ID,PT.NAME AS TEST_PRIORITY_NAME,PT.EXTERNAL_ID AS TEST_PRIORITY_EXTERNAL_ID,PT.REFERENCE_ID AS TEST_PRIORITY_REFERENCE_ID,T.ESTIMATE,T.CREATION_DATE,T.REC_DATETIME,T.ISSOFTDELETED
 FROM  $(NF_SCHEMA).TESTCASE T
 JOIN  $(NF_SCHEMA).TESTPLAN TP ON TP.TESTPLAN_ID=T.TESTPLAN_ID
 JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=T.OWNER_ID
 JOIN  $(NF_SCHEMA).COMPONENT C ON C.COMPONENT_ID=T.COMPONENT_ID
 JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=T.PROJECT_ID
JOIN  $(NF_SCHEMA).TESTCASE_CLASSIFICATION TL ON TL.TESTCASE_CLASS_ID=T.TESTCASE_CLASS_ID
JOIN  $(NF_SCHEMA).TESTCASE_STATE TS ON TS.TESTCASE_STATE_ID=T.TESTCASE_STATE_ID
JOIN  $(NF_SCHEMA).TEST_STATUS TU ON TU.TEST_STATUS_ID=TS.TEST_STATUS_ID
JOIN  $(NF_SCHEMA).TEST_PRIORITY PT ON PT.TEST_PRIORITY_ID=T.TEST_PRIORITY_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_EXECUTION_RESULT (EXECUTION_RESULT_ID, EXECRES_CLASS_ID, EXECRES_CLASS_NAME, NAME, REFERENCE_ID, EXTERNAL_ID, VERDICT, OWNER_ID, OWNER_NAME, BUILD_ID, BUILD_NAME, ITERATION_ID, ITERATION_NAME, TESTTYPE_ID, TESTTYPE_NAME, TESCASE_ID, TESTCASE_NAME, PROJECT_ID, PROJECT_NAME, TESTSCRIPT_ID, TESTSCRIPT_NAME, START_DATE, END_DATE, POINTS_BLOCKED, POINTS_INCONCLUSIVE, MACHINE, POINTS_ATTEMPTED, POINTS_FAILED, POINTS_PASSED, POINTS_PERMFAILED, LAST_UPDATED, CREATION_DATE, SUITE_INDEX, URL, POINTS_DEFERRED, POINTS_TOTAL, EXTERNAL_KEY1, EXTERNAL_KEY2, SOURCE_ID, REC_DATETIME, ISSOFTDELETED,
EXECRESULT_STATE,EXECRESULT_STATE_ID,EXECRESULT_STATE_EXTERNAL_ID,EXECRESULT_STATE_REFERENCE_ID,TEST_STATUS_ID,TEST_STATUS_NAME,TEST_STATUS_EXTERNAL_ID,TEST_STATUS_REFERENCE_ID,LAB_RESOURCE_ID,LAB_RESOURCE_NAME) AS
(SELECT EX.EXECUTION_RESULT_ID, EX.EXECRES_CLASS_ID, EC.NAME AS EXECRES_CLASS_NAME, EX.NAME, EX.REFERENCE_ID, EX.EXTERNAL_ID, EX.VERDICT, EX.OWNER_ID, R.NAME AS OWNER_NAME, EX.BUILD_ID, B.NAME AS BUILD_NAME, EX.ITERATION_ID, I.NAME AS ITERATION_NAME, EX.TESTTYPE_ID, T.NAME AS TESTTYPE_NAME, EX.TESTCASE_ID, T1.NAME AS TESTCASE_NAME, EX.PROJECT_ID, P.NAME AS PROJECT_NAME, EX.TESTSCRIPT_ID, T2.NAME AS TESTSCRIPT_NAME, EX.START_DATE, EX.END_DATE, EX.POINTS_BLOCKED, EX.POINTS_INCONCLUSIVE, EX.MACHINE, EX.POINTS_ATTEMPTED, EX.POINTS_FAILED, EX.POINTS_PASSED, EX.POINTS_PERMFAILED, EX.LAST_UPDATED, EX.CREATION_DATE, EX.SUITE_INDEX, EX.URL,EX.POINTS_DEFERRED,EX.POINTS_TOTAL,EX.EXTERNAL_KEY1, EX.EXTERNAL_KEY2, EX.SOURCE_ID, EX.REC_DATETIME, EX.ISSOFTDELETED,
 TS.NAME AS EXECRESULT_STATE,EX.EXECRESULT_STATE_ID,TS.EXTERNAL_ID AS EXECRESULT_STATE_EXTERNAL_ID,TS.REFERENCE_ID AS EXECRESULT_STATE_REFERENCE_ID,TS.TEST_STATUS_ID,TU.NAME AS TEST_STATUS_NAME,TU.EXTERNAL_ID AS TEST_STATUS_EXTERNAL_ID,TU.REFERENCE_ID AS TEST_STATUS_REFERENCE_ID,
EX.LAB_RESOURCE_ID,L.NAME AS LAB_RESOURCE_NAME
FROM  $(NF_SCHEMA).EXECUTION_RESULT EX
 JOIN  $(NF_SCHEMA).BUILD B ON B.BUILD_ID = EX.BUILD_ID
 JOIN  $(NF_SCHEMA).EXECRESULT_CLASSIFICATION EC ON EC.EXECRES_CLASS_ID = EX.EXECRES_CLASS_ID
 JOIN  $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID = EX.ITERATION_ID
 JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID = EX.PROJECT_ID
 JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID = EX.OWNER_ID
 JOIN  $(NF_SCHEMA).TESTTYPE T ON T.TESTTYPE_ID = EX.TESTTYPE_ID
 JOIN  $(NF_SCHEMA).TESTCASE T1 ON T1.TESTCASE_ID = EX.TESTCASE_ID
 JOIN  $(NF_SCHEMA).TESTSCRIPT T2 ON T2.TESTSCRIPT_ID = EX.TESTSCRIPT_ID
 JOIN  $(NF_SCHEMA).EXECRESULT_STATE TS ON TS.EXECRESULT_STATE_ID=EX.EXECRESULT_STATE_ID
JOIN  $(NF_SCHEMA).TEST_STATUS TU ON TU.TEST_STATUS_ID=TS.TEST_STATUS_ID
JOIN  $(NF_SCHEMA).LAB_RESOURCE L ON L.LAB_RESOURCE_ID=EX.LAB_RESOURCE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTPLAN (EXTERNAL_ID, NAME, REFERENCE_ID, TESTPLAN_ID, TESTPLAN_STATE,PROJECT_ID,PROJECT_NAME,CREATION_DATE,OWNER_ID,OWNER_NAME,LAST_UPDATED,URL,ASSETREGISTRY_ID,ASSETREGISTRY_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,TESTPLAN_CLASS_ID,TESTPLAN_CLASS_NAME,REC_DATETIME,ISSOFTDELETED,
TESTPLAN_STATE_ID,TESTPLAN_STATE_EXTERNAL_ID,TESTPLAN_STATE_REFERENCE_ID,TEST_STATUS_ID,TEST_STATUS_NAME,TEST_STATUS_EXTERNAL_ID,TEST_STATUS_REFERENCE_ID,TEST_PRIORITY_ID,TEST_PRIORITY_NAME,TEST_PRIORITY_EXTERNAL_ID,TEST_PRIORITY_REFERENCE_ID,ESTIMATE) AS
 (SELECT T.EXTERNAL_ID, T.NAME, T.REFERENCE_ID, T.TESTPLAN_ID, TS.NAME AS TESTPLAN_STATE,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.CREATION_DATE,
T.OWNER_ID,R.FULL_NAME AS OWNER_NAME,T.LAST_UPDATED,T.URL,T.ASSETREGISTRY_ID,A.NAME AS ASSETREGISTRY_NAME,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.TESTPLAN_CLASS_ID,TL.NAME AS TESTPLAN_CLASS_NAME,T.REC_DATETIME,T.ISSOFTDELETED,
T.TESTPLAN_STATE_ID,TS.EXTERNAL_ID AS TESTPLAN_STATE_EXTERNAL_ID,TS.REFERENCE_ID TESTPLAN_STATE_REFERENCE_ID,TS.TEST_STATUS_ID,TU.NAME AS TEST_STATUS_NAME,TU.EXTERNAL_ID AS TEST_STATUS_EXTERNAL_ID,TU.REFERENCE_ID AS TEST_STATUS_REFERENCE_ID,
T.TEST_PRIORITY_ID,PT.NAME AS TEST_PRIORITY_NAME,PT.EXTERNAL_ID AS TEST_PRIORITY_EXTERNAL_ID,PT.REFERENCE_ID AS TEST_PRIORITY_REFERENCE_ID,T.ESTIMATE
FROM  $(NF_SCHEMA).TESTPLAN T
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=T.PROJECT_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=T.OWNER_ID
JOIN  $(NF_SCHEMA).ASSETREGISTRY A ON A.ASSETREGISTRY_ID=T.ASSETREGISTRY_ID
JOIN  $(NF_SCHEMA).TESTPLAN_CLASSIFICATION TL ON TL.TESTPLAN_CLASS_ID=T.TESTPLAN_CLASS_ID
JOIN  $(NF_SCHEMA).TESTPLAN_STATE TS ON TS.TESTPLAN_STATE_ID=T.TESTPLAN_STATE_ID
JOIN  $(NF_SCHEMA).TEST_STATUS TU ON TU.TEST_STATUS_ID=TS.TEST_STATUS_ID
JOIN  $(NF_SCHEMA).TEST_PRIORITY PT ON PT.TEST_PRIORITY_ID=T.TEST_PRIORITY_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTSUITE (EXTERNAL_ID,NAME,REFERENCE_ID,TESTSUITE_ID,TESTSUITE_STATE,URL,LAST_UPDATED,PROJECT_ID,PROJECT_NAME,CREATION_DATE,OWNER_ID,OWNER_NAME,CONFIGURATION_ID,
CONFIGURATION_NAME,ASSETREGISTRY_ID,ASSETREGISTRY_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,TESTSUITE_CLASS_ID,TESTSUITE_CLASS_NAME,TESTSUITE_STATE_ID,TESTSUITE_STATE_EXTERNAL_ID,TESTSUITE_STATE_REFERENCE_ID,
TEST_STATUS_ID,TEST_STATUS_NAME,TEST_STATUS_EXTERNAL_ID,TEST_STATUS_REFERENCE_ID,REC_DATETIME,ISSOFTDELETED,DESCRIPTION,ISSEQUENTIAL,CREATOR_ID,CREATOR_NAME,WEIGHT,
TEST_PRIORITY_ID,TEST_PRIORITY_NAME,TEST_PRIORITY_EXTERNAL_ID,TEST_PRIORITY_REFERENCE_ID,ESTIMATE) AS
(SELECT T.EXTERNAL_ID,T.NAME,T.REFERENCE_ID,T.TESTSUITE_ID,TS.NAME AS TESTSUITE_STATE,T.URL,T.LAST_UPDATED,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.CREATION_DATE,T.OWNER_ID,
R.FULL_NAME AS OWNER_NAME,T.CONFIGURATION_ID,C.NAME AS CONFIGURATION_NAME,T.ASSETREGISTRY_ID,A.NAME AS ASSETREGISTRY_NAME,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.TESTSUITE_CLASS_ID,
TL.NAME AS TESTSUITE_CLASS_NAME,T.TESTSUITE_STATE_ID,TS.EXTERNAL_ID AS TESTSUITE_STATE_EXTERNAL_ID,TS.REFERENCE_ID AS TESTSUITE_STATE_REFERENCE_ID,TS.TEST_STATUS_ID,TU.NAME AS TEST_STATUS_NAME,TU.EXTERNAL_ID AS TEST_STATUS_EXTERNAL_ID,TU.REFERENCE_ID AS TEST_STATUS_REFERENCE_ID,
T.REC_DATETIME,T.ISSOFTDELETED,T.DESCRIPTION,T.ISSEQUENTIAL,T.CREATOR_ID,CT.FULL_NAME AS CREATOR_NAME,T.WEIGHT,
T.TEST_PRIORITY_ID,PT.NAME AS TEST_PRIORITY_NAME,PT.EXTERNAL_ID AS TEST_PRIORITY_EXTERNAL_ID,PT.REFERENCE_ID AS TEST_PRIORITY_REFERENCE_ID,T.ESTIMATE
 FROM  $(NF_SCHEMA).TESTSUITE T
 JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=T.PROJECT_ID
 JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=T.OWNER_ID
 JOIN  $(NF_SCHEMA).RESOURCE CT ON CT.RESOURCE_ID=T.CREATOR_ID
 JOIN  $(NF_SCHEMA).CONFIGURATION C ON C.CONFIGURATION_ID =T.CONFIGURATION_ID
 JOIN  $(NF_SCHEMA).ASSETREGISTRY A ON A.ASSETREGISTRY_ID=T.ASSETREGISTRY_ID
JOIN  $(NF_SCHEMA).TESTSUITE_CLASSIFICATION TL ON TL.TESTSUITE_CLASS_ID=T.TESTSUITE_CLASS_ID
JOIN  $(NF_SCHEMA).TESTSUITE_STATE TS ON TS.TESTSUITE_STATE_ID=T.TESTSUITE_STATE_ID
JOIN  $(NF_SCHEMA).TEST_STATUS TU ON TU.TEST_STATUS_ID=TS.TEST_STATUS_ID
JOIN  $(NF_SCHEMA).TEST_PRIORITY PT ON PT.TEST_PRIORITY_ID=T.TEST_PRIORITY_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_EXECWORKITEM_ITER_LOOKUP (EXECWORKITEM_ID, EXECUTION_WORKITEM_NAME, ITERATION_ID, ITERATION_NAME) AS
 (SELECT  CI.EXECWORKITEM_ID, C.NAME AS EXECUTION_WORKITEM_NAME, CI.ITERATION_ID, I.NAME AS ITERATION_NAME FROM  $(NF_SCHEMA).EXECWORKITEM_ITERATION_LOOKUP CI JOIN  $(NF_SCHEMA).EXECUTION_WORKITEM C ON C.EXECWORKITEM_ID=CI.EXECWORKITEM_ID JOIN  $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID=CI.ITERATION_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_EXECWORKITEM_TSTSUTE_LOOKUP (EXECWORKITEM_ID, EXECUTION_WORKITEM_NAME, TESTSUITE_ID, TESTSUITE_NAME) AS
 (SELECT  CT.EXECWORKITEM_ID, C.NAME AS EXECUTION_WORKITEM_NAME, CT.TESTSUITE_ID, T.NAME AS TESTSUITE_NAME FROM  $(NF_SCHEMA).EXECWORKITEM_TESTSUITE_LOOKUP CT JOIN  $(NF_SCHEMA).EXECUTION_WORKITEM C ON C.EXECWORKITEM_ID=CT.EXECWORKITEM_ID JOIN  $(NF_SCHEMA).TESTSUITE T ON T.TESTSUITE_ID=CT.TESTSUITE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_CUSTOMER_LOOKUP (CUSTOMER_ID, CUSTOMER_NAME, REQUEST_ID, REQUEST_NAME) AS
 (SELECT  RC.CUSTOMER_ID, C.NAME AS CUSTOMER_NAME, RC.REQUEST_ID, R.NAME AS REQUEST_NAME FROM  $(NF_SCHEMA).REQUEST_CUSTOMER_LOOKUP RC JOIN  $(NF_SCHEMA).REQUEST R ON R.REQUEST_ID=RC.REQUEST_ID JOIN  $(NF_SCHEMA).CUSTOMER C ON C.CUSTOMER_ID=RC.CUSTOMER_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUIR_EXECWRKITEM_LOOKUP (EXECWORKITEM_ID, EXECUTION_WORKITEM_NAME, REQUIREMENT_ID, REQUIREMENT_NAME) AS
 ( SELECT RC.EXECWORKITEM_ID, C.NAME AS EXECUTION_WORKITEM_NAME, RC.REQUIREMENT_ID, R.NAME AS REQUIREMENT_NAME FROM  $(NF_SCHEMA).REQUIREMENT_EXECWRKITEM_LOOKUP RC JOIN  $(NF_SCHEMA).REQUIREMENT R ON R.REQUIREMENT_ID=RC.REQUIREMENT_ID JOIN  $(NF_SCHEMA).EXECUTION_WORKITEM C ON C.EXECWORKITEM_ID=RC.EXECWORKITEM_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUIREMENT_REQUEST_LOOKUP (REQUEST_ID, REQUEST_NAME, REQUIREMENT_ID, REQUIREMENT_NAME, LINK_TYPE) AS
 ( SELECT RC.REQUEST_ID, C.NAME AS REQUEST_NAME, RC.REQUIREMENT_ID, R.NAME AS REQUIREMENT_NAME, RC.LINK_TYPE FROM   $(NF_SCHEMA).REQUIREMENT_REQUEST_LOOKUP RC JOIN  $(NF_SCHEMA).REQUIREMENT R ON R.REQUIREMENT_ID=RC.REQUIREMENT_ID JOIN  $(NF_SCHEMA).REQUEST C ON C.REQUEST_ID=RC.REQUEST_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUIREMENT_TESTCASE_LOOKUP (TESTCASE_ID, TESTCASE_NAME, REQUIREMENT_ID, REQUIREMENT_NAME, LINK_TYPE) AS
 ( SELECT RC.TESTCASE_ID, C.NAME AS TESTCASE_NAME, RC.REQUIREMENT_ID, R.NAME AS REQUIREMENT_NAME, RC.LINK_TYPE FROM   $(NF_SCHEMA).REQUIREMENT_TESTCASE_LOOKUP RC JOIN  $(NF_SCHEMA).REQUIREMENT R ON R.REQUIREMENT_ID=RC.REQUIREMENT_ID JOIN  $(NF_SCHEMA).TESTCASE C ON C.TESTCASE_ID=RC.TESTCASE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUIREMENT_TESTPLAN_LOOKUP (TESTPLAN_ID, TESTPLAN_NAME, REQUIREMENT_ID, REQUIREMENT_NAME) AS
 ( SELECT RC.TESTPLAN_ID, C.NAME AS TESTPLAN_NAME, RC.REQUIREMENT_ID, R.NAME AS REQUIREMENT_NAME FROM   $(NF_SCHEMA).REQUIREMENT_TESTPLAN_LOOKUP RC JOIN  $(NF_SCHEMA).REQUIREMENT R ON R.REQUIREMENT_ID=RC.REQUIREMENT_ID JOIN  $(NF_SCHEMA).TESTPLAN C ON C.TESTPLAN_ID=RC.TESTPLAN_ID
UNION
SELECT  RT.TESTPLAN_ID, T.NAME AS TESTPLAN_NAME, RRL.REQUIREMENT_ID, R.NAME AS REQUIREMENT_NAME
FROM  $(NF_SCHEMA).REQUICOL_TESTPLAN_LOOKUP RT JOIN  $(NF_SCHEMA).REQUIREMENT_COLLECTION RC ON RC.REQUIREMENT_COLLECTION_ID=RT.REQUIREMENT_COLLECTION_ID JOIN  $(NF_SCHEMA).TESTPLAN T ON T.TESTPLAN_ID=RT.TESTPLAN_ID
JOIN  $(NF_SCHEMA).REQUICOL_REQUIREMENT_LOOKUP RRL ON RRL.REQUIREMENT_COLLECTION_ID=RT.REQUIREMENT_COLLECTION_ID
JOIN  $(NF_SCHEMA).REQUIREMENT R ON R.REQUIREMENT_ID=RRL.REQUIREMENT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUIREMENT_TSTSUITE_LOOKUP (TESTSUITE_ID, TESTSUITE_NAME, REQUIREMENT_ID, REQUIREMENT_NAME) AS
 ( SELECT RC.TESTSUITE_ID, C.NAME AS TESTSUITE_NAME, RC.REQUIREMENT_ID, R.NAME AS REQUIREMENT_NAME FROM   $(NF_SCHEMA).REQUIREMENT_TESTSUITE_LOOKUP RC JOIN  $(NF_SCHEMA).REQUIREMENT R ON R.REQUIREMENT_ID=RC.REQUIREMENT_ID JOIN  $(NF_SCHEMA).TESTSUITE C ON C.TESTSUITE_ID=RC.TESTSUITE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTCASE_ITERATION_LOOKUP (ITERATION_ID, ITERATION_NAME, TESTCASE_ID, TESTCASE_NAME) AS
 (SELECT  RT.ITERATION_ID, I.NAME AS ITERATION_NAME, RT.TESTCASE_ID, T.NAME AS TESTCASE_NAME FROM  $(NF_SCHEMA).TESTCASE_ITERATION_LOOKUP RT JOIN  $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID=RT.ITERATION_ID JOIN  $(NF_SCHEMA).TESTCASE T ON T.TESTCASE_ID=RT.TESTCASE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_EXECRES_REQUEST_LOOKUP (REQUEST_ID, REQUEST_NAME, EXECUTION_RESULT_ID, EXECUTION_RESULT_VERDICT, LINK_TYPE) AS
 (SELECT TR.REQUEST_ID, I.NAME AS REQUEST_NAME, TR.EXECUTION_RESULT_ID, T.VERDICT AS EXECUTION_RESULT_VERDICT, TR.LINK_TYPE FROM  $(NF_SCHEMA).EXECRES_REQUEST_LOOKUP TR JOIN  $(NF_SCHEMA).REQUEST I ON I.REQUEST_ID=TR.REQUEST_ID JOIN  $(NF_SCHEMA).EXECUTION_RESULT T ON T.EXECUTION_RESULT_ID=TR.EXECUTION_RESULT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTPLAN_ITERATION_LOOKUP (ITERATION_ID, ITERATION_NAME, TESTPLAN_ID, TESTPLAN_NAME) AS
 (SELECT  RT.ITERATION_ID, I.NAME AS ITERATION_NAME, RT.TESTPLAN_ID, T.NAME AS TESTPLAN_NAME FROM  $(NF_SCHEMA).TESTPLAN_ITERATION_LOOKUP RT JOIN  $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID=RT.ITERATION_ID JOIN  $(NF_SCHEMA).TESTPLAN T ON T.TESTPLAN_ID=RT.TESTPLAN_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTSUITE_ITERATION_LOOKUP (ITERATION_ID, ITERATION_NAME, TESTSUITE_ID, TESTSUITE_NAME) AS
 (SELECT  RT.ITERATION_ID, I.NAME AS ITERATION_NAME, RT.TESTSUITE_ID, T.NAME AS TESTSUITE_NAME FROM  $(NF_SCHEMA).TESTSUITE_ITERATION_LOOKUP RT JOIN  $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID=RT.ITERATION_ID JOIN  $(NF_SCHEMA).TESTSUITE T ON T.TESTSUITE_ID=RT.TESTSUITE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTSUITELOG_EXECRES_LOOKUP (TESTSUITELOG_ID, TESTSUITELOG_VERDICT, EXECUTION_RESULT_ID, EXECUTION_RESULT_VERDICT) AS
 (SELECT ST.TESTSUITELOG_ID, S.VERDICT AS TESTSUITELOG_VERDICT, ST.EXECUTION_RESULT_ID, T.VERDICT AS EXECUTION_RESULT_VERDICT FROM  $(NF_SCHEMA).TESTSUITELOG_EXECRESULT_LOOKUP ST JOIN  $(NF_SCHEMA).TESTSUITELOG S ON S.TESTSUITELOG_ID=ST.TESTSUITELOG_ID JOIN  $(NF_SCHEMA).EXECUTION_RESULT T ON T.EXECUTION_RESULT_ID=ST.EXECUTION_RESULT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TASK_REQUEST_LOOKUP (REQUEST_ID, REQUEST_NAME, TASK_ID, TASK_NAME) AS
 ( SELECT  TR.REQUEST_ID, R.NAME AS REQUEST_NAME, TR.TASK_ID, T.NAME AS TASK_NAME FROM  $(NF_SCHEMA).TASK_REQUEST_LOOKUP TR JOIN  $(NF_SCHEMA).REQUEST R ON R.REQUEST_ID=TR.REQUEST_ID JOIN  $(NF_SCHEMA).TASK T ON T.TASK_ID=TR.TASK_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TASK_REQUIREMENT_LOOKUP (REQUIREMENT_ID, REQUIREMENT_NAME, TASK_ID, TASK_NAME) AS
 ( SELECT  TR.REQUIREMENT_ID, R.NAME AS REQUIREMENT_NAME, TR.TASK_ID, T.NAME AS TASK_NAME FROM  $(NF_SCHEMA).TASK_REQUIREMENT_LOOKUP TR JOIN  $(NF_SCHEMA).REQUIREMENT R ON R.REQUIREMENT_ID=TR.REQUIREMENT_ID JOIN  $(NF_SCHEMA).TASK T ON T.TASK_ID=TR.TASK_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_FILE_VERSION (CREATION_DATE, FILE_CLASS_ID,EXTERNAL_ID, FILE_VERSION_ID, NAME, NUM_SLOC, REFERENCE_ID, URL,
ACTIVITY_ID,ACTIVITY_NAME,AUTHOR_ID,AUTHOR_NAME,FILE_ID,FILE_NAME,FILE_STREAM_ID,FILE_STREAM_NAME,HASCOMMENT,NUM_SLOC_CHANGED,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
( SELECT C.CREATION_DATE, C.FILE_CLASS_ID,C.EXTERNAL_ID, C.FILE_VERSION_ID, C.NAME, C.NUM_SLOC, C.REFERENCE_ID, C.URL,
C.ACTIVITY_ID,A.NAME AS ACTIVITY_NAME,C.AUTHOR_ID,R.FULL_NAME AS AUTHOR_NAME,C.FILE_ID,F.NAME AS FILE_NAME,C.FILE_STREAM_ID,FS.NAME AS FILE_STREAM_NAME,C.HASCOMMENT,C.NUM_SLOC_CHANGED,C.EXTERNAL_KEY1,C.EXTERNAL_KEY2,C.REC_DATETIME,C.ISSOFTDELETED
 FROM  $(NF_SCHEMA).FILE_VERSION C
 JOIN  $(NF_SCHEMA).ACTIVITY A ON A.ACTIVITY_ID=C.ACTIVITY_ID
 JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=C.AUTHOR_ID
 JOIN  $(NF_SCHEMA).[FILE] F ON F.FILE_ID=C.FILE_ID
 JOIN  $(NF_SCHEMA).FILE_STREAM FS ON FS.FILE_STREAM_ID=C.FILE_STREAM_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJECT_BASELINE (BASELINE_ID, EXTERNAL_ID, FILE_STREAM_ID, FILE_NAME, NAME, OWNER_ID, PROJECT_ID, REFERENCE_ID, URL, BASELINE_DATE, PLANNED_START, PLANNED_FINISH, PLANNED_WORK,BASELINE_WORK_COMPLETED, PLANNED_COST,BASELINE_COST_COMPLETED, PLANNED_DURATION, EXTERNAL_KEY1, EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT P.BASELINE_ID, P.EXTERNAL_ID, P.FILE_STREAM_ID,F.NAME AS FILE_NAME, P.NAME, P.OWNER_ID, P.PROJECT_ID, P.REFERENCE_ID, P.URL, P.BASELINE_DATE, P.PLANNED_START, P.PLANNED_FINISH, P.PLANNED_WORK,P.BASELINE_WORK_COMPLETED,P.PLANNED_COST, P.BASELINE_COST_COMPLETED,P.PLANNED_DURATION, P.EXTERNAL_KEY1,P.EXTERNAL_KEY2,P.REC_DATETIME,P.ISSOFTDELETED FROM  $(NF_SCHEMA).PROJECT_BASELINE P LEFT JOIN  $(NF_SCHEMA).FILE_STREAM F ON F.FILE_STREAM_ID=P.FILE_STREAM_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ACTIVITY_CLASSIFICATION (ACTIVITY_CLASS_ID,NAME) AS (SELECT ACTIVITY_CLASS_ID,NAME FROM  $(NF_SCHEMA).ACTIVITY_CLASSIFICATION)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ACTIVITY_DETAIL (ACTIVITY_ID,ACTIVITY_NAME,ACTUAL_COST,ACTUAL_FINISH,ACTUAL_OVT_COST,ACTUAL_OVT_WORK,ACTUAL_START,ACTUAL_WORK,ACWP,BASELINE_COST,BASELINE_FINISH,BASELINE_START,BASELINE_WORK,BCWP,BCWS,DELAY,EAC,EXTERNAL_ID,FINISH_VARIANCE,IS_CONFIRMED,IS_OVERALLOCATED,OWNER_ID,OWNER_NAME,PLANNED_COST,PLANNED_FINISH,PLANNED_OVT_WORK,PLANNED_START,PLANNED_WORK,REFERENCE_ID,REGULAR_WORK,REMAINING_COST,REMAINING_OVT_COST,REMAINING_OVT_WORK,REMAINING_WORK,RESOURCE_TYPE,START_VARIANCE,TASK_ID,TASK_NAME,UNITS,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,PERCENT_COMPLETE,PERCENT_WORK_COMPLETE,PLANNED_DURATION,ACTUAL_DURATION) AS
(SELECT A.ACTIVITY_ID,AA.NAME AS ACTIVITY_NAME,A.ACTUAL_COST,A.ACTUAL_FINISH,A.ACTUAL_OVT_COST,A.ACTUAL_OVT_WORK,A.ACTUAL_START,A.ACTUAL_WORK,A.ACWP,A.BASELINE_COST,A.BASELINE_FINISH,A.BASELINE_START,A.BASELINE_WORK,A.BCWP,A.BCWS,A.DELAY,A.EAC,AA.EXTERNAL_ID,A.FINISH_VARIANCE,A.IS_CONFIRMED,A.IS_OVERALLOCATED,AA.OWNER_ID,R.FULL_NAME AS OWNER_NAME,A.PLANNED_COST,A.PLANNED_FINISH,A.PLANNED_OVT_WORK,A.PLANNED_START,A.PLANNED_WORK,AA.REFERENCE_ID,A.REGULAR_WORK,A.REMAINING_COST,A.REMAINING_OVT_COST,A.REMAINING_OVT_WORK,A.REMAINING_WORK,A.RESOURCE_TYPE,A.START_VARIANCE,AA.TASK_ID,T.NAME AS TASK_NAME,A.UNITS,AA.URL,AA.EXTERNAL_KEY1,AA.EXTERNAL_KEY2,A.PERCENT_COMPLETE,A.PERCENT_WORK_COMPLETE,A.PLANNED_DURATION,A.ACTUAL_DURATION
FROM  $(NF_SCHEMA).ACTIVITY_DETAIL A
JOIN  $(NF_SCHEMA).ACTIVITY AA ON A.ACTIVITY_ID=AA.ACTIVITY_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=AA.OWNER_ID
JOIN  $(NF_SCHEMA).TASK T ON T.TASK_ID=AA.TASK_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ASSETREGISTRY (ASSETREGISTRY_ID,EXTERNAL_ID,NAME,REFERENCE_ID,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
(SELECT A.ASSETREGISTRY_ID,A.EXTERNAL_ID,A.NAME,A.REFERENCE_ID,A.URL,A.EXTERNAL_KEY1,A.EXTERNAL_KEY2,A.REC_DATETIME,A.ISSOFTDELETED
FROM  $(NF_SCHEMA).ASSETREGISTRY A)
GO

CREATE VIEW $(STAR_SCHEMA).VW_CONFIGURATION(CONFIGURATION_ID,EXTERNAL_ID,NAME,REFERENCE_ID,URL,LAST_UPDATED,OWNER_ID,OWNER_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,CONFIGURATION_CLASS_ID,CONFIGURATION_CLASS_NAME,PROJECT_ID,PROJECT_NAME,REC_DATETIME,ISSOFTDELETED) AS
(SELECT C.CONFIGURATION_ID,C.EXTERNAL_ID,C.NAME,C.REFERENCE_ID,C.URL,C.LAST_UPDATED,C.OWNER_ID,R.FULL_NAME AS OWNER_NAME,C.EXTERNAL_KEY1,C.EXTERNAL_KEY2,C.CONFIGURATION_CLASS_ID,CL.NAME AS CONFIGURATION_CLASS_NAME,C.PROJECT_ID,P.NAME AS PROJECT_NAME,C.REC_DATETIME,C.ISSOFTDELETED
FROM  $(NF_SCHEMA).CONFIGURATION C
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=C.OWNER_ID
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=C.PROJECT_ID
JOIN  $(NF_SCHEMA).CONFIGURATION_CLASSIFICATION CL ON CL.CONFIGURATION_CLASS_ID=C.CONFIGURATION_CLASS_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_CONFIGURATION_ATTRIBUTE(CONFIGURATION_ATTRIBUTE_ID,EXTERNAL_ID,NAME,REFERENCE_ID,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
(SELECT CONFIGURATION_ATTRIBUTE_ID,EXTERNAL_ID,NAME,REFERENCE_ID,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED
FROM  $(NF_SCHEMA).CONFIGURATION_ATTRIBUTE)
GO

CREATE VIEW $(STAR_SCHEMA).VW_CONFIGURATION_ATTR_LOOKUP(CONFIGURATION_ATTRIBUTE_ID,CONFIGURATION_ATTRIBUTE_NAME,CONFIGURATION_ID,CONFIGURATION_NAME) AS
(SELECT C.CONFIGURATION_ATTRIBUTE_ID,CFA.NAME AS CONFIGURATION_ATTRIBUTE_NAME,C.CONFIGURATION_ID,CF.NAME AS CONFIGURATION_NAME
FROM  $(NF_SCHEMA).CONFIGURATION_ATTRIBUTE_LOOKUP C
JOIN  $(NF_SCHEMA).CONFIGURATION_ATTRIBUTE CFA ON CFA.CONFIGURATION_ATTRIBUTE_ID=C.CONFIGURATION_ATTRIBUTE_ID
JOIN  $(NF_SCHEMA).CONFIGURATION CF ON CF.CONFIGURATION_ID=C.CONFIGURATION_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_CONFIG_EXECUTIONRES_LOOKUP(EXECUTION_RESULT_ID,CONFIGURATION_ID,CONFIGURATION_NAME) AS
(SELECT C.EXECUTION_RESULT_ID,C.CONFIGURATION_ID,CF.NAME AS CONFIGURATION_NAME
FROM  $(NF_SCHEMA).CONFIG_EXECUTIONRES_LOOKUP C
JOIN  $(NF_SCHEMA).CONFIGURATION CF ON CF.CONFIGURATION_ID=C.CONFIGURATION_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_EXECUTION_WORKITEM (EXECWORKITEM_ID,CONFIGURATION_ID,CONFIGURATION_NAME,EXECUTION_WORKITEM_STATE,EXTERNAL_ID,NAME,OWNER_ID,OWNER_NAME,PROJECT_ID,PROJECT_NAME,REFERENCE_ID,TESTCASE_ID,TESTCASE_NAME,TESTTYPE_ID,TESTTYPE_NAME,URL,TESTPLAN_ID,TESTPLAN_NAME,FREQUENCY,REGRESSION,WEIGHT,LAST_UPDATED,CURRENT_RESULT_ID,CURRENT_RESULT_NAME,CURRENT_RESULT_VERDICT,TAGS,EXTERNAL_KEY1,EXTERNAL_KEY2,EXECWORKIT_CLASS_ID,EXECWORKIT_CLASS_NAME,CREATION_DATE,TESTSCRIPT_ID,TESTSCRIPT_NAME,
TEST_PRIORITY_ID,PRIORITY,TEST_PRIORITY_EXTERNAL_ID,TEST_PRIORITY_REFERENCE_ID,ESTIMATE,TIMESPENT,REC_DATETIME,ISSOFTDELETED) AS
(SELECT C.EXECWORKITEM_ID,C.CONFIGURATION_ID,CF.NAME AS CONFIGURATION_NAME,C.EXECUTION_WORKITEM_STATE,C.EXTERNAL_ID,C.NAME,C.OWNER_ID,R.FULL_NAME AS OWNER_NAME,C.PROJECT_ID,P.NAME AS PROJECT_NAME,C.REFERENCE_ID,C.TESTCASE_ID,T.NAME AS TESTCASE_NAME,C.TESTTYPE_ID,TT.NAME AS TESTTYPE_NAME, C.URL,C.TESTPLAN_ID,TP.NAME AS TESTPLAN_NAME,C.FREQUENCY,C.REGRESSION,C.WEIGHT,C.LAST_UPDATED,C.CURRENT_RESULT_ID,ER.NAME AS CURRENT_RESULT_NAME,ER.VERDICT AS CURRENT_RESULT_VERDICT,C.TAGS,C.EXTERNAL_KEY1,C.EXTERNAL_KEY2,C.EXECWORKIT_CLASS_ID,EL.NAME AS EXECWORKIT_CLASS_NAME,C.CREATION_DATE,C.TESTSCRIPT_ID,TS.NAME AS TESTSCRIPT_NAME,
C.TEST_PRIORITY_ID,PT.NAME AS PRIORITY,PT.EXTERNAL_ID AS TEST_PRIORITY_EXTERNAL_ID,PT.REFERENCE_ID AS TEST_PRIORITY_REFERENCE_ID,C.ESTIMATE,C.TIMESPENT,C.REC_DATETIME,C.ISSOFTDELETED
FROM  $(NF_SCHEMA).EXECUTION_WORKITEM C
JOIN  $(NF_SCHEMA).CONFIGURATION CF ON CF.CONFIGURATION_ID=C.CONFIGURATION_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=C.OWNER_ID
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=C.PROJECT_ID
JOIN  $(NF_SCHEMA).TESTCASE T ON T.TESTCASE_ID=C.TESTCASE_ID
JOIN  $(NF_SCHEMA).TESTTYPE TT ON TT.TESTTYPE_ID=C.TESTTYPE_ID
JOIN  $(NF_SCHEMA).TESTPLAN TP ON TP.TESTPLAN_ID=C.TESTPLAN_ID
JOIN  $(NF_SCHEMA).TESTSCRIPT TS ON TS.TESTSCRIPT_ID=C.TESTSCRIPT_ID
JOIN  $(NF_SCHEMA).EXECUTION_RESULT ER ON ER.EXECUTION_RESULT_ID=C.CURRENT_RESULT_ID
JOIN  $(NF_SCHEMA).EXECWORKITEM_CLASSIFICATION EL ON EL.EXECWORKIT_CLASS_ID=C.EXECWORKIT_CLASS_ID
JOIN  $(NF_SCHEMA).TEST_PRIORITY PT ON PT.TEST_PRIORITY_ID=C.TEST_PRIORITY_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_POOL (EXTERNAL_ID,NAME,POOL_ID,POOL_TYPE,PARENT_POOL_ID, PARENT_POOL_NAME,REFERENCE_ID,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
(SELECT P.EXTERNAL_ID,P.NAME,P.POOL_ID,P.POOL_TYPE,P.PARENT_POOL_ID, PP.NAME AS PARENT_POOL_NAME,P.REFERENCE_ID,P.URL,P.EXTERNAL_KEY1,P.EXTERNAL_KEY2,P.REC_DATETIME,P.ISSOFTDELETED
FROM  $(NF_SCHEMA).POOL P
JOIN  $(NF_SCHEMA).POOL PP ON PP.POOL_ID=P.PARENT_POOL_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJ_BASELN_BASELN_LOOKUP(BASELINE_ID,BASELINE_NAME,COMPBASELINE_ID,COMPBASELINE_NAME) AS
(SELECT BL.BASELINE_ID,B.NAME,BL.COMPBASELINE_ID, C.NAME
FROM  $(NF_SCHEMA).PROJ_BASELINE_BASELINE_LOOKUP BL
JOIN  $(NF_SCHEMA).PROJECT_BASELINE B ON B.BASELINE_ID=BL.BASELINE_ID
JOIN  $(NF_SCHEMA).PROJECT_BASELINE C ON C.BASELINE_ID=BL.COMPBASELINE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJECT_CLASSIFICATION (NAME,PROJECT_CLASS_ID) AS
(SELECT NAME,PROJECT_CLASS_ID FROM  $(NF_SCHEMA).PROJECT_CLASSIFICATION)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJECT_COMPONENT_LOOKUP(COMPONENT_ID,COMPONENT_NAME,PROJECT_ID,PROJECT_NAME) AS
(SELECT CP.COMPONENT_ID,C.NAME AS COMPONENT_NAME,CP.PROJECT_ID,P.NAME AS PROJECT_NAME
FROM  $(NF_SCHEMA).PROJECT_COMPONENT_LOOKUP CP
JOIN  $(NF_SCHEMA).COMPONENT C ON C.COMPONENT_ID=CP.COMPONENT_ID
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=CP.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJECT_HIERARCHY(CHILD_PROJECT_ID,CHILD_PROJECT_NAME,PARENT_PROJECT_ID,PARENT_PROJECT_NAME) AS
(SELECT BL.CHILD_PROJECT_ID,B.NAME,BL.PARENT_PROJECT_ID, C.NAME
FROM  $(NF_SCHEMA).PROJECT_HIERARCHY BL
JOIN  $(NF_SCHEMA).PROJECT B ON B.PROJECT_ID=BL.CHILD_PROJECT_ID
JOIN  $(NF_SCHEMA).PROJECT C ON C.PROJECT_ID=BL.PARENT_PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJECT_WRKCONFIG_HIERARCHY(PARENT_WKCFG_ID,PARENT_WKCFG_NAME,CHILD_WKCFG_ID,CHILD_WKCFG_NAME) AS
(SELECT BL.PARENT_WKCFG_ID,B.NAME,BL.CHILD_WKCFG_ID, C.NAME
FROM  $(NF_SCHEMA).PROJECT_WORKCONFIG_HIERARCHY BL
JOIN  $(NF_SCHEMA).PROJECT_WORKCONFIGURATION B ON B.PROJECT_WKCFG_ID=BL.PARENT_WKCFG_ID
JOIN  $(NF_SCHEMA).PROJECT_WORKCONFIGURATION C ON C.PROJECT_WKCFG_ID=BL.CHILD_WKCFG_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJECT_ROLE_MEMBER_LOOKUP(PROJECT_ROLE_ID,PROJECT_NAME,PROJECT_ROLE_NAME,RESOURCE_ID,FULL_NAME) AS
(SELECT PRM.PROJECT_ROLE_ID,P.NAME AS PROJECT_NAME,PR.NAME AS PROJECT_ROLE_NAME,PRM.RESOURCE_ID,R.FULL_NAME
FROM  $(NF_SCHEMA).PROJECT_ROLE_MEMBER_LOOKUP PRM
JOIN  $(NF_SCHEMA).PROJECT_ROLE PR ON PR.PROJECT_ROLE_ID=PRM.PROJECT_ROLE_ID
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=PR.PROJECT_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=PRM.RESOURCE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJECT_MEMBER_LOOKUP(PROJECT_ID,PROJECT_NAME,RESOURCE_ID,RESOURCE_NAME) AS
(SELECT PR.PROJECT_ID,P.NAME AS PROJECT_NAME,PR.RESOURCE_ID,R.FULL_NAME AS RESOURCE_NAME
FROM  $(NF_SCHEMA).PROJECT_MEMBER_LOOKUP PR
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=PR.PROJECT_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=PR.RESOURCE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_CLASSIFICATION (NAME,REQUEST_CLASS_ID) AS
(SELECT NAME,REQUEST_CLASS_ID FROM  $(NF_SCHEMA).REQUEST_CLASSIFICATION)
GO

CREATE VIEW $(STAR_SCHEMA).VW_COMPONENT_CLASSIFICATION (NAME,COMPONENT_CLASS_ID) AS
(SELECT NAME,COMPONENT_CLASS_ID FROM  $(NF_SCHEMA).COMPONENT_CLASSIFICATION)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_HIERARCHY (CHILD_REQUEST_ID,CHILD_REQUEST_NAME,PARENT_REQUEST_ID,PARENT_REQUEST_NAME) AS
(SELECT RC.CHILD_REQUEST_ID,C.NAME AS CHILD_REQUEST_NAME,RC.PARENT_REQUEST_ID,P.NAME AS PARENT_REQUEST_NAME
FROM  $(NF_SCHEMA).REQUEST_HIERARCHY RC
JOIN  $(NF_SCHEMA).REQUEST C ON C.REQUEST_ID=RC.CHILD_REQUEST_ID
JOIN  $(NF_SCHEMA).REQUEST P ON P.REQUEST_ID=RC.PARENT_REQUEST_ID)
GO


CREATE VIEW $(STAR_SCHEMA).VW_REQUIREMENT_HIERARCHY (PRED_REQUIREMENT_ID,PRED_REQUIREMENT_NAME,SUCC_REQUIREMENT_ID,SUCC_REQUIREMENT_NAME,LINK_TYPE_ID,LINK_TYPE) AS
(SELECT RC.PRED_REQUIREMENT_ID,C.NAME AS PRED_REQUIREMENT_NAME,RC.SUCC_REQUIREMENT_ID,P.NAME AS SUCC_REQUIREMENT_NAME,RC.LINK_TYPE_ID,
CASE WHEN RC.LINK_TYPE_ID=-1 AND RC.LINK_TYPE IS NOT NULL THEN RC.LINK_TYPE
ELSE LT.NAME END
FROM  $(NF_SCHEMA).REQUIREMENT_HIERARCHY RC
JOIN  $(NF_SCHEMA).REQUIREMENT C ON C.REQUIREMENT_ID=RC.PRED_REQUIREMENT_ID
JOIN  $(NF_SCHEMA).REQUIREMENT P ON P.REQUIREMENT_ID=RC.SUCC_REQUIREMENT_ID
JOIN  $(NF_SCHEMA).REQUIREMENT_LINK_TYPE LT ON LT.LINK_TYPE_ID=RC.LINK_TYPE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUIRE_REQUIRE_LOOKUP (CREQUIREMENT_ID,CREQUIREMENT_NAME,REQUIREMENT_ID,REQUIREMENT_NAME) AS
(SELECT RR.CREQUIREMENT_ID,C.NAME AS CREQUIREMENT_NAME,RR.REQUIREMENT_ID,R.NAME AS REQUIREMENT_NAME
FROM  $(NF_SCHEMA).REQUIREMENT_REQUIREMENT_LOOKUP RR
JOIN  $(NF_SCHEMA).REQUIREMENT C ON C.REQUIREMENT_ID=RR.CREQUIREMENT_ID
JOIN  $(NF_SCHEMA).REQUIREMENT R ON R.REQUIREMENT_ID=RR.REQUIREMENT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUIREMENT_CLASSIFICATION (NAME,REQUIREMENT_CLASS_ID) AS
(SELECT NAME,REQUIREMENT_CLASS_ID FROM  $(NF_SCHEMA).REQUIREMENT_CLASSIFICATION)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TASK_CLASSIFICATION (NAME,TASK_CLASS_ID) AS
(SELECT NAME,TASK_CLASS_ID FROM  $(NF_SCHEMA).TASK_CLASSIFICATION)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_STATE_HISTORY(CHANGE_DATE,DAYS_IN_STATE,REQUEST_ID,REQUEST_NAME,PREV_REQUEST_STATE_ID,PREV_REQUEST_STATE,REQUEST_STATE_ID,REQUEST_STATE,PREV_REQUEST_STATUS_ID,PREV_REQUEST_STATUS,REQUEST_STATUS_ID,REQUEST_STATUS,REQUEST_STATE_HISTORY_ID,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
(SELECT H.CHANGE_DATE,DAYS_IN_STATE, H.REQUEST_ID,R.NAME AS REQUEST_NAME, H.PREV_REQUEST_STATE_ID,PRST.NAME AS PREV_REQUEST_STATE, H.REQUEST_STATE_ID, RST.NAME AS REQUEST_STATE,
H.PREV_REQUEST_STATUS_ID,PRSTU.NAME AS PREV_REQUEST_STATUS, H.REQUEST_STATUS_ID, RSTU.NAME AS REQUEST_STATUS,
H.REQUEST_STATE_HISTORY_ID,H.EXTERNAL_KEY1,H.EXTERNAL_KEY2,H.REC_DATETIME,H.ISSOFTDELETED
FROM  $(NF_SCHEMA).REQUEST_STATE_HISTORY H
JOIN  $(NF_SCHEMA).REQUEST R ON R.REQUEST_ID=H.REQUEST_ID
JOIN  $(NF_SCHEMA).REQUEST_STATE PRST ON PRST.REQUEST_STATE_ID=H.PREV_REQUEST_STATE_ID
JOIN  $(NF_SCHEMA).REQUEST_STATE RST ON RST.REQUEST_STATE_ID=H.REQUEST_STATE_ID
JOIN  $(NF_SCHEMA).REQUEST_STATUS PRSTU ON PRSTU.REQUEST_STATUS_ID=H.PREV_REQUEST_STATUS_ID
JOIN  $(NF_SCHEMA).REQUEST_STATUS RSTU ON RSTU.REQUEST_STATUS_ID=H.REQUEST_STATUS_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUIREMENT_REVISION_HIST(CHANGE_DATE,REQUIREMENT_ID,REQUIREMENT_NAME,REQUIREMENT_REVISION_ID,RESOURCE_ID,FULL_NAME,REVISION_NUMBER,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
(SELECT H.CHANGE_DATE,H.REQUIREMENT_ID,RE.NAME AS REQUIREMENT_NAME,H.REQUIREMENT_REVISION_ID,H.RESOURCE_ID,R.FULL_NAME,H.REVISION_NUMBER,H.EXTERNAL_KEY1,H.EXTERNAL_KEY2,H.REC_DATETIME,H.ISSOFTDELETED
FROM  $(NF_SCHEMA).REQUIREMENT_REVISION_HISTORY H
JOIN  $(NF_SCHEMA).REQUIREMENT RE ON RE.REQUIREMENT_ID=H.REQUIREMENT_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=H.RESOURCE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TASK_CATEGORY (CATEGORY_TYPE,NAME,OWNER_ID,FULL_NAME,REFERENCE_ID,TASK_CATEGORY_ID,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
(SELECT T.CATEGORY_TYPE,T.NAME,T.OWNER_ID,R.FULL_NAME,T.REFERENCE_ID,T.TASK_CATEGORY_ID,T.URL,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.REC_DATETIME,T.ISSOFTDELETED
FROM  $(NF_SCHEMA).TASK_CATEGORY T
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=T.OWNER_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTTYPE (NAME,REFERENCE_ID,TESTTYPE_ID,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
(SELECT NAME,REFERENCE_ID,TESTTYPE_ID,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED
FROM  $(NF_SCHEMA).TESTTYPE)
GO

CREATE VIEW $(STAR_SCHEMA).VW_FILE_BASELINE_ACT_LOOKUP (FILE_BASELINE_ID,FILE_BASELINE_NAME,ACTIVITY_ID,ACTIVITY_NAME) AS
(SELECT FB.FILE_BASELINE_ID,F.NAME AS FILE_BASELINE_NAME,FB.ACTIVITY_ID,A.NAME AS ACTIVITY_NAME
FROM  $(NF_SCHEMA).FILE_BASELINE_ACTIVITY_LOOKUP FB
JOIN  $(NF_SCHEMA).FILE_BASELINE F ON F.FILE_BASELINE_ID=FB.FILE_BASELINE_ID
JOIN  $(NF_SCHEMA).ACTIVITY A ON A.ACTIVITY_ID=FB.ACTIVITY_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TEST_CATEGORY (TEST_CATEGORY_ID,NAME,REFERENCE_ID,EXTERNAL_ID,TERM,VALUE,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED) AS
(SELECT TEST_CATEGORY_ID,NAME,REFERENCE_ID,EXTERNAL_ID,TERM,VALUE,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED FROM  $(NF_SCHEMA).TEST_CATEGORY)
GO

CREATE VIEW $(STAR_SCHEMA).VW_EXECRES_EXECWKITEM_LOOKUP (EXECUTION_RESULT_ID,EXECUTION_RESULT_NAME, EXECWORKITEM_ID,EXECWORKITEM_NAME) AS
(SELECT ERL.EXECUTION_RESULT_ID,ER.NAME AS EXECUTION_RESULT_NAME, ERL.EXECWORKITEM_ID,EW.NAME AS EXECWORKITEM_NAME
FROM  $(NF_SCHEMA).EXECRES_EXECWKITEM_LOOKUP ERL
JOIN  $(NF_SCHEMA).EXECUTION_RESULT ER ON ER.EXECUTION_RESULT_ID=ERL.EXECUTION_RESULT_ID
JOIN  $(NF_SCHEMA).EXECUTION_WORKITEM EW ON EW.EXECWORKITEM_ID=ERL.EXECWORKITEM_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_CONFIG_EXECWORKITM_LOOKUP (CONFIGURATION_ID,CONFIGURATION_NAME,EXECWORKITEM_ID,EXECWORKITEM_NAME) AS
(SELECT CEL.CONFIGURATION_ID,C.NAME AS CONFIGURATION_NAME,CEL.EXECWORKITEM_ID,E.NAME AS EXECWORKITEM_NAME
FROM  $(NF_SCHEMA).CONFIG_EXECUTIONWORKITM_LOOKUP CEL
JOIN  $(NF_SCHEMA).CONFIGURATION C ON C.CONFIGURATION_ID=CEL.CONFIGURATION_ID
JOIN  $(NF_SCHEMA).EXECUTION_WORKITEM E ON E.EXECWORKITEM_ID=CEL.EXECWORKITEM_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTPLAN_CATEGORY_LOOKUP (TESPLAN_ID,TESTPLAN_NAME,TEST_CATEGORY_ID, TEST_CATEGORY_NAME) AS
(SELECT TCL.TESTPLAN_ID,T.NAME AS TESTPLAN_NAME,TCL.TEST_CATEGORY_ID,C.NAME AS TEST_CATEGORY_NAME
FROM  $(NF_SCHEMA).TESTPLAN_CATEGORY_LOOKUP TCL
JOIN  $(NF_SCHEMA).TESTPLAN T ON T.TESTPLAN_ID=TCL.TESTPLAN_ID
JOIN  $(NF_SCHEMA).TEST_CATEGORY C ON C.TEST_CATEGORY_ID=TCL.TEST_CATEGORY_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTCASE_CATEGORY_LOOKUP (TESTCASE_ID,TESTCASE_NAME,TEST_CATEGORY_ID, TEST_CATEGORY_NAME) AS
(SELECT TCL.TESTCASE_ID,T.NAME AS TESTCASE_NAME,TCL.TEST_CATEGORY_ID,C.NAME AS TEST_CATEGORY_NAME
FROM  $(NF_SCHEMA).TESTCASE_CATEGORY_LOOKUP TCL
JOIN  $(NF_SCHEMA).TESTCASE T ON T.TESTCASE_ID=TCL.TESTCASE_ID
JOIN  $(NF_SCHEMA).TEST_CATEGORY C ON C.TEST_CATEGORY_ID=TCL.TEST_CATEGORY_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTSUITE_TESTCASE_LOOKUP (TESTCASE_ID,TESTCASE_NAME,TESTSUITE_ID, TESTSUITE_NAME) AS
(SELECT TCL.TESTCASE_ID,T.NAME AS TESTCASE_NAME,TCL.TESTSUITE_ID,C.NAME AS TESTSUITE_NAME
FROM  $(NF_SCHEMA).TESTSUITE_TESTCASE_LOOKUP TCL
JOIN  $(NF_SCHEMA).TESTCASE T ON T.TESTCASE_ID=TCL.TESTCASE_ID
JOIN  $(NF_SCHEMA).TESTSUITE C ON C.TESTSUITE_ID=TCL.TESTSUITE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTSUITE_TSUITELOG_LOOKUP (TESTSUITELOG_ID,TESTSUITELOG_NAME,TESTSUITE_ID, TESTSUITE_NAME) AS
(SELECT TCL.TESTSUITELOG_ID,T.NAME AS TESTSUITELOG_NAME,TCL.TESTSUITE_ID,C.NAME AS TESTSUITE_NAME
FROM  $(NF_SCHEMA).TESTSUITE_TESTSUITELOG_LOOKUP TCL
JOIN  $(NF_SCHEMA).TESTSUITELOG T ON T.TESTSUITELOG_ID=TCL.TESTSUITELOG_ID
JOIN  $(NF_SCHEMA).TESTSUITE C ON C.TESTSUITE_ID=TCL.TESTSUITE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTPLAN_TESTPLAN_HIERARCHY (PARENT_TESTPLAN_ID,PARENT_TESTPLAN_NAME,CHILD_TESTPLAN_ID,CHILD_TESTPLAN_NAME) AS
(SELECT H.PARENT_TESTPLAN_ID,P.NAME AS PARENT_TESTPLAN_NAME, H.CHILD_TESTPLAN_ID,C.NAME AS CHILD_TESTPLAN_NAME
FROM  $(NF_SCHEMA).TESTPLAN_TESTPLAN_HIERARCHY H
JOIN  $(NF_SCHEMA).TESTPLAN P ON P.TESTPLAN_ID=H.PARENT_TESTPLAN_ID
JOIN  $(NF_SCHEMA).TESTPLAN C ON C.TESTPLAN_ID=H.CHILD_TESTPLAN_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTPLAN_TESTCASE_LOOKUP (TESTPLAN_ID, TESTPLAN_NAME,TESTCASE_ID, TESTCASE_NAME) AS
(SELECT TT.TESTPLAN_ID,TP.NAME AS TESTPLAN_NAME,TT.TESTCASE_ID,TL.NAME AS TESTCASE_NAME
FROM  $(NF_SCHEMA).TESTPLAN_TESTCASE_LOOKUP TT
JOIN  $(NF_SCHEMA).TESTPLAN TP ON TP.TESTPLAN_ID=TT.TESTPLAN_ID
JOIN  $(NF_SCHEMA).TESTCASE TL ON TL.TESTCASE_ID=TT.TESTCASE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_LAB_RESOURCE (LAB_RESOURCE_ID,NAME,SOFTWARE,REFERENCE_ID,LAB_RESOURCE_TYPE,LAB_RESOURCE_NAME,MEMORY,
IP_ADDRESS,PRIMARY_MAC_ADDRESS,ADMINISTRATIVE_STATUS,OPERATIONAL_STATUS,HOSTNAME,FULLY_QUALIFIED_DOMAIN_NAME,
OS_TYPE,OS_LOCALE,OS_KERNEL_WIDTH,CPU_SPEED,CPU_ARCHITECTURE,CPU_ARCHITECTURE_WIDTH,CPU_MANUFACTURER,CPU_TYPE,
DISK_SPACE,RESOURCE_GROUP_ID,RESOURCE_GROUP_NAME,PROJECT_ID, PROJECT_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
(SELECT L.LAB_RESOURCE_ID,L.NAME,L.SOFTWARE,L.REFERENCE_ID,L.LAB_RESOURCE_TYPE,L.LAB_RESOURCE_NAME,L.MEMORY,
L.IP_ADDRESS,L.PRIMARY_MAC_ADDRESS,L.ADMINISTRATIVE_STATUS,L.OPERATIONAL_STATUS,L.HOSTNAME,L.FULLY_QUALIFIED_DOMAIN_NAME,
L.OS_TYPE,L.OS_LOCALE,L.OS_KERNEL_WIDTH,L.CPU_SPEED,L.CPU_ARCHITECTURE,L.CPU_ARCHITECTURE_WIDTH,L.CPU_MANUFACTURER,L.CPU_TYPE,
L.DISK_SPACE,L.RESOURCE_GROUP_ID,R.NAME AS RESOURCE_GROUP_NAME,L.PROJECT_ID, P.NAME AS PROJECT_NAME,L.URL,L.EXTERNAL_KEY1,L.EXTERNAL_KEY2,L.REC_DATETIME,L.ISSOFTDELETED
FROM  $(NF_SCHEMA).LAB_RESOURCE L
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=L.PROJECT_ID
JOIN  $(NF_SCHEMA).RESOURCE_GROUP R
ON R.RESOURCE_GROUP_ID=L.RESOURCE_GROUP_ID)
GO
CREATE VIEW $(STAR_SCHEMA).VW_RESOURCE_GROUP (RESOURCE_GROUP_ID,NAME,REFERENCE_ID,EXTERNAL_ID,IS_EXPIREABLE,START_DATE,EXPIRATION_DATE,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,PROJECT_ID,PROJECT_NAME,REC_DATETIME,ISSOFTDELETED) AS
(SELECT R.RESOURCE_GROUP_ID,R.NAME,R.REFERENCE_ID,R.EXTERNAL_ID,R.IS_EXPIREABLE,R.START_DATE,R.EXPIRATION_DATE,R.URL,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2,R.PROJECT_ID,P.NAME AS PROJECT_NAME,R.REC_DATETIME,R.ISSOFTDELETED
FROM  $(NF_SCHEMA).RESOURCE_GROUP R
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=R.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_RESERVATION (RESERVATION_ID,NAME,REFERENCE_ID,RESERVED_FOR,RESERVED_BY,RESERVE_TO,
RESERVE_FROM,LAB_RESOURCE_ID,LAB_RESOURCE_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,PROJECT_ID,PROJECT_NAME,REC_DATETIME,ISSOFTDELETED) AS
(SELECT R.RESERVATION_ID,R.NAME,R.REFERENCE_ID,R.RESERVED_FOR,R.RESERVED_BY,R.RESERVE_TO,
R.RESERVE_FROM,R.LAB_RESOURCE_ID,L.LAB_RESOURCE_NAME,R.URL,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2,R.PROJECT_ID,P.NAME AS PROJECT_NAME,R.REC_DATETIME,R.ISSOFTDELETED
FROM  $(NF_SCHEMA).RESERVATION R
JOIN  $(NF_SCHEMA).LAB_RESOURCE L
ON L.LAB_RESOURCE_ID=R.LAB_RESOURCE_ID
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=R.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VWCONFIGURATION_CLASSIFICATION(CONFIGURATION_CLASS_ID,NAME) AS (SELECT CONFIGURATION_CLASS_ID,NAME FROM  $(NF_SCHEMA).CONFIGURATION_CLASSIFICATION)
GO
CREATE VIEW $(STAR_SCHEMA).VW_EXECRESULT_CLASSIFICATION (EXECRES_CLASS_ID,NAME) AS (SELECT EXECRES_CLASS_ID,NAME FROM  $(NF_SCHEMA).EXECRESULT_CLASSIFICATION)
GO
CREATE VIEW $(STAR_SCHEMA).VW_EXECWORKITEM_CLASSIFICATION (EXECWORKIT_CLASS_ID,NAME) AS (SELECT EXECWORKIT_CLASS_ID,NAME FROM  $(NF_SCHEMA).EXECWORKITEM_CLASSIFICATION)
GO
CREATE VIEW $(STAR_SCHEMA).VW_TESTCASE_CLASSIFICATION (TESTCASE_CLASS_ID,NAME) AS (SELECT TESTCASE_CLASS_ID,NAME FROM  $(NF_SCHEMA).TESTCASE_CLASSIFICATION)
GO
CREATE VIEW $(STAR_SCHEMA).VW_TESTPLAN_CLASSIFICATION (TESTPLAN_CLASS_ID,NAME) AS (SELECT TESTPLAN_CLASS_ID,NAME FROM  $(NF_SCHEMA).TESTPLAN_CLASSIFICATION)
GO
CREATE VIEW $(STAR_SCHEMA).VW_TESTSUITE_CLASSIFICATION (TESTSUITE_CLASS_ID,NAME) AS (SELECT TESTSUITE_CLASS_ID,NAME FROM  $(NF_SCHEMA).TESTSUITE_CLASSIFICATION)
GO
CREATE VIEW $(STAR_SCHEMA).VW_TESTSUITELOG_CLASSIFICATION (TESTSUITELOG_CLASS_ID,NAME) AS (SELECT TESTSUITELOG_CLASS_ID,NAME FROM  $(NF_SCHEMA).TESTSUITELOG_CLASSIFICATION)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_CATEGORY (REQUEST_CATEGORY_ID, EXTERNAL_ID, REFERENCE_ID, NAME, PROJECT_ID,PROJECT_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT RC.REQUEST_CATEGORY_ID, RC.EXTERNAL_ID, RC.REFERENCE_ID, RC.NAME, RC.PROJECT_ID,P.NAME AS PROJECT_NAME,RC.URL,RC.EXTERNAL_KEY1,RC.EXTERNAL_KEY2,RC.REC_DATETIME,RC.ISSOFTDELETED
 FROM  $(NF_SCHEMA).REQUEST_CATEGORY RC
 JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=RC.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_FILE_CLASSIFICATION (FILE_CLASS_ID,NAME) AS (SELECT FILE_CLASS_ID,NAME FROM  $(NF_SCHEMA).FILE_CLASSIFICATION)
GO
CREATE VIEW $(STAR_SCHEMA).VW_FILE_STREAM_CLASSIFICATION (FILE_STREAM_CLASS_ID,NAME) AS (SELECT FILE_STREAM_CLASS_ID,NAME FROM  $(NF_SCHEMA).FILE_STREAM_CLASSIFICATION)
GO
CREATE VIEW $(STAR_SCHEMA).VW_BUILD_CLASSIFICATION (BUILD_CLASS_ID,NAME) AS (SELECT BUILD_CLASS_ID,NAME FROM  $(NF_SCHEMA).BUILD_CLASSIFICATION)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_CHANGE_HISTORY
(REQCHANGE_HISTORY_ID,REQUEST_CLASS_ID, REQUEST_CLASS_NAME,REQUEST_ID,NAME,PREV_TEAM_ID, TEAM_NAME,
PREV_REQUEST_CATEGORY_ID, PREV_REQUEST_CATEGORY_NAME,PREV_ITERATION_ID, PREV_ITERATION_NAME,PREV_OWNER_ID,PREV_OWNER_NAME,
CHANGE_DATE,PREV_REQUEST_TYPE_ID,PREV_REQUEST_TYPE,PREV_REQUEST_STATE_ID,PREV_REQUEST_STATE,PREV_REQUEST_STATUS_ID,PREV_REQUEST_STATUS,PREV_REQUEST_PRIORITY_ID,PREV_REQUEST_PRIORITY,PREV_REQUEST_SEVERITY_ID,PREV_REQUEST_SEVERITY,PREV_COMMENT_COUNT,PREV_SUBSCRIBER_COUNT,
PREV_TAGS,PREV_PLANNED_WORK,PREV_ACTUAL_WORK,PREV_STORY_POINTS,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,PREV_SUMMARY,REC_DATETIME,ISSOFTDELETED)
AS
(SELECT H.REQCHANGE_HISTORY_ID,H.REQUEST_CLASS_ID,RC.NAME AS REQUEST_CLASS_NAME,H.REQUEST_ID, R.NAME,H.PREV_TEAM_ID,P.NAME AS TEAM_NAME,
H.PREV_REQUEST_CATEGORY_ID, RN.NAME AS PREV_REQUEST_CATEGORY_NAME,
H.PREV_ITERATION_ID,I.NAME AS PREV_ITERATION_NAME,
H.PREV_OWNER_ID, O.FULL_NAME AS PREV_OWNER_NAME,H.CHANGE_DATE,H.PREV_REQUEST_TYPE_ID,RT.NAME AS PREV_REQUEST_TYPE,H.PREV_REQUEST_STATE_ID,PRST.NAME AS PREV_REQUEST_STATE,H.PREV_REQUEST_STATUS_ID,PRSTU.NAME AS PREV_REQUEST_STATUS,
H.PREV_REQUEST_PRIORITY_ID,RP.NAME AS PREV_REQUEST_PRIORITY,H.PREV_REQUEST_SEVERITY_ID,RSEV.NAME AS PREV_REQUEST_SEVERITY,H.PREV_COMMENT_COUNT,H.PREV_SUBSCRIBER_COUNT,H.PREV_TAGS,H.PREV_PLANNED_WORK,
H.PREV_ACTUAL_WORK,H.PREV_STORY_POINTS,H.URL,H.EXTERNAL_KEY1,H.EXTERNAL_KEY2,H.PREV_SUMMARY,H.REC_DATETIME,H.ISSOFTDELETED
FROM  $(NF_SCHEMA).REQUEST_CHANGE_HISTORY H
JOIN  $(NF_SCHEMA).REQUEST R ON R.REQUEST_ID=H.REQUEST_ID
JOIN  $(NF_SCHEMA).REQUEST_CLASSIFICATION RC ON RC.REQUEST_CLASS_ID=H.REQUEST_CLASS_ID
JOIN  $(NF_SCHEMA).TEAM P ON P.TEAM_ID =H.PREV_TEAM_ID
JOIN  $(NF_SCHEMA).REQUEST_CATEGORY RN ON RN.REQUEST_CATEGORY_ID=H.PREV_REQUEST_CATEGORY_ID
JOIN  $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID=H.PREV_ITERATION_ID
JOIN  $(NF_SCHEMA).RESOURCE O ON O.RESOURCE_ID=H.PREV_OWNER_ID
JOIN  $(NF_SCHEMA).REQUEST_TYPE RT ON RT.REQUEST_TYPE_ID=H.PREV_REQUEST_TYPE_ID
JOIN  $(NF_SCHEMA).REQUEST_STATE PRST ON PRST.REQUEST_STATE_ID=H.PREV_REQUEST_STATE_ID
JOIN  $(NF_SCHEMA).REQUEST_STATUS PRSTU ON PRSTU.REQUEST_STATUS_ID=H.PREV_REQUEST_STATUS_ID
JOIN  $(NF_SCHEMA).REQUEST_PRIORITY RP ON RP.REQUEST_PRIORITY_ID=H.PREV_REQUEST_PRIORITY_ID
JOIN  $(NF_SCHEMA).REQUEST_SEVERITY RSEV ON RSEV.REQUEST_SEVERITY_ID=H.PREV_REQUEST_SEVERITY_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_BUILD_COMPILATION_RESULT	(BUILD_COMPRES_ID,BUILD_ID,NAME,COMPONENT_ID,COMPONENT_NAME,COMPILE_ERROR_COUNT,COMPILE_WARNING_COUNT,EXTERNAL_KEY1,EXTERNAL_KEY2,URL,REC_DATETIME,ISSOFTDELETED) AS
SELECT B.BUILD_COMPRES_ID,B.BUILD_ID,BL.NAME,B.COMPONENT_ID,C.NAME AS COMPONENT_NAME,B.COMPILE_ERROR_COUNT,B.COMPILE_WARNING_COUNT,B.EXTERNAL_KEY1,B.EXTERNAL_KEY2,B.URL,B.REC_DATETIME,B.ISSOFTDELETED
FROM  $(NF_SCHEMA).BUILD_COMPILATION_RESULT B
JOIN  $(NF_SCHEMA).COMPONENT C ON C.COMPONENT_ID =B.COMPONENT_ID
JOIN  $(NF_SCHEMA).BUILD BL ON BL.BUILD_ID =B.BUILD_ID
GO

CREATE VIEW $(STAR_SCHEMA).VW_BUILD_UNIT_RESULT	(BUILD_UNITRES_ID,BUILD_ID,NAME,COMPONENT_ID,COMPONENT_NAME,UNIT_TEST_COUNT,UNIT_FAILURE_COUNT,UNIT_ERROR_COUNT,EXTERNAL_KEY1,EXTERNAL_KEY2 ,URL,REC_DATETIME,ISSOFTDELETED)AS
SELECT B.BUILD_UNITRES_ID,B.BUILD_ID,BL.NAME,B.COMPONENT_ID,C.NAME AS COMPONENT_NAME,B.UNIT_TEST_COUNT,B.UNIT_FAILURE_COUNT,B.UNIT_ERROR_COUNT,B.EXTERNAL_KEY1,B.EXTERNAL_KEY2 ,B.URL,B.REC_DATETIME,B.ISSOFTDELETED
FROM  $(NF_SCHEMA).BUILD_UNIT_RESULT B
JOIN  $(NF_SCHEMA).COMPONENT C ON C.COMPONENT_ID =B.COMPONENT_ID
JOIN  $(NF_SCHEMA).BUILD BL ON BL.BUILD_ID =B.BUILD_ID
GO

CREATE VIEW $(STAR_SCHEMA).VW_BUILD_UNIT_EVENT (BUILD_UNIT_EVENT_ID ,BUILD_ID,NAME,COMPONENT_ID,COMPONENT_NAME,UNIT_EVENT,UNIT_TEST,EXTERNAL_KEY1,EXTERNAL_KEY2 ,URL,REC_DATETIME,ISSOFTDELETED) AS
SELECT B.BUILD_UNIT_EVENT_ID ,B.BUILD_ID,BL.NAME,B.COMPONENT_ID,C.NAME AS COMPONENT_NAME,B.UNIT_EVENT,B.UNIT_TEST,B.EXTERNAL_KEY1,B.EXTERNAL_KEY2 ,B.URL,B.REC_DATETIME,B.ISSOFTDELETED
FROM  $(NF_SCHEMA).BUILD_UNIT_EVENT B
JOIN  $(NF_SCHEMA).COMPONENT C ON C.COMPONENT_ID =B.COMPONENT_ID
JOIN  $(NF_SCHEMA).BUILD BL ON BL.BUILD_ID =B.BUILD_ID
GO

CREATE VIEW $(STAR_SCHEMA).VW_UNIT_TEST_RESULT (UNIT_TEST_RESULT_ID ,PROJECT_ID,PROJECT_NAME,TEAM_ID,TEAM_NAME,BUILD_TYPE,COMPONENT_ID,COMPONENT_NAME,UNIT_EVENT,UNIT_TEST,UNIT_COUNT,LAST_RUN_DATE,EXTERNAL_KEY1,EXTERNAL_KEY2 ,URL,REC_DATETIME,ISSOFTDELETED)AS
SELECT B.UNIT_TEST_RESULT_ID ,B.PROJECT_ID,P.NAME AS PROJECT_NAME,B.TEAM_ID,T.NAME AS TEAM_NAME,BUILD_TYPE,B.COMPONENT_ID,C.NAME AS COMPONENT_NAME,B.UNIT_EVENT,B.UNIT_TEST,B.UNIT_COUNT,B.LAST_RUN_DATE,B.EXTERNAL_KEY1,B.EXTERNAL_KEY2 ,B.URL,B.REC_DATETIME,B.ISSOFTDELETED
FROM  $(NF_SCHEMA).UNIT_TEST_RESULT B
JOIN  $(NF_SCHEMA).COMPONENT C ON C.COMPONENT_ID =B.COMPONENT_ID
JOIN  $(NF_SCHEMA).TEAM T ON T.TEAM_ID =B.TEAM_ID
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID =B.PROJECT_ID
GO

CREATE VIEW $(STAR_SCHEMA).VW_RISK (RISK_ID,NAME,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,REQUIREMENT_ID,REQUIREMENT_NAME,PRIORITY,RISK_STATE,OCCURED_DATETIME ,
IMPACT,IMPACT_RANK,PROBABILITY,PROBABILITY_RANK,OWNER_ID,OWNER_NAME,RELEASE_ID,RELEASE_NAME,ITERATION_ID,ITERATION_NAME,TARGET_DATE ,CREATION_DATE ,CLOSE_DATE ,
IMPACT_CATEGORY,CONSEQUENCE_COST,RISK_MANAGEMENT_ACTION,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,PROBABILITY_COST,RISK_SCORE,REC_DATETIME,ISSOFTDELETED) AS
(SELECT R.RISK_ID,R.NAME,R.REFERENCE_ID,R.EXTERNAL_ID,R.PROJECT_ID,P.NAME AS PROJECT_NAME,R.REQUIREMENT_ID,RQ.NAME AS REQUIREMENT_NAME,R.PRIORITY,R.RISK_STATE,R.OCCURED_DATETIME ,R.IMPACT,
R.IMPACT_RANK,R.PROBABILITY,R.PROBABILITY_RANK,R.OWNER_ID,RE.FULL_NAME AS OWNER_NAME,R.RELEASE_ID,RL.NAME AS RELEASE_NAME,R.ITERATION_ID,I.NAME AS ITERATION_NAME,R.TARGET_DATE ,R.CREATION_DATE ,R.CLOSE_DATE ,
R.IMPACT_CATEGORY,R.CONSEQUENCE_COST,R.RISK_MANAGEMENT_ACTION,R.URL,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2,R.PROBABILITY_COST,R.RISK_SCORE,R.REC_DATETIME,R.ISSOFTDELETED
FROM  $(NF_SCHEMA).RISK R
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=R.PROJECT_ID
JOIN  $(NF_SCHEMA).REQUIREMENT RQ ON RQ.REQUIREMENT_ID=R.REQUIREMENT_ID
JOIN  $(NF_SCHEMA).RESOURCE RE ON RE.RESOURCE_ID = R.OWNER_ID
JOIN  $(NF_SCHEMA).RELEASE RL ON RL.RELEASE_ID=R.RELEASE_ID
JOIN  $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID =R.ITERATION_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_JOB (JOB_ID,REFERENCE_ID,EXTERNAL_ID,NAME,OWNER_ID,OWNER_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,URL,PROJECT_ID,PROJECT_NAME,REC_DATETIME,ISSOFTDELETED) AS
(SELECT J.JOB_ID,J.REFERENCE_ID,J.EXTERNAL_ID,J.NAME,J.OWNER_ID,R.FULL_NAME AS OWNER_NAME,J.EXTERNAL_KEY1,J.EXTERNAL_KEY2,J.URL,J.PROJECT_ID,P.NAME AS PROJECT_NAME,J.REC_DATETIME,J.ISSOFTDELETED
FROM  $(NF_SCHEMA).JOB J
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=J.OWNER_ID
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=J.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_JOB_RESULT (JOB_RESULT_ID,REFERENCE_ID,EXTERNAL_ID,NAME,STATE,VERDICT, START_TIME,
END_TIME,DURATION,LAB_RESOURCE_ID,LAB_RESOURCE_NAME,OWNER_ID,OWNER_NAME,JOB_ID,JOB_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT J.JOB_RESULT_ID,J.REFERENCE_ID,J.EXTERNAL_ID,J.NAME,J.STATE,J.VERDICT, J.START_TIME,
J.END_TIME,J.DURATION,J.LAB_RESOURCE_ID,L.NAME AS LAB_RESOURCE_NAME,J.OWNER_ID,R.FULL_NAME AS OWNER_NAME,J.JOB_ID,JB.NAME AS JOB_NAME,
J.EXTERNAL_KEY1,J.EXTERNAL_KEY2,J.SOURCE_ID,J.URL,J.REC_DATETIME,J.ISSOFTDELETED
FROM  $(NF_SCHEMA).JOB_RESULT J
JOIN  $(NF_SCHEMA).JOB JB ON JB.JOB_ID=J.JOB_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=J.OWNER_ID
JOIN  $(NF_SCHEMA).LAB_RESOURCE L ON L.LAB_RESOURCE_ID=J.LAB_RESOURCE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ACTIVITY_STATE_HISTORY (ACTIVITY_STATE_HISTORY_ID,ACTIVITY_ID,PREV_ACTIVITY_STATE,ACTIVITY_STATE,
CHANGE_DATE,DAYS_IN_STATE,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
(SELECT ACTIVITY_STATE_HISTORY_ID,ACTIVITY_ID,PREV_ACTIVITY_STATE,ACTIVITY_STATE,
CHANGE_DATE,DAYS_IN_STATE,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED
FROM  $(NF_SCHEMA).ACTIVITY_STATE_HISTORY)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TASK_STATE_HISTORY (TASK_STATE_HISTORY_ID,TASK_ID,PREV_TASK_STATE,TASK_STATE,
CHANGE_DATE,DAYS_IN_STATE,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
(SELECT TASK_STATE_HISTORY_ID,TASK_ID,PREV_TASK_STATE,TASK_STATE,
CHANGE_DATE,DAYS_IN_STATE,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED
FROM  $(NF_SCHEMA).TASK_STATE_HISTORY)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTSCRIPT (TESTSCRIPT_ID, REFERENCE_ID, EXTERNAL_ID, NAME, LAST_UPDATED, TESTSCRIPT_STATE, TYPE, OWNER_ID,OWNER_NAME, PROJECT_ID, PROJECT_NAME, EXTERNAL_KEY1, EXTERNAL_KEY2, SOURCE_ID, URL, REC_DATETIME, ISSOFTDELETED,
TESTSCRIPT_STATE_ID,TESTSCRIPT_STATE_EXTERNAL_ID,TESTSCRIPT_STATE_REFERENCE_ID,TEST_STATUS_ID,TEST_STATUS_NAME,TEST_STATUS_EXTERNAL_ID,TEST_STATUS_REFERENCE_ID,CREATION_DATE) AS
 (SELECT TEST.TESTSCRIPT_ID, TEST.REFERENCE_ID, TEST.EXTERNAL_ID, TEST.NAME, TEST.LAST_UPDATED, TS.NAME AS TESTSCRIPT_STATE, TEST.TYPE, TEST.OWNER_ID, R.NAME AS OWNER_NAME, TEST.PROJECT_ID, P.NAME AS PROJECT_NAME,TEST.EXTERNAL_KEY1, TEST.EXTERNAL_KEY2, TEST.SOURCE_ID, TEST.URL, TEST.REC_DATETIME, TEST.ISSOFTDELETED,
TEST.TESTSCRIPT_STATE_ID,TS.EXTERNAL_ID AS TESTSCRIPT_STATE_EXTERNAL_ID,TS.REFERENCE_ID AS TESTSCRIPT_STATE_REFERENCE_ID,TS.TEST_STATUS_ID,TU.NAME AS TEST_STATUS_NAME,TU.EXTERNAL_ID AS TEST_STATUS_EXTERNAL_ID,TU.REFERENCE_ID AS TEST_STATUS_REFERENCE_ID,TEST.CREATION_DATE
FROM  $(NF_SCHEMA).TESTSCRIPT TEST
 JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID = TEST.OWNER_ID
 JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID = TEST.PROJECT_ID
 JOIN  $(NF_SCHEMA).TESTSCRIPT_STATE TS ON TS.TESTSCRIPT_STATE_ID=TEST.TESTSCRIPT_STATE_ID
JOIN  $(NF_SCHEMA).TEST_STATUS TU ON TU.TEST_STATUS_ID=TS.TEST_STATUS_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTCASE_TESTSCRIPT_LOOKUP (TESTSCRIPT_ID, TESTSCRIPT_NAME, TESTCASE_ID, TESTCASE_NAME) AS
 (SELECT  RT.TESTSCRIPT_ID, I.NAME AS TESTSCRIPT_NAME, RT.TESTCASE_ID, T.NAME AS TESTCASE_NAME FROM  $(NF_SCHEMA).TESTCASE_TESTSCRIPT_LOOKUP RT JOIN  $(NF_SCHEMA).TESTSCRIPT I ON I.TESTSCRIPT_ID=RT.TESTSCRIPT_ID JOIN  $(NF_SCHEMA).TESTCASE T ON T.TESTCASE_ID=RT.TESTCASE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ITERATION_DETAIL (ITERATION_ID,ITERATION_NAME,ACTUAL_DURATION,ACTUAL_WORK,ACTUAL_WORK_VARIANCE,ACTUAL_START_VARIANCE,ACTUAL_FINISH_VARIANCE,ACTUAL_START,ACTUAL_FINISH,
ACTUAL_COST,ACTUAL_COST_VARIANCE,BASELINE_DURATION,BASELINE_WORK,BASELINE_WORK_VARIANCE,BASELINE_FINISH_VARIANCE,BASELINE_START_VARIANCE,
BASELINE_COST_VARIANCE,BASELINE_START,BASELINE_FINISH,PLANNED_COST,COST_VARIANCE,
PLANNED_DURATION,PLANNED_WORK,WORK_VARIANCE,START_VARIANCE,FINISH_VARIANCE,DURATION_VARIANCE,PLANNED_START,PLANNED_FINISH,PERCENT_COMPLETE,PERCENT_WORK_COMPLETE) AS
(SELECT I.ITERATION_ID,IT.NAME AS ITERATION_NAME,I.ACTUAL_DURATION,I.ACTUAL_WORK,I.ACTUAL_WORK_VARIANCE,I.ACTUAL_START_VARIANCE,I.ACTUAL_FINISH_VARIANCE,I.ACTUAL_START,I.ACTUAL_FINISH,
I.ACTUAL_COST,I.ACTUAL_COST_VARIANCE,I.BASELINE_DURATION,I.BASELINE_WORK,I.BASELINE_WORK_VARIANCE,I.BASELINE_FINISH_VARIANCE,I.BASELINE_START_VARIANCE,
I.BASELINE_COST_VARIANCE,I.BASELINE_START,I.BASELINE_FINISH,I.PLANNED_COST,I.COST_VARIANCE,
I.PLANNED_DURATION,I.PLANNED_WORK,I.WORK_VARIANCE,I.START_VARIANCE,I.FINISH_VARIANCE,I.DURATION_VARIANCE,I.PLANNED_START,I.PLANNED_FINISH,I.PERCENT_COMPLETE,I.PERCENT_WORK_COMPLETE
FROM  $(NF_SCHEMA).ITERATION_DETAIL I
JOIN  $(NF_SCHEMA).ITERATION IT ON IT.ITERATION_ID=I.ITERATION_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROGRAM (PROGRAM_ID,NAME,REFERENCE_ID,EXTERNAL_ID,PROGRAM_MANAGER_ID,PROGRAM_MANAGER,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED,SOURCE_ID) AS
(SELECT PR.PROGRAM_ID,PR.NAME,PR.REFERENCE_ID,PR.EXTERNAL_ID,PR.PROGRAM_MANAGER AS PROGRAM_MANAGER_ID,R.FULL_NAME AS PROGRAM_MANAGER,PR.URL,PR.EXTERNAL_KEY1,PR.EXTERNAL_KEY2,PR.REC_DATETIME,PR.ISSOFTDELETED,PR.SOURCE_ID
FROM  $(NF_SCHEMA).PROGRAM PR
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=PR.PROGRAM_MANAGER)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROGRAM_DETAIL (PROGRAM_ID, PROGRAM_NAME,CURRENCY_ID,CURRENCY,ACTUAL_BUDGET,CURRENT_BUDGET,PLANNED_BUDGET,ACTUAL_VARIANCE,PLANNED_START,PLANNED_FINISH,ACWP,BAC, BCWP,BCWS,EAC, EV_ETC,EV_FLAG, ACTUAL_DURATION,ACTUAL_WORK,ACTUAL_WORK_VARIANCE,ACTUAL_START_VARIANCE,ACTUAL_FINISH_VARIANCE,ACTUAL_COST,ACTUAL_START, ACTUAL_FINISH,ACTUAL_COST_VARIANCE,PLANNED_COST, COST_VARIANCE,PLANNED_DURATION, PLANNED_WORK, WORK_VARIANCE,START_VARIANCE,FINISH_VARIANCE,DURATION_VARIANCE,PERCENT_COMPLETE,PERCENT_WORK_COMPLETE,BUDGETED_REVENUE,PLANNED_REVENUE,ACTUAL_REVENUE,BUDGETED_COST,NET_PRESENT_VALUE,INTERNAL_RATE_OF_RETURN) AS
(SELECT PR.PROGRAM_ID,P.NAME AS PROGRAM_NAME,PR.CURRENCY_ID,C.NAME AS CURRENCY,PR.ACTUAL_BUDGET,PR.CURRENT_BUDGET,PR.PLANNED_BUDGET,PR.ACTUAL_VARIANCE,PR.PLANNED_START,PR.PLANNED_FINISH,PR.ACWP,PR.BAC,PR.BCWP,PR.BCWS,PR.EAC,PR.EV_ETC,PR.EV_FLAG,PR.ACTUAL_DURATION,PR.ACTUAL_WORK,PR.ACTUAL_WORK_VARIANCE,PR.ACTUAL_START_VARIANCE,PR.ACTUAL_FINISH_VARIANCE,PR.ACTUAL_COST,PR.ACTUAL_START,PR.ACTUAL_FINISH,PR.ACTUAL_COST_VARIANCE,PR.PLANNED_COST,PR.COST_VARIANCE,PR.PLANNED_DURATION,PR.PLANNED_WORK,PR.WORK_VARIANCE,PR.START_VARIANCE,PR.FINISH_VARIANCE,PR.DURATION_VARIANCE,PR.PERCENT_COMPLETE,PR.PERCENT_WORK_COMPLETE,PR.BUDGETED_REVENUE,PR.PLANNED_REVENUE,PR.ACTUAL_REVENUE,PR.BUDGETED_COST,PR.NET_PRESENT_VALUE,PR.INTERNAL_RATE_OF_RETURN
FROM  $(NF_SCHEMA).PROGRAM_DETAIL PR
JOIN  $(NF_SCHEMA).PROGRAM P ON P.PROGRAM_ID=PR.PROGRAM_ID
JOIN  $(NF_SCHEMA).CURRENCY C ON C.CURRENCY_ID=PR.CURRENCY_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ITERATION_BASELINE (BASELINE_ID, EXTERNAL_ID, NAME, ITERATION_ID, REFERENCE_ID, URL, BASELINE_DATE, PLANNED_START, PLANNED_FINISH, PLANNED_WORK, BASELINE_WORK_COMPLETED, PLANNED_COST, BASELINE_COST_COMPLETED, PLANNED_DURATION, EXTERNAL_KEY1, EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT P.BASELINE_ID, P.EXTERNAL_ID, P.NAME, P.ITERATION_ID, P.REFERENCE_ID, P.URL, P.BASELINE_DATE, P.PLANNED_START, P.PLANNED_FINISH, P.PLANNED_WORK,P.BASELINE_WORK_COMPLETED,P.PLANNED_COST, P.BASELINE_COST_COMPLETED, P.PLANNED_DURATION, P.EXTERNAL_KEY1,P.EXTERNAL_KEY2,P.REC_DATETIME,P.ISSOFTDELETED FROM  $(NF_SCHEMA).ITERATION_BASELINE P)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJECT_ALLOCATION(PROJECT_ALLOCATION_ID,NAME,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,OWNER_ID,OWNER_NAME,PLANNED_START,PLANNED_FINISH,ACTUAL_START,ACTUAL_FINISH,PLANNED_WORK,ACTUAL_WORK,PLANNED_DURATION,ACTUAL_DURATION,PERCENT_COMPLETE,PERCENT_WORK_COMPLETE,ALLOTED_WORK,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED,PROFILE_ID,PROFILE_NAME,UNITS,SUNDAY_UNITS,MONDAY_UNITS,TUESDAY_UNITS,WEDNESDAY_UNITS,THURSDAY_UNITS,FRIDAY_UNITS,SATURDAY_UNITS) AS
(SELECT PA.PROJECT_ALLOCATION_ID,PA.NAME,PA.REFERENCE_ID,PA.EXTERNAL_ID,PA.PROJECT_ID,P.NAME AS PROJECT_NAME,PA.OWNER_ID,R.FULL_NAME AS OWNER_NAME,PA.PLANNED_START,PA.PLANNED_FINISH,PA.ACTUAL_START,PA.ACTUAL_FINISH,PA.PLANNED_WORK,PA.ACTUAL_WORK,PA.PLANNED_DURATION,PA.ACTUAL_DURATION,PA.PERCENT_COMPLETE,PA.PERCENT_WORK_COMPLETE,PA.ALLOTED_WORK,PA.URL,PA.EXTERNAL_KEY1,PA.EXTERNAL_KEY2,PA.SOURCE_ID,PA.REC_DATETIME,PA.ISSOFTDELETED,PA.PROFILE_ID,PF.NAME AS PROFILE_NAME,PA.UNITS,PA.SUNDAY_UNITS,PA.MONDAY_UNITS,PA.TUESDAY_UNITS,PA.WEDNESDAY_UNITS,PA.THURSDAY_UNITS,PA.FRIDAY_UNITS,PA.SATURDAY_UNITS
FROM  $(NF_SCHEMA).PROJECT_ALLOCATION PA
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID =PA.PROJECT_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=PA.OWNER_ID
JOIN  $(NF_SCHEMA).PROFILE PF ON PF.PROFILE_ID=PA.PROFILE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_SKILL (EXTERNAL_ID, NAME, SKILL_ID, REFERENCE_ID, URL, EXTERNAL_KEY1, EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT EXTERNAL_ID,NAME,SKILL_ID,REFERENCE_ID,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED FROM  $(NF_SCHEMA).SKILL)
GO

CREATE VIEW $(STAR_SCHEMA).VW_RESOURCE_SKILL_LOOKUP (SKILL_ID, SKILL_NAME, RESOURCE_ID, RESOURCE_NAME) AS
 ( SELECT  RS.SKILL_ID, S.NAME AS SKILL_NAME, RS.RESOURCE_ID, R.NAME AS RESOURCE_NAME FROM  $(NF_SCHEMA).RESOURCE_SKILL_LOOKUP RS JOIN  $(NF_SCHEMA).SKILL S ON RS.SKILL_ID=S.SKILL_ID JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=RS.RESOURCE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_COMPETENCY (EXTERNAL_ID, NAME, COMPETENCY_ID, REFERENCE_ID, URL, EXTERNAL_KEY1, EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT EXTERNAL_ID,NAME,COMPETENCY_ID,REFERENCE_ID,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED FROM  $(NF_SCHEMA).COMPETENCY)
GO

CREATE VIEW $(STAR_SCHEMA).VW_RESOURCE_COMPETENCY_LOOKUP (COMPETENCY_ID, COMPETENCY_NAME, RESOURCE_ID, RESOURCE_NAME) AS
 ( SELECT  RS.COMPETENCY_ID, S.NAME AS COMPETENCY_NAME, RS.RESOURCE_ID, R.NAME AS RESOURCE_NAME FROM  $(NF_SCHEMA).RESOURCE_COMPETENCY_LOOKUP RS JOIN  $(NF_SCHEMA).COMPETENCY S ON RS.COMPETENCY_ID=S.COMPETENCY_ID JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=RS.RESOURCE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TIMESHEET (TIMESHEET_ID,TIMESHEET_REPORTING_WEEK,REFERENCE_ID,EXTERNAL_ID,ACTIVITY_ID,ACTIVITY_NAME,ADDITIONAL_WORK,BILLABLE_HOURS,NON_BILLABLE_HOURS,APPROVER_ID,APPROVER_NAME,TIMESHEET_STATE,
PERCENT_COMPLETE,LAST_APPROVAL_DATE,REGULAR_TIME,OVERTIME,MONDAY_DATE,TUESDAY_DATE,WEDNESDAY_DATE,THURSDAY_DATE,FRIDAY_DATE,SATURDAY_DATE,SUNDAY_DATE,MONDAY_REGULAR_TIME,TUESDAY_REGULAR_TIME,WEDNESDAY_REGULAR_TIME,
THURSDAY_REGULAR_TIME,FRIDAY_REGULAR_TIME,SATURDAY_REGULAR_TIME,SUNDAY_REGULAR_TIME,MONDAY_OVT,TUESDAY_OVT,WEDNESDAY_OVT,THURSDAY_OVT,FRIDAY_OVT,SATURDAY_OVT,SUNDAY_OVT,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED) AS
(SELECT TIMESHEET_ID,T.TIMESHEET_REPORTING_WEEK,T.REFERENCE_ID,T.EXTERNAL_ID,T.ACTIVITY_ID,A.NAME AS ACTIVITY_NAME,T.ADDITIONAL_WORK,T.BILLABLE_HOURS,T.NON_BILLABLE_HOURS,T.APPROVER_ID,R.FULL_NAME AS APPROVER_NAME,T.TIMESHEET_STATE,
T.PERCENT_COMPLETE,T.LAST_APPROVAL_DATE,T.REGULAR_TIME,T.OVERTIME,T.MONDAY_DATE,T.TUESDAY_DATE,T.WEDNESDAY_DATE,T.THURSDAY_DATE,T.FRIDAY_DATE,T.SATURDAY_DATE,T.SUNDAY_DATE,T.MONDAY_REGULAR_TIME,T.TUESDAY_REGULAR_TIME,T.WEDNESDAY_REGULAR_TIME,
T.THURSDAY_REGULAR_TIME,T.FRIDAY_REGULAR_TIME,T.SATURDAY_REGULAR_TIME,T.SUNDAY_REGULAR_TIME,T.MONDAY_OVT,T.TUESDAY_OVT,T.WEDNESDAY_OVT,T.THURSDAY_OVT,T.FRIDAY_OVT,T.SATURDAY_OVT,T.SUNDAY_OVT,T.URL,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.SOURCE_ID,T.REC_DATETIME,T.ISSOFTDELETED
FROM  $(NF_SCHEMA).TIMESHEET T
JOIN  $(NF_SCHEMA).ACTIVITY A ON A.ACTIVITY_ID=T.ACTIVITY_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=T.APPROVER_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROFILE (PROFILE_ID, NAME, REFERENCE_ID, EXTERNAL_ID, RATE, EXPERIENCE_IN_MONTHS, URL, EXTERNAL_KEY1, EXTERNAL_KEY2,CITY_ID,CITY_NAME,ORGANIZATION_ID,ORGANIZATION_NAME,REC_DATETIME,ISSOFTDELETED) AS
 ( SELECT P.PROFILE_ID, P.NAME, P.REFERENCE_ID, P.EXTERNAL_ID, P.RATE,  P.EXPERIENCE_IN_MONTHS, P.URL, P.EXTERNAL_KEY1, P.EXTERNAL_KEY2,P.CITY_ID,C.NAME AS CITY_NAME,P.ORGANIZATION_ID,O.NAME AS ORGANIZATION_NAME,P.REC_DATETIME,P.ISSOFTDELETED
  FROM  $(NF_SCHEMA).PROFILE P
  JOIN  $(NF_SCHEMA).CITY C ON C.CITY_ID=P.CITY_ID
  JOIN  $(NF_SCHEMA).ORGANIZATION O ON O.ORGANIZATION_ID=P.ORGANIZATION_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROFILE_SKILL_LOOKUP (SKILL_ID, SKILL_NAME, PROFILE_ID, PROFILE_NAME) AS
 ( SELECT  PS.SKILL_ID, S.NAME AS SKILL_NAME, PS.PROFILE_ID, P.NAME AS PROFILE_NAME FROM  $(NF_SCHEMA).PROFILE_SKILL_LOOKUP PS JOIN  $(NF_SCHEMA).SKILL S ON PS.SKILL_ID=S.SKILL_ID JOIN  $(NF_SCHEMA).PROFILE P ON P.PROFILE_ID=PS.PROFILE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROFILE_COMPETENCY_LOOKUP (COMPETENCY_ID, COMPETENCY_NAME, PROFILE_ID, PROFILE_NAME) AS
 ( SELECT  PC.COMPETENCY_ID, C.NAME AS COMPETENCY_NAME, PC.PROFILE_ID, P.NAME AS PROFILE_NAME FROM  $(NF_SCHEMA).PROFILE_COMPETENCY_LOOKUP PC JOIN  $(NF_SCHEMA).COMPETENCY C ON PC.COMPETENCY_ID=C.COMPETENCY_ID JOIN  $(NF_SCHEMA).PROFILE P ON P.PROFILE_ID=PC.PROFILE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TIMECODE (TIMECODE_ID,REFERENCE_ID,EXTERNAL_ID,NAME,PARENT_TIMECODE_ID,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT TIMECODE_ID,REFERENCE_ID,EXTERNAL_ID,NAME,PARENT_TIMECODE_ID,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED
FROM  $(NF_SCHEMA).TIMECODE)
GO

CREATE VIEW $(STAR_SCHEMA).VW_CHARGECODE (CHARGECODE_ID,REFERENCE_ID,EXTERNAL_ID,NAME,PARENT_CHARGECODE_ID,CHARGECODE_STATE,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT CHARGECODE_ID,REFERENCE_ID,EXTERNAL_ID,NAME,PARENT_CHARGECODE_ID,CHARGECODE_STATE,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED
FROM $(NF_SCHEMA).CHARGECODE)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TIMESHEET_TIMECODE_LOOKUP (TIMESHEET_ID, TIMESHEET_REPORTING_WEEK, TIMECODE_ID, NAME) AS
 (SELECT T.TIMESHEET_ID, TS.TIMESHEET_REPORTING_WEEK, T.TIMECODE_ID, TC.NAME FROM  $(NF_SCHEMA).TIMESHEET_TIMECODE_LOOKUP T JOIN  $(NF_SCHEMA).TIMESHEET TS ON T.TIMESHEET_ID = TS.TIMESHEET_ID JOIN  $(NF_SCHEMA).TIMECODE TC ON T.TIMECODE_ID = TC.TIMECODE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_OPERATING_TERRITORY (TERRITORY_ID,REFERENCE_ID,EXTERNAL_ID,NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT TERRITORY_ID,REFERENCE_ID,EXTERNAL_ID,NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED
FROM  $(NF_SCHEMA).OPERATING_TERRITORY)
GO

CREATE VIEW $(STAR_SCHEMA).VW_COUNTRY(COUNTRY_ID,REFERENCE_ID,EXTERNAL_ID,NAME,TERRITORY_ID,TERRITORY_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT C.COUNTRY_ID,C.REFERENCE_ID,C.EXTERNAL_ID,C.NAME,C.TERRITORY_ID,T.NAME AS TERRITORY_NAME,C.EXTERNAL_KEY1,C.EXTERNAL_KEY2,C.SOURCE_ID,C.URL,C.REC_DATETIME,C.ISSOFTDELETED
FROM  $(NF_SCHEMA).COUNTRY C
JOIN  $(NF_SCHEMA).OPERATING_TERRITORY T ON T.TERRITORY_ID=C.TERRITORY_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROVINCE_STATE (PROVINCE_STATE_ID,REFERENCE_ID,EXTERNAL_ID,NAME,COUNTRY_ID,COUNTRY_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT P.PROVINCE_STATE_ID,P.REFERENCE_ID,P.EXTERNAL_ID,P.NAME,P.COUNTRY_ID,C.NAME AS COUNTRY_NAME,P.EXTERNAL_KEY1,P.EXTERNAL_KEY2,P.SOURCE_ID,P.URL,P.REC_DATETIME,P.ISSOFTDELETED
FROM  $(NF_SCHEMA).PROVINCE_STATE P
JOIN  $(NF_SCHEMA).COUNTRY C ON C.COUNTRY_ID=P.COUNTRY_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_CITY (CITY_ID,REFERENCE_ID,EXTERNAL_ID,NAME,PROVINCE_STATE_ID,PROVINCE_STATE_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT C.CITY_ID,C.REFERENCE_ID,C.EXTERNAL_ID,C.NAME,C.PROVINCE_STATE_ID,P.NAME AS PROVINCE_STATE_NAME,
C.EXTERNAL_KEY1,C.EXTERNAL_KEY2,C.SOURCE_ID,C.URL,C.REC_DATETIME,C.ISSOFTDELETED
FROM  $(NF_SCHEMA).CITY C
JOIN  $(NF_SCHEMA).PROVINCE_STATE P ON P.PROVINCE_STATE_ID=C.PROVINCE_STATE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ORGANIZATION(ORGANIZATION_ID,REFERENCE_ID,EXTERNAL_ID,
NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT ORGANIZATION_ID,REFERENCE_ID,EXTERNAL_ID,NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED
FROM  $(NF_SCHEMA).ORGANIZATION)
GO

 CREATE VIEW $(STAR_SCHEMA).VW_PORTFOLIO (PORTFOLIO_ID,REFERENCE_ID,EXTERNAL_ID,NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME, ISSOFTDELETED) AS
 (SELECT PORTFOLIO_ID,REFERENCE_ID,EXTERNAL_ID,NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME, ISSOFTDELETED
 FROM  $(NF_SCHEMA).PORTFOLIO)
GO

 CREATE VIEW $(STAR_SCHEMA).VW_PORTFOLIO_PROG_PROJ_LOOKUP (PORTFOLIO_ID,PORTFOLIO_NAME,PROGRAM_ID,PROGRAM_NAME,PROJECT_ID,PROJECT_NAME) AS
 (SELECT P.PORTFOLIO_ID,PR.NAME AS PORTFOLIO_NAME,P.PROGRAM_ID,PG.NAME AS PROGRAM_NAME,P.PROJECT_ID,PJ.NAME AS PROJECT_NAME
 FROM  $(NF_SCHEMA).PORTFOLIO_PROG_PROJ_LOOKUP P
 JOIN  $(NF_SCHEMA).PORTFOLIO PR ON PR.PORTFOLIO_ID=P.PORTFOLIO_ID
 JOIN  $(NF_SCHEMA).PROGRAM PG ON PG.PROGRAM_ID=P.PROGRAM_ID
 JOIN  $(NF_SCHEMA).PROJECT PJ ON PJ.PROJECT_ID=P.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_TESTCASE_LOOKUP (REQUEST_ID, REQUEST_NAME, TESTCASE_ID, TESTCASE_NAME, LINK_TYPE) AS
(SELECT RT.REQUEST_ID, R.NAME AS REQUEST_NAME,RT.TESTCASE_ID, TC.NAME AS TESTCASE_NAME, RT.LINK_TYPE
FROM  $(NF_SCHEMA).REQUEST_TESTCASE_LOOKUP RT
JOIN  $(NF_SCHEMA).REQUEST R ON R.REQUEST_ID =RT.REQUEST_ID
JOIN  $(NF_SCHEMA).TESTCASE TC ON TC.TESTCASE_ID=RT.TESTCASE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_RISK_STATE_HISTORY (RISK_STATE_HISTORY_ID,RISK_ID,RISK_NAME,PREV_RISK_STATE,RISK_STATE,CHANGE_DATE,DAYS_IN_STATE,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED) AS
(SELECT RH.RISK_STATE_HISTORY_ID, RH.RISK_ID, R.NAME AS RISK_NAME,  RH.PREV_RISK_STATE, RH.RISK_STATE, RH.CHANGE_DATE, RH.DAYS_IN_STATE, RH.EXTERNAL_KEY1, RH.EXTERNAL_KEY2, RH.SOURCE_ID, RH.REC_DATETIME, RH.ISSOFTDELETED
FROM  $(NF_SCHEMA).RISK_STATE_HISTORY RH
JOIN  $(NF_SCHEMA).RISK R ON R.RISK_ID=RH.RISK_ID)
GO

 CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_STATE (
 REQUEST_STATE_ID,NAME ,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED) AS
(SELECT R.REQUEST_STATE_ID,R.NAME,R.REFERENCE_ID,R.EXTERNAL_ID,R.PROJECT_ID,P.NAME AS PROJECT_NAME,R.URL,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2,R.SOURCE_ID,R.REC_DATETIME,R.ISSOFTDELETED
FROM  $(NF_SCHEMA).REQUEST_STATE R
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=R.PROJECT_ID)
GO

 CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_STATUS (
 REQUEST_STATUS_ID,NAME ,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED) AS
(SELECT R.REQUEST_STATUS_ID,R.NAME,R.REFERENCE_ID,R.EXTERNAL_ID,R.PROJECT_ID,P.NAME AS PROJECT_NAME,R.URL,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2,R.SOURCE_ID,R.REC_DATETIME,R.ISSOFTDELETED
FROM  $(NF_SCHEMA).REQUEST_STATUS R
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=R.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TEAM_ROLE (TEAM_ROLE_ID, NAME, REFERENCE_ID, EXTERNAL_ID, TEAM_ID, TEAM_NAME, OWNER_ID, MANAGER_NAME, URL,EXTERNAL_KEY1,EXTERNAL_KEY2,REC_DATETIME,ISSOFTDELETED) AS
 (SELECT PR.TEAM_ROLE_ID, PR.NAME, PR.REFERENCE_ID, PR.EXTERNAL_ID, PR.TEAM_ID, P.NAME AS TEAM_NAME, PR.OWNER_ID,R.FULL_NAME AS MANAGER_NAME, PR.URL,PR.EXTERNAL_KEY1,PR.EXTERNAL_KEY2,PR.REC_DATETIME,PR.ISSOFTDELETED
 FROM  $(NF_SCHEMA).TEAM_ROLE PR JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=PR.OWNER_ID JOIN  $(NF_SCHEMA).TEAM P ON P.TEAM_ID=PR.TEAM_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_LINK (PRED_REQUEST_ID,PRED_REQUEST_NAME,SUCC_REQUEST_ID,SUCC_REQUEST_NAME,LINK_TYPE) AS
(SELECT RC.PRED_REQUEST_ID,C.NAME AS PRED_REQUEST_NAME,RC.SUCC_REQUEST_ID,P.NAME AS SUCC_REQUEST_NAME,RC.LINK_TYPE
FROM  $(NF_SCHEMA).REQUEST_LINK RC
JOIN  $(NF_SCHEMA).REQUEST C ON C.REQUEST_ID=RC.PRED_REQUEST_ID
JOIN  $(NF_SCHEMA).REQUEST P ON P.REQUEST_ID=RC.SUCC_REQUEST_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_PRIORITY (
REQUEST_PRIORITY_ID,NAME ,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED) AS
(SELECT R.REQUEST_PRIORITY_ID,R.NAME,R.REFERENCE_ID,R.EXTERNAL_ID,R.PROJECT_ID,P.NAME AS PROJECT_NAME,R.URL,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2,R.SOURCE_ID,R.REC_DATETIME,R.ISSOFTDELETED
FROM  $(NF_SCHEMA).REQUEST_PRIORITY R
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=R.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_SEVERITY (
REQUEST_SEVERITY_ID,NAME ,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED) AS
(SELECT R.REQUEST_SEVERITY_ID,R.NAME,R.REFERENCE_ID,R.EXTERNAL_ID,R.PROJECT_ID,P.NAME AS PROJECT_NAME,R.URL,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2,R.SOURCE_ID,R.REC_DATETIME,R.ISSOFTDELETED
FROM  $(NF_SCHEMA).REQUEST_SEVERITY R
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=R.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_RESOLUTION (
REQUEST_RESOLUTION_ID,NAME ,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED) AS
(SELECT R.REQUEST_RESOLUTION_ID,R.NAME,R.REFERENCE_ID,R.EXTERNAL_ID,R.PROJECT_ID,P.NAME AS PROJECT_NAME,R.URL,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2,R.SOURCE_ID,R.REC_DATETIME,R.ISSOFTDELETED
FROM  $(NF_SCHEMA).REQUEST_RESOLUTION R
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=R.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_TYPE (
REQUEST_TYPE_ID,NAME ,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED) AS
(SELECT R.REQUEST_TYPE_ID,R.NAME,R.REFERENCE_ID,R.EXTERNAL_ID,R.PROJECT_ID,P.NAME AS PROJECT_NAME,R.URL,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2,R.SOURCE_ID,R.REC_DATETIME,R.ISSOFTDELETED
FROM  $(NF_SCHEMA).REQUEST_TYPE R
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=R.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ACTION_TYPE (ACTION_TYPE_ID,REFERENCE_ID,EXTERNAL_ID,NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT ACTION_TYPE_ID,REFERENCE_ID,EXTERNAL_ID,NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED
FROM  $(RIASSET).ACTION_TYPE)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ASSET_TYPE (ASSET_TYPE_ID, REFERENCE_ID,EXTERNAL_ID,NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT ASSET_TYPE_ID,REFERENCE_ID,EXTERNAL_ID,NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED
FROM  $(RIASSET).ASSET_TYPE)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ASSET (ASSET_ID, REFERENCE_ID,EXTERNAL_ID,NAME,PROJECT_ID,PROJECT_NAME,ASSET_TYPE_ID,ASSET_TYPE_NAME,VERSION,ASSET_STATE,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED,LAST_MODIFIED) AS
(SELECT A.ASSET_ID,A.REFERENCE_ID,A.EXTERNAL_ID,A.NAME,A.PROJECT_ID,P.NAME AS PROJECT_NAME,A.ASSET_TYPE_ID,AA.NAME AS ASSET_TYPE_NAME,A.VERSION,A.ASSET_STATE,A.EXTERNAL_KEY1,A.EXTERNAL_KEY2,A.SOURCE_ID,A.URL,A.REC_DATETIME,A.ISSOFTDELETED,A.LAST_MODIFIED
FROM  $(RIASSET).ASSET A
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=A.PROJECT_ID
JOIN  $(RIASSET).ASSET_TYPE AA ON AA.ASSET_TYPE_ID=A.ASSET_TYPE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ASSET_HISTORY (HISTORY_ID,ASSET_ID,ASSET_NAME,ACTION_TYPE_ID,ACTION_TYPE_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED,RESOURCE_ID,RESOURCE_NAME,ACTION_DATE) AS
(SELECT H.HISTORY_ID,H.ASSET_ID,A.NAME AS ASSET_NAME,H.ACTION_TYPE_ID,AC.NAME AS ACTION_TYPE_NAME,H.EXTERNAL_KEY1,H.EXTERNAL_KEY2,H.SOURCE_ID,H.URL,H.REC_DATETIME,H.ISSOFTDELETED,H.RESOURCE_ID,R.FULL_NAME AS RESOURCE_NAME,H.ACTION_DATE
FROM  $(RIASSET).ASSET_HISTORY H
JOIN  $(RIASSET).ASSET A ON A.ASSET_ID=H.ASSET_ID
JOIN  $(RIASSET).ACTION_TYPE AC ON AC.ACTION_TYPE_ID=H.ACTION_TYPE_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=H.RESOURCE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ASSET_LOOKUP (PRED_ASSET_ID,PRED_ASSET_NAME,SUCC_ASSET_ID,SUCC_ASSET_NAME,LINK_TYPE) AS
(SELECT A.PRED_ASSET_ID,P.NAME AS PRED_ASSET_NAME,A.SUCC_ASSET_ID,S.NAME AS SUCC_ASSET_NAME,A.LINK_TYPE
FROM  $(RIASSET).ASSET_LOOKUP A
JOIN  $(RIASSET).ASSET P ON P.ASSET_ID=A.PRED_ASSET_ID
JOIN  $(RIASSET).ASSET S ON S.ASSET_ID=A.SUCC_ASSET_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ASSET_REQUEST_LOOKUP (ASSET_ID,ASSET_NAME,REQUEST_ID,REQUEST_NAME,LINK_TYPE) AS
(SELECT A.ASSET_ID,AST.NAME AS ASSET_NAME,A.REQUEST_ID,R.NAME AS REQUEST_NAME,A.LINK_TYPE
FROM  $(RIASSET).ASSET_REQUEST_LOOKUP A
JOIN  $(RIASSET).ASSET AST ON AST.ASSET_ID=A.ASSET_ID
JOIN  $(NF_SCHEMA).REQUEST R ON R.REQUEST_ID=A.REQUEST_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ASSET_REQUIREMENT_LOOKUP (ASSET_ID,ASSET_NAME,REQUIREMENT_ID,REQUIREMENT_NAME,LINK_TYPE) AS
(SELECT A.ASSET_ID,AST.NAME AS ASSET_NAME,A.REQUIREMENT_ID,R.NAME AS REQUIREMENT_NAME,A.LINK_TYPE
FROM  $(RIASSET).ASSET_REQUIREMENT_LOOKUP A
JOIN  $(RIASSET).ASSET AST ON AST.ASSET_ID=A.ASSET_ID
JOIN  $(NF_SCHEMA).REQUIREMENT R ON R.REQUIREMENT_ID=A.REQUIREMENT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ASSET_RESOURCE_LOOKUP (ASSET_ID,ASSET_NAME,OWNER_ID,OWNER_NAME) AS
(SELECT A.ASSET_ID,AST.NAME AS ASSET_NAME,A.OWNER_ID,R.FULL_NAME AS OWNER_NAME
FROM  $(RIASSET).ASSET_RESOURCE_LOOKUP A
JOIN  $(RIASSET).ASSET AST ON AST.ASSET_ID=A.ASSET_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=A.OWNER_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ASSET_ROLE (ASSET_ROLE_ID,REFERENCE_ID,EXTERNAL_ID,NAME,PROJECT_ID,PROJECT_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT A.ASSET_ROLE_ID,A.REFERENCE_ID,A.EXTERNAL_ID,A.NAME,A.PROJECT_ID,P.NAME AS PROJECT_NAME,A.EXTERNAL_KEY1,A.EXTERNAL_KEY2,A.SOURCE_ID,A.URL,A.REC_DATETIME,A.ISSOFTDELETED
FROM  $(RIASSET).ASSET_ROLE A
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=A.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ASSET_ROLE_ASSIGN_HISTORY (HISTORY_ID,ASSET_ROLE_ID,ASSET_ROLE_NAME,PROJECT_ID,PROJECT_NAME,TEAM_ID,TEAM_NAME,ASSIGNEE_ID,ASSIGNEE_NAME,ASSIGNER_ID,ASSIGNER_NAME,ACTION_TYPE_ID,ACTION_TYPE_NAME,ASSIGNMENT_DATE,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT H.HISTORY_ID,H.ASSET_ROLE_ID,AR.NAME AS ASSET_ROLE_NAME,H.PROJECT_ID,P.NAME AS PROJECT_NAME,H.TEAM_ID,T.NAME AS TEAM_NAME,H.ASSIGNEE_ID,R.FULL_NAME AS ASSIGNEE_NAME,H.ASSIGNER_ID,R2.FULL_NAME AS ASSIGNER_NAME,H.ACTION_TYPE_ID,AC.NAME AS ACTION_TYPE_NAME,H.ASSIGNMENT_DATE,H.EXTERNAL_KEY1,H.EXTERNAL_KEY2,H.SOURCE_ID,H.URL,H.REC_DATETIME,H.ISSOFTDELETED
FROM  $(RIASSET).ASSET_ROLE_ASSIGNMENT_HISTORY H
JOIN  $(RIASSET).ASSET_ROLE AR ON AR.ASSET_ROLE_ID=H.ASSET_ROLE_ID
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=H.PROJECT_ID
JOIN  $(NF_SCHEMA).TEAM T ON T.TEAM_ID=H.TEAM_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=H.ASSIGNEE_ID
JOIN  $(NF_SCHEMA).RESOURCE R2 ON R2.RESOURCE_ID=H.ASSIGNER_ID
JOIN  $(RIASSET).ACTION_TYPE AC ON AC.ACTION_TYPE_ID=H.ACTION_TYPE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ASSET_ROLE_ENTITLE_LOOKUP (ASSET_ROLE_ID,ASSET_ROLE_NAME,ENTITLEMENT_ID,ENTITLEMENT_NAME) AS
(SELECT A.ASSET_ROLE_ID,AR.NAME AS ASSET_ROLE_NAME,A.ENTITLEMENT_ID,E.NAME AS ENTITLEMENT_NAME
FROM  $(RIASSET).ASSET_ROLE_ENTITLEMENT_LOOKUP A
JOIN  $(RIASSET).ASSET_ROLE AR ON AR.ASSET_ROLE_ID=A.ASSET_ROLE_ID
JOIN  $(RIASSET).ENTITLEMENT E ON E.ENTITLEMENT_ID=A.ENTITLEMENT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ASSET_ROLE_RESOURCE_LOOKUP (ASSET_ROLE_ID,ASSET_ROLE_NAME,RESOURCE_ID,RESOURCE_NAME) AS
(SELECT A.ASSET_ROLE_ID,AR.NAME AS ASSET_ROLE_NAME,A.RESOURCE_ID,R.FULL_NAME AS RESOURCE_NAME
FROM  $(RIASSET).ASSET_ROLE_RESOURCE_LOOKUP A
JOIN  $(RIASSET).ASSET_ROLE AR ON AR.ASSET_ROLE_ID=A.ASSET_ROLE_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=A.RESOURCE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ASSET_ROLE_TEAM_LOOKUP (ASSET_ROLE_ID,ASSET_ROLE_NAME,TEAM_ID,TEAM_NAME) AS
(SELECT A.ASSET_ROLE_ID,AR.NAME AS ASSET_ROLE_NAME,A.TEAM_ID,T.NAME AS TEAM_NAME
FROM  $(RIASSET).ASSET_ROLE_TEAM_LOOKUP A
JOIN  $(RIASSET).ASSET_ROLE AR ON AR.ASSET_ROLE_ID=A.ASSET_ROLE_ID
JOIN  $(NF_SCHEMA).TEAM T ON T.TEAM_ID=A.TEAM_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ASSET_TESTCASE_LOOKUP (ASSET_ID,ASSET_NAME,TESTCASE_ID,TESTCASE_NAME,LINK_TYPE) AS
(SELECT A.ASSET_ID,AST.NAME AS ASSET_NAME,A.TESTCASE_ID,T.NAME AS TESTCASE_NAME,LINK_TYPE
FROM  $(RIASSET).ASSET_TESTCASE_LOOKUP A
JOIN  $(RIASSET).ASSET AST ON AST.ASSET_ID=A.ASSET_ID
JOIN  $(NF_SCHEMA).TESTCASE T ON T.TESTCASE_ID=A.TESTCASE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ASSET_TESTPLAN_LOOKUP (ASSET_ID,ASSET_NAME,TESTPLAN_ID,TESTPLAN_NAME,LINK_TYPE) AS
(SELECT A.ASSET_ID,AST.NAME AS ASSET_NAME,A.TESTPLAN_ID,T.NAME AS TESTPLAN_NAME,A.LINK_TYPE
FROM  $(RIASSET).ASSET_TESTPLAN_LOOKUP A
JOIN  $(RIASSET).ASSET AST ON AST.ASSET_ID=A.ASSET_ID
JOIN  $(NF_SCHEMA).TESTPLAN T ON T.TESTPLAN_ID=A.TESTPLAN_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ENTITLEMENT (ENTITLEMENT_ID,REFERENCE_ID,EXTERNAL_ID,NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT ENTITLEMENT_ID,REFERENCE_ID,EXTERNAL_ID,NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED
FROM  $(RIASSET).ENTITLEMENT)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ENTITLEMENT_HISTORY (HISTORY_ID,ASSET_ROLE_ID,ASSET_ROLE_NAME,ACTION_TYPE_ID,ACTION_TYPE_NAME,CHANGE_DATE,RESOURCE_ID,RESOURCE_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT H.HISTORY_ID,H.ASSET_ROLE_ID,AR.NAME AS ASSET_ROLE_NAME,H.ACTION_TYPE_ID,AC.NAME AS ACTION_TYPE_NAME,H.CHANGE_DATE,H.RESOURCE_ID,R.FULL_NAME AS RESOURCE_NAME,H.EXTERNAL_KEY1,H.EXTERNAL_KEY2,H.SOURCE_ID,H.URL,H.REC_DATETIME,H.ISSOFTDELETED
FROM  $(RIASSET).ENTITLEMENT_HISTORY H
JOIN  $(RIASSET).ASSET_ROLE AR ON AR.ASSET_ROLE_ID=H.ASSET_ROLE_ID
JOIN  $(RIASSET).ACTION_TYPE AC ON AC.ACTION_TYPE_ID=H.ACTION_TYPE_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=H.RESOURCE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ENTITLEMENT_HISTORY_LOOKUP (HISTORY_ID,ENTITLEMENT_ID,ENTITLEMENT_NAME,ENTITLEMENT_TYPE) AS
(SELECT H.HISTORY_ID,H.ENTITLEMENT_ID,E.NAME AS ENTITLEMENT_NAME,H.ENTITLEMENT_TYPE
FROM  $(RIASSET).ENTITLEMENT_HISTORY_LOOKUP H
JOIN  $(RIASSET).ENTITLEMENT E ON E.ENTITLEMENT_ID=H.ENTITLEMENT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_LICENSE_HISTORY (HISTORY_ID,ASSET_ID,ASSET_NAME,ACTION_TYPE_ID,ACTION_TYPE_NAME,USAGE_DATE,RESOURCE_ID,RESOURCE_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT H.HISTORY_ID,H.ASSET_ID,A.NAME AS ASSET_NAME,H.ACTION_TYPE_ID,AC.NAME AS ACTION_TYPE_NAME,H.USAGE_DATE,H.RESOURCE_ID,R.FULL_NAME AS RESOURCE_NAME,H.EXTERNAL_KEY1,H.EXTERNAL_KEY2,H.SOURCE_ID,H.URL,H.REC_DATETIME,H.ISSOFTDELETED
FROM  $(RIASSET).LICENSE_HISTORY H
JOIN  $(RIASSET).ASSET A ON A.ASSET_ID=H.ASSET_ID
JOIN  $(RIASSET).ACTION_TYPE AC ON AC.ACTION_TYPE_ID=H.ACTION_TYPE_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=H.RESOURCE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ANSWER (ANSWER_ID,REFERENCE_ID,EXTERNAL_ID,NAME,QUESTION_ID,QUESTION_NAME, BALLOT_ID,BALLOT_NAME,BALLOT_TAB_ID,BALLOT_TAB_NAME,VALUE,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT A.ANSWER_ID,A.REFERENCE_ID,A.EXTERNAL_ID,A.NAME,A.QUESTION_ID,Q.NAME AS QUESTION_NAME,A.BALLOT_ID,B.NAME AS BALLOT_NAME,A.BALLOT_TAB_ID,BA.NAME AS BALLOT_TAB_NAME,A.VALUE,A.EXTERNAL_KEY1,A.EXTERNAL_KEY2,A.SOURCE_ID,A.URL,A.REC_DATETIME,A.ISSOFTDELETED
FROM  $(RISCHK).ANSWER A
JOIN  $(RISCHK).QUESTION Q ON Q.QUESTION_ID=A.QUESTION_ID
JOIN  $(RISCHK).BALLOT B ON B.BALLOT_ID=A.BALLOT_ID
JOIN  $(RISCHK).BALLOT_TAB BA ON BA.BALLOT_TAB_ID=A.BALLOT_TAB_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_BALLOT (BALLOT_ID,REFERENCE_ID,EXTERNAL_ID,NAME,SESSION_ID,SESSION_NAME,STATUS,SUBMISSIONTIME,SUBMITTER_ID,SUBMITTER_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT B.BALLOT_ID,B.REFERENCE_ID,B.EXTERNAL_ID,B.NAME,B.SESSION_ID,S.NAME AS SESSION_NAME,B.STATUS,B.SUBMISSIONTIME,B.SUBMITTER_ID,R.FULL_NAME AS SUBMITTER_NAME,B.EXTERNAL_KEY1,B.EXTERNAL_KEY2,B.SOURCE_ID,B.URL,B.REC_DATETIME,B.ISSOFTDELETED
FROM  $(RISCHK).BALLOT B
JOIN  $(RISCHK).SC_SESSION S ON S.SESSION_ID=B.SESSION_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=B.SUBMITTER_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_BALLOTDEF_BALLOT_TAB_LOOKUP (BALLOT_DEFINITION_ID,BALLOT_DEFINITION_NAME,BALLOT_TAB_ID,BALLOT_TAB_NAME) AS
(SELECT B.BALLOT_DEFINITION_ID,BD.NAME AS BALLOT_DEFINITION_NAME,B.BALLOT_TAB_ID,BT.NAME AS BALLOT_TAB_NAME
FROM  $(RISCHK).BALLOTDEF_BALLOT_TAB_LOOKUP B
JOIN  $(RISCHK).BALLOT_DEFINITION BD ON BD.BALLOT_DEFINITION_ID=B.BALLOT_DEFINITION_ID
JOIN  $(RISCHK).BALLOT_TAB BT ON BT.BALLOT_TAB_ID=B.BALLOT_TAB_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_BALLOT_DEFINITION (BALLOT_DEFINITION_ID,REFERENCE_ID,EXTERNAL_ID,NAME,SCALE_ID,SCALE_NAME,DESCRIPTION,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT B.BALLOT_DEFINITION_ID,B.REFERENCE_ID,B.EXTERNAL_ID,B.NAME,B.SCALE_ID,S.NAME AS SCALE_NAME,B.DESCRIPTION,B.EXTERNAL_KEY1,B.EXTERNAL_KEY2,B.SOURCE_ID,B.URL,B.REC_DATETIME,B.ISSOFTDELETED
FROM  $(RISCHK).BALLOT_DEFINITION B
JOIN  $(RISCHK).SC_SCALE S ON S.SCALE_ID=B.SCALE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_BALLOT_TAB (BALLOT_TAB_ID,REFERENCE_ID,EXTERNAL_ID,NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT BALLOT_TAB_ID,REFERENCE_ID,EXTERNAL_ID,NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED FROM  $(RISCHK).BALLOT_TAB)
GO

CREATE VIEW $(STAR_SCHEMA).VW_BALLOT_TAB_QUESTION_LOOKUP (BALLOT_TAB_ID,BALLOT_TAB_NAME,QUESTION_ID,QUESTION_NAME,QUESTION_ORDER) AS
(SELECT B.BALLOT_TAB_ID,BT.NAME AS BALLOT_TAB_NAME,B.QUESTION_ID,Q.NAME AS QUESTION_NAME,B.QUESTION_ORDER
FROM  $(RISCHK).BALLOT_TAB_QUESTION_LOOKUP B
JOIN  $(RISCHK).BALLOT_TAB BT ON BT.BALLOT_TAB_ID=B.BALLOT_TAB_ID
JOIN  $(RISCHK).QUESTION Q ON Q.QUESTION_ID=B.QUESTION_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_QUESTION (QUESTION_ID,REFERENCE_ID,EXTERNAL_ID,NAME,SCALE_ID,DESCRIPTION,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT QUESTION_ID,REFERENCE_ID,EXTERNAL_ID,NAME,SCALE_ID,DESCRIPTION,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED FROM  $(RISCHK).QUESTION)
GO

CREATE VIEW $(STAR_SCHEMA).VW_SCSESSION_COFACILIT_LOOKUP (SESSION_ID,SESSION_NAME,FACILITATOR_ID,FACILITATOR_NAME) AS
(SELECT S.SESSION_ID,SE.NAME AS SESSION_NAME,S.FACILITATOR_ID,R.FULL_NAME AS FACILITATOR_NAME
FROM  $(RISCHK).SCSESSION_COFACILIT_LOOKUP S
JOIN  $(RISCHK).SC_SESSION SE ON SE.SESSION_ID=S.SESSION_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=S.FACILITATOR_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_SESSION_PARTICIPANT_LOOKUP (SESSION_ID,SESSION_NAME,PARTICIPANT_ID,PARTICIPANT_NAME) AS
(SELECT S.SESSION_ID,SE.NAME AS SESSION_NAME,S.PARTICIPANT_ID,R.FULL_NAME AS PARTICIPANT_NAME
FROM  $(RISCHK).SCSESSION_PARTICIPANT_LOOKUP S
JOIN  $(RISCHK).SC_SESSION SE ON SE.SESSION_ID=S.SESSION_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=S.PARTICIPANT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_SC_BALLOT_TAB_RESULT (RESULT_ID,REFERENCE_ID,EXTERNAL_ID,NAME,SESSION_ID,BALLOT_TAB_ID,BALLOT_TAB_NAME,STANDARD_DEV_VALUE,AVERAGE_VALUE,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT R.RESULT_ID,R.REFERENCE_ID,R.EXTERNAL_ID,R.NAME,R.SESSION_ID,R.BALLOT_TAB_ID,BT.NAME AS BALLOT_TAB_NAME,R.STANDARD_DEV_VALUE,R.AVERAGE_VALUE,R.EXTERNAL_KEY1,R.EXTERNAL_KEY2,R.SOURCE_ID,R.URL,R.REC_DATETIME,R.ISSOFTDELETED
FROM  $(RISCHK).SC_BALLOT_TAB_RESULT R
JOIN  $(RISCHK).BALLOT_TAB BT ON BT.BALLOT_TAB_ID=R.BALLOT_TAB_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_SC_SCALE (SCALE_ID,REFERENCE_ID,EXTERNAL_ID,NAME,TRUE_VALUE_DISPLAY,FALSE_VALUE_DISPLAY,INT_START_VALUE,INT_END_VALUE,DEC_START_VALUE,DEC_END_VALUE,PRECISION_VALUE,TALKTHRESHOLDAVG,TALKTHRESHOLDDEV,TYPE,LENGTH,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT SCALE_ID,REFERENCE_ID,EXTERNAL_ID,NAME,TRUE_VALUE_DISPLAY,FALSE_VALUE_DISPLAY,INT_START_VALUE,INT_END_VALUE,DEC_START_VALUE,DEC_END_VALUE,PRECISION_VALUE,TALKTHRESHOLDAVG,TALKTHRESHOLDDEV,TYPE,LENGTH,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED FROM  $(RISCHK).SC_SCALE)
GO

CREATE VIEW $(STAR_SCHEMA).VW_SC_SESSION (SESSION_ID,REFERENCE_ID,EXTERNAL_ID,NAME,BALLOT_DEFINITION_ID,BALLOT_DEFINITION_NAME,TEAM_ID,TEAM_NAME,PROJECT_ID,PROJECT_NAME,STATUS,SESSION_DATE,BALLOT_COUNT,BALLOT_SUBMITTED,DESCRIPTION,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT S.SESSION_ID,S.REFERENCE_ID,S.EXTERNAL_ID,S.NAME,S.BALLOT_DEFINITION_ID,B.NAME AS BALLOT_DEFINITION_NAME,S.TEAM_ID,T.NAME AS TEAM_NAME,S.PROJECT_ID,P.NAME AS PROJECT_NAME,S.STATUS,S.SESSION_DATE,S.BALLOT_COUNT,S.BALLOT_SUBMITTED,S.DESCRIPTION,S.EXTERNAL_KEY1,S.EXTERNAL_KEY2,S.SOURCE_ID,S.URL,S.REC_DATETIME,S.ISSOFTDELETED
FROM  $(RISCHK).SC_SESSION S
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=S.PROJECT_ID
JOIN  $(NF_SCHEMA).TEAM T ON T.TEAM_ID=S.TEAM_ID
JOIN  $(RISCHK).BALLOT_DEFINITION B ON B.BALLOT_DEFINITION_ID=S.BALLOT_DEFINITION_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_PROJECT_RESOURCE_LOOKUP(PROJECT_ID,PROJECT_NAME,RESOURCE_ID,RESOURCE_NAME) AS
(SELECT PR.PROJECT_ID,P.NAME AS PROJECT_NAME,PR.RESOURCE_ID,CASE WHEN R.REFERENCE_ID IS NOT NULL THEN R.REFERENCE_ID ELSE R.FULL_NAME END AS RESOURCE_NAME
FROM  $(NF_SCHEMA).PROJECT_RESOURCE_LOOKUP PR
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=PR.PROJECT_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=PR.RESOURCE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_RISK_REQUEST_LOOKUP(RISK_ID,RISK_NAME,REQUEST_ID,REQUEST_NAME) AS
(SELECT PR.RISK_ID,P.NAME AS RISK_NAME,PR.REQUEST_ID,R.NAME AS REQUEST_NAME
FROM  $(NF_SCHEMA).RISK_REQUEST_LOOKUP PR
JOIN  $(NF_SCHEMA).RISK P ON P.RISK_ID=PR.RISK_ID
JOIN  $(NF_SCHEMA).REQUEST R ON R.REQUEST_ID=PR.REQUEST_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTSUITE_CATEGORY_LOOKUP(TESTSUITE_ID,TESTSUITE_NAME,TEST_CATEGORY_ID,TEST_CATEGORY_NAME) AS
(SELECT TC.TESTSUITE_ID,T.NAME AS TESTSUITE_NAME, TC.TEST_CATEGORY_ID,C.NAME AS TEST_CATEGORY_NAME
FROM  $(NF_SCHEMA).TESTSUITE_CATEGORY_LOOKUP TC
JOIN  $(NF_SCHEMA).TESTSUITE T ON T.TESTSUITE_ID=TC.TESTSUITE_ID
JOIN  $(NF_SCHEMA).TEST_CATEGORY C ON C.TEST_CATEGORY_ID=TC.TEST_CATEGORY_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTSUITE_TESTPLAN_LOOKUP(TESTSUITE_ID,TESTSUITE_NAME,TESTPLAN_ID,TESTPLAN_NAME) AS
(SELECT TC.TESTSUITE_ID,T.NAME AS TESTSUITE_NAME, TC.TESTPLAN_ID,C.NAME AS TESTPLAN_NAME
FROM  $(NF_SCHEMA).TESTSUITE_TESTPLAN_LOOKUP TC
JOIN  $(NF_SCHEMA).TESTSUITE T ON T.TESTSUITE_ID=TC.TESTSUITE_ID
JOIN  $(NF_SCHEMA).TESTPLAN C ON C.TESTPLAN_ID=TC.TESTPLAN_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTSUITE_EXECUTION_RECORD (TESTSUITE_EXECRECORD_ID,REFERENCE_ID,EXTERNAL_ID,NAME ,PROJECT_ID,PROJECT_NAME,CREATOR_ID,CREATOR_NAME,OWNER_ID,OWNER_NAME,TESTSUITE_ID,TESTSUITE_NAME,TESTPLAN_ID,TESTPLAN_NAME,ITERATION_ID,ITERATION_NAME,CONFIGURATION_ID,CONFIGURATION_NAME,CURRENT_SUITELOG_ID,CURRENT_SUITELOG_NAME,WEIGHT,CREATION_DATE,LAST_UPDATED,ISSEQUENTIAL,
TEST_PRIORITY_ID,TEST_PRIORITY_NAME,TEST_PRIORITY_EXTERNAL_ID,TEST_PRIORITY_REFERENCE_ID,ESTIMATE,TIMESPENT,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
( SELECT TSER.TESTSUITE_EXECRECORD_ID,TSER.REFERENCE_ID,TSER.EXTERNAL_ID,TSER.NAME ,TSER.PROJECT_ID,P.NAME AS PROJECT_NAME,TSER.CREATOR_ID,R1.FULL_NAME AS CREATOR_NAME,TSER.OWNER_ID,R2.FULL_NAME AS OWNER_NAME,TSER.TESTSUITE_ID,TS.NAME AS TESTSUITE_NAME,TSER.TESTPLAN_ID,TP.NAME AS TESTPLAN_NAME,TSER.ITERATION_ID,I.NAME AS ITERATION_NAME,TSER.CONFIGURATION_ID,C.NAME AS CONFIGURATION_NAME,TSER.CURRENT_SUITELOG_ID,TL.NAME AS CURRENT_SUITELOG_NAME,TSER.WEIGHT,TSER.CREATION_DATE,TSER.LAST_UPDATED,TSER.ISSEQUENTIAL,
TSER.TEST_PRIORITY_ID,PT.NAME AS TEST_PRIORITY_NAME,PT.EXTERNAL_ID AS TEST_PRIORITY_EXTERNAL_ID,PT.REFERENCE_ID AS TEST_PRIORITY_REFERENCE_ID,TSER.ESTIMATE,TSER.TIMESPENT,
TSER.EXTERNAL_KEY1,TSER.EXTERNAL_KEY2,TSER.SOURCE_ID,TSER.URL,TSER.REC_DATETIME,TSER.ISSOFTDELETED
FROM  $(NF_SCHEMA).TESTSUITE_EXECUTION_RECORD TSER
JOIN  $(NF_SCHEMA).RESOURCE R1 ON R1.RESOURCE_ID=TSER.CREATOR_ID
JOIN  $(NF_SCHEMA).RESOURCE R2 ON R2.RESOURCE_ID=TSER.OWNER_ID
JOIN  $(NF_SCHEMA).TESTSUITE TS ON TS.TESTSUITE_ID=TSER.TESTSUITE_ID
JOIN  $(NF_SCHEMA).TESTPLAN TP ON TP.TESTPLAN_ID=TSER.TESTPLAN_ID
JOIN  $(NF_SCHEMA).ITERATION I ON I.ITERATION_ID=TSER.ITERATION_ID
JOIN  $(NF_SCHEMA).CONFIGURATION C ON C.CONFIGURATION_ID=TSER.CONFIGURATION_ID
JOIN  $(NF_SCHEMA).TESTSUITELOG TL ON TL.TESTSUITELOG_ID=TSER.CURRENT_SUITELOG_ID
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID=TSER.PROJECT_ID
JOIN  $(NF_SCHEMA).TEST_PRIORITY PT ON PT.TEST_PRIORITY_ID=TSER.TEST_PRIORITY_ID)
GO


CREATE VIEW $(STAR_SCHEMA).VW_EXECWORKITEM_REQUEST_LOOKUP (EXECWORKITEM_ID, EXECUTION_WORKITEM_NAME, REQUEST_ID, REQUEST_NAME, LINK_TYPE) AS
 (SELECT  CI.EXECWORKITEM_ID, C.NAME AS EXECUTION_WORKITEM_NAME, CI.REQUEST_ID, I.NAME AS REQUEST_NAME, CI.LINK_TYPE
 FROM  $(NF_SCHEMA).EXECWORKITEM_REQUEST_LOOKUP CI
 JOIN  $(NF_SCHEMA).EXECUTION_WORKITEM C ON C.EXECWORKITEM_ID=CI.EXECWORKITEM_ID
 JOIN  $(NF_SCHEMA).REQUEST I ON I.REQUEST_ID=CI.REQUEST_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_EXECUTION_STEP_RESULT (EXECUTION_STEP_RESULT_ID,REFERENCE_ID,EXTERNAL_ID,NAME,EXECUTION_RESULT_ID,EXECUTION_RESULT_NAME,STEP_TYPE,DESCRIPTION,EXPECTED_RESULT,ACTUAL_RESULT,RESULT,START_TIME,END_TIME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT E.EXECUTION_STEP_RESULT_ID,E.REFERENCE_ID,E.EXTERNAL_ID,E.NAME,E.EXECUTION_RESULT_ID,S.NAME AS EXECUTION_RESULT_NAME,E.STEP_TYPE,E.DESCRIPTION,E.EXPECTED_RESULT,E.ACTUAL_RESULT,E.RESULT,E.START_TIME,E.END_TIME,E.EXTERNAL_KEY1,E.EXTERNAL_KEY2,E.SOURCE_ID,E.URL,E.REC_DATETIME,E.ISSOFTDELETED
FROM  $(NF_SCHEMA).EXECUTION_STEP_RESULT E
JOIN  $(NF_SCHEMA).EXECUTION_RESULT S ON S.EXECUTION_RESULT_ID=E.EXECUTION_RESULT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_EXECSTEPRES_REQUEST_LOOKUP (EXECUTION_STEP_RESULT_ID, EXECUTION_STEP_RESULT_NAME, REQUEST_ID, REQUEST_NAME, LINK_TYPE) AS
 (SELECT  CI.EXECUTION_STEP_RESULT_ID, C.NAME AS EXECUTION_STEP_RESULT_NAME, CI.REQUEST_ID, I.NAME AS REQUEST_NAME, CI.LINK_TYPE
 FROM  $(NF_SCHEMA).EXECSTEPRES_REQUEST_LOOKUP CI
 JOIN  $(NF_SCHEMA).EXECUTION_STEP_RESULT C ON C.EXECUTION_STEP_RESULT_ID=CI.EXECUTION_STEP_RESULT_ID
 JOIN  $(NF_SCHEMA).REQUEST I ON I.REQUEST_ID=CI.REQUEST_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTSUITE_ELEMENT (TESTSUITE_ELEMENT_ID ,REFERENCE_ID,EXTERNAL_ID,NAME,TESTSUITE_ID ,TESTSUITE_NAME,TESTCASE_ID,TESTCASE_NAME,CONFIGURATION_ID,CONFIGURATION_NAME,TESTSCRIPT_ID,TESTSCRIPT_NAME,ELEMENT_INDEX,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED,OWNER_ID,OWNER_NAME) AS
(SELECT TE.TESTSUITE_ELEMENT_ID ,TE.REFERENCE_ID,TE.EXTERNAL_ID,TE.NAME,TE.TESTSUITE_ID ,TS.NAME AS TESTSUITE_NAME,TE.TESTCASE_ID,TC.NAME AS TESTCASE_NAME, TE.CONFIGURATION_ID,C.NAME AS CONFIGURATION_NAME,TE.TESTSCRIPT_ID,TR.NAME AS TESTSCRIPT_NAME,TE.ELEMENT_INDEX,TE.EXTERNAL_KEY1,TE.EXTERNAL_KEY2,TE.SOURCE_ID,TE.URL,TE.REC_DATETIME,TE.ISSOFTDELETED,
TE.OWNER_ID,R.FULL_NAME AS OWNER_NAME
FROM  $(NF_SCHEMA).TESTSUITE_ELEMENT TE
JOIN  $(NF_SCHEMA).TESTCASE TC ON TC.TESTCASE_ID=TE.TESTCASE_ID
JOIN  $(NF_SCHEMA).CONFIGURATION C ON C.CONFIGURATION_ID=TE.CONFIGURATION_ID
JOIN  $(NF_SCHEMA).TESTSUITE TS ON TS.TESTSUITE_ID=TE.TESTSUITE_ID
JOIN  $(NF_SCHEMA).TESTSCRIPT TR ON TR.TESTSCRIPT_ID=TE.TESTSCRIPT_ID
JOIN  $(NF_SCHEMA).RESOURCE R ON R.RESOURCE_ID=TE.OWNER_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUIREMENT_LINK_TYPE (LINK_TYPE_ID,REFERENCE_ID,EXTERNAL_ID,NAME,PROJECT_ID,PROJECT_NAME,PRED_REQUIREMENT_LINK_LABEL,SUCC_REQUIREMENT_LINK_LABEL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT L.LINK_TYPE_ID,L.REFERENCE_ID,L.EXTERNAL_ID,L.NAME,L.PROJECT_ID,P.NAME AS PROJECT_NAME,L.PRED_REQUIREMENT_LINK_LABEL,L.SUCC_REQUIREMENT_LINK_LABEL,L.EXTERNAL_KEY1,L.EXTERNAL_KEY2,L.SOURCE_ID,L.URL,L.REC_DATETIME,L.ISSOFTDELETED
FROM  $(NF_SCHEMA).REQUIREMENT_LINK_TYPE L
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID =L.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_RELATIONAL_LINK (REQUEST_RELATION_ID, NAME, REFERENCE_ID, EXTERNAL_ID, REQUEST1_ID, REQUEST1_NAME, REQUEST2_ID, REQUEST2_NAME, URL, EXTERNAL_KEY1, EXTERNAL_KEY2, SOURCE_ID, REC_DATETIME, ISSOFTDELETED) AS
 (SELECT REQU.REQUEST_RELATION_ID, REQU.NAME, REQU.REFERENCE_ID, REQU.EXTERNAL_ID, REQU.REQUEST1_ID, R.NAME AS REQUEST1_NAME, REQU.REQUEST2_ID, R1.NAME AS REQUEST2_NAME, REQU.URL, REQU.EXTERNAL_KEY1, REQU.EXTERNAL_KEY2, REQU.SOURCE_ID, REQU.REC_DATETIME, REQU.ISSOFTDELETED
FROM  $(NF_SCHEMA).REQUEST_RELATIONAL_LINK REQU
 JOIN  $(NF_SCHEMA).REQUEST R ON R.REQUEST_ID = REQU.REQUEST1_ID
 JOIN  $(NF_SCHEMA).REQUEST R1 ON R1.REQUEST_ID = REQU.REQUEST2_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ASSET_ATTRIBUTE(ASSET_ATTRIBUTE_ID,REFERENCE_ID,EXTERNAL_ID,NAME,ASSET_ID,ASSET_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT A.ASSET_ATTRIBUTE_ID,A.REFERENCE_ID,A.EXTERNAL_ID,A.NAME,A.ASSET_ID,AA.NAME AS ASSET_NAME,A.EXTERNAL_KEY1,A.EXTERNAL_KEY2,A.SOURCE_ID,A.URL,A.REC_DATETIME,A.ISSOFTDELETED
FROM  $(RIASSET).ASSET_ATTRIBUTE A
JOIN  $(RIASSET).ASSET AA ON AA.ASSET_ID=A.ASSET_ID)
GO


CREATE VIEW $(STAR_SCHEMA).VW_ASSET_ATTRIBUTE_VALUE (ASSET_ATTRIBUTE_VALUE_ID,REFERENCE_ID,EXTERNAL_ID,NAME,ASSET_ATTRIBUTE_ID,ASSET_ATTRIBUTE_NAME,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,ISSOFTDELETED) AS
(SELECT V.ASSET_ATTRIBUTE_VALUE_ID,V.REFERENCE_ID,V.EXTERNAL_ID,V.NAME,V.ASSET_ATTRIBUTE_ID,A.NAME AS ASSET_ATTRIBUTE_NAME,V.EXTERNAL_KEY1,V.EXTERNAL_KEY2,V.SOURCE_ID,V.URL,V.REC_DATETIME,V.ISSOFTDELETED
FROM  $(RIASSET).ASSET_ATTRIBUTE_VALUE V
JOIN  $(RIASSET).ASSET_ATTRIBUTE A ON A.ASSET_ATTRIBUTE_ID=V.ASSET_ATTRIBUTE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ASSET_CATEGORY (
ASSET_CATEGORY_ID,REFERENCE_ID,EXTERNAL_ID,NAME,FULL_PATH,ROOT_FLAG,LEAF_FLAG,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,
ISSOFTDELETED) AS
(SELECT ASSET_CATEGORY_ID,REFERENCE_ID,EXTERNAL_ID,NAME,FULL_PATH,ROOT_FLAG,LEAF_FLAG,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,URL,REC_DATETIME,
ISSOFTDELETED
FROM  $(RIASSET).ASSET_CATEGORY)
GO


CREATE VIEW $(STAR_SCHEMA).VW_ASSET_CAT_HIERARCHY (PARENT_CATEGORY_ID,PARENT_CATEGORY_NAME,CHILD_CATEGORY_ID,CHILD_CATEGORY_NAME)
AS
(SELECT T.PARENT_CATEGORY_ID,P.NAME AS PARENT_CATEGORY_NAME,T.CHILD_CATEGORY_ID,C.NAME AS CHILD_CATEGORY_NAME
FROM   $(RIASSET).ASSET_CAT_HIERARCHY T
JOIN  $(RIASSET).ASSET_CATEGORY P ON P.ASSET_CATEGORY_ID = T.PARENT_CATEGORY_ID
JOIN  $(RIASSET).ASSET_CATEGORY C ON C.ASSET_CATEGORY_ID = T.CHILD_CATEGORY_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_ASSET_CAT_ASSET_LOOKUP (ASSET_CATEGORY_ID,ASSET_CATEGORY_NAME,ASSET_ID,ASSET_NAME,FULL_PATH) AS
(SELECT A.ASSET_CATEGORY_ID,AA.NAME AS ASSET_CATEGORY_NAME,A.ASSET_ID,ATT.NAME AS ASSET_NAME,A.FULL_PATH
FROM  $(RIASSET).ASSET_CAT_ASSET_LOOKUP A
JOIN  $(RIASSET).ASSET_CATEGORY AA ON AA.ASSET_CATEGORY_ID=A.ASSET_CATEGORY_ID
JOIN  $(RIASSET).ASSET ATT ON ATT.ASSET_ID=A.ASSET_ID)
GO


CREATE VIEW $(STAR_SCHEMA).VW_TESTSCRIPT_CATEGORY_LOOKUP (TESTSCRIPT_ID, TESTSCRIPT_NAME, TEST_CATEGORY_ID, TEST_CATEGORY_NAME) AS
 (SELECT TEST.TESTSCRIPT_ID, T.NAME AS TESTSCRIPT_NAME, TEST.TEST_CATEGORY_ID, TC.NAME AS TEST_CATEGORY_NAME
FROM  $(NF_SCHEMA).TESTSCRIPT_CATEGORY_LOOKUP TEST
 JOIN  $(NF_SCHEMA).TESTSCRIPT T ON T.TESTSCRIPT_ID = TEST.TESTSCRIPT_ID
 JOIN  $(NF_SCHEMA).TEST_CATEGORY TC ON TC.TEST_CATEGORY_ID = TEST.TEST_CATEGORY_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_EXECWI_CATEGORY_LOOKUP (EXECWORKITEM_ID, EXECWORKITEM_NAME, TEST_CATEGORY_ID, TEST_CATEGORY_NAME) AS
 (SELECT EX.EXECWORKITEM_ID, EW.NAME AS EXECWORKITEM_NAME, EX.TEST_CATEGORY_ID, TC.NAME AS TEST_CATEGORY_NAME
FROM  $(NF_SCHEMA).EXECWORKITEM_CATEGORY_LOOKUP EX
 JOIN  $(NF_SCHEMA).EXECUTION_WORKITEM EW ON EW.EXECWORKITEM_ID = EX.EXECWORKITEM_ID
 JOIN  $(NF_SCHEMA).TEST_CATEGORY TC ON TC.TEST_CATEGORY_ID = EX.TEST_CATEGORY_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TSTSUITER_CATEGORY_LOOKUP (TESTSUITE_EXECRECORD_ID, TESTSUITE_EXECRECORD_NAME, TEST_CATEGORY_ID, TEST_CATEGORY_NAME) AS
 (SELECT TSTS.TESTSUITE_EXECRECORD_ID, TE.NAME AS TESTSUITE_EXECRECORD_NAME, TSTS.TEST_CATEGORY_ID, TC.NAME AS TEST_CATEGORY_NAME
FROM  $(NF_SCHEMA).TSTSUITEXECREC_CATEGORY_LOOKUP TSTS
 JOIN  $(NF_SCHEMA).TEST_CATEGORY TC ON TC.TEST_CATEGORY_ID = TSTS.TEST_CATEGORY_ID
 JOIN  $(NF_SCHEMA).TESTSUITE_EXECUTION_RECORD TE ON TE.TESTSUITE_EXECRECORD_ID = TSTS.TESTSUITE_EXECRECORD_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_EXECRESULT_CATEGORY_LOOKUP (EXECUTION_RESULT_ID, EXECUTION_RESULT_NAME, TEST_CATEGORY_ID, TEST_CATEGORY_NAME) AS
 (SELECT EX.EXECUTION_RESULT_ID, ER.NAME AS EXECUTION_RESULT_NAME, EX.TEST_CATEGORY_ID, TC.NAME AS TEST_CATEGORY_NAME
FROM  $(NF_SCHEMA).EXECRESULT_CATEGORY_LOOKUP EX
 JOIN  $(NF_SCHEMA).EXECUTION_RESULT ER ON ER.EXECUTION_RESULT_ID = EX.EXECUTION_RESULT_ID
 JOIN  $(NF_SCHEMA).TEST_CATEGORY TC ON TC.TEST_CATEGORY_ID = EX.TEST_CATEGORY_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTSTLOG_CATEGORY_LOOKUP (TESTSUITELOG_ID, TESTSUITELOG_NAME, TEST_CATEGORY_ID, TEST_CATEGORY_NAME) AS
 (SELECT TEST.TESTSUITELOG_ID, T.NAME AS TESTSUITELOG_NAME, TEST.TEST_CATEGORY_ID, TC.NAME AS TEST_CATEGORY_NAME
FROM  $(NF_SCHEMA).TESTSUITELOG_CATEGORY_LOOKUP TEST
 JOIN  $(NF_SCHEMA).TESTSUITELOG T ON T.TESTSUITELOG_ID = TEST.TESTSUITELOG_ID
 JOIN  $(NF_SCHEMA).TEST_CATEGORY TC ON TC.TEST_CATEGORY_ID = TEST.TEST_CATEGORY_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_TESTPLAN_LOOKUP (REQUEST_ID, REQUEST_NAME, TESTPLAN_ID, TESTPLAN_NAME, LINK_TYPE) AS
 (SELECT REQU.REQUEST_ID, R.NAME AS REQUEST_NAME, REQU.TESTPLAN_ID, T.NAME AS TESTPLAN_NAME, REQU.LINK_TYPE
FROM  $(NF_SCHEMA).REQUEST_TESTPLAN_LOOKUP REQU
 JOIN  $(NF_SCHEMA).REQUEST R ON R.REQUEST_ID = REQU.REQUEST_ID
 JOIN  $(NF_SCHEMA).TESTPLAN T ON T.TESTPLAN_ID = REQU.TESTPLAN_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_TESTSCRIPT_LOOKUP (REQUEST_ID, REQUEST_NAME, TESTSCRIPT_ID, TESTSCRIPT_NAME, LINK_TYPE) AS
 (SELECT REQU.REQUEST_ID, R.NAME AS REQUEST_NAME, REQU.TESTSCRIPT_ID, T.NAME AS TESTSCRIPT_NAME, REQU.LINK_TYPE
FROM  $(NF_SCHEMA).REQUEST_TESTSCRIPT_LOOKUP REQU
 JOIN  $(NF_SCHEMA).REQUEST R ON R.REQUEST_ID = REQU.REQUEST_ID
 JOIN  $(NF_SCHEMA).TESTSCRIPT T ON T.TESTSCRIPT_ID = REQU.TESTSCRIPT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_TESTSUITE_LOOKUP (REQUEST_ID, REQUEST_NAME, TESTSUITE_ID, TESTSUITE_NAME, LINK_TYPE) AS
 (SELECT REQU.REQUEST_ID, R.NAME AS REQUEST_NAME, REQU.TESTSUITE_ID, T.NAME AS TESTSUITE_NAME, REQU.LINK_TYPE
FROM  $(NF_SCHEMA).REQUEST_TESTSUITE_LOOKUP REQU
 JOIN  $(NF_SCHEMA).REQUEST R ON R.REQUEST_ID = REQU.REQUEST_ID
 JOIN  $(NF_SCHEMA).TESTSUITE T ON T.TESTSUITE_ID = REQU.TESTSUITE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUEST_TYPE_BINDING (REQUEST_TYPE_BINDING_ID, NAME, REFERENCE_ID, EXTERNAL_ID, PROJECT_ID, PROJECT_NAME, REQUEST_TYPE_ID, REQUEST_TYPE_NAME, URL, EXTERNAL_KEY1, EXTERNAL_KEY2, SOURCE_ID, REC_DATETIME, ISSOFTDELETED) AS
(SELECT RT.REQUEST_TYPE_BINDING_ID, RT.NAME, RT.REFERENCE_ID, RT.EXTERNAL_ID, RT.PROJECT_ID, P.NAME AS PROJECT_NAME, RT.REQUEST_TYPE_ID, R.NAME AS REQUEST_TYPE_NAME, RT.URL, RT.EXTERNAL_KEY1, RT.EXTERNAL_KEY2, RT.SOURCE_ID, RT.REC_DATETIME, RT.ISSOFTDELETED
FROM  $(NF_SCHEMA).REQUEST_TYPE_BINDING RT
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID = RT.PROJECT_ID
JOIN  $(NF_SCHEMA).REQUEST_TYPE R ON R.REQUEST_TYPE_ID = RT.REQUEST_TYPE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUIREMT_TESTSCRIPT_LOOKUP(REQUIREMENT_ID,REQUIREMENT_NAME,TESTSCRIPT_ID,TESTSCRIPT_NAME,LINK_TYPE_NAME) AS
(SELECT RT.REQUIREMENT_ID,R.NAME AS REQUIREMENT_NAME,RT.TESTSCRIPT_ID,T.NAME AS TESTSCRIPT_NAME,RT.LINK_TYPE_NAME
FROM  $(NF_SCHEMA).REQUIREMENT_TESTSCRIPT_LOOKUP RT
JOIN  $(NF_SCHEMA).REQUIREMENT R ON R.REQUIREMENT_ID=RT.REQUIREMENT_ID
JOIN  $(NF_SCHEMA).TESTSCRIPT T ON T.TESTSCRIPT_ID=RT.TESTSCRIPT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TEST_STATUS (TEST_STATUS_ID,NAME,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED)AS
(SELECT T.TEST_STATUS_ID,T.NAME,T.REFERENCE_ID,T.EXTERNAL_ID,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.URL,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.SOURCE_ID,T.REC_DATETIME,T.ISSOFTDELETED
FROM  $(NF_SCHEMA).TEST_STATUS T
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID =T.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTSUITE_STATE (TESTSUITE_STATE_ID,NAME,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,TEST_STATUS_ID,TEST_STATUS_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED)AS
(SELECT T.TESTSUITE_STATE_ID,T.NAME,T.REFERENCE_ID,T.EXTERNAL_ID,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.TEST_STATUS_ID,TS.NAME AS TEST_STATUS_NAME,T.URL,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.SOURCE_ID,T.REC_DATETIME,T.ISSOFTDELETED
FROM  $(NF_SCHEMA).TESTSUITE_STATE T
JOIN  $(NF_SCHEMA).TEST_STATUS TS ON TS.TEST_STATUS_ID=T.TEST_STATUS_ID
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID =T.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTSUITELOG_STATE (TESTSUITELOG_STATE_ID,NAME,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,TEST_STATUS_ID,TEST_STATUS_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED)AS
(SELECT T.TESTSUITELOG_STATE_ID,T.NAME,T.REFERENCE_ID,T.EXTERNAL_ID,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.TEST_STATUS_ID,TS.NAME AS TEST_STATUS_NAME,T.URL,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.SOURCE_ID,T.REC_DATETIME,T.ISSOFTDELETED
FROM  $(NF_SCHEMA).TESTSUITELOG_STATE T
JOIN  $(NF_SCHEMA).TEST_STATUS TS ON TS.TEST_STATUS_ID=T.TEST_STATUS_ID
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID =T.PROJECT_ID)
GO


CREATE VIEW $(STAR_SCHEMA).VW_EXECRESULT_STATE (EXECRESULT_STATE_ID,NAME,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,TEST_STATUS_ID,TEST_STATUS_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED)AS
(SELECT T.EXECRESULT_STATE_ID,T.NAME,T.REFERENCE_ID,T.EXTERNAL_ID,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.TEST_STATUS_ID,TS.NAME AS TEST_STATUS_NAME,T.URL,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.SOURCE_ID,T.REC_DATETIME,T.ISSOFTDELETED
FROM  $(NF_SCHEMA).EXECRESULT_STATE T
JOIN  $(NF_SCHEMA).TEST_STATUS TS ON TS.TEST_STATUS_ID=T.TEST_STATUS_ID
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID =T.PROJECT_ID)
GO

 CREATE VIEW $(STAR_SCHEMA).VW_TESTCASE_STATE (TESTCASE_STATE_ID,NAME,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,TEST_STATUS_ID,TEST_STATUS_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED)AS
(SELECT T.TESTCASE_STATE_ID,T.NAME,T.REFERENCE_ID,T.EXTERNAL_ID,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.TEST_STATUS_ID,TS.NAME AS TEST_STATUS_NAME,T.URL,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.SOURCE_ID,T.REC_DATETIME,T.ISSOFTDELETED
FROM  $(NF_SCHEMA).TESTCASE_STATE T
JOIN  $(NF_SCHEMA).TEST_STATUS TS ON TS.TEST_STATUS_ID=T.TEST_STATUS_ID
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID =T.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTPLAN_STATE (TESTPLAN_STATE_ID,NAME,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,TEST_STATUS_ID,TEST_STATUS_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED)AS
(SELECT T.TESTPLAN_STATE_ID,T.NAME,T.REFERENCE_ID,T.EXTERNAL_ID,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.TEST_STATUS_ID,TS.NAME AS TEST_STATUS_NAME,T.URL,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.SOURCE_ID,T.REC_DATETIME,T.ISSOFTDELETED
FROM  $(NF_SCHEMA).TESTPLAN_STATE T
JOIN  $(NF_SCHEMA).TEST_STATUS TS ON TS.TEST_STATUS_ID=T.TEST_STATUS_ID
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID =T.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTSCRIPT_STATE (TESTSCRIPT_STATE_ID,NAME,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,TEST_STATUS_ID,TEST_STATUS_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED)AS
(SELECT T.TESTSCRIPT_STATE_ID,T.NAME,T.REFERENCE_ID,T.EXTERNAL_ID,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.TEST_STATUS_ID,TS.NAME AS TEST_STATUS_NAME,T.URL,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.SOURCE_ID,T.REC_DATETIME,T.ISSOFTDELETED
FROM  $(NF_SCHEMA).TESTSCRIPT_STATE T
JOIN  $(NF_SCHEMA).TEST_STATUS TS ON TS.TEST_STATUS_ID=T.TEST_STATUS_ID
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID =T.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TIMELINE (TIMELINE_ID,NAME,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,STATUS,START_DATE,END_DATE,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED )AS
(SELECT T.TIMELINE_ID,T.NAME,T.REFERENCE_ID,T.EXTERNAL_ID,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.STATUS,T.START_DATE,T.END_DATE,T.URL,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.SOURCE_ID,T.REC_DATETIME,T.ISSOFTDELETED
FROM  $(NF_SCHEMA).TIMELINE T
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID =T.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TEST_PRIORITY (TEST_PRIORITY_ID,NAME,REFERENCE_ID,EXTERNAL_ID,PROJECT_ID,PROJECT_NAME,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED)AS
(SELECT T.TEST_PRIORITY_ID,T.NAME,T.REFERENCE_ID,T.EXTERNAL_ID,T.PROJECT_ID,P.NAME AS PROJECT_NAME,T.URL,T.EXTERNAL_KEY1,T.EXTERNAL_KEY2,T.SOURCE_ID,T.REC_DATETIME,T.ISSOFTDELETED
FROM  $(NF_SCHEMA).TEST_PRIORITY T
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID =T.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_TESTSCRIPT_STEP (TESTSCRIPT_STEP_ID,NAME,REFERENCE_ID,EXTERNAL_ID,TESTSCRIPT_ID,TESTSCRIPT_NAME,PROJECT_ID,PROJECT_NAME,DESCRIPTION,EXPECTED_RESULT,URL,EXTERNAL_KEY1,EXTERNAL_KEY2,SOURCE_ID,REC_DATETIME,ISSOFTDELETED)AS
(SELECT S.TESTSCRIPT_STEP_ID,S.NAME,S.REFERENCE_ID,S.EXTERNAL_ID,S.TESTSCRIPT_ID,T.NAME AS TESTSCRIPT_NAME,P.PROJECT_ID,P.NAME AS PROJECT_NAME,S.DESCRIPTION,S.EXPECTED_RESULT,S.URL,S.EXTERNAL_KEY1,S.EXTERNAL_KEY2,S.SOURCE_ID,S.REC_DATETIME,S.ISSOFTDELETED
FROM  $(NF_SCHEMA).TESTSCRIPT_STEP S
JOIN  $(NF_SCHEMA).TESTSCRIPT T ON T.TESTSCRIPT_ID =S.TESTSCRIPT_ID
JOIN  $(NF_SCHEMA).PROJECT P ON P.PROJECT_ID =T.PROJECT_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_REQUIREME_SCRIPTSTEP_LOOKUP(REQUIREMENT_ID,REQUIREMENT_NAME,TESTSCRIPT_STEP_ID,TESTSCRIPT_STEP_NAME,LINK_TYPE) AS
(SELECT RS.REQUIREMENT_ID,R.NAME AS REQUIREMENT_NAME,RS.TESTSCRIPT_STEP_ID,S.NAME AS TESTSCRIPT_STEP_NAME,RS.LINK_TYPE
FROM  $(NF_SCHEMA).REQUIREMENT_SCRIPTSTEP_LOOKUP RS
JOIN  $(NF_SCHEMA).REQUIREMENT R ON R.REQUIREMENT_ID =RS.REQUIREMENT_ID
JOIN  $(NF_SCHEMA).TESTSCRIPT_STEP S ON S.TESTSCRIPT_STEP_ID=RS.TESTSCRIPT_STEP_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_RQRMNT_WI_LOOKUP (REQUIREMENT_COLLECTION_ID, REQUIREMENT_ID, REFERENCE_ID, NAME, URL, REQUIREMENT_TYPE, STATUS, PRIORITY, STABILITY, DIFFICULTY, STATE, REQUEST_ID, WI_REFERENCE_ID, REQUEST_NAME, REQUEST_URL, REQUEST_TYPE_ID, REQUEST_TYPE_NAME, REQUEST_STATUS_ID, REQUEST_STATUS) AS 
(SELECT RC.REQUIREMENT_COLLECTION_ID, R.REQUIREMENT_ID, R.REFERENCE_ID, R.NAME, R.URL, R.REQUIREMENT_TYPE, R.STATUS, R.PRIORITY, R.STABILITY, R.DIFFICULTY, R.REQUIREMENT_STATE AS STATE, 
		COALESCE(WI.REQUEST_ID,-1) AS REQUEST_ID, WI.REFERENCE_ID AS WI_REFERENCE_ID, WI.NAME AS REQUEST_NAME, WI.URL AS REQUEST_URL, 
		COALESCE(T.REQUEST_TYPE_ID,-1) AS REQUEST_TYPE_ID, T.NAME AS REQUEST_TYPE_NAME, 
		COALESCE(S.REQUEST_STATUS_ID,-1) AS REQUEST_STATUS_ID, S.NAME AS REQUEST_STATUS
FROM $(NF_SCHEMA).REQUIREMENT R 
JOIN $(NF_SCHEMA).REQUICOL_REQUIREMENT_LOOKUP RC ON RC.REQUIREMENT_ID = R.REQUIREMENT_ID
LEFT JOIN $(NF_SCHEMA).REQUIREMENT_REQUEST_LOOKUP RR ON RR.REQUIREMENT_ID = R.REQUIREMENT_ID
LEFT JOIN $(NF_SCHEMA).REQUEST WI ON RR.REQUEST_ID = WI.REQUEST_ID
LEFT JOIN $(NF_SCHEMA).REQUEST_TYPE T ON T.REQUEST_TYPE_ID = WI.REQUEST_TYPE_ID
LEFT JOIN $(NF_SCHEMA).REQUEST_STATUS S ON WI.REQUEST_STATUS_ID = S.REQUEST_STATUS_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_RQRMNT_TC_LOOKUP (REQUIREMENT_COLLECTION_ID, REQUIREMENT_ID, REFERENCE_ID, NAME, URL, REQUIREMENT_TYPE, STATUS, PRIORITY, STABILITY, DIFFICULTY, STATE, TESTCASE_ID, TC_REFERENCE_ID, TESTCASE_NAME, TESTCASE_URL, TESTCASE_STATE_ID, TESTCASE_STATE) AS 
(SELECT RC.REQUIREMENT_COLLECTION_ID, R.REQUIREMENT_ID, R.REFERENCE_ID ,R.NAME, R.URL, R.REQUIREMENT_TYPE, R.STATUS, R.PRIORITY, R.STABILITY, R.DIFFICULTY, R.REQUIREMENT_STATE AS STATE, 
		COALESCE(TC.TESTCASE_ID, -1) AS TESTCASE_ID, TC.REFERENCE_ID AS TC_REFERENCE_ID, TC.NAME AS TESTCASE_NAME, TC.URL AS TESTCASE_URL, 
		COALESCE(S.TESTCASE_STATE_ID,-1) AS TESTCASE_STATE_ID, S.NAME AS TESTCASE_STATE
FROM $(NF_SCHEMA).REQUIREMENT R 
JOIN $(NF_SCHEMA).REQUICOL_REQUIREMENT_LOOKUP RC ON RC.REQUIREMENT_ID = R.REQUIREMENT_ID
LEFT JOIN $(NF_SCHEMA).REQUIREMENT_TESTCASE_LOOKUP RT ON RT.REQUIREMENT_ID = R.REQUIREMENT_ID
LEFT JOIN $(NF_SCHEMA).TESTCASE TC ON RT.TESTCASE_ID = TC.TESTCASE_ID
LEFT JOIN $(NF_SCHEMA).TESTCASE_STATE S ON TC.TESTCASE_STATE_ID = S.TESTCASE_STATE_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_RQRMNT_TC_ER_WI_LOOKUP (REQUIREMENT_ID, REFERENCE_ID, NAME, URL, STATUS, PRIORITY, REQUIREMENT_TYPE, TESTCASE_ID, TESTCASE_NAME, TESTCASE_URL, TESTCASE_STATE_ID, TESTCASE_STATE, TESTPLAN_NAME, TESTPLAN_URL, EXECWORKITEM_ID, EXECWORKITEM_NAME, EXECWORKITEM_URL, RESULT_ID, RESULT_NAME, RESULT_VERDICT, REQUEST_ID, REQUEST_NAME, REQUEST_URL, REQUEST_TYPE_ID, REQUEST_TYPE_NAME, REQUEST_STATUS_ID, REQUEST_STATUS) AS
(SELECT R.REQUIREMENT_ID, R.REFERENCE_ID, R.NAME, R.URL, R.STATUS, R.PRIORITY, R.REQUIREMENT_TYPE, 
		TC.TESTCASE_ID, TC.NAME AS TESTCASE_NAME, TC.URL AS TESTCASE_URL, 
		TS.TESTCASE_STATE_ID, TS.NAME AS TESTCASE_STATE,
		TP.NAME AS TESTPLAN_NAME, TP.URL AS TESTPLAN_URL,
		ERWI.EXECWORKITEM_ID, ERWI.NAME AS EXECWORKITEM_NAME, ERWI.URL AS EXECWORKITEM_URL,
		ER.EXECUTION_RESULT_ID AS RESULT_ID, ER.NAME AS RESULT_NAME, ER.VERDICT AS RESULT_VERDICT,  
		WI.REQUEST_ID, WI.NAME AS REQUEST_NAME, WI.URL AS REQUEST_URL, 
		T.REQUEST_TYPE_ID, T.NAME AS REQUEST_TYPE_NAME, S.REQUEST_STATUS_ID, S.NAME AS REQUEST_STATUS
FROM $(NF_SCHEMA).REQUIREMENT R 
JOIN $(NF_SCHEMA).REQUIREMENT_TESTCASE_LOOKUP RT ON RT.REQUIREMENT_ID = R.REQUIREMENT_ID
JOIN $(NF_SCHEMA).TESTCASE TC ON RT.TESTCASE_ID = TC.TESTCASE_ID
JOIN $(NF_SCHEMA).TESTCASE_STATE TS ON TC.TESTCASE_STATE_ID = TS.TESTCASE_STATE_ID
JOIN $(NF_SCHEMA).EXECUTION_WORKITEM ERWI ON ERWI.TESTCASE_ID = TC.TESTCASE_ID
JOIN $(NF_SCHEMA).EXECUTION_RESULT ER ON ERWI.CURRENT_RESULT_ID = ER.EXECUTION_RESULT_ID
LEFT JOIN $(NF_SCHEMA).TESTPLAN_TESTCASE_LOOKUP TPTC ON TPTC.TESTCASE_ID = TC.TESTCASE_ID
LEFT JOIN $(NF_SCHEMA).TESTPLAN TP ON TPTC.TESTPLAN_ID = TP.TESTPLAN_ID
LEFT JOIN $(NF_SCHEMA).EXECRES_REQUEST_LOOKUP EQ ON EQ.EXECUTION_RESULT_ID = ER.EXECUTION_RESULT_ID
LEFT JOIN $(NF_SCHEMA).REQUEST WI ON EQ.REQUEST_ID = WI.REQUEST_ID
LEFT JOIN $(NF_SCHEMA).REQUEST_TYPE T ON T.REQUEST_TYPE_ID = WI.REQUEST_TYPE_ID
LEFT JOIN $(NF_SCHEMA).REQUEST_STATUS S ON WI.REQUEST_STATUS_ID = S.REQUEST_STATUS_ID)
GO

CREATE VIEW $(STAR_SCHEMA).VW_RQRMNT_COVERAGE_LOOKUP (LOW_PROJECT_ID, LOW_ID, LOW_REF_ID, LOW_NAME, LOW_URL, LOW_TYPE, LOW_STATUS, LOW_PRIORITY, LOW_STABILITY, LOW_DIFFICULTY, LOW_STATE, UP_PROJECT_ID, UP_ID, UP_REF_ID, UP_NAME, UP_URL, UP_TYPE, UP_STATUS, UP_PRIORITY, UP_STABILITY, UP_DIFFICULTY, UP_STATE, LINK_TYPE_ID, LINK_TYPE) AS 
(SELECT LR.PROJECT_ID AS LOW_PROJECT_ID, LR.REQUIREMENT_ID AS LOW_ID, LR.REFERENCE_ID AS LOW_REF_ID, LR.NAME AS LOW_NAME, LR.URL AS LOW_URL, LR.REQUIREMENT_TYPE AS LOW_TYPE, LR.STATUS AS LOW_STATUS, LR.PRIORITY AS LOW_PRIORITY, LR.STABILITY AS LOW_STABILITY, LR.DIFFICULTY AS LOW_DIFFICULTY, LR.REQUIREMENT_STATE AS LOW_STATE, 
		COALESCE(UR.PROJECT_ID, -1) AS UP_PROJECT_ID, COALESCE(UR.REQUIREMENT_ID,-1) AS UP_ID, UR.REFERENCE_ID AS UP_REF_ID, UR.NAME AS UP_NAME, UR.URL AS UP_URL, UR.REQUIREMENT_TYPE AS UP_TYPE, UR.STATUS AS UP_STATUS, UR.PRIORITY AS UP_PRIORITY, UR.STABILITY AS UP_STABILITY, UR.DIFFICULTY AS UP_DIFFICULTY, UR.REQUIREMENT_STATE AS UP_STATE, 
		COALESCE(LT.LINK_TYPE_ID,-1) AS LINK_TYPE_ID, LT.NAME AS LINK_TYPE
FROM $(NF_SCHEMA).REQUIREMENT LR 
LEFT JOIN $(NF_SCHEMA).REQUIREMENT_HIERARCHY H ON H.PRED_REQUIREMENT_ID = LR.REQUIREMENT_ID
LEFT JOIN $(NF_SCHEMA).REQUIREMENT_LINK_TYPE LT ON H.LINK_TYPE_ID = LT.LINK_TYPE_ID
LEFT JOIN $(NF_SCHEMA).REQUIREMENT UR ON H.SUCC_REQUIREMENT_ID = UR.REQUIREMENT_ID
WHERE LR.REQUIREMENT_ID > -1 AND LR.ISSOFTDELETED = 0
UNION
SELECT COALESCE(LR.PROJECT_ID, -1) AS LOW_PROJECT_ID, COALESCE(LR.REQUIREMENT_ID,-1) AS LOW_ID, LR.REFERENCE_ID AS LOW_REF_ID, LR.NAME AS LOW_NAME, LR.URL AS LOW_URL, LR.REQUIREMENT_TYPE AS LOW_TYPE, LR.STATUS AS LOW_STATUS, LR.PRIORITY AS LOW_PRIORITY, LR.STABILITY AS LOW_STABILITY, LR.DIFFICULTY AS LOW_DIFFICULTY, LR.REQUIREMENT_STATE AS LOW_STATE, 
		UR.PROJECT_ID AS UP_PROJECT_ID, UR.REQUIREMENT_ID AS UP_ID, UR.REFERENCE_ID AS UP_REF_ID, UR.NAME AS UP_NAME, UR.URL AS UP_URL, UR.REQUIREMENT_TYPE AS UP_TYPE, UR.STATUS AS UP_STATUS, UR.PRIORITY AS UP_PRIORITY, UR.STABILITY AS UP_STABILITY, UR.DIFFICULTY AS UP_DIFFICULTY, UR.REQUIREMENT_STATE AS UP_STATE, 
		COALESCE(LT.LINK_TYPE_ID,-1) AS LINK_TYPE_ID, LT.NAME AS LINK_TYPE
FROM $(NF_SCHEMA).REQUIREMENT UR 
LEFT JOIN $(NF_SCHEMA).REQUIREMENT_HIERARCHY H ON H.SUCC_REQUIREMENT_ID = UR.REQUIREMENT_ID
LEFT JOIN $(NF_SCHEMA).REQUIREMENT_LINK_TYPE LT ON H.LINK_TYPE_ID = LT.LINK_TYPE_ID
LEFT JOIN $(NF_SCHEMA).REQUIREMENT LR ON H.PRED_REQUIREMENT_ID = LR.REQUIREMENT_ID
WHERE UR.REQUIREMENT_ID > -1 AND UR.ISSOFTDELETED = 0 )
GO

CREATE VIEW $(STAR_SCHEMA).VW_RQRMNT_DOWNGAP_NOCOVERAGE (UPPER_COLLECTION_ID, UP_ID, UP_REF_ID, UP_NAME, UP_URL, UP_TYPE, UP_STATUS, UP_PRIORITY, UP_STABILITY, UP_DIFFICULTY, UP_STATE) AS
(SELECT DISTINCT UPC.REQUIREMENT_COLLECTION_ID AS UPPER_COLLECTION_ID, UP.REQUIREMENT_ID AS UP_ID, UP.REFERENCE_ID AS UP_REF_ID, UP.NAME AS UP_NAME,
	UP.URL AS UP_URL, UP.REQUIREMENT_TYPE AS UP_TYPE, UP.STATUS UP_STATUS,
	UP.PRIORITY AS UP_PRIORITY, UP.STABILITY AS UP_STABILITY, 
	UP.DIFFICULTY AS UP_DIFFICULTY, UP.REQUIREMENT_STATE AS UP_STATE
	FROM $(NF_SCHEMA).REQUIREMENT UP 
JOIN $(NF_SCHEMA).REQUICOL_REQUIREMENT_LOOKUP UPC ON UP.REQUIREMENT_ID = UPC.REQUIREMENT_ID
LEFT JOIN $(NF_SCHEMA).REQUIREMENT_HIERARCHY H ON H.SUCC_REQUIREMENT_ID = UP.REQUIREMENT_ID
LEFT JOIN $(NF_SCHEMA).REQUICOL_REQUIREMENT_LOOKUP LOWC ON LOWC.REQUIREMENT_ID = H.PRED_REQUIREMENT_ID
LEFT JOIN $(NF_SCHEMA).REQUIREMENT LOW ON H.PRED_REQUIREMENT_ID = LOW.REQUIREMENT_ID
WHERE UP.REQUIREMENT_ID > -1 AND UP.ISSOFTDELETED = 0 
AND (
(H.SUCC_REQUIREMENT_ID IS NULL)
OR
(UPC.REQUIREMENT_COLLECTION_ID = LOWC.REQUIREMENT_COLLECTION_ID
AND NOT EXISTS (
	SELECT 1
	FROM $(NF_SCHEMA).REQUICOL_REQUIREMENT_LOOKUP UC 
		JOIN $(NF_SCHEMA).REQUIREMENT_HIERARCHY H ON H.SUCC_REQUIREMENT_ID = UC.REQUIREMENT_ID
		JOIN $(NF_SCHEMA).REQUICOL_REQUIREMENT_LOOKUP LC ON LC.REQUIREMENT_ID = H.PRED_REQUIREMENT_ID
		WHERE UC.REQUIREMENT_COLLECTION_ID = UPC.REQUIREMENT_COLLECTION_ID
		AND LC.REQUIREMENT_COLLECTION_ID <> LOWC.REQUIREMENT_COLLECTION_ID
		AND H.SUCC_REQUIREMENT_ID = UP.REQUIREMENT_ID
		AND H.PRED_REQUIREMENT_ID <> LOW.REQUIREMENT_ID ))
))
GO

CREATE VIEW $(STAR_SCHEMA).VW_RQRMNT_DOWNGAP_LOOKUP (UPPER_COLLECTION_ID, UP_ID, UP_REF_ID, UP_NAME, UP_URL, UP_TYPE, UP_STATUS, UP_PRIORITY, UP_STABILITY, UP_DIFFICULTY, UP_STATE, LINK_TYPE_ID, LINK_TYPE, LOW_ID, LOW_REF_ID, LOW_NAME, LOW_URL, LOW_TYPE, LOW_STATUS, LOW_PRIORITY, LOW_STABILITY, LOW_DIFFICULTY, LOW_STATE) AS
(SELECT DISTINCT UPC.REQUIREMENT_COLLECTION_ID AS UPPER_COLLECTION_ID, UP.REQUIREMENT_ID AS UP_ID, UP.REFERENCE_ID AS UP_REF_ID, UP.NAME AS UP_NAME, UP.URL AS UP_URL, UP.REQUIREMENT_TYPE AS UP_TYPE, UP.STATUS AS UP_STATUS, UP.PRIORITY AS UP_PRIORITY, UP.STABILITY AS UP_STABILITY, UP.DIFFICULTY AS UP_DIFFICULTY, UP.REQUIREMENT_STATE AS UP_STATE, 
		LT.LINK_TYPE_ID, LT.NAME AS LINK_TYPE,
		LOW.REQUIREMENT_ID AS LOW_ID, LOW.REFERENCE_ID AS LOW_REF_ID, LOW.NAME AS LOW_NAME, LOW.URL AS LOW_URL, LOW.REQUIREMENT_TYPE AS LOW_TYPE, LOW.STATUS AS LOW_STATUS, LOW.PRIORITY AS LOW_PRIORITY, LOW.STABILITY AS LOW_STABILITY, LOW.DIFFICULTY AS LOW_DIFFICULTY, LOW.REQUIREMENT_STATE AS LOW_STATE
	FROM $(NF_SCHEMA).REQUIREMENT_HIERARCHY H
JOIN $(NF_SCHEMA).REQUIREMENT UP ON H.SUCC_REQUIREMENT_ID = UP.REQUIREMENT_ID
JOIN $(NF_SCHEMA).REQUIREMENT LOW ON H.PRED_REQUIREMENT_ID = LOW.REQUIREMENT_ID
JOIN $(NF_SCHEMA).REQUICOL_REQUIREMENT_LOOKUP UPC ON UP.REQUIREMENT_ID = UPC.REQUIREMENT_ID
JOIN $(NF_SCHEMA).REQUICOL_REQUIREMENT_LOOKUP LOWC ON LOW.REQUIREMENT_ID = LOWC.REQUIREMENT_ID
JOIN $(NF_SCHEMA).REQUIREMENT_LINK_TYPE LT ON H.LINK_TYPE_ID = LT.LINK_TYPE_ID
WHERE UP.REQUIREMENT_ID > -1 AND LOW.REQUIREMENT_ID > -1 AND UP.ISSOFTDELETED = 0 AND LOW.ISSOFTDELETED = 0
AND UPC.REQUIREMENT_COLLECTION_ID <> LOWC.REQUIREMENT_COLLECTION_ID
AND NOT EXISTS (
	SELECT 1
	FROM $(NF_SCHEMA).REQUICOL_REQUIREMENT_LOOKUP UC 
		JOIN $(NF_SCHEMA).REQUIREMENT_HIERARCHY H ON H.SUCC_REQUIREMENT_ID = UC.REQUIREMENT_ID
		JOIN $(NF_SCHEMA).REQUICOL_REQUIREMENT_LOOKUP LC ON LC.REQUIREMENT_ID = H.PRED_REQUIREMENT_ID
		WHERE UC.REQUIREMENT_COLLECTION_ID = LC.REQUIREMENT_COLLECTION_ID
		AND LC.REQUIREMENT_COLLECTION_ID = UPC.REQUIREMENT_COLLECTION_ID
		AND H.SUCC_REQUIREMENT_ID = UP.REQUIREMENT_ID
		AND H.PRED_REQUIREMENT_ID = LOW.REQUIREMENT_ID )
)
GO

CREATE VIEW $(STAR_SCHEMA).VW_RQRMNT_UPSTREAM_NOCOVERAGE (LOWER_COLLECTION_ID, LOW_ID, LOW_REF_ID, LOW_NAME, LOW_URL, LOW_TYPE, LOW_STATUS, LOW_PRIORITY, LOW_STABILITY, LOW_DIFFICULTY, LOW_STATE) AS
(SELECT LOWC.REQUIREMENT_COLLECTION_ID AS LOWER_COLLECTION_ID, LOW.REQUIREMENT_ID AS LOW_ID, LOW.REFERENCE_ID AS LOW_REF_ID, LOW.NAME AS LOW_NAME,
	LOW.URL AS LOW_URL, LOW.REQUIREMENT_TYPE AS LOW_TYPE, LOW.STATUS LOW_STATUS,
	LOW.PRIORITY AS LOW_PRIORITY, LOW.STABILITY AS LOW_STABILITY, 
	LOW.DIFFICULTY AS LOW_DIFFICULTY, LOW.REQUIREMENT_STATE AS LOW_STATE
	FROM $(NF_SCHEMA).REQUIREMENT LOW 
JOIN $(NF_SCHEMA).REQUICOL_REQUIREMENT_LOOKUP LOWC ON LOW.REQUIREMENT_ID = LOWC.REQUIREMENT_ID
LEFT JOIN $(NF_SCHEMA).REQUIREMENT_HIERARCHY H ON H.PRED_REQUIREMENT_ID = LOW.REQUIREMENT_ID
LEFT JOIN $(NF_SCHEMA).REQUICOL_REQUIREMENT_LOOKUP UPC ON UPC.REQUIREMENT_ID = H.SUCC_REQUIREMENT_ID
LEFT JOIN $(NF_SCHEMA).REQUIREMENT UP ON H.SUCC_REQUIREMENT_ID = UP.REQUIREMENT_ID
WHERE LOW.REQUIREMENT_ID > -1 AND LOW.ISSOFTDELETED = 0 
AND (
(H.PRED_REQUIREMENT_ID IS NULL)
OR
(UPC.REQUIREMENT_COLLECTION_ID = LOWC.REQUIREMENT_COLLECTION_ID
AND NOT EXISTS (
	SELECT 1
	FROM $(NF_SCHEMA).REQUICOL_REQUIREMENT_LOOKUP UC 
		JOIN $(NF_SCHEMA).REQUIREMENT_HIERARCHY H ON H.SUCC_REQUIREMENT_ID = UC.REQUIREMENT_ID
		JOIN $(NF_SCHEMA).REQUICOL_REQUIREMENT_LOOKUP LC ON LC.REQUIREMENT_ID = H.PRED_REQUIREMENT_ID
		WHERE UC.REQUIREMENT_COLLECTION_ID <> UPC.REQUIREMENT_COLLECTION_ID
		AND LC.REQUIREMENT_COLLECTION_ID = LOWC.REQUIREMENT_COLLECTION_ID
		AND H.SUCC_REQUIREMENT_ID <> UP.REQUIREMENT_ID
		AND H.PRED_REQUIREMENT_ID = LOW.REQUIREMENT_ID ))
))
GO

CREATE VIEW $(STAR_SCHEMA).VW_RQRMNT_UPSTREAM_LOOKUP (LOWER_COLLECTION_ID, LOW_ID, LOW_REF_ID, LOW_NAME, LOW_URL, LOW_TYPE, LOW_STATUS, LOW_PRIORITY, LOW_STABILITY, LOW_DIFFICULTY, LOW_STATE, LINK_TYPE_ID, LINK_TYPE, UP_ID, UP_REF_ID, UP_NAME, UP_URL, UP_TYPE, UP_STATUS, UP_PRIORITY, UP_STABILITY, UP_DIFFICULTY, UP_STATE) AS
SELECT DISTINCT LOWC.REQUIREMENT_COLLECTION_ID AS LOWER_COLLECTION_ID, LOW.REQUIREMENT_ID AS LOW_ID, LOW.REFERENCE_ID AS LOW_REF_ID, LOW.NAME AS LOW_NAME, LOW.URL AS LOW_URL, LOW.REQUIREMENT_TYPE AS LOW_TYPE, LOW.STATUS AS LOW_STATUS, LOW.PRIORITY AS LOW_PRIORITY, LOW.STABILITY AS LOW_STABILITY, LOW.DIFFICULTY AS LOW_DIFFICULTY, LOW.REQUIREMENT_STATE AS LOW_STATE, 
				LT.LINK_TYPE_ID, LT.NAME AS LINK_TYPE,
				UP.REQUIREMENT_ID AS UP_ID, UP.REFERENCE_ID AS UP_REF_ID, UP.NAME AS UP_NAME, UP.URL AS UP_URL, UP.REQUIREMENT_TYPE AS UP_TYPE, UP.STATUS AS UP_STATUS, UP.PRIORITY AS UP_PRIORITY, UP.STABILITY AS UP_STABILITY, UP.DIFFICULTY AS UP_DIFFICULTY, UP.REQUIREMENT_STATE AS UP_STATE
	FROM $(NF_SCHEMA).REQUIREMENT_HIERARCHY H
JOIN $(NF_SCHEMA).REQUIREMENT LOW ON H.PRED_REQUIREMENT_ID = LOW.REQUIREMENT_ID
JOIN $(NF_SCHEMA).REQUIREMENT UP ON H.SUCC_REQUIREMENT_ID = UP.REQUIREMENT_ID
JOIN $(NF_SCHEMA).REQUICOL_REQUIREMENT_LOOKUP UPC ON UP.REQUIREMENT_ID = UPC.REQUIREMENT_ID
JOIN $(NF_SCHEMA).REQUICOL_REQUIREMENT_LOOKUP LOWC ON LOW.REQUIREMENT_ID = LOWC.REQUIREMENT_ID
JOIN $(NF_SCHEMA).REQUIREMENT_LINK_TYPE LT ON H.LINK_TYPE_ID = LT.LINK_TYPE_ID
WHERE UP.REQUIREMENT_ID > -1 AND LOW.REQUIREMENT_ID > -1 AND UP.ISSOFTDELETED = 0 AND LOW.ISSOFTDELETED = 0
AND UPC.REQUIREMENT_COLLECTION_ID <> LOWC.REQUIREMENT_COLLECTION_ID
AND NOT EXISTS (
	SELECT 1
	FROM $(NF_SCHEMA).REQUICOL_REQUIREMENT_LOOKUP UC 
		JOIN $(NF_SCHEMA).REQUIREMENT_HIERARCHY H ON H.SUCC_REQUIREMENT_ID = UC.REQUIREMENT_ID
		JOIN $(NF_SCHEMA).REQUICOL_REQUIREMENT_LOOKUP LC ON LC.REQUIREMENT_ID = H.PRED_REQUIREMENT_ID
		WHERE UC.REQUIREMENT_COLLECTION_ID = LC.REQUIREMENT_COLLECTION_ID
		AND LC.REQUIREMENT_COLLECTION_ID = LOWC.REQUIREMENT_COLLECTION_ID
		AND H.SUCC_REQUIREMENT_ID = UP.REQUIREMENT_ID
		AND H.PRED_REQUIREMENT_ID = LOW.REQUIREMENT_ID )
GO

